/*
 *------------------------------------------------------------------------------
 *
 * Name:	rpc.h
 *
 * RCS:		$Id: rpc.h,v 1.1.1.1 2001/12/08 02:07:20 anhv Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	Minimal RPC include file
 *
 * Created by:	Radek Aster
 *
 * Date Created: 12/7/01
 *
 *------------------------------------------------------------------------------
 */

/* @(#)rpc.h	2.3 88/08/10 4.0 RPCSRC; from 1.9 88/02/08 SMI */
/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 *
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * rpc.h, Just includes the billions of rpc header files necessary to
 * do remote procedure calling.
 *
 * Copyright (C) 1984, Sun Microsystems, Inc.
 */

#ifndef _RPC_RPC_H
#define _RPC_RPC_H 1

typedef uint32	   u_int;
typedef uint32	   u_long;
typedef int64	   int64_t;
typedef uint64	   uint64_t;
typedef int32	   int32_t;
typedef uint32	   uint32_t;
typedef ushort16   uint16_t;
typedef short16	   int16_t;
typedef uchar8	   uint8_t;
typedef char8	   int8_t;
typedef ushort16   u_short;
typedef byte	   u_char;
typedef char *	   caddr_t;
typedef int64	   quad_t;
typedef uint64	   u_quad_t;
typedef int	   bool_t;
typedef int	   enum_t;

/* external data representation interfaces */
#include <rpc/xdr.h>		/* generic (de)serializer */

#endif /* rpc/rpc.h */
