
include ${PATH_TO_TOOLS}/defs.mk
include ${PATH_TO_TOOLS}/suffix.mk

OFILES=$(FILES:xxx=o)
SOFILES=$(FILES:xxx=so)
CFILES=$(FILES:xxx=c)
DFILES=$(FILES:xxx=d)

STATIC_LIBRARY=${LIBRARY}.a
DYNAMIC_LIBRARY=${LIBRARY}.so
ALL_LIBRARIES=${STATIC_LIBRARY} ${DYNAMIC_LIBRARY}

install: all
	${INSTALL} ${STATIC_LIBRARY} ${LIB_DIR}/${STATIC_LIBRARY}
	${INSTALL} ${DYNAMIC_LIBRARY} ${LIB_DIR}/${DYNAMIC_LIBRARY}
	@rm -f ${LIB_DIR}/${DYNAMIC_LIBRARY}.1.0
	${LN} -s ${DYNAMIC_LIBRARY} ${LIB_DIR}/${DYNAMIC_LIBRARY}.1.0

all: ${ALL_LIBRARIES}

${STATIC_LIBRARY}: ${OFILES}
	${AR} ruc ${STATIC_LIBRARY} ${OFILES}
	${RANLIB} ${STATIC_LIBRARY}

${DYNAMIC_LIBRARY}: ${SOFILES}
	${LINK.so} -o ${DYNAMIC_LIBRARY} ${SOFILES} ${LIBS}

clean: clean-loc

clean-loc:
	@rm -f ${ALL_LIBRARIES} ${OFILES} ${SOFILES} ${DFILES}

ifneq (${CFILES},)
ifneq ($(findstring clean, ${MAKECMDGOALS}), clean)
-include ${DFILES}
endif
endif

include ${PATH_TO_TOOLS}/export.mk
