/*
 *-----------------------------------------------------------------
 *
 * Name:	sb1250-promio1.sx
 *
 * RCS:  $Id: sb1250-promio1.S,v 1.1 2002/11/21 17:26:41 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/19/01
 *
 *-----------------------------------------------------------------
 */

#ifdef SIBYTE

#include <sys/mips.h>
#include <sys/sb1250/sb1250_uart.h>
#include <exports/promio-api.h>
 
	.set	noreorder

	.text

/*-----------------------------------------------------------------
 * Name:	promio1_put_char()
 *
 * Description:
 *			registers used: t1 = UART
 *							t0 = TEMP
 *							a0 = ARG1
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio1_put_char
	.ent	promio1_put_char
promio1_put_char:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
1:
	ld		TEMP,R_DUART_STATUS(UART)
	nop
	and		TEMP,TEMP,M_DUART_TX_RDY
	beqz	TEMP,1b
	nop
	sd		ARG1,R_DUART_TX_HOLD(UART)
	la  UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
	ld  TEMP,R_DUART_MODE_REG_1(UART)
	la  UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
	ld  TEMP,R_DUART_MODE_REG_1(UART)
	nop
	j		ra
	nop

	.end	promio1_put_char

/*-----------------------------------------------------------------
 * Name:	promio1_get_char()
 *
 * Description:
 *			registers used: t1 = UART
 *							t0 = TEMP
 *							v0 = RET
 *							a0 = ARG1
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio1_get_char
	.ent	promio1_get_char
promio1_get_char:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
1:
	ld		TEMP,R_DUART_STATUS(UART)
	nop
	and		TEMP,TEMP,M_DUART_RX_RDY
	beqz	TEMP,1b
	nop
	ld		RET,R_DUART_RX_HOLD(UART)
	and		RET,RET,0xFF
	nop

1:
	ld		TEMP,R_DUART_STATUS(UART)
	nop
	and		TEMP,TEMP,M_DUART_TX_RDY
	beqz	TEMP,1b
	nop
	sd		RET,R_DUART_TX_HOLD(UART)
	la  UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
	ld  TEMP,R_DUART_MODE_REG_1(UART)
	la  UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
	ld  TEMP,R_DUART_MODE_REG_1(UART)
	nop

	j		ra
	nop

	.end	promio1_get_char

	.globl	promio1_get_char_no_echo
	.ent	promio1_get_char_no_echo
promio1_get_char_no_echo:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
1:
	ld		TEMP,R_DUART_STATUS(UART)
	nop
	and		TEMP,TEMP,M_DUART_RX_RDY
	beqz	TEMP,1b
	nop
	ld		RET,R_DUART_RX_HOLD(UART)
	and		RET,RET,0xFF
	nop

	j		ra
	nop

	.end	promio1_get_char_no_echo

/*-----------------------------------------------------------------
 * Name:	promio1_char_avail()
 *
 * Description:
 *			registers used: t1 = UART
 *							v0 = RET
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio1_char_avail
	.ent	promio1_char_avail
promio1_char_avail:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
	ld		RET,R_DUART_STATUS(UART)
	nop
	and		RET,RET,M_DUART_RX_RDY
	j		ra
	nop

	.end	promio1_char_avail

/*-----------------------------------------------------------------
 * Name:	promio1_tx_ready()
 *
 * Description:
 *			registers used:	t1 = UART
 *							v0 = RET
 *
 *			RET will be 0 or != 0 (NOT == 1, if transmitter is ready)
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio1_tx_ready
	.ent	promio1_tx_ready
promio1_tx_ready:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
	ld		RET,R_DUART_STATUS(UART)
	nop
	and		RET,RET,M_DUART_TX_RDY
	j		ra
	nop

	.end	promio1_tx_ready

	.set	reorder

#endif	/* SIBYTE */

