/*
 *-----------------------------------------------------------------
 *
 * Name:	cmdtable.c
 *
 * RCS:  $Id: cmdtable.c,v 1.38 2002/09/24 01:04:10 johnh Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/6/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-target.h>
#include "pmon.h"

int		setbp(), copy(), dump(), fill(), cont(), go(), help();
int		dis(), modify();
int		registers(), search(), trace(), clrbp(), sdump();
int		sload(), flush();
int		load();
int		do_tlb();
int		dohi(), do_sym(), do_ls();
int		do_set(), do_unset(), do_eset();
int		stty(), debug(), memtst(), call(), no_cmd();
#ifdef PROM_SIBYTE
int		dram_memtst();
#endif
int		do_brian_memtest();
int		stacktrace(), transp();

int		do_compare();

int		do_break();
int		do_prom_cmd();
int		do_quit();
int		do_pci_read();
int		do_pci_write();
int		do_pci_clear();
int		do_pci_stat();
int		do_pci_scan();
int		do_pci_init();
#ifndef SIBYTE
int		gt_mii_uiDiag();
int		bcm5600_uiDiag();
#ifdef	R9000
int		dp83816_uiDiag();
int		r9k_cpu1_go();
int		cmFanCmds();
#endif
#else
int   bmc12500Eth_uiDiag();
int   dp83820_uiDiag();
int   do_lsi();
int   sb1250dm_uiDiag();
#endif

#ifdef DIAG_R7000
int   dp83820_uiDiag();
#endif
#if defined (DIAG_R7000) || defined (DIAG_SIBYTE)
int		do_mdk();
#endif
#if defined(SIBYTE) && defined(AGILE_HARDWARE)
int		do_xlnx();
#endif

#ifndef SIBYTE_BC
int		load_toshiba();
int		toshiba_go();
int		load_ssc_mgmt();
int		do_toshiba_compare();
#endif
int		do_fp_copy();
int		do_tty1_test();


int		tftp_cmd();
int		luc_cmd();
int		do_bsd();
int		do_seep();
#if 0
int		do_view_chassis();
int		do_cm_reset();
int		do_cm_slot_reset();
int		do_cm_slice_reset();
#endif
int		do_seepenv();

int		do_wait();
int		do_i2c();
int     do_ibutton();
int		do_ver();

#if 0
int		do_crash();
#endif

#ifdef R7000
int		do_pcmcia_init();
int		do_disk_init();
int		do_disk_load();
#endif

#ifdef RTC
int		date_cmd();
#endif
#ifdef FLASH
int		flashprogram();
#endif
#ifdef INET
int		boot_cmd(), ping_cmd();
#endif
int		reboot_cmd();

int 		do_showEEEconfig();
int 		do_showEEEError();

int		do_simple_EEE_test();

int		do_autoload();
int		do_autodiag();
int 		do_adMenu();

int	watchdog_cmd();
int	crashdump_cmd();

int	eee_start_polling_ui();

int	do_cp0();
int do_ecc_test();

int do_ecc();
#ifdef SIBYTE_BC
int do_trace();
#endif

int	do_mc();
int do_draminit();

int do_malloc();
/*
 * Memory benchmarking test commands.
 */
int mb_memBenchBzero(int argc, char **argv);
int mb_memBenchWrite32(int argc, char **argv);
int mb_memBenchWrite64(int argc, char **argv);
int mb_memBenchRead32(int argc, char **argv);
int mb_memBenchRead64(int argc, char **argv);
int mb_memBenchCopy32(int argc, char **argv);
int mb_memBenchCopy64(int argc, char **argv);


#if RAL_XXX
extern const Optdesc	sload_opts[];
#endif
extern const Optdesc	load_opts[];
extern const Optdesc	m_opts[];
extern const Optdesc	b_opts[];
extern const Optdesc	debug_opts[];
extern const Optdesc	g_opts[];
extern const Optdesc	t_opts[];
extern const Optdesc	d_opts[];
extern const Optdesc	more_opts[];
extern const Optdesc	ls_opts[];
extern const Optdesc	l_opts[];
#if RAL_XXX
extern const Optdesc	stty_opts[];
#endif
extern const Optdesc	r_opts[];
extern const Optdesc	sh_opts[];
extern const Optdesc	mt_opts[];
extern const Optdesc	flush_opts[];
extern const Optdesc	boot_opts[];

const Cmd	CmdTable[] =
{
	{"h", "[*|cmd..]", 0, "on-line help", help, 1, 99, 0},
	{"hi", "[cnt]", 0, "display command history", dohi, 1, 2, 0},

	{"m", "adr [val|-s str]..", m_opts, "modify memory", modify, 2, 99, 1},
	{"r", "[reg* [val|field val]]", r_opts, "display/set register", registers, 1, 4, 1},
	{"tlb", "[index virt phys size calg]", 0, "display TLB registers", do_tlb, 1, 6, 1},

	{"d", "[-bhws] adr [cnt]", d_opts, "display memory", dump, 2, 4, 1},
	{"l", "[-bct][adr [cnt]]", l_opts, "list (disassemble) memory", dis, 1, 5, 1},

	{"copy", "from to siz", 0, "copy memory", copy, 4, 4, 1},
	{"fill", "from to {val|-s str}..", 0, "fill memory", fill, 4, 99, 1},

	{"search", "from to {val|-s str}..", 0, "search memory", search, 4, 99, 1},
#if RAL_XX
	{"tr", "", 0, "transparent mode", transp, 1, 1, 1},
#endif

	{"cmp", "addr1 addr2, len", 0, "byte compare", do_compare, 4, 4, 0},

	{"g", "[-s][-b bpadr][-e adr][-- args]", g_opts, "start execution (go)", go, 1, 99, 1},
	{"c", "[bptadr]", 0, "continue execution", cont, 1, 2, 1},

	{"t", "[-vibcmMrR] [cnt]", t_opts, "trace (single step)", trace, 1, 99, 1},
	{"to", "[-vibc] [cnt]", t_opts, "trace (step over)", trace, 1, 99, 1},

	{"b", "[-drwx] [-l len] [-s cmd] [adr]..", b_opts, "set break point(s)", setbp, 1, 99, 1},
	{"db", "[numb|*]..", 0, "delete break point(s)", clrbp, 1, 99, 1},

#if RAL_XXX
	{"sload", "[-beastif][-u baud][-o offs][-c cmd][-h port]", load_opts, "serial load", load, 1, 16, 0},
#endif
	{"load", "[ip addr] <fname>", load_opts, "load from network", load, 1, 5, 0},
#if defined(SIBYTE) && defined(AGILE_HARDWARE)
	{"xlnx", "[ luc | lmux0 | lmux1 ]",0,"program xilinx",do_xlnx, 1, 99, 0},
#endif
#if RAL_XXX
	{"dump", "[-B] adr siz [port]", 0, "dump memory to hostport", sdump, 3, 6, 0},
#endif

	{"set", "[name [value]]", 0, "display/set variable", do_set, 1, 3, 1},
	{"eset", "name ...", 0, "edit variable(s)", do_eset, 2, 99, 1},

	{"unset", "name* ...", 0, "unset variable(s)", do_unset, 2, 99, 1},
#ifdef RTC
	{"date", "[yymmddhhmm.ss]", 0, "get/set date and time", date_cmd, 1, 2, 1},
#endif
#ifdef FLASH
	{"flash", "[-w|eb|el] addr size offset", 0, "program flash prom", flashprogram, 4, 5, 0},
#endif

	{"debug", "[-svV][-h port][-- args]", debug_opts, "remote debug mode", debug, 1, 99, 0},
#if RAL_XXX
	{"stty", "[device] [opts]", stty_opts, "set terminal options", stty, 1, 99, 1},
#endif

#if RAL_XXX
	{"sym", "name value", 0, "define symbol", do_sym, 3, 5, 1},
	{"ls", "[-ln sym*|-va adr]", ls_opts, "list symbols", do_ls, 1, 99, 1},
#endif

	{"flush", "[-di]", flush_opts, "flush caches", flush, 1, 3, 1},
	{"mt", "[-c][[addr] size]", mt_opts, "memory test", memtst, 1, 4, 1},
	{"call", "addr [val|-s str]..", 0, "call function", call, 2, 99, 1},

#ifdef PROM_SIBYTE	
	{"dram", "[-c][[addr] size]", mt_opts, "memory test", dram_memtst, 1, 4, 1},
        {"memtest", "<gtmem> <read|write|verify|uart> <local|remote> <cached|uncached> [data]", 0, "brian memtest", do_brian_memtest, 3, 5, 0},
#else
        {"memtest", "<gtmem> <readwrite|verify> <local> <cached|uncached> [data]", 0, "brian memtest", do_brian_memtest, 3, 5, 0},
#endif

#ifdef INET
	{"boot", "[-bens] [[host:]file]", boot_opts, "load network file", boot_cmd, 1, 99, 1},
	{"ping", "[-fqrv] [-c cnt] [-s sz] host", 0, "ping remote host", ping_cmd, 1, 99, 1},
#endif

	{"sh", "", sh_opts, "command shell", no_cmd, 1, 99, 1},
	{"more", "", more_opts, "paginator", no_cmd, 1, 99, 1},
	{"reboot", "", 0, "reboot PMON", reboot_cmd, 1, 2, 0},

	{"prom", "<id | view | erase | fill | autoload | flag | upgrade | copy>", 0, "prom cmds", do_prom_cmd, 1, 99, 0},
	{"quit", "", 0, "quit client program", do_quit, 1, 99, 0},

	{"pci",	"[bus]", 0, "run PCI bus scan", do_pci_scan, 1, 2, 0},
	{"pciread", "<bus> <dev> <func> [off]", 0, "read PCI CFG regs", do_pci_read, 4, 5, 0},
	{"pciwrite", "<bus> <dev> <func> <off> <data>", 0, "write PCI CFG reg", do_pci_write, 6, 6, 0},
	{"pciclear", "<bus> <dev>", 0, "clear pci errors", do_pci_clear, 3, 3, 0},
	{"pcistat", "<bus> <dev>", 0, "read pci cfg stat reg", do_pci_stat, 3, 3, 0},

	{"pciinit", "", 0, "for testing", do_pci_init, 1, 1, 0},
#ifndef SIBYTE
#ifndef R9000
	{"gtdiag", "", 0, "run gt64240mii test menu",gt_mii_uiDiag, 1, 1, 0},
	{"bcm5600", "", 0, "run bcm5600 test menu",bcm5600_uiDiag, 1, 1, 0},
#else
	{"gtdiag", "", 0, "run gt64440mii test menu",gt_mii_uiDiag, 1, 1, 0},
	{"dp83816",    "", 0, "dp83816 Eth diag", dp83816_uiDiag, 1, 10, 0},
#endif
#else
    {"bmc12500",    "", 0, "bmc12500 Eth diag", bmc12500Eth_uiDiag, 1, 10, 0},
#ifndef PROM_SIBYTE_BC    
    {"dp83820",    "", 0, "dp83820 Eth diag", dp83820_uiDiag, 1, 10, 0},
#endif    
	{"lsi", "", 0, "LSI menu", do_lsi, 1, 1, 0},
	{"sb1250dm", "",   0,  "run sb1250dm test menu",sb1250dm_uiDiag, 1,  1,  0},
#endif

#ifdef DIAG_R7000	
    {"dp83820",    "", 0, "dp83820 Eth diag", dp83820_uiDiag, 1, 10, 0},
#endif    
#if defined (DIAG_R7000) || defined (DIAG_SIBYTE)
	{"mdk", "", 0, "DIAG menu", do_mdk, 1, 1, 0},
#endif
	{"tftp", "", 0, "tftp get <ip> <filename>", tftp_cmd, 1, 5, 0},
	{"luc", "",  0, "LUC commands ", luc_cmd, 1,  5, 0},
	{"bsd", "",  0, "BSD commands ", do_bsd, 1,  6, 0},
	{"eee", "",  0, "show EEE config",do_showEEEconfig,1,1,0},
	{"err", "",  0, "show EEE errors",do_showEEEError, 1,1,0},
	{"simple",  "",   0,  "send EEE packets", do_simple_EEE_test, 1,  1,  0},

#if 0
	{"chassis", "", 0, "view chassis map", do_view_chassis, 1, 1, 0},
	{"reset", "<slot|slice>", 0, "cm reset of a slot or slice", do_cm_reset, 3, 4, 0},
#endif
	{"seep", "<view|program|erase>", 0, "show/modify/erase seep", do_seep, 2, 5, 0},
	{"env", "<view|set|reset>", 0, "view/set env variable", do_seepenv, 2, 4, 0},
#if 0
	{"crash", "<view|trigger>", 0, "crashdump utilities", do_crash, 2, 2, 0},
#endif
	{"break", "", 0, "GDB breakpoint", do_break, 1, 1, 0},
	{"wait", "", 0, "wait <sec>", do_wait, 2, 2, 0},
#ifdef SIBYTE 
	{"i2c", "<read bus i2c_addr offset len> <write bus i2c_addr offset len string>", 0, "do I2C read/write", do_i2c, 6, 7, 0},
#else	
	{"i2c", "<read i2c_addr offset len> <write i2c_addr offset len string>", 0, "do I2C read/write", do_i2c, 5, 6, 0},
#endif	
	{"ibutton", "<read which_ibutton offset len> <write which_ibutton offset len string> <readrom which_ibutton>", 0, "do ibutton read/write", do_ibutton, 3, 6, 0},


#ifdef R9000
	{"cpu1go", "<addr>", 0, "switch R9K CPU 1 to runtime", r9k_cpu1_go, 2, 2, 0},
	{"fandebug", "on|off|status", 0, "", cmFanCmds, 2, 2, 0},

#endif
#ifndef SIBYTE_BC
	{"toshiba", "", 0, "load toshiba image", load_toshiba, 1, 1, 0},
	{"tgo", "", 0, "switch toshiba to runtime", toshiba_go, 1, 1, 0},
	{"mgmt", "", 0, "load ssc_mgmt to local mem", load_ssc_mgmt, 1, 1, 0},
	{"compareit", "", 0, "compare toshiba images", do_toshiba_compare, 1, 1, 0},
#endif

	{"ver", "", 0, "show version string", do_ver, 1, 1, 0},
#ifdef R7000
	{"pcmciainit", "", 0, "init bridge and sockets", do_pcmcia_init,
	 1, 1, 0 },
	{"diskinit", "", 0, "init disks", do_disk_init, 1, 1, 0},
	{"diskload", "", 0, "load from disk", do_disk_load, 1, 4, 0},
#endif

	{"fp", "", 0, "copy fp from 0x4 to 0x83", do_fp_copy, 1, 1, 0},
	{"tty1", "", 0, "read tty1", do_tty1_test, 1, 1, 0},
	{"autoload", "", 0, "load images", do_autoload, 1, 1, 0},

	{"autodiag", "<long|short>|<wait|nowait>", 0, "run functional Diag tests", do_autodiag, 1, 3, 0},
	{"admenu", "", 0, "restart AutoDiag Menu", do_adMenu, 1, 1, 0},

	{"wd", "<ena|dis|view> <nsec>", 0, "watchdog commands", watchdog_cmd, 1, 3, 0},
	{"crashdump", "<view|remove> [saved|pending]", 0, "crashdump commands", crashdump_cmd, 2, 3, 0},
	{"poll", "<on|off>", 0, "turn on/off polling loop", eee_start_polling_ui, 2, 2, 0},

	{"cp0", "", 0, "show/set current CP0 regs", do_cp0, 1, 3, 0},
	{"ecctest", "", 0, "test ECC interrupt", do_ecc_test, 1, 1, 0},
        {"ecc", "ena|dis[0|1]|view|test|data|start|stop|sbe|scrub [<begin> <end>]", 0, "ecc test", do_ecc, 2, 4, 0},
//WTG trace will allow us to get an Address for ECC errors
#ifdef SIBYTE_BC
        {"trace", "check|start[init[nmi]]|stop|freeze|read[raw]", 0, "trace", do_trace, 2, 4, 0},
#endif
//WTG removed  to make some space in RPROM
#ifndef SIBYTE_BC
    {"mb_bzero", "<numBytes> <numIter> <memType> [-u] [-c]", 0, "bzero benchmark", mb_memBenchBzero, 4, 6, 0},
    {"mb_r32", "<numBytes> <numIter> <memType> [-u] [-c] [-l]", 0, "32-bit read benchmark", mb_memBenchRead32, 4, 7, 0},
    {"mb_r64", "<numBytes> <numIter> <memType> [-u] [-c] [-l]", 0, "64-bit read benchmark", mb_memBenchRead64, 4, 7, 0},
    {"mb_w32", "<numBytes> <numIter> <memType> [-u] [-c]", 0, "32-bit write benchmark", mb_memBenchWrite32, 4, 6, 0},
    {"mb_w64", "<numBytes> <numIter> <memType> [-u] [-c]", 0, "64-bit write benchmark", mb_memBenchWrite64, 4, 6, 0},
    {"mb_c32", "<numBytes> <numIter> <fromMmemType> <toMemType> [-u] [-c]", 0, "32-bit copy benchmark", mb_memBenchCopy32, 5, 7, 0},
    {"mb_c64", "<numBytes> <numIter> <fromMemType> <toMemType> [-u] [-c]", 0, "64-bit copy benchmark", mb_memBenchCopy64, 5, 7, 0},

#endif
    {"mc", "", 0, "show Mem Controller settings", do_mc, 1, 1, 0},
	{"draminit", "show [0|1]", 0, "run dram init code", do_draminit, 1, 3, 0},


	{0}
};

