/*
 *-----------------------------------------------------------------
 *
 * Name:	serio-io.S
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2004, OnStor Inc.
 *
 * Description:	serio I/O code for prom using ns16550.
 *
 * Created by:	Shaun Hui
 *
 * Date Created:03/18/04
 *
 *-----------------------------------------------------------------
 */
#ifdef PROM

#include <nfx-incl.h>
#include <sys/mips.h>
#include <sys/gt64440r.h>
#include <sys/ns16550.h>


	.globl	initserial
	.globl	stringserial
	.globl	hexserial

        .rdata
hexchar:
        .ascii  "0123456789abcdef"
                                                                                

        .text
        .set    noreorder

LEAF(stringserial)
        move    a2, ra
        addu    a1, a0, s0
        lbu     a0, 0(a1)
1:
        beqz    a0, 2f
        nop
        bal     tgt_putchar
        addiu   a1, 1
        b       1b
        lbu     a0, 0(a1)
                                                                                
2:
        j       a2
        nop
END(stringserial)


LEAF(hexserial)
        move    a2, ra
        move    a1, a0
        li      a3, 7
1:
        rol     a0, a1, 4
        move    a1, a0
        and     a0, 0xf
        la      v0, hexchar
        addu    v0, s0
        addu    v0, a0
        bal     tgt_putchar
        lbu     a0, 0(v0)
                                                                                
        bnez    a3, 1b
        addu    a3, -1
                                                                                
        j       a2
        nop
END(hexserial)
                                                                                
#ifdef EVAL_BOARD
LEAF(tgt_putchar)
        la      v0, COM1_BASE_ADDR
1:
        lbu     v1, NSREG(NS16550_LSR)(v0)
        and     v1, LSR_TXRDY
        beqz    v1, 1b
        nop
                                                                                
        sb      a0, NSREG(NS16550_DATA)(v0)
        j       ra
        nop
END(tgt_putchar)
                                                                                
#define B0      0
#define B50     50
#define B75     75
#define B110    110
#define B134    134
#define B150    150
#define B200    200
#define B300    300
#define B600    600
#define B1200   1200
#define B1800   1800
#define B2400   2400
#define B4800   4800
#define B9600   9600
#define B19200  19200
#define B38400  38400
#define B57600  57600
#define B115200 115200

LEAF(initserial)
        la      v0, COM1_BASE_ADDR
1:
        li      v1, FIFO_ENABLE|FIFO_RCV_RST|FIFO_XMT_RST|FIFO_TRIGGER_4
        sb      v1, NSREG(NS16550_FIFO)(v0)
        li      v1, CFCR_DLAB
        sb      v1, NSREG(NS16550_CFCR)(v0)
        li      v1, NS16550HZ/(16*B9600)
        sb      v1, NSREG(NS16550_DATA)(v0)
        srl     v1, 8
        sb      v1, NSREG(NS16550_IER)(v0)
        li      v1, CFCR_8BITS
        sb      v1, NSREG(NS16550_CFCR)(v0)

        sb      v1, NSREG(NS16550_MCR)(v0)
        li      v1, 0x0
        sb      v1, NSREG(NS16550_IER)(v0)
                                                                                
        move    v1, v0
        la      v0, COM2_BASE_ADDR
        bne     v0, v1, 1b
        nop

        j       ra
        nop
END(initserial)
                                                                                
#else

LEAF(tgt_putchar)
        mfc0    v0, C0_PRID
        srl     v0, 24
        sll     v0, 12
        add     v0, (GT_BASE_ADDR + 0x8000)
1:
        lw      v1, 16(v0)
        and     v1, 0x00000200
        bnez    v1, 1b
        nop
                                                                                
        andi    v1, a0, 0x00ff
        sw      v1, 12(v0)
        lw      v1, 16(v0)
        ori     v1, v1, 0x0200
        sw      v1, 16(v0)

        j       ra
        nop
END(tgt_putchar)

LEAF(initserial)
        mfc0    v0, C0_PRID
        srl     v0, 24
        sll     v0, 12
        add     v0, (GT_BASE_ADDR + 0x8000)
	li	v1, 0x000004c4
	sw	v1, 0(v0)

	li	v1, 0x20000000
	sw	v1, 24(v0)

	li	v1, 0x00003000
	sw	v1, 8(v0)

	li	v1, 0x80000000
	sw	v1, 16(v0)

	li	v1, 0x00009000
	sw	v1, 28(v0)

	j	ra
	nop

END(initserial)

#endif	/* EVAL_BOARD */

#endif	/* PROM */

