/*
 *=============================================================================
 * File Name   :    bcm5632-socregs.c
 *
 *  RCS: $Id: bcm5632-socregs.c,v 1.1.1.1 2001/12/22 04:14:58 tonyw Exp $
 *
 *  Description:    Copied and modified from Broadcom
 *
 *  Created    :    09-04-2001
 *
 *  Author     :    Tony Wong
 *
 *  Copyright(c)  Agile Storage, Inc. 2001
 *=============================================================================
 */

#include <nfx-incl.h>

#include "bcm5632-socregs.h"

#ifdef NDEBUG
# define IFNND(x,y)
#else
# define IFNND(x,y) x,y
#endif

#ifdef NO_MEM_NAMES
# define IFMEMN(x,y)
#else
# define IFMEMN(x,y) x,y
#endif

#ifdef NO_REG_NAMES
# define IFREGN(x,y)
#else
# define IFREGN(x,y) x,y
#endif

#ifdef NO_RESET_INFO
# define IFRSTI(x,y,z)
#else
# define IFRSTI(x,y,z) x,y,z
#endif

# define IFDESC(x,y) x,y

char *soc_blocknames_5632[] = {
        "ANY_GPIC",
        "ANY_PIC",
	"ANY_XGPIC"
};

char *soc_regtypenames_5632[] = {
    "general", "port", "cos"
};

/* BCM5632 register fields */
soc_fieldinfo_t sr_SYS_CONF_1_fields[] = {
	{ CPUprstf, 1, 15, SOCF_LE },
	{ Flood_controlf, 1, 14, SOCF_LE },
	{ Chip_securityf, 1, 13, SOCF_LE },
	{ AgeENf, 1, 12, SOCF_LE },
	{ Per_VLAN_STf, 1, 11, SOCF_LE },
	{ STPENf, 1, 10, SOCF_LE },
	{ PinMonf, 1, 9, SOCF_LE },
	{ PoutMonf, 1, 8, SOCF_LE },
	{ CPUcfgrdyf, 1, 7, SOCF_LE },
	{ GMCf, 1, 6, SOCF_LE },
	{ VLAN_GMCf, 1, 5, SOCF_LE },
	{ PQWRREnf, 1, 4, SOCF_LE },
	{ Cooperativef, 1, 3, SOCF_LE },
	{ FailOverEnf, 1, 2, SOCF_LE },
	{ Multiplexer10Gportf, 1, 1, SOCF_LE },
	{ ReservedConf1f, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_SYS_CONF_2_fields[] = {
	{ MaxAgef, 7, 9, SOCF_LE },
	{ TimeoutENf, 1, 8, SOCF_LE },
	{ CPU_Timeout_ENf, 1, 7, SOCF_LE },
	{ BConly_SCf, 1, 6, SOCF_LE },
	{ MaxStormf, 2, 4, SOCF_LE },
	{ MaxStorm10gf, 2, 2, SOCF_LE },
	{ ReservedConf2f, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_SYS_CONF_3_fields[] = {
	{ Qonf, 1, 15, SOCF_LE },
	{ ReservedConf3f, 1, 14, SOCF_LE },
	{ DiffServf, 1, 13, SOCF_LE },
	{ TypeParsef, 1, 12, SOCF_LE },
	{ IPMCtrapf, 1, 11, SOCF_LE },
	{ IGMPtrapf, 1, 10, SOCF_LE },
	{ GARPtrapf, 1, 9, SOCF_LE },
	{ ARPtrapf, 1, 8, SOCF_LE },
	{ T802ADtrapf, 1, 7, SOCF_LE },
	{ ICMPtrapf, 1, 6, SOCF_LE },
	{ BPDU1trapf, 1, 5, SOCF_LE },
	{ BPDU2trapf, 1, 4, SOCF_LE },
	{ MarkerENf, 1, 3, SOCF_LE },
	{ BufDataEnf, 1, 2, SOCF_LE },
	{ ReservedConf32f, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EP_SETUP_1_fields[] = {
	{ Epprstf, 1, 15, SOCF_LE },
	{ Epconff, 3, 12, SOCF_LE },
	{ ReservedEPf, 6, 6, SOCF_LE },
	{ EPL2sizef, 6, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EP_SETUP_2_fields[] = {
	{ EEPROMIDf, 3, 13, SOCF_LE },
	{ ReservedEP2f, 5, 8, SOCF_LE },
	{ EPVLANsizef, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_PRIO_QMAP_fields[] = {
	{ PL7QAf, 2, 14, SOCF_LE },
	{ PL6QAf, 2, 12, SOCF_LE },
	{ PL5QAf, 2, 10, SOCF_LE },
	{ PL4QAf, 2, 8, SOCF_LE },
	{ PL3QAf, 2, 6, SOCF_LE },
	{ PL2QAf, 2, 4, SOCF_LE },
	{ PL1QAf, 2, 2, SOCF_LE },
	{ PL0QAf, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_DFSV_QMAP_0_fields[] = {
	{ DS7QAf, 2, 14, SOCF_LE },
	{ DS6QAf, 2, 12, SOCF_LE },
	{ DS5QAf, 2, 10, SOCF_LE },
	{ DS4QAf, 2, 8, SOCF_LE },
	{ DS3QAf, 2, 6, SOCF_LE },
	{ DS2QAf, 2, 4, SOCF_LE },
	{ DS1QAf, 2, 2, SOCF_LE },
	{ DS0QAf, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QWEIGHT_1G_fields[] = {
	{ Q3RRWeightf, 4, 12, SOCF_LE },
	{ Q2RRWeightf, 4, 8, SOCF_LE },
	{ Q1RRWeightf, 4, 4, SOCF_LE },
	{ Q0RRWeightf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QWEIGHT_10G_fields[] = {
	{ Q3RRWeight10Gf, 4, 12, SOCF_LE },
	{ Q2RRWeight10Gf, 4, 8, SOCF_LE },
	{ Q1RRWeight10Gf, 4, 4, SOCF_LE },
	{ Q0RRWeight10Gf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QMAX_1G_fields[] = {
	{ Q3MaxLimitf, 4, 12, SOCF_LE },
	{ Q2MaxLimitf, 4, 8, SOCF_LE },
	{ Q1MaxLimitf, 4, 4, SOCF_LE },
	{ Q0MaxLimitf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QMAX_10G_fields[] = {
	{ Q3MaxLimit10Gf, 4, 12, SOCF_LE },
	{ Q2MaxLimit10Gf, 4, 8, SOCF_LE },
	{ Q1MaxLimit10Gf, 4, 4, SOCF_LE },
	{ Q0MaxLimit10Gf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QMGMT_1_fields[] = {
	{ ReservedQMf, 2, 14, SOCF_LE },
	{ CPUQ0Enf, 1, 13, SOCF_LE },
	{ TGQ0Enf, 1, 12, SOCF_LE },
	{ GxQ0Enf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QMGMT_2_fields[] = {
	{ ReservedQM2f, 3, 13, SOCF_LE },
	{ TGQ1Enf, 1, 12, SOCF_LE },
	{ GxQ1Enf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QMGMT_3_fields[] = {
	{ ReservedQM3f, 3, 13, SOCF_LE },
	{ TGQ2Enf, 1, 12, SOCF_LE },
	{ GxQ2Enf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QMGMT_4_fields[] = {
	{ ReservedQM4f, 3, 13, SOCF_LE },
	{ TGQ3Enf, 1, 12, SOCF_LE },
	{ GxQ3Enf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_QMGMT_5_fields[] = {
	{ OqFullBp3f, 1, 15, SOCF_LE },
	{ OqFullBp2f, 1, 14, SOCF_LE },
	{ OqFullBp1f, 1, 13, SOCF_LE },
	{ OqFullBp0f, 1, 12, SOCF_LE },
	{ Q3LatencyEnf, 1, 11, SOCF_LE },
	{ Q2LatencyEnf, 1, 10, SOCF_LE },
	{ Q1LatencyEnf, 1, 9, SOCF_LE },
	{ Q0LatencyEnf, 1, 8, SOCF_LE },
	{ Q3LatencyLimf, 2, 6, SOCF_LE },
	{ Q2LatencyLimf, 2, 4, SOCF_LE },
	{ Q1LatencyLimf, 2, 2, SOCF_LE },
	{ Q0LatencyLimf, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BMGMT_1_fields[] = {
	{ JumboEnf, 1, 15, SOCF_LE },
	{ JumboSizef, 2, 13, SOCF_LE },
	{ B8G_modef, 1, 12, SOCF_LE },
	{ CPUless_modef, 1, 11, SOCF_LE },
	{ Fair_Sharef, 1, 10, SOCF_LE },
	{ Non_Jumbo_MTUf, 1, 9, SOCF_LE },
	{ ReservedBMf, 2, 7, SOCF_LE },
	{ WaterMark1f, 7, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BMGMT_2_fields[] = {
	{ ReservedBM2f, 2, 14, SOCF_LE },
	{ WaterMark2f, 7, 7, SOCF_LE },
	{ WaterMark3f, 7, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BMGMT_3_fields[] = {
	{ WaterMark1CPUf, 7, 9, SOCF_LE },
	{ WaterMark1_10Gf, 9, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BMGMT_4_fields[] = {
	{ WaterMark2CPUf, 7, 9, SOCF_LE },
	{ WaterMark2_10Gf, 9, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BMGMT_5_fields[] = {
	{ WaterMark3CPUf, 7, 9, SOCF_LE },
	{ WaterMark3_10Gf, 9, 0, SOCF_LE }
};
soc_fieldinfo_t sr_PHY_CONF_fields[] = {
	{ ReservedPHYf, 2, 14, SOCF_LE },
	{ MIISlowClkf, 1, 13, SOCF_LE },
	{ PHYOpRegf, 5, 8, SOCF_LE },
	{ PHYOpSpf, 4, 4, SOCF_LE },
	{ PHYOpMdf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_MAC_CONF_1G_fields[] = {
	{ SuperMacf, 1, 15, SOCF_LE },
	{ UltraMacf, 1, 14, SOCF_LE },
	{ Bp_colf, 1, 13, SOCF_LE },
	{ IPG64f, 1, 12, SOCF_LE },
	{ BP_IPG64f, 1, 11, SOCF_LE },
	{ Bpratef, 2, 9, SOCF_LE },
	{ BebSelf, 1, 8, SOCF_LE },
	{ Extcycself, 2, 6, SOCF_LE },
	{ Mactestf, 1, 5, SOCF_LE },
	{ BPIpgSelf, 2, 3, SOCF_LE },
	{ ReservedMACf, 3, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TRK_SETUP_0_fields[] = {
	{ Tsetup_remotef, 4, 12, SOCF_LE },
	{ Tsetup_localf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TRK_DIST_SEL_fields[] = {
	{ Failover_Timerf, 2, 14, SOCF_LE },
	{ Failback_Timerf, 2, 12, SOCF_LE },
	{ L2MacSAf, 1, 11, SOCF_LE },
	{ L2MacDAf, 1, 10, SOCF_LE },
	{ L2EthTypef, 1, 9, SOCF_LE },
	{ L2VLANIDf, 1, 8, SOCF_LE },
	{ IPMacSAf, 1, 7, SOCF_LE },
	{ IPMacDAf, 1, 6, SOCF_LE },
	{ L3Protocolf, 1, 5, SOCF_LE },
	{ L3VLANIDf, 1, 4, SOCF_LE },
	{ L3IPSAf, 1, 3, SOCF_LE },
	{ L3IPDAf, 1, 2, SOCF_LE },
	{ L3SSf, 1, 1, SOCF_LE },
	{ L3DSf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_PMON_CONF_fields[] = {
	{ ReservedPMf, 4, 12, SOCF_LE },
	{ MdPIDf, 4, 8, SOCF_LE },
	{ MgIPIDf, 4, 4, SOCF_LE },
	{ MgOPIDf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_PENG_CONF_1_fields[] = {
	{ ReservedR26f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_PENG_CONF_2_fields[] = {
	{ ReservedR27f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_XGMI_CONF_1_fields[] = {
	{ XGMII_IDLEf, 8, 8, SOCF_LE },
	{ XGMII_SOPf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_XGMI_CONF_2_fields[] = {
	{ XGMII_EOPf, 8, 8, SOCF_LE },
	{ XGMII_ERRORf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_XGMI_CONF_3_fields[] = {
	{ XGMII_BIDLEf, 8, 8, SOCF_LE },
	{ ReservedXGMI3f, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_XGMI_CONF_4_fields[] = {
	{ SEL_XGMII_PAf, 1, 15, SOCF_LE },
	{ ReservedXGMIf, 1, 14, SOCF_LE },
	{ EnOpenLoopf, 1, 13, SOCF_LE },
	{ OpenLoop_IPGExtRatiof, 13, 0, SOCF_LE },
	{ Reserved22Cf, 0, 0, SOCF_LE }
};
soc_fieldinfo_t sr_XGMI_CONF_5_fields[] = {
	{ XGMII_BIDLE_ODDf, 8, 8, SOCF_LE },
	{ XGMII_IDLE_ODDf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_AUTH_VLAN_fields[] = {
	{ VLAN_Au_ENf, 1, 15, SOCF_LE },
	{ VLAN_Au_Pf, 3, 12, SOCF_LE },
	{ VLAN_Au_IDf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P_CONF_1_fields[] = {
	{ UpLinkIDf, 4, 12, SOCF_LE },
	{ Drop_untagf, 1, 11, SOCF_LE },
	{ Drop_tagf, 1, 10, SOCF_LE },
	{ Flood_loopbackf, 1, 9, SOCF_LE },
	{ LinkLEDEnf, 1, 8, SOCF_LE },
	{ Storm_controlf, 1, 7, SOCF_LE },
	{ Port_securityf, 1, 6, SOCF_LE },
	{ VLAN_ingressf, 1, 5, SOCF_LE },
	{ LrnDisf, 1, 4, SOCF_LE },
	{ PortSTf, 2, 2, SOCF_LE },
	{ B2benablef, 1, 1, SOCF_LE },
	{ Multiplexer1Gportf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P_CONF_2_fields[] = {
	{ RstAnegf, 1, 15, SOCF_LE },
	{ AnegEnbf, 1, 14, SOCF_LE },
	{ LinkUpf, 1, 13, SOCF_LE },
	{ PAUSE_CAPf, 1, 12, SOCF_LE },
	{ ASM_DIRf, 1, 11, SOCF_LE },
	{ TXPAUSEf, 1, 10, SOCF_LE },
	{ RXPAUSEf, 1, 9, SOCF_LE },
	{ Offlinef, 1, 8, SOCF_LE },
	{ back_jam_enf, 1, 7, SOCF_LE },
	{ Preamblewdf, 3, 4, SOCF_LE },
	{ IPGwdf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P_CONF_3_fields[] = {
	{ M_S_cfgf, 1, 15, SOCF_LE },
	{ M_S_valf, 1, 14, SOCF_LE },
	{ EnGMIIf, 1, 13, SOCF_LE },
	{ EnTxExPausef, 1, 12, SOCF_LE },
	{ Skip_expanf, 1, 11, SOCF_LE },
	{ M_S_ptypef, 1, 10, SOCF_LE },
	{ Dis_phy_resetf, 1, 9, SOCF_LE },
	{ Keep_defaultf, 1, 8, SOCF_LE },
	{ ReservedPC3f, 1, 7, SOCF_LE },
	{ Duplex_cfgf, 1, 6, SOCF_LE },
	{ Speedselect_cfgf, 2, 4, SOCF_LE },
	{ Force_modef, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P10G_CONF_1_fields[] = {
	{ UpLinkID10Gf, 4, 12, SOCF_LE },
	{ Drop_untag10Gf, 1, 11, SOCF_LE },
	{ Drop_tag10Gf, 1, 10, SOCF_LE },
	{ ReservedPGf, 1, 9, SOCF_LE },
	{ LinkLEDEn10Gf, 1, 8, SOCF_LE },
	{ Storm_control10Gf, 1, 7, SOCF_LE },
	{ Port_security10Gf, 1, 6, SOCF_LE },
	{ VLAN_ingress10Gf, 1, 5, SOCF_LE },
	{ LrnDis10Gf, 1, 4, SOCF_LE },
	{ PortST10Gf, 2, 2, SOCF_LE },
	{ ReservedPG2f, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P10G_CONF_2_fields[] = {
	{ ReservedPG10Gf, 2, 14, SOCF_LE },
	{ LinkUp10Gf, 1, 13, SOCF_LE },
	{ PAUSE10Gf, 1, 12, SOCF_LE },
	{ ASM_DIR10Gf, 1, 11, SOCF_LE },
	{ TXPAUSE10Gf, 1, 10, SOCF_LE },
	{ RXPAUSE10Gf, 1, 9, SOCF_LE },
	{ ReservedPG22f, 4, 5, SOCF_LE },
	{ IPGwordselect10Gf, 1, 4, SOCF_LE },
	{ IPGword10Gf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P10G_CONF_3_fields[] = {
	{ ReservedPG3f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P_VLAN_MAP_0_fields[] = {
	{ ReservedPVf, 2, 14, SOCF_LE },
	{ CpuMapf, 1, 13, SOCF_LE },
	{ TGMapf, 1, 12, SOCF_LE },
	{ GigaMapf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_DFT_PORT_PRIORITY_0_fields[] = {
	{ ReservedPPf, 1, 15, SOCF_LE },
	{ Priorityf, 3, 12, SOCF_LE },
	{ VLANf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P_CTYP_0_fields[] = {
	{ VlClassEthTypef, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P_CDFT_0_fields[] = {
	{ VlClassValEtnryf, 1, 15, SOCF_LE },
	{ VlClassPriorityf, 3, 12, SOCF_LE },
	{ VlClassVIDf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TEST_CTL_1_fields[] = {
	{ CtrlFlags1f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TEST_CTL_2_fields[] = {
	{ CtrlFlags2f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TEST_CTL_3_fields[] = {
	{ CtrlFlags3f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TEST_CTL_4_fields[] = {
	{ CtrlFlags4f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TEST_CTL_5_fields[] = {
	{ CtrlFlags5f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TEST_CTL_6_fields[] = {
	{ CtrlFlags6f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TEST_CTL_7_fields[] = {
	{ CtrlFlags7f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_HMON_MAC_1_fields[] = {
	{ H1MacLSBf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_HMON_MAC_2_fields[] = {
	{ H2MacMSBf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_HMON_MAC_3_fields[] = {
	{ H2MacMSB3f, 16, 16, SOCF_LE },
	{ H1MacMSB3f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_VMON_0_fields[] = {
	{ ReservedMVLANf, 19, 13, SOCF_LE },
	{ MVLANIDf, 13, 0, SOCF_LE }
};
soc_fieldinfo_t sr_SECVIO_PORTMAP_fields[] = {
	{ ReservedSVf, 19, 13, SOCF_LE },
	{ P12Xf, 1, 12, SOCF_LE },
	{ P11Xf, 1, 11, SOCF_LE },
	{ P10Xf, 1, 10, SOCF_LE },
	{ P09Xf, 1, 9, SOCF_LE },
	{ P08Xf, 1, 8, SOCF_LE },
	{ P07Xf, 1, 7, SOCF_LE },
	{ P06Xf, 1, 6, SOCF_LE },
	{ P05Xf, 1, 5, SOCF_LE },
	{ P04Xf, 1, 4, SOCF_LE },
	{ P03Xf, 1, 3, SOCF_LE },
	{ P02Xf, 1, 2, SOCF_LE },
	{ P01Xf, 1, 1, SOCF_LE },
	{ P00Xf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_SYS_STATUS_fields[] = {
	{ ReservedSSf, 11, 21, SOCF_LE },
	{ LastOfMIBIdf, 12, 9, SOCF_LE },
	{ LastTblCmdXf, 1, 8, SOCF_LE },
	{ NowTblMgmtf, 1, 7, SOCF_LE },
	{ NowEPInitf, 1, 6, SOCF_LE },
	{ NowMIBInitf, 1, 5, SOCF_LE },
	{ NowL2Initf, 1, 4, SOCF_LE },
	{ ReservedSS2f, 1, 3, SOCF_LE },
	{ NowSBInitf, 1, 2, SOCF_LE },
	{ LastBISTXf, 1, 1, SOCF_LE },
	{ NowBISTf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P_STATUS_fields[] = {
	{ Aneglpregf, 16, 16, SOCF_LE },
	{ LinkFailf, 1, 15, SOCF_LE },
	{ AnegComptf, 1, 14, SOCF_LE },
	{ SvlanViolationf, 1, 13, SOCF_LE },
	{ DvlanViolationf, 1, 12, SOCF_LE },
	{ AllQueueDropf, 1, 11, SOCF_LE },
	{ InBFullf, 1, 10, SOCF_LE },
	{ TblUNAVLf, 1, 9, SOCF_LE },
	{ TimeOutf, 1, 8, SOCF_LE },
	{ AnegFailf, 1, 7, SOCF_LE },
	{ DisTxPausef, 1, 6, SOCF_LE },
	{ DisRxPausef, 1, 5, SOCF_LE },
	{ Anegpagervdf, 1, 4, SOCF_LE },
	{ PS1_PS0f, 2, 2, SOCF_LE },
	{ RF2_RF1f, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_P10G_STATUS_fields[] = {
	{ Aneglpreg10Gf, 16, 16, SOCF_LE },
	{ LinkFail10Gf, 1, 15, SOCF_LE },
	{ AnegCompt10Gf, 1, 14, SOCF_LE },
	{ SvlanViolation10Gf, 1, 13, SOCF_LE },
	{ DvlanViolation10Gf, 1, 12, SOCF_LE },
	{ AllQueueDrop10Gf, 1, 11, SOCF_LE },
	{ InBFull10Gf, 1, 10, SOCF_LE },
	{ TblUNAVL10Gf, 1, 9, SOCF_LE },
	{ TimeOut10Gf, 1, 8, SOCF_LE },
	{ AnegFail10Gf, 1, 7, SOCF_LE },
	{ DisTxPause10Gf, 1, 6, SOCF_LE },
	{ DisRxPause10Gf, 1, 5, SOCF_LE },
	{ Anegpagervd10Gf, 1, 4, SOCF_LE },
	{ PS1_PS010Gf, 2, 2, SOCF_LE },
	{ RF2_RF110Gf, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_CPU_CMD_fields[] = {
	{ SxAddrMSBf, 16, 16, SOCF_LE },
	{ ReservedCPUf, 7, 9, SOCF_LE },
	{ SwResetf, 1, 8, SOCF_LE },
	{ ReservedCPU2f, 2, 6, SOCF_LE },
	{ TblSelf, 3, 3, SOCF_LE },
	{ TblMgmtCmdf, 3, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TBL_ENTID_fields[] = {
	{ ReservedTAf, 1, 31, SOCF_LE },
	{ TblEntryCntf, 15, 16, SOCF_LE },
	{ ReservedTA2f, 1, 15, SOCF_LE },
	{ TblEntryNof, 15, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TBL_SXADDR_fields[] = {
	{ SxAddrLSBf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TBL_DBUF_0_fields[] = {
	{ TblDataBf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_INV_fields[] = {
	{ ReservedCPUIf, 22, 10, SOCF_LE },
	{ CPUInitStartf, 1, 9, SOCF_LE },
	{ PCIErrf, 1, 8, SOCF_LE },
	{ MemInitDonef, 1, 7, SOCF_LE },
	{ BISTDonef, 1, 6, SOCF_LE },
	{ MIBCntOFf, 1, 5, SOCF_LE },
	{ TblCmdDonef, 1, 4, SOCF_LE },
	{ RxPktLastf, 1, 3, SOCF_LE },
	{ RxPktf, 1, 2, SOCF_LE },
	{ TxPktLastf, 1, 1, SOCF_LE },
	{ TxPktf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_INV_MSK_fields[] = {
	{ IntVecMskf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_PKT_CH_PTRS_fields[] = {
	{ ReservedDMAf, 3, 29, SOCF_LE },
	{ NxtTxChf, 5, 24, SOCF_LE },
	{ ReservedDMA2f, 3, 21, SOCF_LE },
	{ NxtAllocTxChf, 5, 16, SOCF_LE },
	{ ReservedDMA3f, 3, 13, SOCF_LE },
	{ NxtRxChf, 5, 8, SOCF_LE },
	{ ReservedDMA4f, 3, 5, SOCF_LE },
	{ NxtAllocRxChf, 5, 0, SOCF_LE }
};
soc_fieldinfo_t sr_RX_CH_0_fields[] = {
	{ PktsRxAf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TX_CH_0_fields[] = {
	{ PktsTxAf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BPDU_1_fields[] = {
	{ BPDU1_LSBf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BPDU_2_fields[] = {
	{ BPDU2_LSBf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BPDU_3_fields[] = {
	{ BPDU2_MSBf, 16, 16, SOCF_LE },
	{ BPDU1_MSBf, 16, 0, SOCF_LE }
};
soc_reginfo_t soc_registers_5632[] = {

	/* BCM5632 registers */
	{ IFNND(SYS_CONF_1r,) IFREGN("SYS_CONF_1",) ANY_PIC,
		soc_genreg, 0x0000, 16, sr_SYS_CONF_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";System Configuration Register I (Register 00)")
	},
	{ IFNND(SYS_CONF_2r,) IFREGN("SYS_CONF_2",) ANY_PIC,
		soc_genreg, 0x0001, 7, sr_SYS_CONF_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,"; System Configuration Register II (Register 01)")
	},
	{ IFNND(SYS_CONF_3r,) IFREGN("SYS_CONF_3",) ANY_PIC,
		soc_genreg, 0x0002, 15, sr_SYS_CONF_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";System Configuration Register III (Register 02)")
	},
	{ IFNND(EP_SETUP_1r,) IFREGN("EP_SETUP_1",) ANY_PIC,
		soc_genreg, 0x0003, 4, sr_EP_SETUP_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";EEPROM Initialization Setup I (Register 03)")
	},
	{ IFNND(EP_SETUP_2r,) IFREGN("EP_SETUP_2",) ANY_PIC,
		soc_genreg, 0x0004, 3, sr_EP_SETUP_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";EEPROM Initialization Setup II (Register 04)")
	},
	{ IFNND(PRIO_QMAPr,) IFREGN("PRIO_QMAP",) ANY_PIC,
		soc_genreg, 0x0005, 8, sr_PRIO_QMAP_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Priority Queue Assignment Register (Register 05)")
	},
	{ IFNND(DFSV_QMAP_0r,) IFREGN("DFSV_QMAP_0",) ANY_PIC,
		soc_genreg, 0x0006, 8, sr_DFSV_QMAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";DiffServ Queue Assignment Register (Register 06~0D)")
	},
	{ IFNND(DFSV_QMAP_1r,) IFREGN("DFSV_QMAP_1",) ANY_PIC,
		soc_genreg, 0x0007, 8, sr_DFSV_QMAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";DiffServ Queue Assignment Register (Register 06~0D)")
	},
	{ IFNND(DFSV_QMAP_2r,) IFREGN("DFSV_QMAP_2",) ANY_PIC,
		soc_genreg, 0x0008, 8, sr_DFSV_QMAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";DiffServ Queue Assignment Register (Register 06~0D)")
	},
	{ IFNND(DFSV_QMAP_3r,) IFREGN("DFSV_QMAP_3",) ANY_PIC,
		soc_genreg, 0x0009, 8, sr_DFSV_QMAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";DiffServ Queue Assignment Register (Register 06~0D)")
	},
	{ IFNND(DFSV_QMAP_4r,) IFREGN("DFSV_QMAP_4",) ANY_PIC,
		soc_genreg, 0x000a, 8, sr_DFSV_QMAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";DiffServ Queue Assignment Register (Register 06~0D)")
	},
	{ IFNND(DFSV_QMAP_5r,) IFREGN("DFSV_QMAP_5",) ANY_PIC,
		soc_genreg, 0x000b, 8, sr_DFSV_QMAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";DiffServ Queue Assignment Register (Register 06~0D)")
	},
	{ IFNND(DFSV_QMAP_6r,) IFREGN("DFSV_QMAP_6",) ANY_PIC,
		soc_genreg, 0x000c, 8, sr_DFSV_QMAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";DiffServ Queue Assignment Register (Register 06~0D)")
	},
	{ IFNND(DFSV_QMAP_7r,) IFREGN("DFSV_QMAP_7",) ANY_PIC,
		soc_genreg, 0x000d, 8, sr_DFSV_QMAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";DiffServ Queue Assignment Register (Register 06~0D)")
	},
	{ IFNND(QWEIGHT_1Gr,) IFREGN("QWEIGHT_1G",) ANY_PIC,
		soc_genreg, 0x000e, 4, sr_QWEIGHT_1G_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Priority Queue Weighted Round-Robin Control (G port) (Register 0E)")
	},
	{ IFNND(QWEIGHT_10Gr,) IFREGN("QWEIGHT_10G",) ANY_PIC,
		soc_genreg, 0x000f, 4, sr_QWEIGHT_10G_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Priority Queue Weight Round-Robin Control (10 Gigabit port) (Register 0F)")
	},
	{ IFNND(QMAX_1Gr,) IFREGN("QMAX_1G",) ANY_PIC,
		soc_genreg, 0x0010, 4, sr_QMAX_1G_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Output Queue MaxLimit Register (G port or CPU port) (Register 10)")
	},
	{ IFNND(QMAX_10Gr,) IFREGN("QMAX_10G",) ANY_PIC,
		soc_genreg, 0x0011, 4, sr_QMAX_10G_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Output Queue MaxLimit Register11 (10 Gigabit port) (Reg11)")
	},
	{ IFNND(QMGMT_1r,) IFREGN("QMGMT_1",) ANY_PIC,
		soc_genreg, 0x0012, 4, sr_QMGMT_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Output Queue Management Register I (Register 12)")
	},
	{ IFNND(QMGMT_2r,) IFREGN("QMGMT_2",) ANY_PIC,
		soc_genreg, 0x0013, 3, sr_QMGMT_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Output Queue Management Register II (Register 13)")
	},
	{ IFNND(QMGMT_3r,) IFREGN("QMGMT_3",) ANY_PIC,
		soc_genreg, 0x0014, 3, sr_QMGMT_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Output Queue Management Register III (Register 14)")
	},
	{ IFNND(QMGMT_4r,) IFREGN("QMGMT_4",) ANY_PIC,
		soc_genreg, 0x0015, 3, sr_QMGMT_4_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Output Queue Management Register IV (Register 15)")
	},
	{ IFNND(QMGMT_5r,) IFREGN("QMGMT_5",) ANY_PIC,
		soc_genreg, 0x0016, 12, sr_QMGMT_5_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Output Queue Management Register V (Register 16)")
	},
	{ IFNND(BMGMT_1r,) IFREGN("BMGMT_1",) ANY_PIC,
		soc_genreg, 0x0017, 8, sr_BMGMT_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Buffer Management Register I (Register 17)")
	},
	{ IFNND(BMGMT_2r,) IFREGN("BMGMT_2",) ANY_PIC,
		soc_genreg, 0x0018, 3, sr_BMGMT_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Buffer Management Register II (Register 18)")
	},
	{ IFNND(BMGMT_3r,) IFREGN("BMGMT_3",) ANY_PIC,
		soc_genreg, 0x0019, 2, sr_BMGMT_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Buffer Management Register III (Register 19)")
	},
	{ IFNND(BMGMT_4r,) IFREGN("BMGMT_4",) ANY_PIC,
		soc_genreg, 0x001a, 2, sr_BMGMT_4_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Buffer Management Register IV (Register 1A)")
	},
	{ IFNND(BMGMT_5r,) IFREGN("BMGMT_5",) ANY_PIC,
		soc_genreg, 0x001b, 2, sr_BMGMT_5_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Buffer Management Register V (Register 1B)")
	},
	{ IFNND(PHY_CONFr,) IFREGN("PHY_CONF",) ANY_PIC,
		soc_genreg, 0x001c, 5, sr_PHY_CONF_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Vendor Specific PHY Configuration Register (Register 1C)")
	},
	{ IFNND(MAC_CONF_1Gr,) IFREGN("MAC_CONF_1G",) ANY_PIC,
		soc_genreg, 0x001d, 11, sr_MAC_CONF_1G_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";1000Base-T 10/100 MAC Configuration Register (Register 1D)")
	},
	{ IFNND(TRK_SETUP_0r,) IFREGN("TRK_SETUP_0",) ANY_PIC,
		soc_genreg, 0x001e, 2, sr_TRK_SETUP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Trunking Assignment Setup Register (Register 1E~ 23)")
	},
	{ IFNND(TRK_SETUP_1r,) IFREGN("TRK_SETUP_1",) ANY_PIC,
		soc_genreg, 0x001f, 2, sr_TRK_SETUP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Trunking Assignment Setup Register (Register 1E~ 23)")
	},
	{ IFNND(TRK_SETUP_2r,) IFREGN("TRK_SETUP_2",) ANY_PIC,
		soc_genreg, 0x0020, 2, sr_TRK_SETUP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Trunking Assignment Setup Register (Register 1E~ 23)")
	},
	{ IFNND(TRK_SETUP_3r,) IFREGN("TRK_SETUP_3",) ANY_PIC,
		soc_genreg, 0x0021, 2, sr_TRK_SETUP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Trunking Assignment Setup Register (Register 1E~ 23)")
	},
	{ IFNND(TRK_SETUP_4r,) IFREGN("TRK_SETUP_4",) ANY_PIC,
		soc_genreg, 0x0022, 2, sr_TRK_SETUP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Trunking Assignment Setup Register (Register 1E~ 23)")
	},
	{ IFNND(TRK_SETUP_5r,) IFREGN("TRK_SETUP_5",) ANY_PIC,
		soc_genreg, 0x0023, 2, sr_TRK_SETUP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Trunking Assignment Setup Register (Register 1E~ 23)")
	},
	{ IFNND(TRK_DIST_SELr,) IFREGN("TRK_DIST_SEL",) ANY_PIC,
		soc_genreg, 0x0024, 14, sr_TRK_DIST_SEL_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Trunk Distribution Packet Field Selection Register (Register 24)")
	},
	{ IFNND(PMON_CONFr,) IFREGN("PMON_CONF",) ANY_PIC,
		soc_genreg, 0x0025, 4, sr_PMON_CONF_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Monitoring Configuration Register (Register 25)")
	},
	{ IFNND(PENG_CONF_1r,) IFREGN("PENG_CONF_1",) ANY_PIC,
		soc_genreg, 0x0026, 1, sr_PENG_CONF_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,"")
	},
	{ IFNND(PENG_CONF_2r,) IFREGN("PENG_CONF_2",) ANY_PIC,
		soc_genreg, 0x0027, 1, sr_PENG_CONF_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,"")
	},
	{ IFNND(XGMI_CONF_1r,) IFREGN("XGMI_CONF_1",) ANY_PIC,
		soc_genreg, 0x0028, 2, sr_XGMI_CONF_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";XGMII Delimiter and Special Character Code Config Register I (Register 28)")
	},
	{ IFNND(XGMI_CONF_2r,) IFREGN("XGMI_CONF_2",) ANY_PIC,
		soc_genreg, 0x0029, 2, sr_XGMI_CONF_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";XGMII Delimiter and Special Character Code Config Register II (Register 29)")
	},
	{ IFNND(XGMI_CONF_3r,) IFREGN("XGMI_CONF_3",) ANY_PIC,
		soc_genreg, 0x002a, 2, sr_XGMI_CONF_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";XGMII Delimiter and Special Character Code Config Register III (Register 2A)")
	},
	{ IFNND(XGMI_CONF_4r,) IFREGN("XGMI_CONF_4",) ANY_PIC,
		soc_genreg, 0x002b, 5, sr_XGMI_CONF_4_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";XGMII Delimiter and Special Character Code Config Register IV (Register 2B)")
	},
	{ IFNND(XGMI_CONF_5r,) IFREGN("XGMI_CONF_5",) ANY_PIC,
		soc_genreg, 0x002c, 2, sr_XGMI_CONF_5_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,"")
	},
	{ IFNND(AUTH_VLANr,) IFREGN("AUTH_VLAN",) ANY_PIC,
		soc_genreg, 0x002d, 3, sr_AUTH_VLAN_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Authentication Register (Register 2D)")
	},
	{ IFNND(P_CONF_1r,) IFREGN("P_CONF_1",) ANY_GPIC,
		soc_portreg, 0x002e, 12, sr_P_CONF_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Configuration Register I (2E-51 for Giga ports)")
	},
	{ IFNND(P_CONF_2r,) IFREGN("P_CONF_2",) ANY_GPIC,
		soc_portreg, 0x002f, 11, sr_P_CONF_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Configuration Register II (2E-51 for Giga ports)")
	},
	{ IFNND(P_CONF_3r,) IFREGN("P_CONF_3",) ANY_GPIC,
		soc_portreg, 0x0030, 12, sr_P_CONF_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Configuration Register III (2E-51 for Giga ports)")
	},
	{ IFNND(P10G_CONF_1r,) IFREGN("P10G_CONF_1",) ANY_XGPIC,
		soc_portreg, 0x0052, 11, sr_P10G_CONF_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Configuration Register I (2E-51 for Giga ports)")
	},
	{ IFNND(P10G_CONF_2r,) IFREGN("P10G_CONF_2",) ANY_XGPIC,
		soc_portreg, 0x0053, 9, sr_P10G_CONF_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Configuration Register II (2E-51 for Giga ports)")
	},
	{ IFNND(P10G_CONF_3r,) IFREGN("P10G_CONF_3",) ANY_XGPIC,
		soc_portreg, 0x0054, 1, sr_P10G_CONF_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Configuration Register III (2E-51 for Giga ports)")
	},
	{ IFNND(P_VLAN_MAP_0r,) IFREGN("P_VLAN_MAP_0",) ANY_PIC,
		soc_genreg, 0x0055, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_1r,) IFREGN("P_VLAN_MAP_1",) ANY_PIC,
		soc_genreg, 0x0056, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_2r,) IFREGN("P_VLAN_MAP_2",) ANY_PIC,
		soc_genreg, 0x0057, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_3r,) IFREGN("P_VLAN_MAP_3",) ANY_PIC,
		soc_genreg, 0x0058, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_4r,) IFREGN("P_VLAN_MAP_4",) ANY_PIC,
		soc_genreg, 0x0059, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_5r,) IFREGN("P_VLAN_MAP_5",) ANY_PIC,
		soc_genreg, 0x005a, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_6r,) IFREGN("P_VLAN_MAP_6",) ANY_PIC,
		soc_genreg, 0x005b, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_7r,) IFREGN("P_VLAN_MAP_7",) ANY_PIC,
		soc_genreg, 0x005c, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_8r,) IFREGN("P_VLAN_MAP_8",) ANY_PIC,
		soc_genreg, 0x005d, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_9r,) IFREGN("P_VLAN_MAP_9",) ANY_PIC,
		soc_genreg, 0x005e, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_10r,) IFREGN("P_VLAN_MAP_10",) ANY_PIC,
		soc_genreg, 0x005f, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_11r,) IFREGN("P_VLAN_MAP_11",) ANY_PIC,
		soc_genreg, 0x0060, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(P_VLAN_MAP_12r,) IFREGN("P_VLAN_MAP_12",) ANY_PIC,
		soc_genreg, 0x0061, 4, sr_P_VLAN_MAP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";port vlan map")
	},
	{ IFNND(DFT_PORT_PRIORITY_0r,) IFREGN("DFT_PORT_PRIORITY_0",) ANY_PIC,
		soc_genreg, 0x0062, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_1r,) IFREGN("DFT_PORT_PRIORITY_1",) ANY_PIC,
		soc_genreg, 0x0063, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_2r,) IFREGN("DFT_PORT_PRIORITY_2",) ANY_PIC,
		soc_genreg, 0x0064, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_3r,) IFREGN("DFT_PORT_PRIORITY_3",) ANY_PIC,
		soc_genreg, 0x0065, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_4r,) IFREGN("DFT_PORT_PRIORITY_4",) ANY_PIC,
		soc_genreg, 0x0066, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_5r,) IFREGN("DFT_PORT_PRIORITY_5",) ANY_PIC,
		soc_genreg, 0x0067, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_6r,) IFREGN("DFT_PORT_PRIORITY_6",) ANY_PIC,
		soc_genreg, 0x0068, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_7r,) IFREGN("DFT_PORT_PRIORITY_7",) ANY_PIC,
		soc_genreg, 0x0069, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_8r,) IFREGN("DFT_PORT_PRIORITY_8",) ANY_PIC,
		soc_genreg, 0x006a, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_9r,) IFREGN("DFT_PORT_PRIORITY_9",) ANY_PIC,
		soc_genreg, 0x006b, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_10r,) IFREGN("DFT_PORT_PRIORITY_10",) ANY_PIC,
		soc_genreg, 0x006c, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_11r,) IFREGN("DFT_PORT_PRIORITY_11",) ANY_PIC,
		soc_genreg, 0x006d, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(DFT_PORT_PRIORITY_12r,) IFREGN("DFT_PORT_PRIORITY_12",) ANY_PIC,
		soc_genreg, 0x006e, 3, sr_DFT_PORT_PRIORITY_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";default port priority")
	},
	{ IFNND(P_CTYP_0r,) IFREGN("P_CTYP_0",) ANY_GPIC,
		soc_portreg, 0x006f, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_0r,) IFREGN("P_CDFT_0",) ANY_GPIC,
		soc_portreg, 0x0070, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_1r,) IFREGN("P_CTYP_1",) ANY_GPIC,
		soc_portreg, 0x0071, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_1r,) IFREGN("P_CDFT_1",) ANY_GPIC,
		soc_portreg, 0x0072, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_2r,) IFREGN("P_CTYP_2",) ANY_GPIC,
		soc_portreg, 0x0073, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_2r,) IFREGN("P_CDFT_2",) ANY_GPIC,
		soc_portreg, 0x0074, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_3r,) IFREGN("P_CTYP_3",) ANY_GPIC,
		soc_portreg, 0x0075, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_3r,) IFREGN("P_CDFT_3",) ANY_GPIC,
		soc_portreg, 0x0076, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_4r,) IFREGN("P_CTYP_4",) ANY_GPIC,
		soc_portreg, 0x0077, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_4r,) IFREGN("P_CDFT_4",) ANY_GPIC,
		soc_portreg, 0x0078, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_5r,) IFREGN("P_CTYP_5",) ANY_GPIC,
		soc_portreg, 0x0079, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_5r,) IFREGN("P_CDFT_5",) ANY_GPIC,
		soc_portreg, 0x007a, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_6r,) IFREGN("P_CTYP_6",) ANY_GPIC,
		soc_portreg, 0x007b, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_6r,) IFREGN("P_CDFT_6",) ANY_GPIC,
		soc_portreg, 0x007c, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_7r,) IFREGN("P_CTYP_7",) ANY_GPIC,
		soc_portreg, 0x007d, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_7r,) IFREGN("P_CDFT_7",) ANY_GPIC,
		soc_portreg, 0x007e, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_8r,) IFREGN("P_CTYP_8",) ANY_GPIC,
		soc_portreg, 0x007f, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_8r,) IFREGN("P_CDFT_8",) ANY_GPIC,
		soc_portreg, 0x0080, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_9r,) IFREGN("P_CTYP_9",) ANY_GPIC,
		soc_portreg, 0x0081, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_9r,) IFREGN("P_CDFT_9",) ANY_GPIC,
		soc_portreg, 0x0082, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_10r,) IFREGN("P_CTYP_10",) ANY_GPIC,
		soc_portreg, 0x0083, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_10r,) IFREGN("P_CDFT_10",) ANY_GPIC,
		soc_portreg, 0x0084, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_11r,) IFREGN("P_CTYP_11",) ANY_GPIC,
		soc_portreg, 0x0085, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_11r,) IFREGN("P_CDFT_11",) ANY_GPIC,
		soc_portreg, 0x0086, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_12r,) IFREGN("P_CTYP_12",) ANY_GPIC,
		soc_portreg, 0x0087, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_12r,) IFREGN("P_CDFT_12",) ANY_GPIC,
		soc_portreg, 0x0088, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_13r,) IFREGN("P_CTYP_13",) ANY_GPIC,
		soc_portreg, 0x0089, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_13r,) IFREGN("P_CDFT_13",) ANY_GPIC,
		soc_portreg, 0x008a, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_14r,) IFREGN("P_CTYP_14",) ANY_GPIC,
		soc_portreg, 0x008b, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_14r,) IFREGN("P_CDFT_14",) ANY_GPIC,
		soc_portreg, 0x008c, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(P_CTYP_15r,) IFREGN("P_CTYP_15",) ANY_GPIC,
		soc_portreg, 0x008d, 1, sr_P_CTYP_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Class Ethertype & Default Priority Register (Register 6F~7E)")
	},
	{ IFNND(P_CDFT_15r,) IFREGN("P_CDFT_15",) ANY_GPIC,
		soc_portreg, 0x008e, 3, sr_P_CDFT_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";VLAN Classification Default Priority/VLAN 1-4(7F-8E)")
	},
	{ IFNND(TEST_CTL_1r,) IFREGN("TEST_CTL_1",) ANY_PIC,
		soc_genreg, 0x020f, 1, sr_TEST_CTL_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";test_ctl_1")
	},
	{ IFNND(TEST_CTL_2r,) IFREGN("TEST_CTL_2",) ANY_PIC,
		soc_genreg, 0x0210, 1, sr_TEST_CTL_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";test_ctl_2")
	},
	{ IFNND(TEST_CTL_3r,) IFREGN("TEST_CTL_3",) ANY_PIC,
		soc_genreg, 0x0211, 1, sr_TEST_CTL_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";test_ctl_3")
	},
	{ IFNND(TEST_CTL_4r,) IFREGN("TEST_CTL_4",) ANY_PIC,
		soc_genreg, 0x0212, 1, sr_TEST_CTL_4_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";test_ctl_4")
	},
	{ IFNND(TEST_CTL_5r,) IFREGN("TEST_CTL_5",) ANY_PIC,
		soc_genreg, 0x0213, 1, sr_TEST_CTL_5_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";test_ctl_5")
	},
	{ IFNND(TEST_CTL_6r,) IFREGN("TEST_CTL_6",) ANY_PIC,
		soc_genreg, 0x0214, 1, sr_TEST_CTL_6_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";test_ctl_6")
	},
	{ IFNND(TEST_CTL_7r,) IFREGN("TEST_CTL_7",) ANY_PIC,
		soc_genreg, 0x0215, 1, sr_TEST_CTL_7_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";test_ctl_7")
	},
	{ IFNND(HMON_MAC_1r,) IFREGN("HMON_MAC_1",) ANY_PIC,
		soc_genreg, 0x0400, 1, sr_HMON_MAC_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored Host MAC Address Register I (Register 400)")
	},
	{ IFNND(HMON_MAC_2r,) IFREGN("HMON_MAC_2",) ANY_PIC,
		soc_genreg, 0x0401, 1, sr_HMON_MAC_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored Host MAC Address Register II (Register 401)")
	},
	{ IFNND(HMON_MAC_3r,) IFREGN("HMON_MAC_3",) ANY_PIC,
		soc_genreg, 0x0402, 2, sr_HMON_MAC_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored Host MAC Address Register III (Register 402)")
	},
	{ IFNND(VMON_0r,) IFREGN("VMON_0",) ANY_PIC,
		soc_genreg, 0x0403, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_1r,) IFREGN("VMON_1",) ANY_PIC,
		soc_genreg, 0x0404, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_2r,) IFREGN("VMON_2",) ANY_PIC,
		soc_genreg, 0x0405, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_3r,) IFREGN("VMON_3",) ANY_PIC,
		soc_genreg, 0x0406, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_4r,) IFREGN("VMON_4",) ANY_PIC,
		soc_genreg, 0x0407, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_5r,) IFREGN("VMON_5",) ANY_PIC,
		soc_genreg, 0x0408, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_6r,) IFREGN("VMON_6",) ANY_PIC,
		soc_genreg, 0x0409, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_7r,) IFREGN("VMON_7",) ANY_PIC,
		soc_genreg, 0x040a, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_8r,) IFREGN("VMON_8",) ANY_PIC,
		soc_genreg, 0x040b, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_9r,) IFREGN("VMON_9",) ANY_PIC,
		soc_genreg, 0x040c, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_10r,) IFREGN("VMON_10",) ANY_PIC,
		soc_genreg, 0x040d, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_11r,) IFREGN("VMON_11",) ANY_PIC,
		soc_genreg, 0x040e, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_12r,) IFREGN("VMON_12",) ANY_PIC,
		soc_genreg, 0x040f, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_13r,) IFREGN("VMON_13",) ANY_PIC,
		soc_genreg, 0x0410, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_14r,) IFREGN("VMON_14",) ANY_PIC,
		soc_genreg, 0x0411, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_15r,) IFREGN("VMON_15",) ANY_PIC,
		soc_genreg, 0x0412, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_16r,) IFREGN("VMON_16",) ANY_PIC,
		soc_genreg, 0x0413, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_17r,) IFREGN("VMON_17",) ANY_PIC,
		soc_genreg, 0x0414, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_18r,) IFREGN("VMON_18",) ANY_PIC,
		soc_genreg, 0x0415, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_19r,) IFREGN("VMON_19",) ANY_PIC,
		soc_genreg, 0x0416, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_20r,) IFREGN("VMON_20",) ANY_PIC,
		soc_genreg, 0x0417, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_21r,) IFREGN("VMON_21",) ANY_PIC,
		soc_genreg, 0x0418, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_22r,) IFREGN("VMON_22",) ANY_PIC,
		soc_genreg, 0x0419, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_23r,) IFREGN("VMON_23",) ANY_PIC,
		soc_genreg, 0x041a, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_24r,) IFREGN("VMON_24",) ANY_PIC,
		soc_genreg, 0x041b, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_25r,) IFREGN("VMON_25",) ANY_PIC,
		soc_genreg, 0x041c, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_26r,) IFREGN("VMON_26",) ANY_PIC,
		soc_genreg, 0x041d, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_27r,) IFREGN("VMON_27",) ANY_PIC,
		soc_genreg, 0x041e, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_28r,) IFREGN("VMON_28",) ANY_PIC,
		soc_genreg, 0x041f, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_29r,) IFREGN("VMON_29",) ANY_PIC,
		soc_genreg, 0x0420, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_30r,) IFREGN("VMON_30",) ANY_PIC,
		soc_genreg, 0x0421, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(VMON_31r,) IFREGN("VMON_31",) ANY_PIC,
		soc_genreg, 0x0422, 2, sr_VMON_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Monitored VLAN (Register 403~422)")
	},
	{ IFNND(SECVIO_PORTMAPr,) IFREGN("SECVIO_PORTMAP",) ANY_PIC,
		soc_genreg, 0x0423, 14, sr_SECVIO_PORTMAP_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Security Violation Port Map Register (Register 423)")
	},
	{ IFNND(SYS_STATUSr,) IFREGN("SYS_STATUS",) ANY_PIC,
		soc_genreg, 0x0424, 11, sr_SYS_STATUS_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";System Status Register (Register 424)")
	},
	{ IFNND(P_STATUSr,) IFREGN("P_STATUS",) ANY_GPIC,
		soc_portreg, 0x0425, 15, sr_P_STATUS_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Operation Status Register (Register 425~431)")
	},
	{ IFNND(P10G_STATUSr,) IFREGN("P10G_STATUS",) ANY_XGPIC,
		soc_portreg, 0x0431, 15, sr_P10G_STATUS_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Port Operation Status Register (Register 425~431)")
	},
	{ IFNND(CPU_CMDr,) IFREGN("CPU_CMD",) ANY_PIC,
		soc_genreg, 0x0432, 6, sr_CPU_CMD_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";CPU Command Register (Register 432)")
	},
	{ IFNND(TBL_ENTIDr,) IFREGN("TBL_ENTID",) ANY_PIC,
		soc_genreg, 0x0433, 4, sr_TBL_ENTID_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Access Entry ID Register (Register 433)")
	},
	{ IFNND(TBL_SXADDRr,) IFREGN("TBL_SXADDR",) ANY_PIC,
		soc_genreg, 0x0434, 1, sr_TBL_SXADDR_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Search/DMA Address Register (Register 434)")
	},
	{ IFNND(TBL_DBUF_0r,) IFREGN("TBL_DBUF_0",) ANY_PIC,
		soc_genreg, 0x0435, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_1r,) IFREGN("TBL_DBUF_1",) ANY_PIC,
		soc_genreg, 0x0436, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_2r,) IFREGN("TBL_DBUF_2",) ANY_PIC,
		soc_genreg, 0x0437, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_3r,) IFREGN("TBL_DBUF_3",) ANY_PIC,
		soc_genreg, 0x0438, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_4r,) IFREGN("TBL_DBUF_4",) ANY_PIC,
		soc_genreg, 0x0439, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_5r,) IFREGN("TBL_DBUF_5",) ANY_PIC,
		soc_genreg, 0x043a, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_6r,) IFREGN("TBL_DBUF_6",) ANY_PIC,
		soc_genreg, 0x043b, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_7r,) IFREGN("TBL_DBUF_7",) ANY_PIC,
		soc_genreg, 0x043c, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_8r,) IFREGN("TBL_DBUF_8",) ANY_PIC,
		soc_genreg, 0x043d, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(TBL_DBUF_9r,) IFREGN("TBL_DBUF_9",) ANY_PIC,
		soc_genreg, 0x043e, 1, sr_TBL_DBUF_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Table Data Buffers Register (Register 435~43E)")
	},
	{ IFNND(INVr,) IFREGN("INV",) ANY_PIC,
		soc_genreg, 0x043f, 11, sr_INV_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";CPU Interrupt Vector Register (Register 43F)")
	},
	{ IFNND(INV_MSKr,) IFREGN("INV_MSK",) ANY_PIC,
		soc_genreg, 0x0440, 1, sr_INV_MSK_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";CPU Interrupt Vector Mask Register (Register 440)")
	},
	{ IFNND(PKT_CH_PTRSr,) IFREGN("PKT_CH_PTRS",) ANY_PIC,
		soc_genreg, 0x0441, 8, sr_PKT_CH_PTRS_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx/Tx DMA Channel Pointer Register (Register 441)")
	},
	{ IFNND(RX_CH_0r,) IFREGN("RX_CH_0",) ANY_PIC,
		soc_genreg, 0x0442, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_1r,) IFREGN("RX_CH_1",) ANY_PIC,
		soc_genreg, 0x0443, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_2r,) IFREGN("RX_CH_2",) ANY_PIC,
		soc_genreg, 0x0444, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_3r,) IFREGN("RX_CH_3",) ANY_PIC,
		soc_genreg, 0x0445, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_4r,) IFREGN("RX_CH_4",) ANY_PIC,
		soc_genreg, 0x0446, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_5r,) IFREGN("RX_CH_5",) ANY_PIC,
		soc_genreg, 0x0447, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_6r,) IFREGN("RX_CH_6",) ANY_PIC,
		soc_genreg, 0x0448, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_7r,) IFREGN("RX_CH_7",) ANY_PIC,
		soc_genreg, 0x0449, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_8r,) IFREGN("RX_CH_8",) ANY_PIC,
		soc_genreg, 0x044a, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_9r,) IFREGN("RX_CH_9",) ANY_PIC,
		soc_genreg, 0x044b, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_10r,) IFREGN("RX_CH_10",) ANY_PIC,
		soc_genreg, 0x044c, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_11r,) IFREGN("RX_CH_11",) ANY_PIC,
		soc_genreg, 0x044d, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_12r,) IFREGN("RX_CH_12",) ANY_PIC,
		soc_genreg, 0x044e, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_13r,) IFREGN("RX_CH_13",) ANY_PIC,
		soc_genreg, 0x044f, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_14r,) IFREGN("RX_CH_14",) ANY_PIC,
		soc_genreg, 0x0450, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_15r,) IFREGN("RX_CH_15",) ANY_PIC,
		soc_genreg, 0x0451, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_16r,) IFREGN("RX_CH_16",) ANY_PIC,
		soc_genreg, 0x0452, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_17r,) IFREGN("RX_CH_17",) ANY_PIC,
		soc_genreg, 0x0453, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_18r,) IFREGN("RX_CH_18",) ANY_PIC,
		soc_genreg, 0x0454, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_19r,) IFREGN("RX_CH_19",) ANY_PIC,
		soc_genreg, 0x0455, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_20r,) IFREGN("RX_CH_20",) ANY_PIC,
		soc_genreg, 0x0456, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_21r,) IFREGN("RX_CH_21",) ANY_PIC,
		soc_genreg, 0x0457, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_22r,) IFREGN("RX_CH_22",) ANY_PIC,
		soc_genreg, 0x0458, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_23r,) IFREGN("RX_CH_23",) ANY_PIC,
		soc_genreg, 0x0459, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_24r,) IFREGN("RX_CH_24",) ANY_PIC,
		soc_genreg, 0x045a, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_25r,) IFREGN("RX_CH_25",) ANY_PIC,
		soc_genreg, 0x045b, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_26r,) IFREGN("RX_CH_26",) ANY_PIC,
		soc_genreg, 0x045c, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_27r,) IFREGN("RX_CH_27",) ANY_PIC,
		soc_genreg, 0x045d, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_28r,) IFREGN("RX_CH_28",) ANY_PIC,
		soc_genreg, 0x045e, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_29r,) IFREGN("RX_CH_29",) ANY_PIC,
		soc_genreg, 0x045f, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_30r,) IFREGN("RX_CH_30",) ANY_PIC,
		soc_genreg, 0x0460, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(RX_CH_31r,) IFREGN("RX_CH_31",) ANY_PIC,
		soc_genreg, 0x0461, 1, sr_RX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Rx DMA Channel Address Registers (Register 442~461)")
	},
	{ IFNND(TX_CH_0r,) IFREGN("TX_CH_0",) ANY_PIC,
		soc_genreg, 0x0462, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_1r,) IFREGN("TX_CH_1",) ANY_PIC,
		soc_genreg, 0x0463, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_2r,) IFREGN("TX_CH_2",) ANY_PIC,
		soc_genreg, 0x0464, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_3r,) IFREGN("TX_CH_3",) ANY_PIC,
		soc_genreg, 0x0465, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_4r,) IFREGN("TX_CH_4",) ANY_PIC,
		soc_genreg, 0x0466, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_5r,) IFREGN("TX_CH_5",) ANY_PIC,
		soc_genreg, 0x0467, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_6r,) IFREGN("TX_CH_6",) ANY_PIC,
		soc_genreg, 0x0468, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_7r,) IFREGN("TX_CH_7",) ANY_PIC,
		soc_genreg, 0x0469, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_8r,) IFREGN("TX_CH_8",) ANY_PIC,
		soc_genreg, 0x046a, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_9r,) IFREGN("TX_CH_9",) ANY_PIC,
		soc_genreg, 0x046b, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_10r,) IFREGN("TX_CH_10",) ANY_PIC,
		soc_genreg, 0x046c, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_11r,) IFREGN("TX_CH_11",) ANY_PIC,
		soc_genreg, 0x046d, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_12r,) IFREGN("TX_CH_12",) ANY_PIC,
		soc_genreg, 0x046e, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_13r,) IFREGN("TX_CH_13",) ANY_PIC,
		soc_genreg, 0x046f, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_14r,) IFREGN("TX_CH_14",) ANY_PIC,
		soc_genreg, 0x0470, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_15r,) IFREGN("TX_CH_15",) ANY_PIC,
		soc_genreg, 0x0471, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_16r,) IFREGN("TX_CH_16",) ANY_PIC,
		soc_genreg, 0x0472, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_17r,) IFREGN("TX_CH_17",) ANY_PIC,
		soc_genreg, 0x0473, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_18r,) IFREGN("TX_CH_18",) ANY_PIC,
		soc_genreg, 0x0474, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_19r,) IFREGN("TX_CH_19",) ANY_PIC,
		soc_genreg, 0x0475, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_20r,) IFREGN("TX_CH_20",) ANY_PIC,
		soc_genreg, 0x0476, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_21r,) IFREGN("TX_CH_21",) ANY_PIC,
		soc_genreg, 0x0477, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_22r,) IFREGN("TX_CH_22",) ANY_PIC,
		soc_genreg, 0x0478, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_23r,) IFREGN("TX_CH_23",) ANY_PIC,
		soc_genreg, 0x0479, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_24r,) IFREGN("TX_CH_24",) ANY_PIC,
		soc_genreg, 0x047a, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_25r,) IFREGN("TX_CH_25",) ANY_PIC,
		soc_genreg, 0x047b, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_26r,) IFREGN("TX_CH_26",) ANY_PIC,
		soc_genreg, 0x047c, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_27r,) IFREGN("TX_CH_27",) ANY_PIC,
		soc_genreg, 0x047d, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_28r,) IFREGN("TX_CH_28",) ANY_PIC,
		soc_genreg, 0x047e, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_29r,) IFREGN("TX_CH_29",) ANY_PIC,
		soc_genreg, 0x047f, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_30r,) IFREGN("TX_CH_30",) ANY_PIC,
		soc_genreg, 0x0480, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(TX_CH_31r,) IFREGN("TX_CH_31",) ANY_PIC,
		soc_genreg, 0x0481, 1, sr_TX_CH_0_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Frame Tx DMA Channel Address Registers (Register 462~481)")
	},
	{ IFNND(BPDU_1r,) IFREGN("BPDU_1",) ANY_PIC,
		soc_genreg, 0x0482, 1, sr_BPDU_1_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Customer BPDU Register I (Register 482)")
	},
	{ IFNND(BPDU_2r,) IFREGN("BPDU_2",) ANY_PIC,
		soc_genreg, 0x0483, 1, sr_BPDU_2_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Customer BPDU Register II (Register 483)")
	},
	{ IFNND(BPDU_3r,) IFREGN("BPDU_3",) ANY_PIC,
		soc_genreg, 0x0484, 2, sr_BPDU_3_fields
		IFRSTI(,0x0,0xFFFF)
		IFDESC(,";Customer BPDU Register III (Register 484)")
	}};

/* BCM5632 memory blocks. */
soc_block_t sm_BCM5632_blocks[] = {
	ANY_PIC
};

/* BCM5632 memory fields. */
soc_fieldinfo_t sm_L2_L7__fields[] = {
	{IncCntrf, 16, 300, SOCF_LE},
	{UncondFwdf, 1, 299, SOCF_LE},
	{CondDropf, 1, 298, SOCF_LE},
	{CP_Portnumf, 4, 294, SOCF_LE},
	{CpPktf, 1, 293, SOCF_LE},
	{QueueNumf, 2, 291, SOCF_LE},
	{RplQuef, 1, 290, SOCF_LE},
	{VlanPrif, 3, 287, SOCF_LE},
	{RplVprif, 1, 286, SOCF_LE},
	{Vidf, 12, 274, SOCF_LE},
	{RplVidf, 1, 273, SOCF_LE},
	{Dscpf, 8, 265, SOCF_LE},
	{RplDscpf, 1, 264, SOCF_LE},
	{Portnumf, 4, 260, SOCF_LE},
	{RplPortnumf, 1, 259, SOCF_LE},
	{PortEnablef, 13, 246, SOCF_LE},
	{FLDDEqf, 1, 245, SOCF_LE},
	{FLDDMaskf, 8, 237, SOCF_LE},
	{FLDDf, 8, 229, SOCF_LE},
	{FLDCEqf, 1, 228, SOCF_LE},
	{FLDCMaskf, 8, 220, SOCF_LE},
	{FLDCf, 8, 212, SOCF_LE},
	{FLDBEqf, 1, 211, SOCF_LE},
	{FLDBMaskf, 8, 203, SOCF_LE},
	{FLDBf, 8, 195, SOCF_LE},
	{FLDAEqf, 1, 194, SOCF_LE},
	{FLDAMaskf, 8, 186, SOCF_LE},
	{FLDAf, 8, 178, SOCF_LE},
	{TOSEqf, 1, 177, SOCF_LE},
	{TOSMaskf, 8, 169, SOCF_LE},
	{TOSf, 8, 161, SOCF_LE},
	{PROTEqf, 1, 160, SOCF_LE},
	{PROTMaskf, 8, 152, SOCF_LE},
	{PROTf, 8, 144, SOCF_LE},
	{TSSEqf, 1, 143, SOCF_LE},
	{TSSMaskf, 16, 127, SOCF_LE},
	{TSSf, 16, 111, SOCF_LE},
	{TDSEqf, 1, 110, SOCF_LE},
	{TDSMaskf, 16, 94, SOCF_LE},
	{TDSf, 16, 78, SOCF_LE},
	{IPSAMaskAllf, 1, 77, SOCF_LE},
	{IPSAEqf, 1, 76, SOCF_LE},
	{IPSAMaskf, 5, 71, SOCF_LE},
	{IPSAf, 32, 39, SOCF_LE},
	{IPDAMaskAllf, 1, 38, SOCF_LE},
	{IPDAEqf, 1, 37, SOCF_LE},
	{IPDAMaskf, 5, 32, SOCF_LE},
	{IPDAf, 32, 0, SOCF_LE},
};
soc_fieldinfo_t sm_VLAN__fields[] = {
	{PortMapf, 14, 40, SOCF_LE},
	{OutputTagUntagf, 14, 26, SOCF_LE},
	{PortStatef, 26, 0, SOCF_LE},
};
soc_fieldinfo_t sm_ARL_5632__fields[] = {
	{MacAddr0f, 8, 67, SOCF_LE},
	{MacAddr1f, 8, 59, SOCF_LE},
	{MacAddr2f, 8, 51, SOCF_LE},
	{MacAddr3f, 8, 43, SOCF_LE},
	{MacAddr4f, 8, 35, SOCF_LE},
	{MacAddr5f, 8, 27, SOCF_LE},
	{VLANIdf, 12, 15, SOCF_LE},
	{DestinationPortf, 6, 9, SOCF_LE},
	{TimeStampf, 7, 2, SOCF_LE},
	{validf, 1, 1, SOCF_LE},
	{Staticf, 1, 0, SOCF_LE},
};
soc_fieldinfo_t sm_EEPROM__fields[] = {
	{ValueEEPROMf, 16, 0, SOCF_LE},
};
/* end of BCM5632 memory fields. */
soc_meminfo_t soc_memories_5632[] = {
	/* BCM5632 memories. */
	{ IFNND(L2_L7_m, ) IFMEMN("L4_",) 0,
		1, sm_BCM5632_blocks, 0x0, 40,
		48, sm_L2_L7__fields
	},
	{ IFNND(VLAN_m, ) IFMEMN("VLAN_",) 0,
		1, sm_BCM5632_blocks, 0x0, 7,
		3, sm_VLAN__fields
	},
	{ IFNND(ARL_5632_m, ) IFMEMN("ARL_5632_",) 0,
		1, sm_BCM5632_blocks, 0x0, 10,
		11, sm_ARL_5632__fields
	},
	{ IFNND(EEPROM_m, ) IFMEMN("EEPROM_",) 0,
		1, sm_BCM5632_blocks, 0x0, 2,
		1, sm_EEPROM__fields
	},
/* end of BCM5632 memories. */
};

char *socreg_info_5632(soc_reg_t idx) {
        static char tmp[128];
        sprintf(tmp,"\t%s - %s",
#ifdef NO_REG_NAMES
                "A SOC register",
#else
                soc_registers_5632[idx].name,
#endif
                soc_registers_5632[idx].desc
        );
        return tmp;
}

uint32 reg_addr_5632(soc_reg_t reg, ...)
{
    va_list ap;
    uint32 idx;

    va_start(ap, reg);
    switch (reg) {
       /* VLAN Classification regs */
       case P_CTYP_0r:
       case P_CTYP_1r:
       case P_CTYP_2r:
       case P_CTYP_3r:
       case P_CTYP_4r:
       case P_CTYP_5r:
       case P_CTYP_6r:
       case P_CTYP_7r:
       case P_CTYP_8r:
       case P_CTYP_9r:
       case P_CTYP_10r:
       case P_CTYP_11r:
       case P_CTYP_12r:
       case P_CTYP_13r:
       case P_CTYP_14r:
       case P_CTYP_15r:
       case P_CDFT_0r:
       case P_CDFT_1r:
       case P_CDFT_2r:
       case P_CDFT_3r:
       case P_CDFT_4r:
       case P_CDFT_5r:
       case P_CDFT_6r:
       case P_CDFT_7r:
       case P_CDFT_8r:
       case P_CDFT_9r:
       case P_CDFT_10r:
       case P_CDFT_11r:
       case P_CDFT_12r:
       case P_CDFT_13r:
       case P_CDFT_14r:
       case P_CDFT_15r:
            idx = va_arg(ap, int);
            if (idx < NUM_E_PORT_5632)
                return (reg + (idx * 32));
            break;
       /* GE port config regs */
       case P_CONF_1r: 
       case P_CONF_2r: 
       case P_CONF_3r: 
            idx = va_arg(ap, int);
            if (idx < NUM_GE_PORT_5632)
                return (reg + (idx * 3));
            break;
       case P_STATUSr:
	   case P_VLAN_MAP_0r:
	   case DFT_PORT_PRIORITY_0r:
            idx = va_arg(ap, int);
            if (idx < NUM_E_PORT_5632)
                return (reg + idx);
            break;
       default:
            /* All other regs */
            return reg;
    }
    return (-1);
}

soc_fieldinfo_t *find_field_5632(
 soc_field_t field, unsigned n, soc_fieldinfo_t *fields
) {
        int i;

        for(i=0; i<n; i++) {
                if(fields[i].field == field) {
                        return &(fields[i]);
                }
        }
        return 0;
}

/* Fixes the endianness of 'v' based on '*f'. */
#define FIX_REG_VALUE_E(v,f) \
if(!((f)->flags & SOCF_LE)) { \
        int tmp=0; \
        int i; \
        for(i=0; i<(f)->len; i++) { \
                tmp=(tmp<<1)|((v)&1); \
                (v)>>=1; \
        } \
        (v)=tmp; \
}

uint32 get_reg_field_5632(
 soc_reg_t reg, uint32 current, soc_field_t field
) {
        soc_reginfo_t *reginfo=&(soc_registers_5632[reg]);
        soc_fieldinfo_t *fieldinfo;
        uint32 value;

        fieldinfo=find_field_5632(field,reginfo->nFields,reginfo->fields);
        value=(current>>fieldinfo->bp)&((1<<(fieldinfo->len-1)<<1)-1);
        FIX_REG_VALUE_E(value,fieldinfo);
        return value;
}

uint32 set_reg_field_5632(
 soc_reg_t reg, uint32 current, soc_field_t field, uint32 value
) {
        soc_reginfo_t *reginfo=&(soc_registers_5632[reg]);
        soc_fieldinfo_t *fieldinfo;
        int mask;

        fieldinfo=find_field_5632(field,reginfo->nFields,reginfo->fields);
        FIX_REG_VALUE_E(value,fieldinfo);
        mask=(1<<(fieldinfo->len-1)<<1)-1;
        return (current&~(mask<<fieldinfo->bp))|value<<fieldinfo->bp;
}

/* flags can be SOCF_RO, SOCF_WO, or zero (read/write) */

uint32 get_reg_datamask_5632(soc_reg_t reg, int flags) {
        int i, start, end;
        soc_fieldinfo_t *fieldp;
        soc_reginfo_t *regp;
        uint32 result=0;

        regp=&(soc_registers_5632[reg]);
        for(i=0; i<regp->nFields; i++) {
                fieldp=&(regp->fields[i]);
                if ((fieldp->flags & flags) == flags) {
                        start=fieldp->bp;
                        end=fieldp->bp+fieldp->len-1;
                        result |= ((-1<<start) & ((1<<end<<1)-1));
                }
        }
        return result;
}

/* This is inefficient, because it does a lookup for each field. */
void sprint_reg_data_5632(
        char *bp, char *infix, soc_reg_t reg, uint32 value
) {
        int i,n;
        soc_field_t field;
        int len;
        char buf[24];

        n=soc_registers_5632[reg].nFields;
        for(i=0; i<n; i++) {
                field=soc_registers_5632[reg].fields[i].field;
                len=soc_registers_5632[reg].fields[i].len;
                if(i==n-1) {
                        infix="";
                }
                sprintf(buf,"#%%d = 0x%%0%dx%%s",(len+3)>>2);
                sprintf(bp,buf,
                        field, get_reg_field_5632(reg,value,field), infix
                );
                while(*bp) bp++;
        }
}

/* to fix 32-bit-word order for BCM5632 LE */
#define FIX_MEM_ORDER_E(v,m) (BYTES2WORDS((m)->bytes)-1-(v))

uint32 *get_mem_field_5632(
 soc_mem_t mem, uint32 *entbuf, soc_field_t field, uint32 *fldbuf
) {
        soc_meminfo_t *meminfo=&(soc_memories_5632[mem]);
        soc_fieldinfo_t *fieldinfo;
        int i,wp,bp,len;

        fieldinfo=find_field_5632(field,meminfo->nFields,meminfo->fields);
        bp=fieldinfo->bp;
        if (fieldinfo->flags & SOCF_LE) {
                wp=bp>>5;
                bp=bp & 0x1f;
                i=0;
                for(len=fieldinfo->len; len>0; len-=32) {
                        if(bp) {
                                fldbuf[i] =
                                 entbuf[FIX_MEM_ORDER_E(wp++,meminfo)]>>bp &
                                 ((1<<(32-bp))-1);
                                fldbuf[i] |=
                                 entbuf[FIX_MEM_ORDER_E(wp,meminfo)]<<(32-bp);
                        }
                        else {
                                fldbuf[i]=entbuf[FIX_MEM_ORDER_E(wp++,meminfo)];
                        }
                        if(len<32) {
                                fldbuf[i] &= ((1<<len)-1);
                        }
                        i++;
                }
        }
        else {
                len=fieldinfo->len;
                i=(len-1)>>5;
                while(len>0) {
                        fldbuf[i]=0;
                        do {
                                fldbuf[i]=
                                 (fldbuf[i]<<1) |
                                 (
                                  (entbuf[FIX_MEM_ORDER_E(bp>>5,meminfo)] >>
                                        (bp&0x1f)
                                  )&1
                                 );
                                len--;
                                bp++;
                        } while(len & 0x1f);
                        i--;
                }
        }
        return fldbuf;
}

uint32 *set_mem_field_5632(
 soc_mem_t mem, uint32 *entbuf, soc_field_t field, uint32 *fldbuf
) {
        soc_meminfo_t *meminfo=&(soc_memories_5632[mem]);
        soc_fieldinfo_t *fieldinfo;
        uint32 mask;
        int i,wp,bp,len;

        fieldinfo=find_field_5632(field,meminfo->nFields,meminfo->fields);
        bp=fieldinfo->bp;
        if(fieldinfo->flags & SOCF_LE) {
                wp=bp>>5;
                bp=bp & 0x1f;
                i=0;
                for(len=fieldinfo->len; len>0; len-=32) {
                        if(bp) {
                                if(len<32) {
                                        mask=(1<<len)-1;
                                }
                                else {
                                        mask=-1;
                                }
                                entbuf[FIX_MEM_ORDER_E(wp,meminfo)] &=
                                        ~(mask<<bp);
                                entbuf[FIX_MEM_ORDER_E(wp++,meminfo)] |=
                                        fldbuf[i]<<bp;
                                entbuf[FIX_MEM_ORDER_E(wp,meminfo)] &=
                                        ~(mask>>(32-bp));
                                entbuf[FIX_MEM_ORDER_E(wp,meminfo)] |=
                                        fldbuf[i]>>(32-bp) & ((1<<bp)-1);
                        }
                        else {
                                if(len<32) {
                                        mask=(1<<len)-1;
                                        entbuf[FIX_MEM_ORDER_E(wp,meminfo)] &=
                                                ~mask;
                                        entbuf[FIX_MEM_ORDER_E(wp++,meminfo)]|=
                                                fldbuf[i]<<bp;
                                }
                                else {
                                        entbuf[FIX_MEM_ORDER_E(wp++,meminfo)] =
                                                fldbuf[i];
                                }
                        }
                        i++;
                }
        }
        else /* Big endian: swap bits */ {
                len=fieldinfo->len;
                while(len>0) {
                        len--;
                        entbuf[FIX_MEM_ORDER_E(bp>>5,meminfo)] &=
                                ~(1<<(bp&0x1f));
                        entbuf[FIX_MEM_ORDER_E(bp>>5,meminfo)] |=
                                (fldbuf[len>>5]>>(len&0x1f) & 1) << (bp&0x1f);
                        bp++;
                }
        }
        return entbuf;
}

unsigned get_mem_field_numwords_5632(soc_mem_t mem, soc_field_t field) {
        soc_meminfo_t *meminfo;
        soc_fieldinfo_t *fieldinfo;

        meminfo=&(soc_memories_5632[mem]);
        fieldinfo=find_field_5632(field,meminfo->nFields,meminfo->fields);
        return (fieldinfo->len+31)>>5;
}

unsigned get_mem_numbytes_5632(soc_mem_t mem) {
        soc_meminfo_t *meminfo;

        meminfo=&(soc_memories_5632[mem]);
        return meminfo->bytes;
}

uint32 *zero_mem_value_5632(soc_mem_t mem, uint32 *buf) {
        int i;

        for(i=0; i<BYTES2WORDS(get_mem_numbytes_5632(mem)); i++) {
                buf[i]=0;
        }
        return buf;
}

uint32 *get_mem_datamask_5632(soc_mem_t mem, uint32 *buf) {
        int f, b, start, end;
        soc_fieldinfo_t *fieldp;
        soc_meminfo_t *memp;
        uint32 tmp;

        (void) zero_mem_value_5632(mem,buf);
        memp=&(soc_memories_5632[mem]);
        for(f=0; f<memp->nFields; f++) {
                fieldp=&(memp->fields[f]);
                if (!(fieldp->flags & SOCF_RES)) { /* not reserved */
                    start=fieldp->bp;
                    end=fieldp->bp+fieldp->len-1;
                    for(b=start>>5; b<=end>>5; b++) {
                        tmp=-1;
                        if(b==start>>5) {
                                tmp &= -1<<(start%32);
                        }
                        if(b==end>>5) {
                                tmp &= (1<<(end%32)<<1)-1;
                        }
                        buf[FIX_MEM_ORDER_E(b,memp)] |= tmp;
                    }
                }
        }
        return buf;
}


/* Return the min/max Port Number for this type of PIC */
soc_port_t minport_5632(soc_block_t block) {
        switch(block) {
        case ANY_GPIC:
        case ANY_PIC:
                return(0);
        case ANY_XGPIC:
                return(NUM_GE_PORT_5632);
                default:
                return -1;
        }
}
soc_port_t maxport_5632(soc_block_t block) {
        switch(block) {
        case ANY_GPIC:
        case ANY_PIC:
                return(NUM_GE_PORT_5632-1);
        case ANY_XGPIC:
                return(NUM_XGE_PORT_5632+NUM_GE_PORT_5632-1);
                default: 
                return -1; 
        }
}

