/*
 *-----------------------------------------------------------------
 *
 * Name:	cache.c
 *
 * RCS:  $Id: cache-util.c,v 1.1 2001/12/08 21:53:36 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	cache verification routines
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/4/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>


uint32	mips_icache_size;
uint32	mips_icache_linesize;
uint32	mips_icache_ways;

uint32	mips_dcache_size;
uint32	mips_dcache_linesize;
uint32	mips_dcache_ways;

uint32	mips_scache_size;
uint32	mips_scache_linesize;
uint32	mips_scache_ways;
uint32	mips_scache_split;
uint32	mips_scache_discontig;

uint32	mips_tcache_size;
uint32	mips_tcache_linesize;
uint32	mips_tcache_ways;

/*-----------------------------------------------------------------
 * Name:	is_primary_cached_data(addr)
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/4/01
 *
 *-----------------------------------------------------------------
 */
is_primary_cached_data(
	void	* addr
)
{
	/*
	 *
	 * Get cache tag index
	 * foreach set in cache (4-way) {
	 *		read tag
	 *		is (cache valid) && (addr == tag)
	 * }
	 *
	 */




}	/* is_primary_cached_data() */

/*-----------------------------------------------------------------
 * Name:	is_secondary_cached_data(addr)
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/4/01
 *
 *-----------------------------------------------------------------
 */
is_secondary_cached_data(
	void	* addr
)
{
	/*
	 *
	 * Get cache tag index
	 * foreach set in cache (4-way) {
	 *		read tag
	 *		is (cache valid) && (addr == tag)
	 * }
	 *
	 */



}	/* is_secondary_cached_data() */

/*-----------------------------------------------------------------
 * Name:	is_cached_data(addr)
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/4/01
 *
 *-----------------------------------------------------------------
 */
is_cached_data(
	void	* addr
)
{
	/*
	 * 1. Check secondary cache
	 * 2. Check primary cache
	 */
	if (is_secondary_cached_data(addr))
		return 1;
	else if (is_primary_cached_data(addr))
		return 1;
	else
		return 0;

}	/* is_cached_data() */

