/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2002, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-rpc-ed-hdr.h,v 1.1.1.1 2002/04/23 17:47:36 laurentb Exp $
 *
 * Name			: cifs-rpc-ed-hdr.h
 *
 * Description	: CIFS DCE/RPC headers encode & decode functions. 
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 01/08/2002
 *
 *-----------------------------------------------------------------
 */

#ifndef _CIFS_RPC_ED_HDR_H
#define _CIFS_RPC_ED_HDR_H


int32	//NFX_OK or NFX_ERR
cifsrpc_decodeHeader(cifsrpc_pipe *rpip, uchar8 *datp, uint32 bytesToWriteCnt);


int32	//NFX_OK or NFX_ERR
cifsrpc_encodeHeader(cifsrpc_pipe *rpip, uchar8 packetType, uchar8 flags,
						uint32 fragLen, uint32 authLen, uint32 callId);


int32	//NFX_OK or NFX_ERR
cifsrpcEDinterf(cifsrpc_ed *edp, cifsrpc_intf *ifp, char *label, uchar8 lv);


int32	//NFX_OK or NFX_ERR
cifsrpcEDbindRequest(cifsrpc_ed *edp, cifsrpc_bindReq *bp, uchar8 lv);


int32	//NFX_OK or NFX_ERR
cifsrpcEDbindAck(cifsrpc_ed *edp, cifsrpc_bindAck *bp, uchar8 lv);


int32	//NFX_OK or NFX_ERR
cifsrpcEDrequestHdr(cifsrpc_ed *edp, cifsrpc_reqHdr *rp, uchar8 lv);


int32	//NFX_OK or NFX_ERR
cifsrpcEDresponseHdr(cifsrpc_ed *edp, cifsrpc_respHdr *rp, uchar8 lv);


int32   //NFX_OK or NFX_ERR
cifsrpc_encodeResponseHeader(cifsrpc_pipe *rpip, uint32 allocHint);


int32	//NFX_OK or NFX_ERR
cifsrpcEDfault(cifsrpc_ed *edp, cifsrpc_faultHdr *fp, uchar8 lv);

#endif // #ifndef _CIFS_RPC_ED_HDR_H
