/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-api.h,v 1.1.1.1 2002/04/23 17:41:15 laurentb Exp $
 *
 * Name			: cifs-api.h
 *
 * Description	: CIFS module api header
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 10/31/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _CIFS_API_H
#define _CIFS_API_H


#ifdef LINUX_TEST

#define CIFSTEST

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#endif

#ifdef FS_STANDALONE

#include "../sm-fs/fs-includes.h"
#include "../ssc-cifsauth/cifsauth-api.h"
#include "../sm-fssf/fssf-api.h"
#include "../sm-cifs/nfp-objects-api.h"
#include "../sm-netbios/nb-api.h"
#include "../sm-cifs/cifs-sec.h"
#include "../sm-cifs-rpc/cifs-rpc-api.h"
#include "../sm-cifs/cifs.x"

#define eee_freePacket(eDescp) {}

#else	//FS_STANDALONE

#include <nfx-incl.h>
#include <exports/cm-api.h>
#include <exports/malloc-api.h>
#include <exports/eee-api.h>
#include <exports/queue-api.h>
#include <exports/thread-api.h>
#include <exports/elog-api.h>
#include <exports/tpl-api.h>
#include <exports/evm-api.h>
#include <exports/fs-api.h>
#include <exports/cifsauth-api.h>
#include <exports/fssf-api.h>
#include <exports/nfp-objects-api.h>
#include <exports/nb-api.h>
#include <exports/cifs-sec.h>
#include <exports/cifs-rpc-api.h>
#include <exports/cifs.x>

#endif	//FS_STANDALONE

int32 cifs_init(void);

#endif

