/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-string.h,v 1.1.1.1 2002/04/23 17:41:16 laurentb Exp $
 * 
 * Name			: cifs-string.h
 *
 * Description	: CIFS string tools functions header
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 03/19/2002
 *
 *-----------------------------------------------------------------
 */
#ifndef _CIFS_STRING_H
#define _CIFS_STRING_H

#define	cifs_getSmbUniStr(dstp, srcp, maxl, smbp)				\
		cifs_getUniStr(dstp, srcp, maxl, 						\
		((GETLE2(smbp, SMBO_FLG2) & SMB_FLG2_UNICODE) != 0))
		



char *
cifs_spaces(uchar8 level);

		
char *
cifs_strcpy(char *dstp, const char *srcp);


uchar8*	//pointer on address after the SOURCE string ending 0, NULL if error
cifs_getUniStr(uni16		*dstp,
				uchar8		*srcp,
				ushort16	maxDstLenInByte,
				boolean		uniSrc);	//The source string is UNICODE or not


int32			//Size of destination string in bytes including terminating '\0'
cifs_putUniStr(	uchar8	*dstp,	//Destination string in UNICODE or ASCII
	            uni16	*srcp,	//Source string in UNICODE
				uchar8	*smbp,	//Destination SMB message pointer
				uint32	*dstStrLenInBytes,
				uint32	maxDestLenInBytes);


int32			//Size of destination string in bytes including terminating '\0'
cifs_putStr(uchar8	*dstp,	//Destination string in UNICODE or ASCII
            uchar8	*srcp,	//Source string in ASCII
			uchar8	*smbp,	//Destination SMB message pointer
			uint32	*dstStrLenInBytes,
			uint32	maxDestLenInBytes);


void cutString(uni16 *s, uni16 *start, uni16 *end);


#endif	//_CIFS_STRING_H

