/*
 *------------------------------------------------------------------------------
 *
 * Name:        ispfc_debug.h
 *
 * RCS:         $Id: debug.c,v 1.5 2002/10/25 23:43:53 janv Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description: Runtime assertion (and more) code.
 *
 * Created by:  Radek Aster
 *
 * Date Created: 8/24/01
 *
 *------------------------------------------------------------------------------
 */
#include <nfx-incl.h>
#include "debug.h"

void 
__assert_fail (char *assertion, 
               char *file,
               uint32 line,
               char *function)
{
#define MAX_SIZE_ASSERT_STR 512
        char msg[MAX_SIZE_ASSERT_STR];
#define MAX_SIZE_FUNC_STR 128
        char infunc[MAX_SIZE_FUNC_STR];

        if (function == NULL)
                *infunc = '\0';
        else
                snprintf(infunc, MAX_SIZE_FUNC_STR, " in %s", function);
        
        snprintf(msg, MAX_SIZE_ASSERT_STR, "%s:%d: ASSERTION failure \"%s\"%s",
                file, line, assertion, infunc);
        panic(msg);
}

