/*
 * Definitions for TCP and UDP client/server programs using I/O Multiplexing
 */

#ifndef INET_H_INCLUDED
#define INET_H_INCLUDED

#define SERV_HOST_ADDR "10.1.1.41"
#define SERV_TCP_PORT 7234

#define LISTENQ 5
#define MAXBUF  10000 // optimize!!!

#ifndef SHUT_WR
#define SHUT_WR 1
#endif

#define AV_MAX_USERID		256
#define AV_MAX_PASSWORD		256

#define EL_OK				NFX_OK
#define EL_NOTLOGIN			(EL_OK+1)
#define EL_NOTCONNECTED		(EL_OK+2)


typedef struct
{
	uint64          isPCC;                  // 1 - PCC, 0 - Non PCC
	char			nodeName[LNM_MAX_NODE_NAME];
	char            clusterName[LNM_MAX_CLUSTER_NAME];
	char            avUserid[AV_MAX_USERID];   
	char            avPassword[AV_MAX_PASSWORD];
	uint32			avIp;
} el_config_t;

/* 
 * Message type
 */
typedef enum
{
	EL_CONFIG_NTFY 	 = EL_MSG_BASE,     // EL config from Regm
	EL_CONFIG_SET_REQ,                  // EL config from CLI
	EL_CONFIG_VIEW_REQ                  // EL view request from CLI
} el_msgType_t;

typedef struct
{
	el_msgType_t	msgType;    // the message type SHALL always be first
	struct
	{
		char	option[128];
		char	value[256];
	} entry;
} el_msg_t;

#endif
