/*
 *-----------------------------------------------------------------
 *
 * Name:	esm.h
 *
 * RCS:  $Id: esm.h,v 1.15 2002/11/07 01:22:00 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:   Definitions and prototypes for module internals.
 *
 * Created by:	Bob Fozard
 *
 * Date Created:	3/20/01
 *
 *-----------------------------------------------------------------
 */

typedef struct esm_event_qelem_t esm_event_qelem_t;
struct esm_event_qelem_t
{
    esm_event_t                     event;
    eeeRTC_t                        qTime;
    DLL_ENTRY(esm_event_qelem_t)    dllEntry;
};

enum
{
    ESM_QUEUE_PRI_HI,
    ESM_QUEUE_PRI_LO,
    ESM_QUEUE_PRI_MAX,
};

typedef struct esm_instance_t esm_instance_t;
struct esm_instance_t
{
	esm_table_t 	 			*table;
    int32                       index;
	ushort16				    currentState;
	ushort16					flags;
#define ESM_CAN_YIELD        0x0001  // this type of ESM can call
                                     // esm_yield()
#define ESM_YIELD            0x0002  // this ESM instance is in
                                     // esm_yield()
#define ESM_RUNNING          0x0004  // CAN_YIELD ESM thread has
                                     // been created
#define ESM_IS_BUSY          0x0008  // ESM is busy with an executive
#define ESM_DESTROY          0x0010  // Deferred destroy
	void						*userInfo;
	esm_handle_t				handle;
    DLL_HDR(esm_event_qelem_t)  eventQueueHdr;
	int32                       qcount;
    DLL_ENTRY(esm_instance_t)   queueEntry;
    address_t                   stackBase;
    address_t                   savedStackPtr;
    int32                       stackSize; // TODO - save base+size in base?
    esm_event_t                 event;
    DLL_ENTRY(esm_instance_t)   yieldQueueEntry;
    int32                       waitSecs;
#ifdef LINUX_TEST
    int32                       threadNum;
#endif

	// List of spinlocks held by this thread
	LIST_HEAD(, spinlock)		sm_spinlocksHeld;
};

#define ESM_GET_HANDLE_INDEX(_handle_)              \
	((_handle_) & 0xffff)

extern esm_instance_t *esm_currInst;
extern int32 esm_instance_curr_size;
extern esm_instance_t **esm_instance_ptrs;

void
esm_initPlatform(
);

void
esm_runThreadEvent(
	esm_instance_t		*esm,
	esm_event_t			event
);

void
esm_readPollInd(
    int32   count
);

void
esm_writePollInd(
    int32   count
);

esm_instance_t *
esm_getInstFromHandle(
	esm_handle_t    handle
);

void
esm_destroy_esm(
    esm_instance_t  *esm
);

int32
esm_allocStack(
    esm_instance_t  *esm
);

int32
esm_destroyed(
    esm_instance_t  *esm
);

void
esm_threadLongJump(
    esm_instance_t  *esm
);

int32
esm_enqueueEvent(
    esm_instance_t  *esm,
    esm_event_t     event,
    int32           queuePriority
);

/*------------------------------------------------------------------*/
void
esm_stackInit();

address_t
esm_stackAlloc();

void
esm_stackDealloc(
    address_t   ptr
);

void
esm_stackViewStats();

