/*------------------------------------------------------------------------------
 * RCS:  $Id: evm-srvr-includes.h,v 1.16 2002/09/27 21:18:59 isabellec Exp $
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Name         : evm-srvr-includes.h
 *
 * Description  : includes for the EVM SRVR
 *
 * Created by   : Lan Chin
 *
 * Date Created : 28-SEP-2001
 *
 *------------------------------------------------------------------------------
 */

#if !defined(EVM_SRVR_INCLUDES_H)
#define EVM_SRVR_INCLUDES_H

#ifdef LINUX_TEST
#include <stdio.h>      // fprintf(), stderr
#include <stdlib.h>     // exit()
#include <string.h>     // memset()
#endif // LINUX_TEST

#include "nfx-incl.h"

#include "exports/eee-desc.h"
#include "exports/eee-app.h"
#include "exports/malloc-api.h"
#include "exports/eee-drv.h"
#include "exports/cm-api.h"
#include "exports/eee-error.h"
#include "exports/esm-api.h"
#include "exports/eee-desc.h"
#include "exports/sbm-api.h"
#include "exports/scsi-api.h"
#include "exports/sdm-agent-api.h"
#include "exports/timer-api.h"
#include "exports/dp-proxy.h"
#include "exports/queue-api.h"

#include "../sm-evm/evm_com_defs.h"
#include "../sm-evm/evm-api.h"
#include "../sm-evm/evm_loc_defs.h"

#include "evm-srvr-defines.h"
#include "evm-srvr-structs.h"

/*------------------------------------------------------------------------------
 * Global variables.
 *------------------------------------------------------------------------------
 */

extern evm_stats_t  evm_stats;
extern uint32       evmSrvrPort;
extern int32        evmAppId;
extern int32        sacAppId;
extern int32        sbmAppId;
extern int32        eaAppId;
extern boolean      evmDoAssert;
extern boolean      evmDoTstamp;
extern evm_volErr_t evmErrors;
DLL_HDR(evm_vol_t)  evm_volList;

#ifdef DEBUG
extern int32        perfAppId;
#endif

/*------------------------------------------------------------------------------
 * Function prototypes.
 *------------------------------------------------------------------------------
 */

void
evm_postEvt(uint32      event,
            evm_volId_t volId,
            int			state);

/*----------------------------------------------------------------------------*/
#endif /* EVM_SRVR_INCLUDES_H */
