/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: except.h,v 1.10 2002/11/05 00:44:05 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	3/2/02
 *
 *-----------------------------------------------------------------
 */

#ifndef _EXCEPT_H
#define _EXCEPT_H

#ifdef LANGUAGE_C
void exc_install_handler(
    uchar8  * dest,
    uchar8  * src,
    uchar8  * src_end,
    uint32  max_len
);

void tlb_refill_exception();
void xtlb_refill_exception();
void cache_error_exception();
void general_exception();
void interrupt_exception();

void intr_init();
void rm_bpts();
void dbgmode();

#define load_byte(adr)  (*(byte *)(adr))
#define load_half(adr)  (*(ushort16 *)(adr))
#define load_word(adr)  (*(unsigned long *)(adr))
#define load_dword(adr) (*(unsigned long long *)(adr))
#define load_reg(adr)   (*(sreg_t *)(adr))
#define load_int(adr)   (*(int *)(adr))

#endif

/*
 * From PMON's pmon.h
 */
#if __mips >= 3
#define REGSZ       8
#define sr          sd
#define lr          ld
#define MTC0        dmtc0
#define MFC0        dmfc0
#else
#define REGSZ       4
#define sr          sw
#define lr          lw
#define MTC0        mtc0
#define MFC0        mfc0
#endif

#define SREG(reg,rno,base)  sr  reg,+((rno)*REGSZ)(base)
#define LREG(reg,rno,base)  lr  reg,+((rno)*REGSZ)(base)

#define R_ENTRYHI   34
#define R_ENTRYLO   35
#define R_ENTRYLO0  35
#define R_INDEX     36
#define R_RANDOM    37

#define R_STATUS    38
#define R_CAUSE     39
#define R_EPC       40
#define R_CONTEXT   41
#define R_BADVA     42
#define R_PRID      43
#define R_K1TMP     44

#if defined(R4000)
#define R_ENTRYLO1  45
#define R_PGMASK    46
#define R_WIRED     47
#define R_CONFIG    48
#define R_LLADDR    49
#define R_WATCHLO   50
#define R_WATCHHI   51
#define R_ECC       52
#define R_CACHERR   53
#define R_TAGLO     54
#define R_TAGHI     55
#define R_ERREPC    56
#define R_XCONTEXT  57
#define R_WATCHMASK 58
#define R_ICR       59
#define R_IPLLO     60
#define R_IPLHI     61
#define R_INFO      62
#define NONFPREGS   63
#endif

#ifdef TX3927
#define R_ERREPC	R_EPC
#define R_CONFIG	45
#define R_PGMASK	46
#define R_WIRED		47
#define R_CACHE		48
#define R_DEBUG		49
#define R_DEPC		50
#define R_TAGLO		51
#define NONFPREGS   52
#endif

#define NREGS	NONFPREGS

#ifdef LANGUAGE_C
extern cpureg_t	EXC_DBGREG[];
extern uchar8	* excodes[];
extern uchar8	* exc_getname(uint32 cause);
extern uint32	running_under_gdb;
extern uchar8	* gpr_regs[];
extern uchar8	* cp0_regs[];
#endif

/* regsize states */
#define REGSZ_32    0
#define REGSZ_64    1

#endif	/* _EXCEPT_H */

