/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: nmi.S,v 1.5 2002/09/07 19:51:47 bob Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/8/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>
#include "except-api.h"
#include "except.h"

LEAF(exc_nmi_handler)
	.set	noat

#ifdef R4000
	mfc0    k0,C0_SR
	li		k1,~SR_ERL
	and     k0,k1
	mtc0	k0,C0_SR
#endif

	la	k0,EXC_DBGREG
	SREG(k1,R_K1TMP,k0)

	la  k1,EXC_DBGREG
	SREG(t0,R_T0,k1)        /* $8  (t0) */
	move    t0,k1           # now use t0 as pointer
	LREG(k1,R_K1TMP,t0)
	SREG(AT,R_AT,t0)        /* $1  (AT) */
	.set at
	SREG(v0,R_V0,t0)        /* $2  (v0) */
	SREG(v1,R_V1,t0)        /* $3  (v1) */
	SREG(a0,R_A0,t0)        /* $4  (a0) */
	SREG(a1,R_A1,t0)        /* $5  (a1) */
	SREG(a2,R_A2,t0)        /* $6  (a2) */
	SREG(a3,R_A3,t0)        /* $7  (a3) */
	SREG(t1,R_T1,t0)        /* $9  (t1) */
	SREG(t2,R_T2,t0)        /* $10 (t2) */
	SREG(t3,R_T3,t0)        /* $11 (t3) */
	SREG(t4,R_T4,t0)        /* $12 (t4) */
	SREG(t5,R_T5,t0)        /* $13 (t5) */
	SREG(t6,R_T6,t0)        /* $14 (t6) */
	SREG(t7,R_T7,t0)        /* $15 (t7) */
	SREG(s0,R_S0,t0)        /* $16 (s0) */
	SREG(s1,R_S1,t0)        /* $17 (s1) */
	SREG(s2,R_S2,t0)        /* $18 (s2) */
	SREG(s3,R_S3,t0)        /* $19 (s3) */
	SREG(s4,R_S4,t0)        /* $20 (s4) */
	SREG(s5,R_S5,t0)        /* $21 (s5) */
	SREG(s6,R_S6,t0)        /* $22 (s6) */
	SREG(s7,R_S7,t0)        /* $23 (s7) */
	SREG(t8,R_T8,t0)        /* $24 (t8) */
	SREG(t9,R_T9,t0)        /* $25 (t9) */
	/* $26 (k0) */
	SREG(k1,R_K1,t0)        /* $27 (k1) */
	SREG(gp,R_GP,t0)        /* $28 (gp) */
	SREG(sp,R_SP,t0)        /* $29 (sp) */
	SREG(s8,R_FP,t0)        /* $30 (s8) */
	SREG(ra,R_RA,t0)        /* $31 (ra) */
	
	mfhi    t1
	mflo    t2
	SREG(t1,R_HI,t0)        /* Hi */
	SREG(t2,R_LO,t0)        /* Lo */
	
	.set noreorder
	
#ifdef R7000
	mfc0    t1,C0_INX
	SREG(t1,R_INDEX,t0)         /* Index */
	mfc0    t1,C0_RAND
	SREG(t1,R_RANDOM,t0)        /* Random */
	MFC0    t1,C0_TLBLO
	SREG(t1,R_ENTRYLO,t0)       /* TLB EntryLo */
	MFC0    t1,C0_TLBLO1
	SREG(t1,R_ENTRYLO1,t0)      /* TLB EntryLo1 */
	MFC0    t1,C0_CTEXT
	SREG(t1,R_CONTEXT,t0)       /* Context */
	mfc0    t1,C0_PGMASK
	SREG(t1,R_PGMASK,t0)        /* TLB PageMask */
	mfc0    t1,C0_WIRED
	SREG(t1,R_WIRED,t0)         /* TLB Wired */
	MFC0    t1,C0_BADVADDR
	SREG(t1,R_BADVA,t0)         /* BadVA */
	MFC0    t1,C0_TLBHI
	SREG(t1,R_ENTRYHI,t0)       /* TLB EntryHi */
	mfc0    t1,C0_PRID
	SREG(t1,R_PRID,t0)          /* Prid */
	mfc0    t1,C0_CONFIG
	SREG(t1,R_CONFIG,t0)        /* Config */
	mfc0    t1,C0_LLADDR
	SREG(t1,R_LLADDR,t0)        /* LLAddr */
	MFC0    t1,C0_WATCHLO
	SREG(t1,R_WATCHLO,t0)       /* WatchLo */
	MFC0    t1,C0_WATCHHI
	SREG(t1,R_WATCHHI,t0)       /* WatchHi */
	MFC0    t1,C0_XCTEXT
	SREG(t1,R_XCONTEXT,t0)      /* XContext */
	mfc0    t1,C0_WATCHMASK
	SREG(t1,R_WATCHMASK,t0)     /* WatchLo */
	mfc0    t1,C0_ECC
	SREG(t1,R_ECC,t0)           /* ECC */
	mfc0    t1,C0_CACHEERR
	SREG(t1,R_CACHERR,t0)       /* CacheErr */
	mfc0    t1,C0_TAGLO
	SREG(t1,R_TAGLO,t0)         /* Taglo */
	mfc0    t1,C0_TAGHI
	SREG(t1,R_TAGHI,t0)         /* TagHi */
	MFC0    t1,C0_ERREPC
	SREG(t1,R_ERREPC,t0)        /* ErrorEPC */
	
	cfc0    t1,C0C_ICR
	SREG(t1,R_ICR,t0)           /* ICR */
	cfc0    t1,C0C_IPLLO
	SREG(t1,R_IPLLO,t0)         /* IPLLo */
	cfc0    t1,C0C_IPLHI
	SREG(t1,R_IPLHI,t0)         /* IPLHi */
	
	MTC0    zero,C0_WATCHLO
	MTC0    zero,C0_WATCHHI
	ctc0    zero,C0C_ICR
	ctc0    zero,C0C_IPLLO
	ctc0    zero,C0C_IPLHI
#endif

#ifdef SB1250
	mfc0    t1,C0_INX
	SREG(t1,R_INDEX,t0)         /* Index */
	mfc0    t1,C0_RAND
	SREG(t1,R_RANDOM,t0)        /* Random */
	MFC0    t1,C0_TLBLO
	SREG(t1,R_ENTRYLO,t0)       /* EntryLo */
	MFC0    t1,C0_TLBLO1
	SREG(t1,R_ENTRYLO1,t0)      /* TLB EntryLo1 */
	MFC0    t1,C0_CTEXT
	SREG(t1,R_CONTEXT,t0)       /* Context */
	mfc0    t1,C0_PGMASK
	SREG(t1,R_PGMASK,t0)        /* TLB PageMask */
	mfc0    t1,C0_WIRED
	SREG(t1,R_WIRED,t0)         /* TLB Wired */
	MFC0    t1,C0_BADVADDR
	SREG(t1,R_BADVA,t0)         /* BadVA */
	MFC0    t1,C0_TLBHI
	SREG(t1,R_ENTRYHI,t0)       /* EntryHi */
	mfc0    t1,C0_PRID
	SREG(t1,R_PRID,t0)          /* Prid */
	mfc0    t1,C0_CONFIG
	SREG(t1,R_CONFIG,t0)        /* Config */
	MFC0    t1,C0_LLADDR
	SREG(t1,R_LLADDR,t0)        /* LLAddr */
	MFC0    t1,C0_WATCHLO
	SREG(t1,R_WATCHLO,t0)       /* WatchLo */
	MFC0    t1,C0_WATCHHI
	SREG(t1,R_WATCHHI,t0)       /* WatchHi */
	MFC0    t1,C0_XCTEXT
	SREG(t1,R_XCONTEXT,t0)      /* XContext */
	mfc0    t1,C0_ECC
	SREG(t1,R_ECC,t0)           /* ECC */
	mfc0    t1,C0_CACHEERR
	SREG(t1,R_CACHERR,t0)       /* CacheErr */
	mfc0    t1,C0_TAGLO
	SREG(t1,R_TAGLO,t0)         /* Taglo */
	mfc0    t1,C0_TAGHI
	SREG(t1,R_TAGHI,t0)         /* TagHi */
	MFC0    t1,C0_ERREPC
	SREG(t1,R_ERREPC,t0)        /* ErrorEPC */
	
	MTC0    zero,C0_WATCHLO
	MTC0    zero,C0_WATCHHI
#endif
	
	mfc0    a0,C0_CAUSE
	MFC0    a1,C0_EPC
	mfc0    t3,C0_SR
	SREG(a0,R_CAUSE,t0)         /* Cause */
	SREG(a1,R_EPC,t0)           /* EPC */
	mtc0    zero,C0_CAUSE       /* Clear pending watchpoint */
#ifdef R4000
	# save the SR value but clear EXL bit to
	# reflect state before the exception
	and     t3,~SR_ERL      # switch off EXL bit
#else
	# save the SR value but fixup the KU & IE bits to
	# reflect their state before the exception
	li      t1,0x3f         # KU&IE mask
	and     t2,t3,t1        # extract KU&IE bits
	not     t1              # invert the mask
	and     t3,t1           # clear KU&IE field
	srl     t2,2            # fixup KU&IE field
	or      t3,t2           # insert the KU&IE field
#endif
	SREG(t3,R_STATUS,t0)    # save Status
	
#ifndef SSC_MGMT
	mfc0	a1,C0_ERREPC
#endif
	
	# switch us back to the correct kernel/interrupt mode, but with
	# all external interrupts masked out.
	#   lw      t3,initial_sr
	and     t3,~SR_IMASK
	mtc0    t3,C0_SR
	.set reorder
	
###### Need to re-setup the stack (mainly when getting here from BSD) 
.extern stack
        la      sp,stack+STKSIZE-24

	move    a2,ra
	la  t0,exception_nmi
	j   t0
	
END(exc_nmi_handler)

