#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <assert.h>

/*
 * twiddle: generate all combinations of upper- and lower- case
 * of a given input string.
 *
 * Example: "twiddle abc" gives:
 * 
 * 	abc
 * 	abC
 * 	aBc
 * 	aBC
 * 	Abc
 * 	AbC
 * 	ABc
 * 	ABC
 * 
 */

static char *str;

static void
twiddle(char *s, int i)
{
	if (i == 0) {
		puts(str);
		return;
	}

	*s = tolower(*s);
	twiddle(s+1, i-1);
	*s = toupper(*s);
	twiddle(s+1, i-1);
}

int
main(int argc, char *argv[])
{
	assert(argc == 2);
	str = argv[1];
	twiddle(str, strlen(str));
	return 0;
}
