/*
 * Name		: fs-link.h
 * RCS		: $ID$
 * Description	: link table implementation definations
 * Created by	: Rahul Khona
 * Date Created	: 8/10/2001
 */

typedef struct fs_LinkEntry {
    fs_Inumber      inum;
    fs_Inumber      parent;
    uint32          numLinks;
} fs_LinkEntry_t;

/*
 * Prototypes
 */

extern fs_Status fs_findParent(fs_Context *, uint64, fs_Inumber,
                                         fs_Inumber *, uint64 *);
extern fs_Status fs_addLink(fs_Context *, uint64, fs_Inode *, fs_Inumber);
extern fs_Status fs_removeLink(fs_Context *, uint64, fs_Inode *, fs_Inumber);
extern void fs_eek_link_inode(fs_Context *, uint32, boolean);
