/*
 *-----------------------------------------------------------------
 *
 * Name:	gmc-util.c
 *
 * RCS:  $Id: gmc-util.c,v 1.3 2002/02/04 18:26:13 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/26/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#ifndef SBM_REMOVE_GMC
#include "../sm-sbm/sbm-gmc.h"
#include "gmc.h"

/*-----------------------------------------------------------------
 * Name:	gmc_fill_sac_block()
 *
 * Description:	Initialize a sac block to 0's
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/26/01
 *
 *-----------------------------------------------------------------
 */
void
gmc_fill_sac_block(
	uint32	index,
	uint32	fill
)
{
	uint32	* addr;
	uint32	i;

	addr = (uint32 *)&(gmc->sac[index * gmc_regs->gmc_sac_block_size]);

	GMC_TRACE(("gmc_fill_sac_block, sac at 0x%x\n", gmc->sac));
	GMC_TRACE(("                    filling index %d at 0x%x with 0x%x\n",
															index, addr, fill));

	for (i=0; i<gmc_regs->gmc_sac_block_size/4; i++)
		addr[i] = fill;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
uchar8 *
gmc_getSACBlockAddr(
	uint32	index)
{
	return &(gmc->sac[index * gmc_regs->gmc_sac_block_size]);

}

#endif	/* !SBM_REMOVE_GMC */
