/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: timer.c,v 1.2 2002/10/14 22:02:17 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	2/25/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/hwMap.h>
#include <sys/mips.h>
#include <sys/gt64240r.h>
#include <exports/except-api.h>

/*-----------------------------------------------------------------
 * Name:	timer_start_us
 *
 * Description:	
 *
 *				Parameter is in microseconds.
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/30/01
 *
 *-----------------------------------------------------------------
 */
void
timer_start_us(
	uint32	timer_num,
	uint32	us,
	void	(* int_func)(uint32, uint32, address_t)
)
{
	volatile uint32 * tptr_value;
	volatile uint32 * tptr_control;
	volatile uint32 * tptr_imask;
	volatile uint32 * tptr_icause;
	volatile uint32 * imask_low;

	uint32  tclk_cnt = get_busclock() * us;

	switch (timer_num) {
		case 3:
			imask_low = (volatile uint32 *)PHYS_TO_K1(
							HW_GALILEO_BASE + CPU_INTERRUPT_MASK_REGISTER_LOW);
			*imask_low |= 0x200;

			tptr_value = (volatile uint32 *)PHYS_TO_K1(
											HW_GALILEO_BASE + TIMER_COUNTER3);
			tptr_control = (volatile uint32 *)PHYS_TO_K1(
									HW_GALILEO_BASE + TIMER_COUNTER_0_3_CONTROL);
			tptr_imask = (volatile uint32 *)PHYS_TO_K1(
							HW_GALILEO_BASE + TIMER_COUNTER_0_3_INTERRUPT_MASK);
			tptr_icause = (volatile uint32 *)PHYS_TO_K1(
							HW_GALILEO_BASE + TIMER_COUNTER_0_3_INTERRUPT_CAUSE);

			*tptr_value = tclk_cnt;
			*tptr_imask |= 0x8;
			*tptr_control &= ~0xFF000000;
			*tptr_control |= 0x03000000;       /* timer mode | enable */

			break;

		default:
			panic("timer %d unsupported\n", timer_num);
	}

#if 0
	gtint_intr_registerHandler(2, int_func);
#endif
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	2/21/02
 *
 *-----------------------------------------------------------------
 */
void
timer_stop(
	uint32	timer_num
)
{
	volatile uint32 * tptr_control;
	volatile uint32 * imask_low;

	switch (timer_num) {
		case 3:
			imask_low = (volatile uint32 *)PHYS_TO_K1(
							HW_GALILEO_BASE + CPU_INTERRUPT_MASK_REGISTER_LOW);
			*imask_low &= ~0x200;

			tptr_control = (volatile uint32 *)PHYS_TO_K1(
									HW_GALILEO_BASE + TIMER_COUNTER_0_3_CONTROL);

			*tptr_control &= ~0xFF000000;

			break;

		default:
			panic("timer %d unsupported\n", timer_num);
	}

#if 0
	gtint_intr_unregisterHandler(2);
#endif
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/24/02
 *
 *-----------------------------------------------------------------
 */
void
timer_int_clear(
	uint32	timer_num
)
{
	volatile uint32 * tptr_icause;

	switch (timer_num) {
		case 3:
			tptr_icause = (volatile uint32 *)PHYS_TO_K1(
							HW_GALILEO_BASE + TIMER_COUNTER_0_3_INTERRUPT_CAUSE);

			*tptr_icause &= ~0x8;		/* clear interrupt from TC3 */

			break;

		default:
			panic("timer %d unsupported\n", timer_num);
	}
}

