/*
 *-----------------------------------------------------------------
 *
 * Name:	hash-api.h
 *
 * RCS:  $Id: hash-api.h,v 1.2 2002/03/11 18:45:58 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	Hash Table API function prototypes
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/3/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _HASH_API_H
#define _HASH_API_H

#define	HT_ERR_DATA_IN_USE		-1

address_t	hash_create(	uint32	num_buckets,
							uint32	(*hash)(),
							int32	(*compare)(),
							void	(*release)());

void	hash_destroy(	address_t	htp);

int32	hash_insert(	address_t	htp,
						void		* key,
						void		* data);

void *	hash_lookup(	address_t	htp,
						void		* key,
						void		* data);

void *	hash_delete(	address_t	htp,
						void		* key,
						void		* data);

#endif	/* _HASH_API_H */

