/*
 *-----------------------------------------------------------------
 *
 * Name:	hash.h
 *
 * RCS:  $Id: hash.h,v 1.2 2002/11/22 23:22:48 maximk Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	Hash Table definitions
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/3/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _HASH_H
#define _HASH_H

typedef struct ht_item {
	struct ht_item	* next;
	void			* data;
} ht_item_t;

typedef struct ht {
	ht_item_t	** head;
	uint32		(* hash)();
	int32		(* compare)();
	void		(* release)();
	uint32		num_buckets;
	nfx_spinlock_t ht_spin;
} ht_t;



ht_item_t *	hash_getNode();

void	hash_freeNode(	ht_item_t	* htp);

#endif	/* _HASH_H */

