/*
 *-----------------------------------------------------------------
 *
 * Name:	vs-hash-api.h
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2003, Agile Storage Inc.
 *
 * Description:	Virtual server hash table API function prototypes
 *
 * Created by:	Xiaobing Zhang
 *
 * Date Created:	01/15/03
 *
 *-----------------------------------------------------------------
 */

#ifndef _VS_HASH_API_H
#define _VS_HASH_API_H

#include <exports/vs-mem-api.h>

#define	VS_HT_ERR_DATA_IN_USE		-1

address_t           /* returns hash table handle, or NULL */
vs_hash_create(
	uint32  num_buckets,
	uint32  (* hash)(
				void    * key
			),
	int32   (* compare)(
				vs_mem_index_t	ht_data,
				vs_mem_index_t	search_data
			),
	void    (* release)(
				vs_mem_index_t	data
			)
);

void	vs_hash_destroy(	address_t	htp);

int32	vs_hash_insert(	address_t		htp,
						void			* key,
						vs_mem_index_t	data);

vs_mem_index_t	vs_hash_lookup(	address_t		htp,
								void			* key,
								vs_mem_index_t	data);

vs_mem_index_t	vs_hash_delete(	address_t		htp,
								void			* key,
								vs_mem_index_t	data);

#endif	/* _VS_HASH_API_H */

