/*
 *------------------------------------------------------------------------------
 *
 * Name:	ispfc_channels.h
 *
 * RCS:		$Id: ispfc_channels.h,v 1.2 2001/07/13 00:24:18 raster Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	QLogic 2300 FC HAL channel definitions.
 *
 * Created by:	Radek Aster
 *
 * Date Created: 6/6/01
 *
 *------------------------------------------------------------------------------
 */

#ifndef __ISPFC_CHANNELS_H__

#define __ISPFC_CHANNELS_H__

#define MAX_CHANNEL_NAME_LEN		64

typedef struct {
	wwn_t		channel_wwn;
	char		channel_name[MAX_CHANNEL_NAME_LEN];
	byte		channel_interface_type;
	union {
	  struct { /* Valid if channel_interface_type == HAL_IF_FC_L_PORT */
			byte	     channel_ha_bus_id;
			byte	     channel_ha_dev_id;
		} fc_l;
		struct { /* Valid if channel_interface_type == HAL_IF_FC_[N|NL]_PORT */
			byte	     channel_ha_bus_id;
			byte	     channel_ha_dev_id;
			wwn_t	     channel_peer_wwn;
		} fc_n_or_fc_nl;
		struct { /* Valid if channel_interface_type == HAL_IF_FC_[F|FL]_PORT */
			byte	     channel_phys_port;
			wwn_t	     channel_switch_wwn;
			uint32       channel_fl_port;
		} fc_f_or_fc_fl;
	} u;
} channel_name_t;

int ispfc_channel_add(channel_name_t *);
int ispfc_channel_remove(channel_name_t *);
int ispfc_channel_lookup(channel_name_t *);
int ispfc_channel_set_fl_port(channel_name_t *);

void ispfc_channels_dump(void);

#endif /* __ISPFC_CHANNELS_H__ */


