#include "ispfc_private.h"
#include "ispfc_trace.h"

ispfc_trace_t *tr = NULL;
uint32 tr_inited = 0;

void 
ispfc_trace_init(void)
{
	tr = eee_ramAlloc(sizeof(ispfc_trace_t));
	bzero(tr, sizeof(ispfc_trace_t));
	tr_inited = 1;
}


void 
ispfc_trace_add(uint32 op_type, uint32 lba, uint32 lbc)
{
	if (tr_inited == 0)
		ispfc_trace_init();
	tr->elems[tr->index].op_type = op_type;
	tr->elems[tr->index].lba     = lba;
	tr->elems[tr->index].lbc     = lbc;
	if (++tr->index == TRACE_DEPTH)
		tr->index = 0;
}

void 
ispfc_trace_dump(int32 count)
{
	int32 index;
	int32 i;

	if (tr_inited == 0)
		ispfc_trace_init();

	index = tr->index - count;
	if (index < 0)
		index += TRACE_DEPTH;

	for (i = 0; i < count; ++i) {
		printf("[%4d] ", i - count);
		switch(tr->elems[index].op_type) {
		case TR_FC_WRITE_DISPATCH:	 printf("FW  "); break;
		case TR_FC_WRITE_RESPONSE:	 printf("FWR "); break;
		case TR_SCSI_WRITE_REQUEST:	 printf("SW  "); break;
		case TR_SCSI_WRITE_RESPONSE:	 printf("SWR "); break;
		default: VERIFY(0);
		}
		printf("%8d/%3d\n", tr->elems[index].lba, tr->elems[index].lbc);

		if (++index > TRACE_DEPTH)
			index = 0;
	}
}

