/*
 *-----------------------------------------------------------------
 *
 * Name:	atoi.c
 *
 * RCS:  $Id: atoi.c,v 1.3 2002/10/24 17:30:58 swang Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	converts p to int
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/03/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

int32
atoi (
	const char8	* p
)
{
	int32	digit, isneg;
	int32	value;

	isneg = 0;
	value = 0;

	for (; isspace (*p); p++);	/* gobble up leading whitespace */

	/* do I have a sign? */
	if (*p == '-') {
		isneg = 1;
		p++;
	} else if (*p == '+')
		p++;

	for (; *p; p++) {
		if (*p >= '0' && *p <= '9') {
			value *= 10; 	
			digit = *p - '0';
		}
		else 
			break;
		value += digit;
	}

	if (isneg)
		value = 0 - value;

	return (value);

}	/* atoi() */

