/*
 *-----------------------------------------------------------------
 *
 * Name:	atollx.c
 *
 * RCS:  $Id: atollx.c,v 1.2 2001/10/03 18:10:31 maximk Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	converts p to long long
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/8/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

uint64 atollx (
	uint64	* value,
	char8	* p
)
{
	int32	digit;
	uint64	v;
	uint32	c;

	v = 0;

	for (; isspace (*p); p++);	/* gobble up leading whitespace */

	if ((*p == '0') && (*(p+1) == 'x'))
		p+=2;

	for (; *p; p++) {
		v *= 16;
		c = *p;
		if (c >= '0' && c <= '9')
			digit = c - '0';
		else if (c >= 'a' && c <= 'f')
			digit = c - 'a' + 10;
		else if (c >= 'A' && c <= 'F')
			digit = c - 'A' + 10;
		else
			break;
		v += digit;
	}

	*value = v;

	return (v);
}	/* atollx() */

