/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-help.c,v 1.2 2002/04/06 23:22:27 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>

void
mdk_help_sub(uchar8 *line, uint32 num_basic, uint32 num_restr,mdk_package_t ** pkgPtr)
{
	uchar8	* str;
	uint32    test_num;

			str = getToken(line + 1);
			if(str == NULL){	
			       printf("help <test no>\n");	
			} 
			else 
			{
				if(isdigit(str[0]))
				{
					test_num = atoi(str);
					if (test_num < num_basic)
						printf("%s\n",((*pkgPtr)->basicTests[test_num]).testHelp);
					else if(test_num < num_basic + num_restr)
						printf("%s\n",((*pkgPtr)->restrictedTests[test_num - num_basic]).testHelp);
					else
						printf("Unknown test number %d\n", test_num);
				}
				else {
				     switch (str[0]) {
					case 'a':
					case 'A':
						printf(" This will run all the tests listed above sequentially.\n");
						printf(" If you want to run an individual test, enter the test no.\n");
						printf(" You can also list multiple tests on the same command line.\n");
						break;

					case 'l':
					case 'L':
						printf("l <n> <test>. Runs test/tests n number of times.\n");
						break;

					case 'o':
					case 'O':
						printf("This allows the user to enter additional test parameters.\n");
						break;

					case 'u':
					case 'U':
						printf(" Brings you tp the top level menu\n");
						break;

					case 'q':
					case 'Q':
						printf(" Quits the program\n");
						break;
						
					break;
					default:
					break;
				}
			}	
		}		
}


void
mdk_help_top(uchar8 *line)
{
	uchar8	* str;
	uint32    pkg_num;

			str = getToken(line + 1);
			if(str == NULL){	
			       printf("help <pkg no>\n");	
			} else {
			     switch (str[0]) {
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
					pkg_num = atoi(str);
					if (pkg_num < mdkp->num_pkgs )
						printf("%s\n", mdk_package_list[pkg_num]->menuHelp);
					else
						printf("Unknown package number %d\n", pkg_num);
					break;

				case 'a':
				case 'A':
					printf(" This will run all the tests listed above sequentially.\n");
					printf(" If you want to run an individual test, enter the test no.\n");
					printf(" You can also list multiple tests on the same command line.\n");
					break;

				case 'e':
				case 'E':
					printf("The log captures the errors encountered while running tests.\n");
					printf("You can erase the log by entering 'z' on the command line.\n");
					break;
				
				
				case 'l':
				case 'L':
					printf("You can run test/tests this many number of times.\n");
					break;
				case 'o':
				case 'O':
					printf("This is not supported now.\n");
					break;

				case 'q':
				case 'Q':
					printf(" Quits the program\n");
					break;
					
				case 'z':
				case 'Z':
					printf("This zeros all the entries in the error log.\n");
					printf("Do not use this option if you still want to keep the error log.\n");
				break;
				default:
				break;
			     }
			}

}

