/*
 *-----------------------------------------------------------------
 *
 * Name:	mdk-menu.c
 *
 * RCS:  $Id: mdk-menu.c,v 1.1.1.1 2002/03/26 01:43:51 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_show_menu(
	int32	pg_num
)
{
	uchar8			str[LINE_WIDTH];
	mdk_package_t	** package;
	uint32			i;

	clear_screen();

	sprintf(str, "Version %s", mdkp->version);
	center(str, LINE_WIDTH);
	sprintf(str, "%s   %s", mdkp->date, mdkp->time);
	center(str, LINE_WIDTH);

	printf("\n");
	printf("A = Acceptance Test     B = Burn In     O = Set Options     H = Help\n");
	printf("Test Packages:\n");
	package = &(mdkp->pkg[pg_num * MDK_PACKAGES_PER_PAGE]);
	i = 0;
	while (1) {
		if (i == MDK_PACKAGES_PER_PAGE)
			break;
		if (!(*package))
			break;
		printf("    %4d: %-20s  %-20s\n", (pg_num * MDK_PACKAGES_PER_PAGE)+i,
								(*package)->menuName, (*package)->menuComment);
		package++;
		i++;
	}
	printf("\n");
	if (pg_max == 0)
		printf("                                                            Q = Quit\n");
	else if (pg_num == pg_max)
		printf("                                        - = Prev Page       Q = Quit\n");
	else if (pg_num == 0)
		printf("                        + = Next Page                       Q = Quit\n");
	else
		printf("                        + = Next Page   - = Prev Page       Q = Quit\n");
		printf("             E = Error Log   Z = Zero Log\n");
	printf("Enter Selection:  ");
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_show_submenu(
	mdk_package_t	** pkgPtr
)
{
	uchar8			str[LINE_WIDTH];
	mdk_test_t		* basic;
	mdk_test_t		* restr;
	uint32			i;

	clear_screen();

	sprintf(str, "%s    Tests", (*pkgPtr)->menuName);
	center(str, LINE_WIDTH);

	printf("\n");
	printf("A = All Tests                           O = Set Options     H = Help\n");
	printf("U = Up to top level menu                                    Q = Quit\n");
	printf("L = Run Test n Times\n");
	printf("\n");
	printf("Tests:\n");

	i = 0;
	basic = (*pkgPtr)->basicTests;
	if (basic) {
		while (basic->testName) {
			printf("    %2d : %-20s  %-20s\n",
									i, basic->testName, basic->testComment);
			i++;
			basic++;
		}
	}
	restr = (*pkgPtr)->restrictedTests;
	if (restr) {
		while (restr->testName) {
			printf("\n");
			printf("    %2d(r) : %-20s  %-20s",
									i, restr->testName, restr->testComment);
			i++;
			restr++;
		}
	}
	printf("\n\n");
	printf("Enter Selection:  ");
}

