/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-packages.c,v 1.9 2002/08/28 22:17:52 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>

/*------------------------------------------------------------------*/
#if defined (DIAG_SIBYTE)
int32 txrx_mem_test(mdk_test_params_t *);
int32 fp_mem_test(mdk_test_params_t *); 
int32 ldt_mem_test(mdk_test_params_t *);
int32 txrx_rmem_test(mdk_test_params_t *);
int32 fp_rmem_test(mdk_test_params_t *);
int32 gen_rmem_test(mdk_test_params_t *);
int32 full_dram_test(mdk_test_params_t *);
int32 full_dram_restr_test(mdk_test_params_t *);
int32 mdk_mem_map_tlb_init();
int32 mdk_set_tlb();

int32 mem_pkg_init();
int32 mem_pkg_err();

mdk_test_t	sb_mem_tests[] = {
	{"LDT Test", "","Tests 0x40000000 to 0x47000000 on the LDT bus",ldt_mem_test},
	{"Full DRAM Test","","This tests the full memory of 4DRAMS",full_dram_test},
//	{"Sibyte TXRX",	"","Tests memory to TXRX",txrx_mem_test},
//	{"Sibyte FP", "","Tests memory attached to FP",fp_mem_test},
	{NULL, NULL, NULL,NULL},
	};

mdk_test_t	sb_mem_restr_tests[] = {
//	{"Sibyte TXRX",	"","Walking 1/0",	txrx_rmem_test},
//	{"Sibyte FP", "","Walking 1/0",	fp_rmem_test},
	{"Generic Test", "","User to provide range and size of memory to be tested",	gen_rmem_test},
	{"Full DRAM Test","","This tests the full memory of 4DRAMS",full_dram_restr_test},
	{"Restore Original TLB", "","This resets the original TLB",mdk_mem_map_tlb_init},
	{"MDK Set TLB", "","Used to configure new TLB for full DRAM", mdk_set_tlb},
	{NULL, NULL, NULL,NULL},
};	

mdk_option_t	mem_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Continue Despite Err", "0 = off, 1 = on", 0},
	{"Walking Ones", "0 = off, 1 = on", 0},
	{"Walking Zeros", "0 = off, 1 = on", 0},
	{"Address", "0 = off, 1 = on", 0},
	{NULL, NULL, 0},
};

#define MEM_OPT_MAX	3

mdk_package_t	diag_mem_pkg = {
	"MEM",
	"Memory Tests",
	"This option runs appropriate memory tests",
	mem_pkg_init,
	mem_pkg_err,
	sb_mem_tests,
	sb_mem_restr_tests,
	mem_opts,
};

#elif defined (DIAG_R7000)
/*------------------------------------------------------------------*/
int32 gen_rmem_test(mdk_test_params_t *);
int32 gt_mem_test(mdk_test_params_t *);
int32 toshiba_mem_test(mdk_test_params_t *);
int32 gt_restr_mem_test(mdk_test_params_t *);
int32 mem_pkg_init();
int32 mem_pkg_err();

mdk_test_t	gt_mem_tests[] = {
	{"GT SDRAM", "","Tests SDRAM memory attached to the Galileo",gt_mem_test},
	{"Toshiba Mem ", "","Tests memory attached to the Toshiba",toshiba_mem_test},
	{NULL, NULL, NULL,NULL},
};

mdk_test_t	gt_mem_restr_tests[] = {
	{"GT SDRAM", "Walking 1/0","SDRAM mem attached to Galileo",gt_restr_mem_test},
	{"Generic Test", "","User to provide range and size of memory to be tested",	gen_rmem_test},
	{NULL, NULL, NULL,NULL},
};

mdk_option_t	mem_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Continue Despite Err", "0 = off, 1 = on", 0},
	{"Walking Ones", "0 = off, 1 = on", 0},
	{"Walking Zeros", "0 = off, 1 = on", 0},
	{"Address", "0 = off, 1 = on", 0},
	{NULL, NULL, 0},
};

#define MEM_OPT_MAX	3

mdk_package_t	diag_mem_pkg = {
	"MEM",
	"Memory Tests",
	"This option runs appropriate memory tests",
	mem_pkg_init,
	mem_pkg_err,
	gt_mem_tests,
	gt_mem_restr_tests,
	mem_opts,
};
#endif

/*------------------------------------------------------------------*/
int32 pci_pkg_init();
int32 pci_pkg_err();
#if defined (DIAG_R7000)
int32 mpci_intelClPd6729(mdk_test_params_t *);
int32 mpci_toshiba(mdk_test_params_t *);
int32 mpci_bcm5632(mdk_test_params_t *);
int32 mpci_qlogic(mdk_test_params_t *);
int32 mpci_bc5600(mdk_test_params_t *);
#elif defined (DIAG_SIBYTE)
int32 mpci_txrx(mdk_test_params_t *);
int32 mpci_fp(mdk_test_params_t *);
int32 mpci_ldt_txrx(mdk_test_params_t *);
int32 mpci_ldt_fp(mdk_test_params_t *);
#endif
int32 mpci_gmac(mdk_test_params_t *);

#if defined (DIAG_R7000)
mdk_test_t	pci_tests[] = {
		{"Intel CL-PD6729", "", "Writes/Reads to pci reg of PCMCIA controller",mpci_intelClPd6729},
		{"Toshiba Mgmt Processor", "", "Writes/Reads to pci reg of toshiba mgmt processor",mpci_toshiba},
		{"BCM5632 Test", "", "Writes/Reads to pci reg of Broadcom 5632",mpci_bcm5632},
		{"Qlogic Test", "", "Writes/Reads to pci reg of Qlogic fibre chan controller",mpci_qlogic},
		{"BCM5600 Test", "", "Writes/Reads to pci reg of Broadcom 5600",mpci_bc5600},
		{"DP83820 Test", "", "Writes/Reads to pci reg of 83820 GMAC",mpci_gmac},
		{NULL, NULL, NULL,NULL},
};
#elif defined (DIAG_SIBYTE)
mdk_test_t	pci_tests[] = {
		{"SIBYTE-TXRX Test", "", "Writes/Reads to pci reg of TXRX Sibyte",mpci_txrx},
		{"SIBYTE-FP Test", "", "Writes/Reads to pci reg of FP Sibyte",mpci_fp},
		{"SIBYTE-LDT TXRX Test", "", "Writes/Reads to hypertransport reg of TXRX Sibyte",mpci_ldt_txrx},
		{"SIBYTE-LDT FP Test", "", "Writes/Reads to hypertransport reg of FP Sibyte",mpci_ldt_fp},
		{"DP83820 Test", "", "Writes/Reads to pci reg of 83820 GMAC",mpci_gmac},
		{NULL, NULL, NULL,NULL},
};
#endif

mdk_option_t	pci_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{ NULL, NULL, 0}
};
	
mdk_package_t	diag_pci_pkg = {
	"PCI",
	"PCI Tests",
	"This option runs appropriate pci write/read to dev on PCI bus",
	pci_pkg_init,
	pci_pkg_err,
	pci_tests,
	0,
	pci_opts,
};

#if defined (DIAG_R7000)
/*------------------------------------------------------------------*/
int32 bcm5600_int_lb_port0(mdk_test_params_t *);
int32 bcm5600_int_lb_port2(mdk_test_params_t *);
int32 bcm5600_8353_phy_lb_port0(mdk_test_params_t *);
/*int32 bcm5600_8353_phy_lb_port2(mdk_test_params_t *);*/
int32 disable_mac_lb0(mdk_test_params_t *);
int32 disable_mac_lb2(mdk_test_params_t *);
int32 disable_phy_8353(mdk_test_params_t *);
int32 bcm5600_setMacLpbk0(mdk_test_params_t *);
int32 bcm5600_setMacLpbk2(mdk_test_params_t *);
int32 bcm5600_pkg_init();
int32 bcm5600_pkg_err();
int32 bcm5600_reg_test(mdk_test_params_t *);

mdk_test_t	bcm5600_tests[] = {
//	{"PMC 8353 PHY Lpbk","","sets the PMC SERDES 8353 into loopback",bcm5600_8353_phy_lb_port0},
	/*{"PMC 8353 PHY Loopback Port 2","","sets the PMC SERDES 8353 into loopback",bcm5600_8353_phy_lb_port2},*/
	{NULL, NULL, NULL,NULL}
};

mdk_test_t	bcm5600_restr_tests[] = {
	{"MAC Lpbk Port 0","GT64240<->BCM5600-MAC","sets one of the 5600 ports into internal loopback",bcm5600_int_lb_port0},
	{"MAC Lpbk Port 2","GT64240<->BCM5600-MAC","sets the 5600 into internal loopback",bcm5600_int_lb_port2},
	{"Disable MAC Lpbk Port 0","","Disable Loopback",disable_mac_lb0},
	{"Disable MAC Lpbk Port 2","","Disable Loopback",disable_mac_lb2},
	{"Disable PHY Lpbk","","Disable Loopback",disable_phy_8353},
	{"Set Mac Lpbk Port 0","","Enable Loopback",bcm5600_setMacLpbk0},
	{"Set Mac Lpbk Port 2","","Enable Loopback",bcm5600_setMacLpbk2},
	{NULL, NULL, NULL,NULL}
};

mdk_option_t	bcm5600_opts[] = {
	"Verbosity", "0 = off, 1 = on", 0,
	"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0,
	"LoopBack Packet Count","1-1000000", 1,
	"Port", "0, 1", 0,
	NULL, NULL, 0,
};

mdk_package_t	diag_bcm5600_pkg = {
	"BCM5600",
	"BCM 5600 Tests",
	"This option runs BC 5600 related tests",
	bcm5600_pkg_init,
	bcm5600_pkg_err,
	bcm5600_tests,
	bcm5600_restr_tests,
	bcm5600_opts,
};


/*------------------------------------------------------------------*/
int32 gt_reg_test(mdk_test_params_t *);
int32 gt_phy_bc5221(mdk_test_params_t *); /* Register test */
int32 gt_mdio_bc5228(mdk_test_params_t *);
int32 gt_mdio_8353_1(mdk_test_params_t *);
int32 gt_mdio_8353_2(mdk_test_params_t *);
/*int32 gt_int_test(mdk_test_params_t *);*/
int32 gt_i2c_test(mdk_test_params_t *);
int32 gt_temp_test(mdk_test_params_t *);
int32 seep_test(mdk_test_params_t *);
//int32 ssc_rtc_test(mdk_test_params_t *);
int32 slice_seep_test(mdk_test_params_t *);  /* Only for BETA boards */
int32 gt_5228_phy_lb(mdk_test_params_t *);
int32 gt_5221_phy_lb_port0(mdk_test_params_t *);
int32 gt_5221_phy_lb_port2(mdk_test_params_t *);
int32 gt_5228_reset_lpbk(mdk_test_params_t *);
int32 gt_5228_set_lpbk(mdk_test_params_t *);
int32 gt_5228_ext_lb(mdk_test_params_t *);
int32 gt_5600_ext_lb0(mdk_test_params_t *);
int32 gt_5600_ext_lb2(mdk_test_params_t *);
int32 gt_fpga_test(mdk_test_params_t *);
int32 gt_5221_reset_lpbk(mdk_test_params_t *);
int32 gt_5221_set_lpbk(mdk_test_params_t *);
int32 gt_pkg_init();
int32 gt_pkg_err();

mdk_test_t	gt_tests[] = {
	{"BC5221 Register","Read/Write","Reads/Writes to the BC5221",gt_phy_bc5221},
	{"BC5228 Register","Read/Write","Reads/Writes to the BC5228",gt_mdio_bc5228},
	{"SERDES_1 Register","Read/Write","Reads/Writes to the PMC 8353",gt_mdio_8353_1},
	{"SERDES_2 Register","Read/Write","Reads/Writes to the PMC 8353",gt_mdio_8353_2},
	{"Mgmt FPGA","","Tests management FPGA registers",gt_fpga_test},
	{"I2C Device","","Checks for supposed devices on I2C bus",gt_i2c_test},
	{"Temp Test","","Checks temp and verifies if its within accepted range",gt_temp_test},
	{"Board Seep Test","","Writes a test string into seep and reads it for verification. Restores original SEEP info",seep_test},
	{"Slice Seep Test","","Writes a test string into seep and reads it for verification. Restores original SEEP info",slice_seep_test},
//	{"Dallas RTC","","Scans for device ID and verifies",ssc_rtc_test},
	{"EXT Lpbk Port 0","","Use external loopback connectors in the backplane",gt_5600_ext_lb0},
	{"EXT Lpbk Port 1","","Use external loopback connectors in the backplane",gt_5228_ext_lb},
	{"EXT Lpbk Port 2","","Use external loopback connectors in the backplane",gt_5600_ext_lb2},
	{NULL, NULL, NULL,NULL}
};
	/*{"Galileo Reg Test","","Write/Read GT regs",gt_reg_test},*/

mdk_test_t	gt_restr_tests[] = {
/*	{"Galileo Intr Test","","test GT->CPU INT",gt_int_test},*/
	{"Port 0 PHY Lpbk","","sets the Broadcom 5221 into loopback",gt_5221_phy_lb_port0},
	{"Port 1 PHY Lpbk","","sets the Broadcom 5228/5221 into loopback",gt_5228_phy_lb},
	{"Port 2 PHY Lpbk","","sets the Broadcom 5221 into loopback",gt_5221_phy_lb_port2},
	{"Set BCM5221 PHY Lpbk","","Sets the Broadcom 5221 PHY into loopback",gt_5221_set_lpbk},
	{"Reset BCM5221 PHY Lpbk","","resets the Broadcom 5221 PHY from loopback",gt_5221_reset_lpbk},
	{"Set BCM5228 PHY Lpbk","","Sets the Broadcom 5228 PHY into loopback",gt_5228_set_lpbk},
	{"Reset BCM5228 PHY Lpbk","","resets the Broadcom 5228 PHY from loopback",gt_5228_reset_lpbk},
	{NULL, NULL, NULL,NULL}
};

mdk_option_t	gt_opts[] = {
	"Verbosity", "0 = off, 1 = on", 0,
	"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0,
	"LoopBack Packet Count","1-1000000", 1,
	NULL, NULL, 0,
};

mdk_package_t	diag_gt_pkg = {
	"GALILEO",
	"Galileo Tests",
	"This option runs Galileo related tests",
	gt_pkg_init,
	gt_pkg_err,
	gt_tests,
	gt_restr_tests,
	gt_opts,
};

/*------------------------------------------------------------------*/
#if 0
int32 rtc_ram_test(mdk_test_params_t *);
int32 rtc_int_test(mdk_test_params_t *);
int32 rtc_wd_test(mdk_test_params_t *);
int32 rtc_nmi_test(mdk_test_params_t *);
int32 rtc_pkg_init();
int32 rtc_pkg_err();

mdk_test_t	rtc_tests[] = {
	{"RAM Test","","Save/Erase/Write/Read/Restore",	rtc_ram_test},
	{"Interrupt Test","","test RTC->CPU INT",rtc_int_test},
	{"Watchdog Test","","test RTC->CPU Watchdog",rtc_wd_test},
	{NULL, NULL, NULL,NULL},
};

mdk_test_t	rtc_restr_tests[] = {
	{"Watchdog Reset Test","","reboots the card",rtc_nmi_test},
	{NULL, NULL, NULL,NULL},
};

mdk_option_t	rtc_opts[] = {
	"Verbosity", "0 = off, 1 = on", 0,
	NULL, NULL, 0,
};

mdk_package_t	diag_rtc_pkg = {
	"RTC",
	"Real Time Clock Tests",
	"This option runs tests related to RealTime clock",
	rtc_pkg_init,
	rtc_pkg_err,
	rtc_tests,
	rtc_restr_tests,
	rtc_opts,
};
#endif
#endif

/*------------------------------------------------------------------*/
#if defined (DIAG_SIBYTE)
int32 gmac_extlb_test(mdk_test_params_t *);
int32 gmac_5208_phylb_test(mdk_test_params_t *);
#elif defined (DIAG_R7000)
int32 gt_gmac_phylb(mdk_test_params_t *);
int32 gmac_set_all_phylb(mdk_test_params_t *);
int32 gmac_reset_all_phylb(mdk_test_params_t *);
int32 gt_gmac_extlb_test(mdk_test_params_t *);
#endif


int32 gmac_dis_lbMode(mdk_test_params_t *);
int32 gmac_set_lbMode(mdk_test_params_t *);
int32 gmac_intlb_test(mdk_test_params_t *);
int32 gmac_loopbk_results(mdk_test_params_t *);
int32 gmac_pkg_init();
int32 gmac_pkg_err();

#if defined (DIAG_SIBYTE)
mdk_test_t	gmac_tests[] = {
	{"PHY Lpbk Test","","Sets the PHY into loopback",gmac_5208_phylb_test}, 
	{NULL, NULL, NULL,NULL},
};

mdk_test_t	gmac_restr_tests[] = {
	{"Set Int Lpbk Mode","","Sets the MAC to internal Loopback",gmac_set_lbMode},
	{"Disable Int Lpbk Mode","","Disables the MAC to internal Loopback",gmac_dis_lbMode},
	{"Int Lpbk Test","","Sets the 83820 MAC into loopback",	gmac_intlb_test},
	{"EXT Lpbk Test","","Loopback using backplane connectors",gmac_extlb_test},
	{"Loopback Test Results","","Shows the Loopback Results",gmac_loopbk_results},	
	{NULL, NULL, NULL,NULL},
};

mdk_option_t	gmac_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0},
	{"LoopBack Packet Count","1-1000000", 1},
	{"Loopback On FP","0=off, 1=on", 0},
	{NULL, NULL, 0},
};
#elif defined(DIAG_R7000)
mdk_test_t	gmac_tests[] = {
	{"EXT Lpbk Test","","Loopback using backplane connectors",gt_gmac_extlb_test},
	{NULL, NULL, NULL,NULL},
};

mdk_test_t	gmac_restr_tests[] = {
	{"PHY Loopback","","sets the PMC SERDES 8353 into loopback",gt_gmac_phylb},
	{"Set All PHY ports in Lpbk","  (Slice 0 ONLY)","Sets all the PHY ports into loopback",gmac_set_all_phylb},	
	{"Reset All PHY lpbk ports","  (Slice 0 ONLY)","resets all the PHY ports from loopback",gmac_reset_all_phylb},	
	{"Int Lpbk Test","","Sets the 83820 MAC into loopback",	gmac_intlb_test},
	{"Set Int Lpbk Mode","","Sets the MAC to internal Loopback",gmac_set_lbMode},
	{"Disable Int Lpbk Mode","","Disables the MAC to internal Loopback",gmac_dis_lbMode},
	{"Loopback Test Results","","Shows the Loopback Results",gmac_loopbk_results},	
	{NULL, NULL, NULL,NULL},
};

mdk_option_t	gmac_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0},
	{"LoopBack Packet Count","1-1000000", 1},
	{NULL, NULL, 0},
};
#endif

mdk_package_t	diag_gmac_pkg = {
	"DP83820",
	"DP83820 Tests",
	"This option runs DP83820 tests",
	gmac_pkg_init,
	gmac_pkg_err,
	gmac_tests,
	gmac_restr_tests,
	gmac_opts,
};


/*------------------------------------------------------------------*/
#if defined (DIAG_SIBYTE)
int32 sb_lucisUp_test(mdk_test_params_t *);
int32 sb_luc_Regtest(mdk_test_params_t *);
/* mac loopback -lsi8104 */
int32 sb_luc_int_lb_test_port0(mdk_test_params_t *);
int32 sb_luc_int_lb_test_port1(mdk_test_params_t *);
int32 sb_luc_int_lb_test_port2(mdk_test_params_t *);
int32 sb_luc_int_lb_test_port3(mdk_test_params_t *);
int32 sb_reset_luc_int_lpbk(mdk_test_params_t *);
int32 luc_pkg_init();
int32 luc_pkg_err();

mdk_test_t	luc_tests[] = {
	{"Luc","","Test reads 1st reg of Luc",sb_lucisUp_test},
	{"LUC Reg","","Tests LUC registers",sb_luc_Regtest},
	{"Int Luc Lpbk Port-0","","Runs MAC loopback",sb_luc_int_lb_test_port0},
	{"Int Luc Lpbk Port-1","","Runs MAC loopback",sb_luc_int_lb_test_port1},
	{"Int Luc Lpbk Port-2","","Runs MAC loopback",sb_luc_int_lb_test_port2},
	{"Int Luc Lpbk Port-3","","Runs MAC loopback",sb_luc_int_lb_test_port3},
	{"Reset Luc from Int Lpbk","","Resets the Luc ports from MAC interface loopback",sb_reset_luc_int_lpbk},
	{NULL, NULL, NULL,NULL},
};

mdk_option_t	luc_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0},
	{"LoopBack Packet Count","1-1000000", 1},
	{NULL, NULL, 0},
};

mdk_package_t	diag_luc_pkg = {
	"LUC",
	"Luc Tests",
	"This option runs Luc-related tests",
	luc_pkg_init,
	luc_pkg_err,
	luc_tests,
	0,
	luc_opts,
};

/*------------------------------------------------------------------*/
int32 sb_lsiMac_Regtest(mdk_test_params_t *);
int32 sb_lsi_mac_linkUp_test_port0(mdk_test_params_t *);
int32 sb_lsi_mac_linkUp_test_port1(mdk_test_params_t *);
int32 sb_lsi_mac_linkUp_test_port2(mdk_test_params_t *);
int32 sb_lsi_mac_linkUp_test_port3(mdk_test_params_t *);
/* mac loopback -lsi8104 */
int32 sb_lsi_mac_lb_test_port0(mdk_test_params_t *);
int32 sb_lsi_mac_lb_test_port1(mdk_test_params_t *);
int32 sb_lsi_mac_lb_test_port2(mdk_test_params_t *);
int32 sb_lsi_mac_lb_test_port3(mdk_test_params_t *);
int32 sb_lsi_mac_lb_test_port4(mdk_test_params_t *);
int32 sb_lsi_mac_lb_test_port5(mdk_test_params_t *);
int32 sb_reset_lsi_mac_lpbk(mdk_test_params_t *);
int32 lsi8104_pkg_init();
int32 lsi8104_pkg_err();

mdk_test_t	lsi8104_tests[] = {
	{"Register Test","","Tests LSI Mac  registers",sb_luc_Regtest},
//	{"Status Link 0","","Tests if ext loopback cables are plugged in",sb_lsi_mac_linkUp_test_port0},
//	{"Status Link 1","","Tests if ext loopback cables are plugged in",sb_lsi_mac_linkUp_test_port1},
//	{"Status Link 2","","Tests if ext loopback cables are plugged in",sb_lsi_mac_linkUp_test_port2},
//	{"Status Link 3","","Tests if ext loopback cables are plugged in",sb_lsi_mac_linkUp_test_port3},
	{"LSI Mac Lpbk Port-0","","Runs MAC loopback",sb_lsi_mac_lb_test_port0},
	{"LSI Mac Lpbk Port-1","","Runs MAC loopback",sb_lsi_mac_lb_test_port1},
	{"LSI Mac Lpbk Port-2","","Runs MAC loopback",sb_lsi_mac_lb_test_port2},
	{"LSI Mac Lpbk Port-3","","Runs MAC loopback",sb_lsi_mac_lb_test_port3},
	{"LSI Mac Lpbk Port-4","","Runs MAC loopback",sb_lsi_mac_lb_test_port4},
	{"LSI Mac Lpbk Port-5","","Runs MAC loopback",sb_lsi_mac_lb_test_port5},
	{"Reset Mac from Lpbk","","Resets the LSI MAC ports from loopback",sb_reset_lsi_mac_lpbk},
	{NULL, NULL, NULL,NULL},
};

mdk_option_t	lsi8104_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0},
	{"LoopBack Packet Count","1-1000000", 1},
	{NULL, NULL, 0},
};

mdk_package_t	diag_lsi8104_pkg = {
	"LSI-8104",
	"LSI-8104 MAC Tests",
	"This option runs LSI-8104 MAC related tests",
	lsi8104_pkg_init,
	lsi8104_pkg_err,
	lsi8104_tests,
	0,
	lsi8104_opts,
};

/*------------------------------------------------------------------*/
int32 sb_phy5208_reg_test(mdk_test_params_t *);
int32 sb_smbus_test(mdk_test_params_t *);
int32 sb_phy_reg_test(mdk_test_params_t *);
int32 sb_int_lb_test(mdk_test_params_t *);
//int32 sb_phy_lb_port0(mdk_test_params_t *);
//int32 sb_phy_lb_port1(mdk_test_params_t *);
int32 sb_ext_lb_test_port0(mdk_test_params_t *);
int32 sb_ext_lb_test_port1(mdk_test_params_t *);
int32 sb_ext_lb_test_port2(mdk_test_params_t *);
int32 sb_ext_lb_test_port3(mdk_test_params_t *);
int32 sb_ext_lb_test_port4(mdk_test_params_t *);
int32 sb_ext_lb_test_port5(mdk_test_params_t *);
/* FP */
int32 sb_ext_fp_lb_test_port0(mdk_test_params_t *);
int32 sb_ext_fp_lb_test_port1(mdk_test_params_t *);
int32 sb_ext_fp_lb_test_port2(mdk_test_params_t *);
int32 sb_ext_fp_lb_test_port3(mdk_test_params_t *);
int32 sb_ext_fp_lb_test_port4(mdk_test_params_t *);
int32 sb_ext_fp_lb_test_port5(mdk_test_params_t *);
/* txrx */
int32 sb_phy_lb_test_port0(mdk_test_params_t *);
int32 sb_phy_lb_test_port1(mdk_test_params_t *);
int32 sb_phy_lb_test_port2(mdk_test_params_t *);
int32 sb_phy_lb_test_port3(mdk_test_params_t *);

int32 sb_D1621temp_test(mdk_test_params_t *);
int32 sb_M1617TxRxtemp_test(mdk_test_params_t *);
int32 sb_M1617Fptemp_test(mdk_test_params_t *);
int32 sb_Xlnxtemp_test(mdk_test_params_t *);
int32 seep_test(mdk_test_params_t *);
int32 fp_cpu_seep_test(mdk_test_params_t *);
int32 sb_fpga_test(mdk_test_params_t *);
int32 sb_set_fp_phy_lpbk(mdk_test_params_t *);
int32 sb_reset_fp_phy_lpbk(mdk_test_params_t *);
int32 sb_loopbk_results(mdk_test_params_t *);
int32 sb_pkg_init();
int32 sb_pkg_err();

mdk_test_t	sb_tests[] = {
	{"SmBus/I2C Test","","Test reads 1st reg of all devices on SmBus",sb_smbus_test},
	{"Dallas-1621 Temp","","Checks temp and verifies if its within accepted range",sb_D1621temp_test},
	{"Maxim-1617 TXRX Temp","","Checks temp and verifies if its within accepted range",sb_M1617TxRxtemp_test},
	{"Maxim-1617 FP Temp","","Checks temp and verifies if its within accepted range",sb_M1617Fptemp_test},
//	{"Luc XLNX Temp","","Checks temp and verifies if its within accepted range",sb_Xlnxtemp_test},
	{"Board Seep Test","","Writes a test string into seep and reads it for verification. Restores original SEEP info",seep_test},
	{"Processor Seep Test","","Writes a test string into seep and reads it for verification. Restores original SEEP info",fp_cpu_seep_test},
	{"PMC8353 Reg Test","","Write/Read SB regs",sb_phy_reg_test},
	{"BC5208 Reg Test","","Test reads/writes to regs of all PHY devices",sb_phy5208_reg_test},
	{"Mgmt FPGA","","Tests management FPGA registers",sb_fpga_test},
	{"Lpbk Test Port0","","TXRX:connect ext loopback cables.FP:checks the PHY loopback",sb_ext_lb_test_port0},
	{"Lpbk Test Port1","","TXRX:connect ext loopback cables.FP:checks the PHY loopback",sb_ext_lb_test_port1},
	{"Lpbk Test Port2","","TXRX:connect ext loopback cables.FP:checks the PHY loopback",sb_ext_lb_test_port2},
	{"Lpbk Test Port3","","TXRX:connect ext loopback cables.FP:checks the PHY loopback",sb_ext_lb_test_port3},
	{"Lpbk Test Port4","","TXRX:connect ext loopback cables.FP:checks the PHY loopback",sb_ext_lb_test_port4},
	{"Lpbk Test Port5","","TXRX:connect ext loopback cables.FP:checks the PHY loopback",sb_ext_lb_test_port5},
	{"Set FP 8353 PHY Lpbk","","Sets the PHY ports into loopback",sb_set_fp_phy_lpbk},
	{NULL, NULL, NULL,NULL},
};


mdk_test_t	sb_restr_tests[] = {
	{"TXRX:PHY Lpbk Port-0","","Runs PHY loopback",sb_phy_lb_test_port0},
	{"TXRX:PHY Lpbk Port-1","","Runs PHY loopback",sb_phy_lb_test_port1},
	{"TXRX:PHY Lpbk Port-2","","Runs PHY loopback",sb_phy_lb_test_port2},
	{"TXRX:PHY Lpbk Port-3","","Runs PHY loopback",sb_phy_lb_test_port3},
	{"Reset FP ports from PHY Lpbk","","Resets the PHY ports from loopback",sb_reset_fp_phy_lpbk},
	{"FP: EXT Lpbk Port-0","","Runs EXT loopback",sb_ext_fp_lb_test_port0},
	{"FP: EXT Lpbk Port-1","","Runs EXT loopback",sb_ext_fp_lb_test_port1},
	{"FP: EXT Lpbk Port-2","","Runs EXT loopback",sb_ext_fp_lb_test_port2},
	{"FP: EXT Lpbk Port-3","","Runs EXT loopback",sb_ext_fp_lb_test_port3},
	{"FP: EXT Lpbk Port-4","","Runs EXT loopback",sb_ext_fp_lb_test_port4},
	{"FP: EXT Lpbk Port-5","","Runs EXT loopback",sb_ext_fp_lb_test_port5},
	/*{"View Loopback Test Results","","Shows the Loopback Results",sb_loopbk_results},*/
	{"Internal Loopback Test","","Connects TX/RX fifo",sb_int_lb_test},
	{NULL, NULL, NULL,NULL},
};

mdk_option_t	sb_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0},
	{"LoopBack Packet Count","1-1000000", 1},
	{"Loopback On FP","0=off, 1=on", 0},
	{NULL, NULL, 0},
};

mdk_package_t	diag_sb_pkg = {
	"SIBYTE",
	"Sibyte Tests",
	"This option runs SIBYTE-related tests",
	sb_pkg_init,
	sb_pkg_err,
	sb_tests,
	sb_restr_tests,
	sb_opts,
};

#endif

/*------------------------------------------------------------------*/
int32 conflict_pkg_init();
int32 conflict_pkg_err();
#ifdef DIAG_SIBYTE
int32 sb_conflict_test(mdk_test_params_t *);
#elif defined (DIAG_R7000)
int32 fc_conflict_test(mdk_test_params_t *);
#endif

#ifdef DIAG_SIBYTE
mdk_test_t	conflict_tests[] = {
	{"Conflict Test","","Turns on external loopback at SIBYTE TXRX, DP83820", sb_conflict_test},
	{NULL, NULL, NULL,NULL},
};


mdk_option_t	conflict_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0},
	{"LoopBack Packet Count","1-1000000", 1},
	{"Loopback Duration","0-1000", 0},
	{NULL, NULL, 0},
};
#elif defined (DIAG_R7000)
mdk_test_t	conflict_tests[] = {
	{"Conflict Test","","Turns on external loopback of all ports on Galileo, DP83820", fc_conflict_test},
	{NULL, NULL, NULL,NULL},
};


mdk_option_t	conflict_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{"Packet Trace", "0=off, 1=rx on, 2=tx on, 3=tx&rx on ", 0},
	{"LoopBack Packet Count","1-1000000", 1},
	{"FC Loopback Port","Not Supported", 0},
	{"Loopback Duration","0-1000", 0},
	{NULL, NULL, 0},
};
#endif

mdk_package_t	diag_conflict_pkg = {
	"CONFLICT",
	"CONFLICT Tests",
	"This option runs all the EXT loopback tests simultaneously",
	conflict_pkg_init,
	conflict_pkg_err,
	conflict_tests,
	0,
	conflict_opts,
};

/*------------------------------------------------------------------*/
int32 serdes_txrx_self_test(mdk_test_params_t *);
int32 serdes_fp0_self_test(mdk_test_params_t *);
int32 serdes_fp1_self_test(mdk_test_params_t *);
int32 serdes_reset_all_phy(mdk_test_params_t *);
int32 serdes_pkg_init();
int32 serdes_pkg_err();

mdk_test_t	serdes_tests[] = {
	{"TXRX:Self Test","","Inject/Verify packets",serdes_txrx_self_test},
	{"FP 0:Self Test","","Inject/Verify packets",serdes_fp0_self_test},
	{"FP 1:Self Test","","Inject/Verify packets",serdes_fp1_self_test},
	{"Reset PHY","","Reset all the PHYS",serdes_reset_all_phy},
	{NULL, NULL, NULL,NULL},
};

mdk_option_t	serdes_opts[] = {
	{"Verbosity", "0 = off, 1 = on", 0},
	{NULL, NULL, 0},
};

mdk_package_t	diag_serdes_pkg = {
	"SERDES",
	"Serdes Tests",
	"This option runs Serdes tests",
	serdes_pkg_init,
	serdes_pkg_err,
	serdes_tests,
	0,
	serdes_opts,
};




