/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-fc.c,v 1.1.1.1 2002/03/26 01:43:53 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>
#include "mdk-mem.h"

int32
fc_pkg_init()
{
	printf("fc_init\n");
	tp->resultCnt = 1;
}

int32
fc_pkg_err(
	mdk_log_entry_t	* err
)
{

	uint32 i;
	uint32 num1 = 0;
	uint32 num2 = 0;

	switch (err->testresult) {
		case ERR_ADDR_FAIL:
			if (tp->param[TP_VERBOSE] == 1) {
				printf("I2C Device Test Failure : \n");
				printf("-------------------------------\n");
			        printf("addr		expected(ignore)	got(ignore) \n");
				while (err->result[0].addr[num1++]);
				printf("num1 %d\n",num1);
				for (i=0;i<(num1-1);i++) {
				printf("0x%x	 0x%x		0x%x\n",
					err->result[0].addr[i], err->result[0].exptd[i], err->result[0].rcvd[i]);}
			}
				break;

		case ERR_TIMEOUT:
			if (tp->param[TP_VERBOSE] == 1) {
				printf("Loopback test timeout\n");
			}	
				break;
		default:
				printf("Unknown error, testresult = 0x%x\n", err->testresult);
				break;
	}

	return 0;
}



