/*------------------------------------------------------------------------------
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Name         : ndmp-auth-api.h
 *
 * Description  : Interface of the NDMP authentication library,
 *
 * Created by   : Isabelle Cnudde
 *
 * Date Created : 06-SEP-2001
 *
 *------------------------------------------------------------------------------
 */
#ifndef _NDMP_AUTH_API_H_
#define _NDMP_AUTH_API_H_

/*------------------------------------------------------------------------------
 * Include files
 *------------------------------------------------------------------------------
 */

#include "nfx-incl.h"

/*------------------------------------------------------------------------------
 * Constants and macros.
 *------------------------------------------------------------------------------
 */

#define NDMP_AUTH_TEXT  1
#define NDMP_AUTH_MD5   2

/*------------------------------------------------------------------------------
 * Prototype of global functions.
 *------------------------------------------------------------------------------
 */

boolean                                 // TRUE if authentication is successful
ndmp_authenticate(int       type,       // NDMP_AUTH_TEXT, NDMP_AUTH_MD5
                  char *    id,         // identifier
                  byte *    secret,     // password or digest (if MD5)
                  byte *    challenge); // challenge string (if MD5)

/*----------------------------------------------------------------------------*/

#endif // _NDMP_AUTH_API_H_
