/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * RCS:  $Id: nb-util.h,v 1.1.1.1 2002/04/23 17:52:14 laurentb Exp $
 *
 * Name			: nb-util.h
 *
 * Description	: Contains NetBIOS utility definitions.
 *
 * Created by	: Xiaobing Zhang
 *
 * Date Created	: 11/07/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _NB_UTIL_H
#define _NB_UTIL_H

/*--------------------
 * Function prototypes
 *--------------------
 */
uint16 nb_genXid(void);

boolean nb_isNameEqual(nb_name_t *name1, nb_name_t *name2);

int32 nb_lookupSrvName(nb_name_t *name);

uint32 *nb_getSrvNameState(nb_srvCB_t *srvCbP, nb_name_t *name);

void nb_addServerCb(nb_srvCB_t **srvCbsHeadP,
					nb_srvCB_t *srvCbP);

void nb_removeServerCb(nb_srvCB_t **srvCbsHeadP,
					   nb_srvCB_t *srvCbP);

int32 nb_isValidServer(nb_srvCB_t *nbSrvCbP);

nb_queryCB_t *nb_createQueryCb(nb_reqCB_t *nbReqCbP);

void nb_deleteQueryCb(nb_queryCB_t *nbQueryCbP);

nb_reqCB_t *nb_createReqCb(nb_srvCB_t *nbSrvCbP, uint16	reqType);

void nb_deleteReqCb(nb_reqCB_t *nbReqCbP);

nb_reqCB_t *nb_getReqCb(nb_srvCB_t *nbSrvCbP, uint16 xid);

nb_ssnCB_t *nb_createSsnCb(nb_srvCB_t *nbSrvCbP);

void nb_deleteSsnCb(nb_ssnCB_t *nbSsnCbP);

nb_ssnCB_t *nb_getSsnCb(nb_srvCB_t *srvCbP, uint32 raddr, uint16 rport);

pkt_desc_t *nb_createXmtPktSP(void *pktP,
							  uint32 svcType,
					  		  pkt_desc_t *xmtPktDescP);

pkt_desc_t *nb_allocOutgoingPkt(nb_ssnCB_t *nbSsnCbP, void **smbMsgHdrP);

int32 nb_freeOutgoingPkt(nb_ssnCB_t	*nbSsnCbP, pkt_desc_t *pktDescP);

int32 nb_freeIncomingPkt(nb_ssnCB_t	*nbSsnCbP, pkt_desc_t *pktDescP);

int32 nb_timerStop(int32 *tmr_handle);

int32 nb_timerDestroy(int32 *tmr_handle);

#endif /* _NB_UTIL_H */
