/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:        nfs-hash.h
 *
 * RCS:  $Id: nfs-hash.h,v 1.1 2002/10/01 00:35:38 shaun Exp $
 *
 * Copyright (C) 2002, Agile Storage Inc.
 *
 * Description: Contain function prototypes for NFS hashing routines.
 *
 * Created by:	Shaun Hui
 *
 * Date Created: 09/30/02
 *
 *-----------------------------------------------------------------
 */
#ifndef _NFS_HASH_H
#define _NFS_HASH_H
    

/*-----------------------------------------------------------------
 * Name:        nfs_hashCreateReqCb
 *  
 * Description: Create hash table for nfs reqCB.
 *              
 * Created by:  Shaun Hui
 *  
 * Date Created: 08/10/2002
 *-----------------------------------------------------------------
 */
void *nfs_hashCreateReqCb( int32 tbl_size );


/*-----------------------------------------------------------------
 * Name:        nfs_hashLookupReqCb
 *  
 * Description: Lookup Req CB based on XID.
 *
 * Created by:  Shaun Hui
 *  
 * Date Created: 08/10/2002
 *-----------------------------------------------------------------
 */
void *nfs_hashLookupReqCb( uint32 xid );


/*-----------------------------------------------------------------
 * Name:        nfs_hashInsertReqCb
 *  
 * Description: Insert Req CB into hash table.
 *
 * Created by:  Shaun Hui
 *  
 * Date Created: 08/10/2002
 *-----------------------------------------------------------------
 */
void 
nfs_hashInsertReqCb( uint32 xid, nfs_request_t *nfsReqp);

/*-----------------------------------------------------------------
 * Name:        nfs_hashDeleteReqCb
 *  
 * Description: Delete Req CB from hash table.
 *
 * Created by:  Shaun Hui
 *  
 * Date Created: 08/10/2002
 *-----------------------------------------------------------------
 */
void *nfs_hashDeleteReqCb( uint32 xid );


int32 nfs_hashShow( void );

#endif /* _NFS_HASH_H */
