/*
 *THIS FILE CONTAINS TEST STUB FUNCTIONS & TEST CODE ONLY
 */
#ifdef	NOTUSED						//NOTUSED

//#include <stdio.h>                      /*REMOVE*/

#include <nfx-incl.h> 
#include <exports/nfs-api.h>

#define	NFS_DBG_PRINTF

uchar8	fs_testMsg[1024];		/*File system test message*/
uchar8	fs_respMsg[1024];		/*Response messaeg buffer to NFS*/
eee_desc_t eDescriptor;
#ifdef	NOTUSED

int32
sendAgileMsg(int32 sock, void *msgBuff, uint32 msgLen, char *appName,
		uint32 cpuId, uint32 slotId, uint32 whichPlane,
		struct timeval *timeout, void *respBuff, uint32 respMsgLen)
{

	NFS_DBG_PRINTF("sendAgileMsg Enter: \n");

	return (mountd_test(sock, msgBuff, msgLen, respBuff, respMsgLen));
}

int regAgileApp (char *appName)
{

	/*stub function*/


}

int recvAgileMsg (int fd,                   // From regAgileApp()
                  void *msgBuff,            // Where to put the message
                  uint32  msgLen,           // and how much room there is
                  struct timeval *timeout,  // (opt) How long to wait
                  char *appName,            // (opt) From which application
                  uint32  *cpuId,          // (opt) and where
                  uint32  *slotId)        // (opt) it is on in the NFX
{
	

	return (msgLen);
};

#endif	/*NOTUSED*/

void fs_rxFillStatInfo(fs_Stat *fsStatp)
{
	fsStatp->fsBlockSize =  100000;
	fsStatp->numBlks = 1000;
	fsStatp->numBlksAvail = 50000;
	fsStatp->numBlksAvailUser = 10000;
	fsStatp->numInodes = 10000;
	fsStatp->numInodesAvail = 10000;
	fsStatp->numInodesAvailUser = 10000;
	fsStatp->readsPerSec = 100;
	fsStatp->writesPerSec = 100;
	fsStatp->avgReadSize = 1024;
	fsStatp->avgWriteSize = 1024;


}

void fs_rxFillFsInfo(fs_Fsinfo *fsInfop)
{

	fsInfop->maxFileSize = 1000000;
	fsInfop->readMax = 8192;
	fsInfop->readPref = 4096;
	fsInfop->readMult = 4;
	fsInfop->writeMax = 8192;
	fsInfop->writePref = 4096;
	fsInfop->writeMult = 4;
	fsInfop->readDirPref = 8192;
	fsInfop->timeDelta.secs = 0;
	fsInfop->timeDelta.usecs = 1;
	fsInfop->fsProperties = FS_PROP_LINK | FS_PROP_SYMLINK;
	

}

void fs_rxSimFillAttributes(fs_Attr *fattrp, uint32 type, uint32 preOpFlag)
{

	fattrp->type = type;
	fattrp->mode = 0x0000444;
	fattrp->numLinks = 1;
	fattrp->uid = 100;
	fattrp->gid = 200;
	fattrp->blockSize = 1024000;
	fattrp->devNum.major = 1000;
	fattrp->devNum.minor = 100;
	fattrp->volId = 512;
	fattrp->inode = 201326592;
	if (type == FS_FTYPE_REG)
		fattrp->inode++;
	fattrp->atime.secs = 3600;
	fattrp->atime.usecs = 10;
	if (preOpFlag)
	{
		fattrp->size = 0;
		fattrp->mtime.secs = 0;
		fattrp->mtime.usecs = 0;
		fattrp->ctime.secs = 0;
		fattrp->ctime.usecs = 0;
	}
	else
	{
		fattrp->size = 2048;
		fattrp->mtime.secs = 3600;
		fattrp->mtime.usecs = 10;
		fattrp->ctime.secs = 3600;
		fattrp->ctime.usecs = 10;
	}

}

void fs_rxUpdateSetAttr(fs_Attr *sourceAttrp, fs_Attr *destAttrp)
{

	if (sourceAttrp->type != -1)
		destAttrp->type = sourceAttrp->type;

	if (sourceAttrp->mode != -1)
		destAttrp->mode = sourceAttrp->mode;

	if (sourceAttrp->numLinks != -1)
		destAttrp->numLinks = sourceAttrp->numLinks;

	if (sourceAttrp->uid != -1)
		destAttrp->uid = sourceAttrp->uid;

	if (sourceAttrp->gid != -1)
		destAttrp->gid = sourceAttrp->gid;
	if (sourceAttrp->blockSize != -1)
		destAttrp->blockSize = sourceAttrp->blockSize;

	if (sourceAttrp->volId != -1)
		destAttrp->volId = sourceAttrp->volId;

	if (sourceAttrp->inode != -1)
		destAttrp->inode = sourceAttrp->inode;
	if (sourceAttrp->size != -1)
		destAttrp->size = sourceAttrp->size;



}

void fs_rxSimFillRespHdr(fs_MsgRespHdr *fsHdrp, uint32 reqType, 
			fs_MsgFlag flags, fs_Status status, uint64 clientPrivate)
{
	
	fsHdrp->requestType = reqType;
	fsHdrp->flags = flags;
	fsHdrp->fsStatus = status;
	fsHdrp->clientPrivate = clientPrivate;
}

void fs_rxSimFillReaddirEntry(fs_DirEntry *fsDirEntryp, uint64 inode, uint64 cookie, char *namep, ushort16 nameLen)
{

	fsDirEntryp->inode = inode;
	fsDirEntryp->cookie = cookie;
	memcpy(&fsDirEntryp->name[0], namep, nameLen);
	fsDirEntryp->nameLen = nameLen;

}

int32
fs_rxFillDirEntry(fs_MsgReadDirResp *fsReaddirResp)
{
	char                    name[128];
	uint64                  inode, cookie;
	int32			length;
	ushort16		nameLen;
	fs_DirEntry             *dirent;

	length = 0;	
	fsReaddirResp->numEntriesThis = 5;

	dirent = &fsReaddirResp->dirEntry[0];

	inode = 45658;
	cookie = 0x01;
	memset(name, 0, sizeof(name));
	memcpy(name, ".", 1);
	nameLen = 1;
	fs_rxSimFillReaddirEntry(dirent, inode, cookie,
                                        &name[0], nameLen);

	length += sizeof(fs_DirEntry) + nameLen;

	/*
	 *Advance to next entry
	 */
	FS_READDIR_ADV_ENTRY_PTR(dirent);
	length = sizeof(fs_DirEntry) + nameLen;
	inode = 45657;
	cookie = 0x04;
	memset(name, 0, sizeof(name));
	memcpy(name, "..", 2);
	nameLen = 2;
	fs_rxSimFillReaddirEntry(dirent, inode, cookie,
                                        &name[0], nameLen);
	length += sizeof(fs_DirEntry) + nameLen;

	FS_READDIR_ADV_ENTRY_PTR(dirent);
	inode = 45661;
	cookie = 0x1c;
	memset(name, 0, sizeof(name));
	memcpy(name, "b", 1);
	nameLen = 1;
	fs_rxSimFillReaddirEntry(dirent, inode, cookie,
                                        &name[0], nameLen);
	length += sizeof(fs_DirEntry) + nameLen;

	FS_READDIR_ADV_ENTRY_PTR(dirent);
	inode = 41964;
	cookie = 0x28;
	memset(name, 0, sizeof(name));
	memcpy(name, "am", 2);
	nameLen = 2;
	fs_rxSimFillReaddirEntry(dirent, inode, cookie,
                                        &name[0], nameLen);
	length += sizeof(fs_DirEntry) + nameLen;
	
	FS_READDIR_ADV_ENTRY_PTR(dirent);
	inode = 45661;
	cookie = 0x38;
	memset(name, 0, sizeof(name));
	memcpy(name, "bln", 3);
	nameLen = 3;
	fs_rxSimFillReaddirEntry(dirent, inode, cookie,
                                        &name[0], nameLen);
	length += sizeof(fs_DirEntry) + nameLen;


	return (length);
}

int32
fs_rxFillDirEntryPlus(fs_MsgReadDirPlusResp *fsReaddirplusResp, fs_Handle *fhandlep)
{
	fs_DirEntryPlus		*fsDirEntryPlusp;
	char                    name[128];
	uint64                  inode, cookie;
	int32			length;
	ushort16		nameLen;


	fsDirEntryPlusp = &fsReaddirplusResp->dirEntry[0];
	fsReaddirplusResp->numEntriesThis = 5;

        inode = 45658;
        cookie = 0x01;
        memset(name, 0, sizeof(name));
        memcpy(name, ".", 1);
        nameLen = 1;
        fs_rxSimFillReaddirEntry(&fsDirEntryPlusp->dirEntry, inode, cookie,
                                        &name[0], nameLen);
	memcpy(&fsDirEntryPlusp->handle, fhandlep, sizeof(fs_Handle));	
	fs_rxSimFillAttributes(&fsDirEntryPlusp->attr, FS_FTYPE_REG, FALSE);

        length = sizeof(fs_DirEntryPlus) + nameLen;

	fsDirEntryPlusp = &fsReaddirplusResp->dirEntry[1];
        inode = 45657;
        cookie = 0x04;
        memset(name, 0, sizeof(name));
        memcpy(name, "..", 2);
        nameLen = 2;
        fs_rxSimFillReaddirEntry(&fsDirEntryPlusp->dirEntry, inode, cookie,
                                        &name[0], nameLen);
	memcpy(&fsDirEntryPlusp->handle, fhandlep, sizeof(fs_Handle));	
	fs_rxSimFillAttributes(&fsDirEntryPlusp->attr, FS_FTYPE_REG, FALSE);
        length += sizeof(fs_DirEntryPlus) + nameLen;


	fsDirEntryPlusp = &fsReaddirplusResp->dirEntry[2];
        inode = 45661;
        cookie = 0x1c;
        memset(name, 0, sizeof(name));
        memcpy(name, "b", 1);
        nameLen = 1;
        fs_rxSimFillReaddirEntry(&fsDirEntryPlusp->dirEntry, inode, cookie,
                                        &name[0], nameLen);
	memcpy(&fsDirEntryPlusp->handle, fhandlep, sizeof(fs_Handle));	
	fs_rxSimFillAttributes(&fsDirEntryPlusp->attr, FS_FTYPE_REG, FALSE);
        length += sizeof(fs_DirEntryPlus) + nameLen;

	fsDirEntryPlusp = &fsReaddirplusResp->dirEntry[3];
        inode = 41964;
        cookie = 0x28;
        memset(name, 0, sizeof(name));
        memcpy(name, "am", 2);
        nameLen = 2;
        fs_rxSimFillReaddirEntry(&fsDirEntryPlusp->dirEntry, inode, cookie,
                                        &name[0], nameLen);
	memcpy(&fsDirEntryPlusp->handle, fhandlep, sizeof(fs_Handle));	
	fs_rxSimFillAttributes(&fsDirEntryPlusp->attr, FS_FTYPE_REG, FALSE);
        length += sizeof(fs_DirEntryPlus) + nameLen;

	fsDirEntryPlusp = &fsReaddirplusResp->dirEntry[4];
        inode = 45661;
        cookie = 0x38;
        memset(name, 0, sizeof(name));
        memcpy(name, "bln", 3);
        nameLen = 3;
        fs_rxSimFillReaddirEntry(&fsDirEntryPlusp->dirEntry, inode, cookie,
                                        &name[0], nameLen);
	memcpy(&fsDirEntryPlusp->handle, fhandlep, sizeof(fs_Handle));	
	fs_rxSimFillAttributes(&fsDirEntryPlusp->attr, FS_FTYPE_REG, FALSE);
        length += sizeof(fs_DirEntryPlus) + nameLen;


        return (length);



}
void fs_rxSimFillFhandle(fs_Handle *parentHandlep, fs_Handle *fileHandlep)   
{

	fileHandlep->volId = parentHandlep->volId;
	fileHandlep->inum = parentHandlep->inum + 10;
	fileHandlep->gen = parentHandlep->gen;

}

/*
 *fs_rxSim: receive a file system control message from NFS module, 
 *sends a fake reply back to the NFS module
 */ 
void fs_rxSim (uchar8 *msgp, uint32 rxMsgLen, uint32 destPort, uint32 sourcePort)
{
	eee_descBuf_t  *bd;
	fs_MsgReqHdr    *fsMsgReqHdrp;
	char		*sendMsgp;
	eee_desc_t 	*eDescp;
	uint32		msgLen;

	fsMsgReqHdrp = (fs_MsgReqHdr *)msgp;

	NFS_DBG_PRINTF("fs_rxSim 1: requestType: %d\n", fsMsgReqHdrp->requestType);		
	sendMsgp = &fs_testMsg[0];	

        switch (fsMsgReqHdrp->requestType)
        {
        case FS_REQ_NULL:                           // do nothing
        case FS_REQ_GET_ATTR:                       // get attributes of a file or dir
        {
		fs_MsgGetAttrResp	*fsGetAttrResp;

		fsGetAttrResp = (fs_MsgGetAttrResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsGetAttrResp->hdr, fsMsgReqHdrp->requestType, 
				fsMsgReqHdrp->flags,
				FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		NFS_DBG_PRINTF("fs_rxSim 2\n");
		fs_rxSimFillAttributes(&fsGetAttrResp->attr, FS_FTYPE_REG, FALSE);
		NFS_DBG_PRINTF("fs_rxSim 3\n");
		msgLen = sizeof(fs_MsgGetAttrResp);	
                break;

        }
        case FS_REQ_SET_ATTR:                   // set attributes of a file or dir
        {
		fs_MsgSetAttrReq	*fsSetAttReqp;
		fs_MsgSetAttrResp 	*fsSetAttrResp;

		fsSetAttReqp = (fs_MsgSetAttrReq *)msgp;
		fsSetAttrResp = (fs_MsgSetAttrResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsSetAttrResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		/*
		 *Fill in pre-op & post-op attributes
		 */
		fs_rxSimFillAttributes(&fsSetAttrResp->attr[0], FS_FTYPE_REG, TRUE);
		fs_rxSimFillAttributes(&fsSetAttrResp->attr[1], FS_FTYPE_REG, TRUE);
		/*
		memcpy(&fsSetAttrResp->attr[1], &fsSetAttReqp->attr, sizeof(fs_Attr));
		*/
		fs_rxUpdateSetAttr(&fsSetAttReqp->attr, &fsSetAttrResp->attr[1]);
		msgLen = sizeof(fs_MsgSetAttrResp) + sizeof(fs_Attr) + sizeof (fs_Attr);
                break;
        }

        case FS_REQ_LOOKUP:                     // lookup attributes of a file
        {
		fs_MsgLookupReq		*fsLookupReqp;
		fs_MsgLookupResp	*fsLookupResp;

		NFS_DBG_PRINTF("fs_rxSim 5: LookupReq\n");
		fsLookupReqp = (fs_MsgLookupReq *)msgp;
		fsLookupResp = (fs_MsgLookupResp  *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsLookupResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		/*
		 *Fake out return filehandle
		 */
		fs_rxSimFillFhandle(&fsLookupReqp->parentHandle, &fsLookupResp->fileHandle);
		/*
		 *Fill in parent dir attributes & lookup object attributes
		 */
		fs_rxSimFillAttributes(&fsLookupResp->attr[0], FS_FTYPE_DIR, FALSE);
		fs_rxSimFillAttributes(&fsLookupResp->attr[1], FS_FTYPE_REG, FALSE);
		msgLen = sizeof (fs_MsgLookupResp) + sizeof(fs_Attr) + sizeof(fs_Attr);
                break;
        }
        case FS_REQ_ACCESS:                     // check access permission on object
        {
		fs_MsgAccessReq		*fsAccessReqp;
		fs_MsgAccessResp	*fsAccessResp;

		/*
		 *Fake out Access Reply from file system.
		 *Sends reply back to NFS module
		 */
		fsAccessReqp = (fs_MsgAccessReq *)msgp;
		fsAccessResp = (fs_MsgAccessResp  *)fs_testMsg;
                fs_rxSimFillRespHdr(&fsAccessResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		fsAccessResp->accessBits = fsAccessReqp->accessBits;
		NFS_DBG_PRINTF("fs_rxSim: accessBits: %08x\n", fsAccessResp->accessBits);
		fs_rxSimFillAttributes(&fsAccessResp->attr[0], FS_FTYPE_REG, FALSE);
		msgLen = sizeof(fs_MsgAccessResp) + sizeof(fs_Attr);

                break;
        }
        case FS_REQ_READLINK:                   // read a soft link
        {
		fs_MsgReadLinkResp	*fsReadLinkResp;

		/*
		 *Fake a Readlink resp. from file system
		 */
		fsReadLinkResp = (fs_MsgReadLinkResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsReadLinkResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		fs_rxSimFillAttributes(&fsReadLinkResp->attr[0], FS_FTYPE_LNK, FALSE);
		/*
		fsReadLinkResp->nameLen = 8;
		memcpy(&fsReadLinkResp->linkName, "linktext", 8);
		*/
		fsReadLinkResp->nameLen = 17;
		memcpy(&fsReadLinkResp->linkName, "/export/home/data", fsReadLinkResp->nameLen);
		msgLen = sizeof(fs_MsgReadLinkResp) + sizeof(fs_Attr) + fsReadLinkResp->nameLen;
                break;
        }
        case FS_REQ_READ:                       // read data from a file
		{
			fs_MsgReadResp		*fsReadResp;
			fs_MsgReadReq		*fsReadReqp;

			fsReadReqp = (fs_MsgReadReq *)msgp;
			fsReadResp = (fs_MsgReadResp *)fs_testMsg;
			fs_rxSimFillRespHdr(&fsReadResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
			fs_rxSimFillAttributes(&fsReadResp->attr[0], FS_FTYPE_REG, FALSE);
			fsReadResp->bytesRead = fsReadReqp->readLength;
			fsReadResp->eof = 1;
			msgLen = sizeof(fs_MsgReadResp) + sizeof(fs_Attr);
			break;
		}
        case FS_REQ_WRITE:                      // write data to a file
		{
			fs_MsgWriteResp		*fsWriteResp;
			fs_MsgWriteReq		*fsWriteReqp;

			/*
			 *Fake a Write Resp from file system
			 */
			fsWriteReqp = (fs_MsgWriteReq *)msgp;			
			fsWriteResp = (fs_MsgWriteResp *)fs_testMsg;
			fs_rxSimFillRespHdr(&fsWriteResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
			fs_rxSimFillAttributes(&fsWriteResp->attr[0], FS_FTYPE_REG, TRUE);
			fs_rxSimFillAttributes(&fsWriteResp->attr[1], FS_FTYPE_REG, FALSE);
			/*
			fsWriteResp->bytesWrite = fsWriteReqp->writeLength;
			*/
			msgLen = sizeof(fs_MsgWriteResp) + sizeof(fs_Attr) + sizeof(fs_Attr);
			break;
		}
        case FS_REQ_CREATE:                     // create a new file
        {
		fs_MsgCreateReq		*fsCreateReqp;
		fs_MsgCreateResp	*fsCreateResp;

		fsCreateReqp = (fs_MsgCreateReq *)msgp;
		fsCreateResp = (fs_MsgCreateResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsCreateResp->hdr,  fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
                /*
                 *Fake out return filehandle
                 */
                fs_rxSimFillFhandle(&fsCreateReqp->parentHandle, &fsCreateResp->fileHandle);

		/*STOP HERE*/
		/*
		 *Fill pre-op & post-op parent dir attributes, and post-op file attributes
		 *in respective order
		 */
		fs_rxSimFillAttributes(&fsCreateResp->attr[0], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsCreateResp->attr[1], FS_FTYPE_DIR, FALSE);
		fs_rxSimFillAttributes(&fsCreateResp->attr[2], FS_FTYPE_REG, FALSE);
		msgLen = sizeof (fs_MsgCreateResp) + sizeof(fs_Attr) + sizeof(fs_Attr) +
			sizeof(fs_Attr);
                break;
        }
        case FS_REQ_MKDIR:                      // create a new directory
        {
		fs_MsgMkdirReq		*fsMkdirReqp;
		fs_MsgMkdirResp		*fsMkdirResp;
		
		fsMkdirReqp = (fs_MsgMkdirReq *)msgp;
		fsMkdirResp = (fs_MsgMkdirResp *)fs_testMsg;
                fs_rxSimFillRespHdr(&fsMkdirResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		fs_rxSimFillFhandle(&fsMkdirReqp->parentHandle, &fsMkdirResp->dirHandle);
		fs_rxSimFillAttributes(&fsMkdirResp->attr[0], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsMkdirResp->attr[1], FS_FTYPE_DIR, FALSE);
		fs_rxUpdateSetAttr(&fsMkdirReqp->dirAttr, &fsMkdirResp->attr[2]);
		msgLen = sizeof(fs_MsgMkdirResp) + sizeof(fs_Attr) + sizeof(fs_Attr) +
				sizeof (fs_Attr);
		break;
        }
        case FS_REQ_SYMLINK:                    // create a soft link
        {
		fs_MsgSymLinkResp	*fsSymlinkResp;
		fs_MsgSymLinkReq 	*fsSymlinkReqp;

		fsSymlinkReqp = (fs_MsgSymLinkReq *)msgp;		
		/*
		 *Build a fake reply from the file system
		 */
		fsSymlinkResp = (fs_MsgSymLinkResp       *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsSymlinkResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		/*
		 *Fake out return filehandle
		 */
		fs_rxSimFillFhandle(&fsSymlinkReqp->parentHandle, &fsSymlinkResp->fileHandle);
		/*
		 *Fill pre-op & post-op parent dir attributes, and post-op file attributes
		 *in respective order
		 */
		fs_rxSimFillAttributes(&fsSymlinkResp->attr[0], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsSymlinkResp->attr[1], FS_FTYPE_DIR, FALSE);
		fs_rxSimFillAttributes(&fsSymlinkResp->attr[2], FS_FTYPE_LNK, FALSE);
		msgLen = sizeof(fs_MsgSymLinkResp) + sizeof(fs_Attr) + sizeof(fs_Attr) + 
				sizeof (fs_Attr);					
                break;
        }
        case FS_REQ_MKNOD:                      // create device file
        {
                break;
        }
        case FS_REQ_REMOVE:                     // remove a file
        {
		fs_MsgRemoveResp	*fsRemoveResp;

		fsRemoveResp = (fs_MsgRemoveResp *)fs_testMsg;
		NFS_DBG_PRINTF("fsMsgReqHdrp->clientPrivate: %08x\n", fsMsgReqHdrp->clientPrivate);
		fs_rxSimFillRespHdr(&fsRemoveResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		/*
		 *Fill in pre-op & post-op from/to directory attributes
		 */
		fs_rxSimFillAttributes(&fsRemoveResp->attr[0], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsRemoveResp->attr[1], FS_FTYPE_DIR, FALSE);
		msgLen = sizeof (fs_MsgRemoveResp) + sizeof(fs_Attr) + sizeof(fs_Attr);

                break;

        }

        case FS_REQ_RMDIR:                      // remove a directory
        {
		fs_MsgRmdirResp		*fsRmdirResp;

		fsRmdirResp = (fs_MsgRmdirResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsRmdirResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		/*
		 *Fill in pre-op & post-op from/to directory attributes
		 */
		fs_rxSimFillAttributes(&fsRmdirResp->attr[0], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsRmdirResp->attr[1], FS_FTYPE_DIR, FALSE);
		msgLen = sizeof (fsRmdirResp) + sizeof(fs_Attr) + sizeof(fs_Attr);

                break;
        }
        case FS_REQ_RENAME:                     // rename a file or directory
        {
		fs_MsgRenameResp	*fsRenameResp;

		fsRenameResp = (fs_MsgRenameResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsRenameResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		/*
		 *Fill in pre-op & post-op from/to directory attributes
		 */
		fs_rxSimFillAttributes(&fsRenameResp->attr[0], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsRenameResp->attr[1], FS_FTYPE_DIR, FALSE);
		fs_rxSimFillAttributes(&fsRenameResp->attr[2], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsRenameResp->attr[3], FS_FTYPE_DIR, FALSE);
		msgLen = sizeof(fs_MsgRenameResp) + sizeof(fs_Attr) + sizeof(fs_Attr) +
			sizeof(fs_Attr) + sizeof(fs_Attr);
                break;
        }
        case FS_REQ_HARDLINK:                   // create a hard link to a file
	{
		fs_MsgHardLinkResp	*fsHardlinkResp;
	
		fsHardlinkResp = (fs_MsgHardLinkResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsHardlinkResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		/*
		 *Fill in pre-op & post-op from/to directory attributes
		 */
		fs_rxSimFillAttributes(&fsHardlinkResp->attr[0], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsHardlinkResp->attr[1], FS_FTYPE_DIR, FALSE);
		fs_rxSimFillAttributes(&fsHardlinkResp->attr[2], FS_FTYPE_DIR, TRUE);
		fs_rxSimFillAttributes(&fsHardlinkResp->attr[3], FS_FTYPE_DIR, FALSE);
		msgLen = sizeof (fs_MsgHardLinkResp) + sizeof(fs_Attr) + sizeof(fs_Attr) +
			sizeof(fs_Attr) + sizeof(fs_Attr);

                break;
	}
        case FS_REQ_READDIR:                    // read a directory's contents
	{
		fs_MsgReadDirResp	*fsReaddirResp;
		int32			length;

		fsReaddirResp = (fs_MsgReadDirResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsReaddirResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		fs_rxSimFillAttributes(&fsReaddirResp->dirAttr, FS_FTYPE_DIR, FALSE);
		fsReaddirResp->cookieVerif = 0x384776251efe9200;
		length = fs_rxFillDirEntry(fsReaddirResp);		
		fsReaddirResp->eof = 1;
		msgLen = sizeof (fs_MsgReadDirResp) + length;	
                break;
	}
        case FS_REQ_READDIRPLUS:                // read a directory's contents & attributes
	{
		fs_MsgReadDirPlusReq	*fsReaddirplusReqp;
		fs_MsgReadDirPlusResp	*fsReaddirplusResp;
		int32			length;
	
		fsReaddirplusReqp = (fs_MsgReadDirPlusReq *)msgp;	
		fsReaddirplusResp = (fs_MsgReadDirPlusResp   *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsReaddirplusResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		fs_rxSimFillAttributes(&fsReaddirplusResp->attr, FS_FTYPE_DIR, FALSE);
		fsReaddirplusResp->cookieVerif = 0x384776251efe9200;
		length = fs_rxFillDirEntryPlus(fsReaddirplusResp, &fsReaddirplusReqp->fileHandle);
		fsReaddirplusResp->eof = 1;
		msgLen = sizeof(fs_MsgReadDirPlusResp) + length;	
                break;
	}
        case FS_REQ_STAT:                       // get filesystem stats
	{
		fs_MsgStatResp		*fsStatResp;

		fsStatResp = (fs_MsgStatResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsStatResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);

		fs_rxSimFillAttributes(&fsStatResp->attr, FS_FTYPE_DIR, FALSE);
		fs_rxFillStatInfo(&fsStatResp->stat);
		msgLen = sizeof(fs_MsgStatResp);
                break;
	}
        case FS_REQ_FSINFO:                     // get statis filesystem information
	{
		fs_MsgFsinfoResp	*fsInfoResp;

		fsInfoResp = (fs_MsgFsinfoResp *)fs_testMsg;
                fs_rxSimFillRespHdr(&fsInfoResp->hdr, fsMsgReqHdrp->requestType,
                                fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		fs_rxSimFillAttributes(&fsInfoResp->attr, FS_FTYPE_DIR, FALSE);
		fs_rxFillFsInfo(&fsInfoResp->fsinfo);
		msgLen = sizeof(fs_MsgFsinfoResp);
                break;
	}
        case FS_REQ_PATHCONF:                   // get POSIX info
                break;
        case FS_REQ_COMMIT:                     // commit mods to stable storage

                break;
	case FS_REQ_GET_ROOT:
	{
		fs_MsgGetRootResp	*fsGetRootResp;
		fs_Handle		*fhandlep;

		fsGetRootResp = (fs_MsgGetRootResp *)fs_testMsg;
		fs_rxSimFillRespHdr(&fsGetRootResp->hdr, fsMsgReqHdrp->requestType,
				fsMsgReqHdrp->flags,
                                FS_ERR_NONE, fsMsgReqHdrp->clientPrivate);
		/*FHANDLE: volid: 512 inode: 201326592 gen: 38666240*/
		fhandlep = &fsGetRootResp->dirHandle;
		fhandlep->volId.whole_thing = 512; 
		fhandlep->inum = 201326592;
		fhandlep->gen = 38666240;
		msgLen = sizeof(fs_MsgGetRootResp);
		break;		

	}

        }       /*switch*/

	/*
	 *
	 *Send response message to NFS 
	 */
	eDescp = &eDescriptor;
	bd = &eDescp->bd[1];
	memset(fs_respMsg, 0, 1024);
	bd->buf = &fs_respMsg[0];
	memcpy(bd->buf, sendMsgp, msgLen);
	bd->len = msgLen;
	/*
	 *Send response message back to NFS
	 */
	NFS_DBG_PRINTF("fs_rxSim: Msglen: %d\n", msgLen);
	nfs_msgRcv( eDescp );	
}
 
int32
nfs_eee_sendMessage( uchar8 *src,
                        uint32 num_bytes,
                        uint32 dest_port,
                        uint32 source_port )
{

	NFS_DBG_PRINTF("eee_sendMessage 1\n");	
	/*
	 *Fake a file system reply and sends back to NFS module
	 */
	fs_rxSim(src, num_bytes, dest_port,source_port);
}

#endif	/*NOTUSED*/
