// vi:ts=4
#include <stdio.h>

#include "exports/opt-api.h"

static void
usage (char *name)
{
	printf ("To get: %s g opt-string\n", name);
	printf ("To set: %s s opt-string value\n", name);
	printf ("To del: %s d opt-string\n", name);
}

extern int
main (int argc, char *argv[])
{
	char **look;
	char **cfgObj;
	char *sObj[3];
	int rc;

	if ((argc == 3) && (*argv[1] == 'g')) {
		cfgObj = get_cfg_val (argv[2]);

		if (cfgObj) {

			for (look = cfgObj; *look; look += 2) {
				printf ("Got %s=%s\n", look[0], look[1]);
			}

			free_cfg_val (cfgObj);
		}
	}
	else if ((argc == 4) && (*argv[1] == 's')) {
		sObj[0] = argv[2];
		sObj[1] = argv[3];
		sObj[2] = NULL;
		rc = put_cfg_val (sObj);
		printf ("put returned %d\n", rc);
	}
	else if ((argc == 3) && (*argv[1] == 'd')) {
		sObj[0] = argv[2];
		sObj[1] = NULL;
		sObj[2] = NULL;
		rc = del_cfg_obj (sObj);
		printf ("del returned %d\n", rc);
	}
	else {
		usage (argv[0]);
	}
	return 0;
}
