/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name: ppm-hdr.h
 *
 * RCS:  $Id: ppm-hdr.h,v 1.2 2001/12/18 20:43:39 swang Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: ppm msg hdr definition
 *
 * Created by:	Su Wang
 *
 * Date Created: 10/16/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _PPM_HDR_H
#define _PPM_HDR_H

/* define groud ids */
#define PPM_IPM			0
#define PPM_CLIENT_MAX	1		/* depend on num of client registered */

/* define action */
#define PPM_ACT_NO		0
#define PPM_ACT_UI		1

/* max ppm msg size, including ppm hdr, client can change */
/* the value  */
#define PPM_MSG_MAX_SIZE		512		

/* txrx msg hdr */
typedef struct ppm_mhdr {
  union {
	uint32		parm1_cpu;		/* msg between ssc and txrx */
	uint32		parm1_mtype;		/* msg on ssc */
  } parm1;
  union {
	uint32		parm2_slot;		/* msg between ssc and txrx */
	uint32		parm2_client;	/* msg on ssc */
  } parm2;
  uint16		ppmh_gid;		/* grp id */
  uint16		ppmh_action;	/* action needed */
  uint32		ppmh_size;	    /* msg size */
} ppm_mhdr_t;

#define			ppmh_mtype		parm1.parm1_mtype
#define			ppmh_cpu		parm1.parm1_cpu
#define			ppmh_client		parm2.parm2_client
#define			ppmh_slot		parm2.parm2_slot
#endif /* _PPM_HDR_H */
