/*
 *------------------------------------------------------------------------------
 *
 * Name:	raid-xyratex.h
 *
 * RCS:		$Id: raid-xyratex.h,v 1.11 2002/10/23 18:37:03 nitinb Exp $
 *
 * Copyright (C) 2001, 2002 Agile Storage Inc.
 *
 * Description:	RAID config manager Xyratex specific definitions.
 *
 * Created by:	Radek Aster
 *
 * Date Created: 4/19/01
 *
 *------------------------------------------------------------------------------
 */

#ifndef __RAID_XYRATEX_H__
#define __RAID_XYRATEX_H__

#define MDACMD_IOCTL				0x22

#define MDACIOCTL_GETCONTROLLERINFO		0x01
#define	MDACIOCTL_GETLOGDEVINFOVALID	   	0x03	
#define	MDACIOCTL_GETPHYSDEVINFOVALID	   	0x05
#define	MDACIOCTL_RETRIEVEDEBUGDUMP		0x0C
#define MDACIOCTL_GETLOGDEVSTATISTICS	   	0x0d
#define	MDACIOCTL_GETPHYSDEVSTATISTICS		0x0F
#define	MDACIOCTL_GETEVENT			0x15
#define	MDACIOCTL_STOREIMAGE			0x2c
#define MDACIOCTL_FLASHIMAGES			0x2e
#define MDACIOCTL_GETSUBSYSTEMDATA		0x70
#define MDACIOCTL_SETSUBSYSTEMDATA		0x71
#define MDACIOCTL_STARTDISCOVERY		0x81	
#define MDACIOCTL_SETRAIDDEVSTATE		0x82
#define MDACIOCTL_LONGOPERATION			0x83
#define MDACIOCTL_INITRAIDDEVSTART		0x86     /* Start Foreground Initialisation */
#define MDACIOCTL_INITRAIDDEVSTOP		0x87     /* Stop  Foreground Initialisation */
#define MDACIOCTL_REBUILDRAIDDEVSTART		0x88
#define MDACIOCTL_REBUILDRAIDDEVSTOP		0x89
#define MDACIOCTL_MAKECONSISTENTDATASTART	0x8A     /* Start Background Initialisation */
#define MDACIOCTL_MAKECONSISTENTDATASTOP	0x8B     /* Stop  Background Initialisation */
#define MDACIOCTL_CONSISTENCYCHECKSTART		0x8C
#define MDACIOCTL_CONSISTENCYCHECKSTOP		0x8D
#define MDACIOCTL_RESETDEVICE			0x90
#define MDACIOCTL_FLUSHDEVICEDATA		0x91
#define MDACIOCTL_LOCATEDEVICE			0x94
#define MDACIOCTL_ENQ3				0xA0
#define MDACIOCTL_KILLPARTNER			0xA8
#define MDACIOCTL_RELINQUISHCONTROLLER		0xA9
#define MDACIOCTL_GETDUALCONTROLLERSTATUS	0xAA
#define MDACIOCTL_GETHOSTWWNTABLE		0xAB
#define MDACIOCTL_SETREALTIMECLOCK		0xAC
#define	MDACIOCTL_PASS_THRU_CDB			0xAD
#define	MDACIOCTL_PASS_THRU_INITIATE	   	0xAE
#define MDACIOCTL_SETHOSTWWNTABLE		0xAF
#define MDACIOCTL_CREATENEWCONF			0xC0
#define MDACIOCTL_DELETERAIDDEV			0xC1
#define MDACIOCTL_ADDNEWCONF			0xC4
#define	MDACIOCTL_XLATEPHYSDEVTORAIDDEV		0xC5
#define MDACIOCTL_MORE				0xC6
#define MDACIOCTL_SETPHYSDEVPARAMETER	   	0xC8
#define MDACIOCTL_CLEARCONF			0xCA
#define	MDACIOCTL_GETDEVCONFINFO		0xCB
#define MDACIOCTL_GETGROUPCONFINFO		0xCC
#define MDACIOCTL_GETFREESPACELIST		0xCD
#define MDACIOCTL_GETLOGDEVPARAMETER	   	0xCE
#define MDACIOCTL_SETLOGDEVPARAMETER		0xCF
#define	MDACIOCTL_GETCONTROLLERPARAMETER	0xD0
#define	MDACIOCTL_SETCONTROLLERPARAMETER	0xD1
#define MDACIOCTL_READSANMAP			0xD3
#define	MDACIOCTL_WRITESANMAP			0xD4
#define MDACIOCTL_GETENCLOSUREINFO		0xD8
#define MDACIOCTL_GETENVSTATUS			0xD7
#define MDACIOCTL_SETENVPARMS			0xD9

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_GETCONTROLLERINFO
 * --------------------------------------------------------------------------------------------------------------
 */
typedef struct {

	byte Reserved0;				/* Byte 0 */

	#define	SCSI_BUS_INTERFACE		0
	#define FIBRE_BUS_INTERFACE		1
	#define PCI_BUS_INTERFACE		3

	byte BusInterfaceType;                  /* Byte 1 - see above */

	#define	FSI_CT_DAC960E			0x01	               /* start of internal products */
	#define	FSI_CT_DAC960M			0x08
	#define	FSI_CT_DAC960PD			0x10
	#define	FSI_CT_DAC960PL			0x11
	#define	FSI_CT_DAC960PDU		0x12
	#define	FSI_CT_DAC960PE			0x13
	#define	FSI_CT_DAC960PG			0x14
	#define	FSI_CT_DAC960PJ			0x15
	#define	FSI_CT_DAC960PTL0		0x16
	#define	FSI_CT_DAC960PR			0x17
	#define	FSI_CT_DAC960PRL		0x18
	#define	FSI_CT_DAC960PT			0x19
	#define	FSI_CT_DAC1164P			0x1A
	#define	FSI_CT_DAC960PTL1		0x1B
	#define	FSI_CT_ExtremeRAID2000		0x1C
	#define	FSI_CT_ExtremeRAID3000		0x1D
	#define	FSI_CT_AcceleRAID352		0x1E
	#define	FSI_CT_AcceleRAID170		0x1F
	#define	FSI_CT_AcceleRAID160		0x20	               /* end of internal products */

	#define	FSI_CT_DAC960S      		0x60	               /* start of external products */
	#define	FSI_CT_DAC960SU     		0x61	
	#define	FSI_CT_DAC960SX     		0x62	
	#define	FSI_CT_DAC960SF     		0x63	
	#define	FSI_CT_DAC960SS     		0x64	
	#define	FSI_CT_DAC960FL     		0x65	
	#define	FSI_CT_DAC960LL     		0x66	
	#define	FSI_CT_DAC960FF     		0x67	
	#define	FSI_CT_DAC960HP     		0x68	
	#define	FSI_CT_METEOR_FL    		0x69	
	#define	FSI_CT_METEOR_FF    		0x6a	
	#define	FSI_CT_FFx          		0x6b
	#define FSI_CT_FF2			0x6c	
	#define FSI_CT_FFx2			0x6d	

	byte ControllerType;			/* Byte 2 - see above */
	byte Reserved1;				/* Byte 3 */
	byte BusInterfaceSpeed[ 2];		/* Byte 4 - Speed in MHz */
	byte BusWidthInBits;			/* Byte 6 - 1 = FC, 8 = SCSI, 16 = LVD */
	byte InternalFlashCode;			/* Byte 7 */
	byte nHostPortsPresent;			/* Byte 8 */
	byte Reserved2[ 7];			/* Byte 9 */
	byte BusInterfaceName[ 16];		/* Byte 16 */
	byte ControllerName[ 16];		/* Byte 32 */
	byte Reserved3[ 16];			/* Byte 48 */
                                                         
	/* Firmware Release Information */                    
	byte MajorFirmwareRev;                  /* Byte 64 */
	byte MinorFirmwareRev;                  /* Byte 65 */
	byte FWTurnNumber;                      /* Byte 66 */
	byte FWBuildNumber;			/* Byte 67 */
	byte FWReleaseDay;			/* Byte 68 */
	byte FWReleaseMonth;			/* Byte 69 */
	byte FWReleaseCentury;			/* Byte 70 */
	byte FWReleaseYear;			/* Byte 71 */
                                                         
	/* Hardware Release Information */                    
	byte HardwareRev;                       /* Byte 72 */
	byte Reserved4[ 3];                     /* Byte 73 */
	byte HWReleaseDay;			/* Byte 76 */
	byte HWReleaseMonth;			/* Byte 77 */
	byte HWReleaseCentury;			/* Byte 78 */
	byte HWReleaseYear;			/* Byte 79 */
                                                         
	/* Hardware Manufacturing Information */              
	byte BatchNumber;		        /* Byte 80 */
	byte Reserved5;                         /* Byte 81 */
	byte PlantNumber;                       /* Byte 82 */
	byte Reserved6;                         /* Byte 83 */
	byte HWMfgDay;				/* Byte 84 */
	byte HWMfgMonth;			/* Byte 85 */
	byte HWMfgCentury;			/* Byte 86 */
	byte HwMfgYear;				/* Byte 87 */
	byte MaxPDD;				/* Byte 88 - Max # of PDDs per XLD/ILD */
	byte MaxILD;				/* Byte 89 - Max # of ILDs per XLD */
	byte NVRamSizeKB[ 2];                   /* Byte 90 */
	byte MaxXLD;				/* Byte 92 - Max # of XLDs */
	byte Reserved7[ 3];                     /* Byte 93 */
                                                         
	/* Unique Information Per Controller */               
	char SerialNumber[ 16];		        /* Byte 96 */
	byte Reserved8[ 16];                    /* Byte 112 */
	                                                      
	/* Vendor Information */                              
	byte Reserved9[ 3];                     /* Byte 128 */
	byte OEMInfo;				/* Byte 131 */ 
	char VendorName[ 16];			/* Byte 132 */
		
	/* Other Physical/Controller/Operation Information */
	#define	BBU_PRESENT_MASK		0x01;
	#define	ACTIVEACTIVE_CLUSTER_MASK	0x02;

	byte OtherPCOInfo;                      /* Byte 148 */
	byte Reserved10[ 3];                    /* Byte 149 */
                                                         
	/* Physical Device Scan Information */                
	#define	SCANISACTIVE_MASK		0x01;                
                                                         
	byte PDScanInfo;                        /* Byte 152 */
	byte PDChannel;                         /* Byte 153 */
	byte PDTargetID;                        /* Byte 154 */
	byte PDLUN;                             /* Byte 155 */
                                                         
	/* Maximum Command Data Transfer Sizes */             
	byte MaxTransferBlocks[ 2];             /* Byte 156 */
	byte MaxSGEntriesPerCh[ 2];             /* Byte 158 */
                                                         
	/* Logical/Physical Drive Counts */                   
	byte nLDPresent[ 2];                    /* Byte 160 */
	byte nLDCritical[ 2];                   /* Byte 162 */
	byte nLDOffline[ 2];                    /* Byte 164 */
	byte nPDPresentAllHw[ 2];               /* Byte 166 */
	byte nPDPresent[ 2];                    /* Byte 168 */
	byte nPDCritical[ 2];                   /* Byte 170 */
	byte nPDOffline[ 2];                    /* Byte 172 */
	byte MaxParallelCommands[ 2];           /* Byte 174 */
                                                         
	/* Channel and Target ID Information */               
	byte nPhysicalChannels;                 /* Byte 176 */
	byte nVirtualChannels;                  /* Byte 177 */
	byte MaxPhysicalChannels;               /* Byte 178 */
	byte MaxVirtualChannels;                /* Byte 179 */
	byte MaxTargetsPerCh[ 8];               /* Byte 180 */
	byte ChannelStatus[ 8];                 /* Byte 188 */    
	byte Reserved11[ 12];                   /* Byte 196 */
		                                                   
	/* Memory/Cache Information */                        
	byte DRAMSizeMB[ 2];		        /* Byte 208 */
	byte CacheSizeMB[ 2];                   /* Byte 210 */
	byte ValidCacheSizeBytes[ 4];           /* Byte 212 */
	byte DirtyCacheSizeBytes[ 4];           /* Byte 216 */
	byte MemorySpeed[ 2];                   /* Byte 220 */
	byte MaxMemoryDataWidthSizeBits;        /* Byte 222 */

	#define	DRAM_CACHE			0x01
	#define	EDRAM_CACHE			0x02
	#define	EDO_CACHE			0x03
	#define	SDRAM_CACHE			0x04	/* more bits used but not defined */

	byte CacheType;                         /* Byte 223 */
	char CacheTypeString[ 16];              /* Byte 224 */

	/* Execution Memory Info - Present only in dual memory architecture */
	byte DualMemSizeMB[ 2];                 /* Byte 240 */
	byte L2CacheSizeKB[ 2];                 /* Byte 242 */
	byte Reserved12[ 8];                    /* Byte 244 */
	byte DualMemorySpeed[ 2];               /* Byte 252 */
	byte DualMaxMemoryDataWidthSizeBits;    /* Byte 254 */
	byte DualMemoryType;                    /* Byte 255 */
	char DualMemoryTypeString[ 16];         /* Byte 256 */
                                                         
	/* First CPU Type information */                      
	byte CPU0SpeedMhz[ 2];                  /* Byte 272 */
                                                         
	#define	CPU_i960CA			0x01                       
	#define	CPU_i960RD			0x02                       
	#define	CPU_i960RN			0x03                       
	#define	CPU_i960RP			0x04                       
	#define	CPU_Northbay			0x05                       
	#define	CPU_StrongArm			0x06                       
	#define	CPU_i960RM			0x07                       
	#define	CPU_StrongArm2			0x08                       
			                                                
	byte CPU0Type;                          /* Byte 274 */
	byte CPU0Count;                         /* Byte 275 */
	byte Reserved13[ 12];                   /* Byte 276 */
	char CPU0NameString[ 16];               /* Byte 288 */

	/* Second CPU Type information */
	byte CPU1SpeedMhz[ 2];                  /* Byte 304 */
	byte CPU1Type;                          /* Byte 306 */
	byte CPU1Count;                         /* Byte 307 */
	byte Reserved14[ 12];                   /* Byte 308 */
	char CPU1NameString[ 16];               /* Byte 320 */

	/* Debugging/Profiling/Command Time Tracing Information */
	byte ProfileDataPageNo[ 2];             /* Byte 336 */
	byte nProgramsWaitingForProfile[ 2];    /* Byte 338 */
	byte CommandTraceDataPageNo[ 2];        /* Byte 340 */
	byte nCommandTraceWaitingForProfile[ 2];/* Byte 342 */
	byte Reserved15[ 8];                    /* Byte 344 */

	/* Error counters on physical devices */
	byte nPDResets[ 2];                     /* Byte 352 */
	byte nPDParityErrors[ 2];               /* Byte 354 */
	byte nPDSoftErrors[ 2];                 /* Byte 356 */
	byte nPDCommandsFailed[ 2];             /* Byte 358 */
	byte nPDMiscErrors[ 2];                 /* Byte 360 */
	byte nPDTimeoutErrors[ 2];              /* Byte 362 */
	byte nPDSelectionTimeoutErrors[ 2];     /* Byte 364 */
	byte nPDRetries[ 2];                    /* Byte 366 */
	byte nPDAborts[ 2];                     /* Byte 368 */
	byte nPDHostCommandAborts[ 2];          /* Byte 370 */
	byte nPDPFADetected[ 2];                /* Byte 372 */
	byte nPDHostCommandFailed[ 2];          /* Byte 374 */
	byte nPDHardErrors[ 2];                 /* Byte 376 */
	byte Reserved16[ 6];                    /* Byte 378 */

	/* Error counters on logical devices */
	byte nLDSoftErrors[ 2];                 /* Byte 384 */   
	byte nLDCommandsFailed[ 2];             /* Byte 386 */
	byte nLDHostCommandAborts[ 2];          /* Byte 388 */
	byte Reserved17[ 2];                    /* Byte 390 */

	/* Error counters on controller */
	byte nControllerMemoryParityErrors[ 2]; /* Byte 392 */
	byte nControllerHostCommandAborts[ 2];  /* Byte 394 */
	byte Reserved18[ 4];                    /* Byte 396 */

	/* Long duration activity information */
	byte nLongBgInitActive[ 2];             /* Byte 400 */
	byte nLongLDInitActive[ 2];             /* Byte 402 */
	byte nLongPDInitActive[ 2];             /* Byte 404 */
	byte nLongCCActive[ 2];                 /* Byte 406 */
	byte nLongRBActive[ 2];                 /* Byte 408 */ 
	byte nLongMOActive[ 2];                 /* Byte 410 */
	byte nLongPAActive[ 2];                 /* Byte 412 */
	byte Reserved19[ 2];                    /* Byte 414 */

	/* Flash ROM Info */
	byte FlashType;                         /* Byte 416 */
	byte Reserved20;                        /* Byte 417 */
	byte FlashSizeMB[ 2];                   /* Byte 418 */
	byte nMaxFlashes[ 4];                   /* Byte 420 */
	byte nFlashesDone[ 4];                  /* Byte 424 */
	byte Reserved21[ 4];                    /* Byte 428 */
	char FlashTypeString[ 16];              /* Byte 432 */

	/* Firmware runtime information */
	byte RebuildRate;                       /* Byte 448 */
	byte BgInitRate;                        /* Byte 449 */
	byte FgInitRate;                        /* Byte 450 */
	byte CCRate;                            /* Byte 451 */
	byte CCInfo[ 2];                        /* Byte 452 */
	byte Reserved22[ 2];                    /* Byte 454 */
	byte MaxDP[ 4];                         /* Byte 456 */
	byte FreeDP[ 4];                        /* Byte 460 */
	byte MaxIOP[ 4];                        /* Byte 464 */
	byte FreeIOP[ 4];                       /* Byte 468 */
	byte nMaxCombLength[ 2];                /* Byte 472 */
	byte nConfigGroups[ 2];                 /* Byte 474 */
	byte ControllerStatus[ 4];              /* Byte 476 */
	byte LongOpsBitMap[ 32];                /* Byte 480 */

	/* External Products information and status */
	byte EnquiryStatus;                     /* Byte 512 */
	byte EnquiryMisc;                       /* Byte 513 */
	byte Reserved23[ 2];                    /* Byte 514 */
	byte PartnerCtrlFWMajor;                /* Byte 516 */
	byte PartnerCtrlFWMinor;                /* Byte 517 */
	byte PartnerCtrlFWBuild;                /* Byte 518 */
	byte PartnerCtrlFWMismatchCode;         /* Byte 519 */
			
	/* Dual controller status info */
	#define	DCFORMAT_ORIGINAL		0
	#define	DCFORMAT_TID			1
	#define	DCFORMAT_LUN			2

	byte DCStatFormat;                      /* Byte 520 */
	byte DCStatLun;                         /* Byte 521 */
	byte DCStatSD;                          /* Byte 522 */
	byte DCStatLength;                      /* Byte 523 */
	byte DCStatState[ 4];                   /* Byte 524 */
	byte DCStatStateInfo[ 4];               /* Byte 528 */
	byte DCStatPartnerStatus[ 4];           /* Byte 532 */
	byte DCStatControllerInfo[ 4];          /* Byte 536 */
	byte Slot0WWN[ 8];                      /* Byte 540 */
	byte Slot0Pld[ 2];                      /* Byte 548 */
	byte Slot0rsvd[ 2];                     /* Byte 550 */
	byte Slot1WWN[ 8];                      /* Byte 552 */
	byte Slot1Pld[ 2];                      /* Byte 560 */
	byte Slot1rsvd[ 2];                     /* Byte 562 */
	byte ChannelSpeedInfo[ 12];             /* Byte 564 */
	byte HostChConType[ 4];                 /* Byte 576 */
	byte Reserved24[ 444];                  /* Byte 580 */
} FSI_ControllerInfo_t;

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_GETCONTROLLERPARAMETER
 * --------------------------------------------------------------------------------------------------------------
 */
typedef struct {
#define FSI_CPARMS_B0_RDAHEN			0x01
#define FSI_CPARMS_B0_BILODLY			0x02
#define FSI_CPARMS_B0_FUA_DISABLE		0x04
#define FSI_CPARMS_B0_REASS1S			0x08
#define FSI_CPARMS_B0_TRUVRFY			0x10
#define FSI_CPARMS_B0_DWTVRFY			0x20
#define FSI_CPARMS_B0_BG_INIT			0x40
#define FSI_CPARMS_B0_CLUSTERING		0x80
        byte           Byte0;			/* byte 0 */
#define FSI_CPARMS_B1_SUPERREADAHEAD		0x80
        byte           Byte1;			/* byte 1 */
#define FSI_CPARMS_B2_DEVICE_COMBING		0x01
        byte           Byte2;			/* byte 2 */
        byte           Byte3;			/* byte 3 */
#define FSI_CPARMS_B4_V_DEC			0x01
#define FSI_CPARMS_B4_SAFTE			0x02
#define FSI_CPARMS_B4_SES			0x04
#define FSI_CPARMS_B4_V_ARM			0x20
#define FSI_CPARMS_B4_V_OFM			0x40
        byte           Byte4;			/* byte 4 */
        byte           RebuildRate;		/* byte 5 - Rebuild rate 0-50 */
        byte           CacheLineSize;		/* byte 6 */
	byte	       OEMCode;			/* byte 7 */
        byte           StartUpMode;		/* byte 8 */
        byte           SpinDevs;		/* byte 9 */
        byte           SpinDelay1;		/* byte 10 */
        byte           SpinDelay2;		/* byte 11 */
#define FSI_CPARMS_B12_VUTURSNS			0x08
#define FSI_CPARMS_B12_DCCFIL			0x10
#define FSI_CPARMS_B12_NOPAUSE			0x20
#define FSI_CPARMS_B12_DISQFULL			0x40
#define FSI_CPARMS_B12_DISBUSY			0x80
        byte           Byte12;			/* byte 12 */
#define FSI_CPARMS_B13_FAILOVERNODENAME		0x04
#define FSI_CPARMS_B13_DISABLE_UPS		0x80
#define FSI_CPARMS_B13_FTOPO_MASK		0x70
#define FSI_CPARMS_B13_FTOPO_SHIFT		4
#define FSI_CPARMS_B13_FTOPO_INACTIVE_PORT	0
#define FSI_CPARMS_B13_FTOPO_MULTIPORT		1
#define FSI_CPARMS_B13_FTOPO_CLUSTERING		2
#define FSI_CPARMS_B13_FTOPO_MULTI_ID		3
#define FSI_CPARMS_B13_FTOPO_MASTER_SLAVE	4
        byte           Byte13;			/* byte 13 */
#define FSI_CPARMS_B14_RESET_PROPAGATE_RESET	0x02
#define FSI_CPARMS_B14_RESET_NONSTD_MP_RESET	0x04
        byte           ResetStyle;		/* byte 14 */
#define FSI_CPARMS_B15_SERIAL_CONTROL_DEBUG	0x01
#define FSI_CPARMS_B15_SERIAL_CONTROL_VT100	0x03
        byte           SerialControl;		/* byte 15 */
#define FSI_CPARMS_B16_SERIAL_BAUD_19200	6
#define FSI_CPARMS_B16_SERIAL_BAUD_9600		5
#define FSI_CPARMS_B16_SERIAL_BAUD_4800		4
#define FSI_CPARMS_B16_SERIAL_BAUD_2400		3
        byte           SerialBaud;		/* byte 16 */
#define FSI_CPARMS_B17_SERIAL_PCONTROL_CBITS7	0x01
#define FSI_CPARMS_B17_SERIAL_PCONTROL_CSTOP1	0x02
#define FSI_CPARMS_B17_SERIAL_PCONTROL_CSTOP15	0x04
#define FSI_CPARMS_B17_SERIAL_PCONTROL_CPARDIS	0x10
#define FSI_CPARMS_B17_SERIAL_PCONTROL_CPARODD	0x20
        byte           SerialPortControl;	/* byte 17 */
        byte           Byte18;			/* byte 18 */
#define FSI_CPARMS_B19_SMARTLARGEHOSTXFERS	0x01
#define FSI_CPARMS_B19_FRAME_SIZE_MASK		0x0c
#define FSI_CPARMS_B19_FRAME_SIZE_2048		0x00
#define FSI_CPARMS_B19_FRAME_SIZE_512		0x04
#define FSI_CPARMS_B19_FRAME_SIZE_1024		0x08
#define FSI_CPARMS_B19_PCI_LATENCY_MASK		0x30
#define FSI_CPARMS_B19_PCI_LATENCY_SHIFT	4
#define FSI_CPARMS_B19_PCI_LATENCY_SHORT	0
#define FSI_CPARMS_B19_PCI_LATENCY_MED		1
#define FSI_CPARMS_B19_PCI_LATENCY_LONG		2
        byte           Byte19;			/* byte 19 */
#define FSI_CPARMS_B20_MS_AUTOREST		0x01
        byte           Byte20;			/* byte 20 */
#define FSI_CPARMS_B21_MS_AA_FSIM		0x01
#define FSI_CPARMS_B21_MS_AA_CCASH		0x02
#define FSI_CPARMS_B21_MS_AA_FAULT_SIGNALS	0x04
#define FSI_CPARMS_B21_MS_AA_C4_FAULTS		0x08
        byte           AAbits;			/* byte 21 */
#define FSI_CPARMS_B22_MS_FLG_SIMPLEX_NO_RSTCOM	0x01
        byte           SimplexNoReset;		/* byte 22 */
        byte           QueueLimit;		/* byte 23 */
        byte           HardLoopID[2][2];	/* byte 24 */
        byte           Byte28[34];		/* byte 28 */
        byte           Byte62[4];		/* byte 62 */
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_MASK	0xf0
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_SHIFT	4
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_NEVER	0
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_3MIN	1
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_5MIN	2
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_15MIN	3
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_30MIN	4
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_60MIN	5
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_90MIN	6
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_2HRS	7
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_4HRS	8
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_8HRS	9
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_12HRS	10
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_16HRS	11
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_24HRS	12
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_2DAYS	13
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_4DAYS	14
#define FSI_CPARMS_B66_ROF_REARM_INTERVAL_7DAYS	15
#define FSI_CPARMS_B66_ROF_REBOOT_COUNT_MASK	0x0f
#define FSI_CPARMS_B66_ROF_REBOOT_COUNT_SHIFT   0
	byte	       ROFControl;		/* byte 66 */
        byte           DebugDumpEnable;		/* byte 67 */
        byte           Byte68[30];		/* byte 68 */
        byte           BGIRate;			/* byte 98 - Background Init rate 0-50 */
        byte           MoreRate;		/* byte 99 - More rate 0-50 */
        byte           ConsistencyCheckRate;	/* byte 100 - Consistency Check rate 0-50 */
        byte           Byte101[27];		/* byte 101 */
} FSI_ControllerParms_t;

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_GETPHYSDEVINFOVALID
 * --------------------------------------------------------------------------------------------------------------
 */
typedef	struct {
	byte Reserved0;				/* Byte 0 */
	byte ch;				/* Byte 1 */
	byte id;				/* Byte 2 */
	byte Reserved1;				/* Byte 3 - LUNId for internal products only */
	byte StatusBits;			/* Byte 4 */
	byte MHStatusBits;			/* Byte 5 */
	byte PDState;				/* Byte 6 */
	byte DataWidth;				/* Byte 7 */
	byte NegDevSpeed[2];			/* Byte 8 */
	byte nPC;				/* Byte 10 */
	byte ChannelBits;			/* Byte 11 */
	byte Reserved2[4];			/* Byte 12 */
	byte MacAddress[16];			/* Byte 16 */
	byte MaxTags[2];			/* Byte 32 */
	byte PDStat;				/* Byte 34 */
	byte LongStat;				/* Byte 35 */
	byte ParityErrors;			/* Byte 36 */
	byte SoftErrors;			/* Byte 37 */
	byte HardErrors;			/* Byte 38 */
	byte MiscErrors;			/* Byte 39 */
	byte Timeouts;				/* Byte 40 */
	byte Retries;				/* Byte 41 */
	byte Aborts;				/* Byte 42 */
	byte PFAFault;				/* Byte 43 - 1 = PFA (SMART) error */	
	byte Reserved3[6];			/* Byte 44 */
	byte BlockSizeInBytes[2];		/* Byte 50 */
	byte OrgDevSize[4];			/* Byte 52 - might be saved as blocks or MB */
	byte UseableDevSize[4];			/* Byte 56 */
	byte Reserved4[68];			/* Byte 60 */
	byte InquiryData[36];			/* Byte 128 - 1st 36 bytes of scsi inquiry */
	char SerialNumber[20];			/* Byte 164 */
	byte Reserved5[328];			/* Byte 184 */
} FSI_GetPhysDevInfoValid_t;

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_GETPHYSDEVSTATISTICS
 * --------------------------------------------------------------------------------------------------------------
 */
typedef	struct {
	byte MilliSecondsSinceStart[4];		/* Byte 0 */
	byte Byte4[4];				/* Byte 4 */
	byte Byte8;				/* Byte 8 */
	byte ChannelNumber;			/* Byte 9 */
	byte TargetId;				/* Byte 10 */
	byte Byte11;				/* Byte 11 */
	byte Byte12[4];				/* Byte 12 */

	byte NumberOfReads[4];			/* Byte 16 */
	byte NumberOfWrites[4];			/* Byte 20 */
	byte BytesRead[4];			/* Byte 24 -- not implemented */
	byte BytesWritten[4];			/* Byte 28 -- not implemented */

	byte NumberOfCacheReads[4];		/* Byte 32 -- not implemented */
	byte NumberOfCacheWrites[4];		/* Byte 36 -- not implemented */
	byte CacheBytesRead[4];			/* Byte 40 -- not implemented */
	byte CacheBytesWritten[4];		/* Byte 44 -- not implemented */

	byte NumberOfCommandWaitsDone[4];	/* Byte 48 -- not implemented */
	byte NumberOfCommandActiveOnDevice[2];	/* Byte 52 */
	byte NumberOfCommandWaitingOnDevice[2];	/* Byte 54 */

	byte Byte56[4];				/* Byte 56 */
	byte Byte60[4];				/* Byte 60 */
} FSI_GetPhysDevStats_t;

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_GETFREESPACELIST 
 * --------------------------------------------------------------------------------------------------------------
 */
#define MAX_NUM_PHYSDEVS	256
typedef struct {
        ushort16		RDN;
        byte			Reserved[6];
        byte			Address[4];
        byte			Size[4];
} FSI_devFreeSpace_t;


typedef struct {
	ushort16		NumEntries;
	ushort16		TotalEntries;
	byte			Reserved[12];
	FSI_devFreeSpace_t	DeviceSpace[MAX_NUM_PHYSDEVS];
} FSI_freeSpace_t;

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_GETLOGDEVINFOVALID
 * --------------------------------------------------------------------------------------------------------------
 */
typedef struct {
	byte Reserved0[4];
        byte State;
        byte RaidLevel;
        byte StripeSize;
        byte CacheLineSize;
        byte LDControl;
#define FSI_LDCONTROL_INITIALIZED		0x80
#define FSI_LDCONTROL_WRITECACHEENABLED		0x10
        byte OperationsStatus;
#define FSI_OPSTATUS_CCHECKACTIVE		0x01
#define FSI_OPSTATUS_REBUILDACTIVE		0x02
#define FSI_OPSTATUS_MDCONSISTACTIVE		0x04
#define FSI_OPSTATUS_INITACTIVE			0x08
#define FSI_OPSTATUS_MIGRATIONACTIVE		0x10
#define FSI_OPSTATUS_PATROLACTIVE		0x20
#define FSI_OPSTATUS_ACTIVE_MASK		0x3F
        byte R5WriteUpdate;
        byte R5Algor;
        byte LDN[2];			/* Little Endian */
        byte Reserved1[2];
        byte ErrorCounters[16];		/* Unused for now */
        byte Reserved2[2];
        byte BlockSize[2];
        byte OrgDeviceSize[4];
        byte DeviceSize[4];
        byte Reserved3[4];
        char LDName[17];
        byte Reserved4[15];
        byte SCSIInquiry36[36];
        byte Reserved5[12];
        byte Reserved6[16];
        byte ConsistencyCheckBlockNumber[8];
        byte RebuildBlockNumber[8];
        byte MDConsistentBlockNumber[8];
        byte LDInitializationBlockNumber[8];
        byte DataMigrationBlockNumber[8];
        byte Reserved7[16];
        byte StatBackgroundInit[2];
        byte StatLogDeviceInit[2];
        byte StatPhysDevInit[2];
        byte StatConsistencyCheckInit[2];
        byte StatRebuildLong[2];
        byte StatMORE[2];
        byte RDN[2];
        byte Reserved8[42];
} FSI_GetLogDevInfoValid_t;

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_GETLOGDEVPARAMETER
 * --------------------------------------------------------------------------------------------------------------
 */
#define FSI_RWCONTROL_READ_CACHE_MASK		0x07
#define FSI_RWCONTROL_READ_CACHE_DISABLED	0x00
#define FSI_RWCONTROL_READ_CACHE_ENABLED	0x01
#define FSI_RWCONTROL_READ_AHEAD_ENABLED	0x02
#define FSI_RWCONTROL_INT_READ_AHEAD_ENABLED	0x03
#define FSI_RWCONTROL_WRITE_CACHE_MASK		0x38
#define FSI_RWCONTROL_WRITE_CACHE_DISABLED	0x00
#define FSI_RWCONTROL_READ_ONLY			0x08
#define FSI_RWCONTROL_WRITE_CACHE_ENABLED	0x10
#define FSI_RWCONTROL_INT_WRITE_CACHE_ENABLED	0x18

typedef struct {
	byte			DevType;	/* Byte 0 */
	byte			DevState;	/* Byte 1 */
	ushort16		RAIDDevNumber;	/* Byte 2 */
	byte			Reserved1;	/* Byte 4 */
	byte			BIOSGeometry;	/* Byte 5 */	
	byte			StripeSize;	/* Byte 6 */	
	byte			rw_control;	/* Byte 7 */
	byte			Reserved2[8];	/* Byte 8 */
} FSI_LogDevParms_t;
/*
 * --------------------------------------------------------------------------------------------------------------
 * Configuration data structures
 * --------------------------------------------------------------------------------------------------------------
 */
typedef struct {
	byte			dev_type; /* 0x0F for physical device */
	byte			dev_state;
	ushort16		rdn;
	uint32			dev_size;
	byte			controller_num;
	byte			channel_num;
	byte			target_id;
	byte			lun_id;
	uint32			dev_start_addr;
} FSI_phys_dev_def_t;

typedef struct {
	byte			reserved;
	byte			dev_state;
	ushort16		rdn;
	uint32			dev_start_addr;
} FSI_used_dev_def_t;

typedef struct {
	byte			dev_type;
	byte			dev_state;
	ushort16		rdn;
	uint32			dev_size;
	byte			dev_used;
	byte			stripe_size;
	byte			cacheline_size;
	byte			rw_control;
	uint32			used_devsize;
	FSI_used_dev_def_t	udds[0];
} FSI_logical_dev_def_t; 

/*
 * --------------------------------------------------------------------------------------------------------------
 * Used with MDACIOCTL_RESETDEVICE, and MDACIOCTL_FLUSHDEVICEDATA
 * --------------------------------------------------------------------------------------------------------------
 */
#define MDADEV_PHYSICALDISK			0x00
#define MDADEV_LOGICALRAIDDEVICE		0x01
#define MDADEV_PHYSICALCHANNEL			0x02
#define MDADEV_VIRTUALRAIDDEVICE		0x03
#define MDADEV_PHYSICALCONTROLLER		0x04
#define MDADEV_RAIDCONTROLLER			0x05
#define MDADEV_CONFIGURATIONGROUP		0x10
#define MDADEV_ENCLOSURE			0x11

extern raid_cmd_transformer_t xyratex_transformer[];

#define SWAP8(_p_) \
	{ \
		  *((uint64 *)(_p_)) = (((*((uint64 *)(_p_)) >> 56) & 0x00000000000000FFLL) | \
				        ((*((uint64 *)(_p_)) >> 40) & 0x000000000000FF00LL) | \
				        ((*((uint64 *)(_p_)) >> 24) & 0x0000000000FF0000LL) | \
				        ((*((uint64 *)(_p_)) >>  8) & 0x00000000FF000000LL) | \
				        ((*((uint64 *)(_p_)) <<  8) & 0x000000FF00000000LL) | \
				        ((*((uint64 *)(_p_)) << 24) & 0x0000FF0000000000LL) | \
				        ((*((uint64 *)(_p_)) << 40) & 0x00FF000000000000LL) | \
				        ((*((uint64 *)(_p_)) << 56) & 0xFF00000000000000LL)); \
	}

#define SWAP4(_p_) \
	{ \
		  *((uint32 *)(_p_)) = (((*((uint32 *)(_p_)) >> 24) & 0x000000FFL) | \
				        ((*((uint32 *)(_p_)) >>  8) & 0x0000FF00L) | \
				        ((*((uint32 *)(_p_)) <<  8) & 0x00FF0000L) | \
				        ((*((uint32 *)(_p_)) << 24) & 0xFF000000L)); \
	}

#define SWAP2(_p_) \
	{ \
		  *((ushort16 *)(_p_)) = (((*((ushort16 *)(_p_)) >>  8) & 0x00FF) | \
				          ((*((ushort16 *)(_p_)) <<  8) & 0xFF00)); \
	}

#define RAID_PASSTHRU_CDB_ALLOC_LEN		32

#define SCSI_LOG_PC_OFFSET			6
#define SCSI_LOG_PC_CURRENT_THRESHOLD		0x0		
#define SCSI_LOG_PC_CURRENT_CUMULATIVE		0x1
#define SCSI_LOG_PC_DEFAULT_THRESHOLD		0x2
#define SCSI_LOG_PC_DEFAULT_CUMULATIVE		0x3

#endif /* __RAID_XYRATEX_H__ */
