#
#-----------------------------------------------------------------
#
# Name:
#
# RCS:  $Id: eccinit.S,v 1.2 2002/09/21 22:10:23 rick Exp $
#
# Copyright (C) 2001, Agile Storage, Inc.
#
# Description:
#
# Created by:	Rick Lund
#
# Date Created:	11/10/01
#
#-----------------------------------------------------------------
#

#include <nfx-target.h>
#include <sys/sb1250/sbmips.h>
#include <sys/cache.h>

    .text
    .set mips64
    .set noreorder

/* 
 * void  memz(void * start_addr, void * end_addr)
 *
 * zero memory from start_addr until end_addr, in 32 byte loops
 */
	.globl	memz
	.ent	memz
memz:
/*
 * force cache alignment
 * round up start_addr and round down end_addr
 */
    li      t0,~CACHELINE_MASK
    addu    a0,CACHELINE_MASK
    and     a0,a0,t0
    and     a1,a1,t0

/*
 * initialize memory parity by zeroing it
 */
1:  sd      zero,0(a0)
    sd      zero,8(a0)
    sd      zero,0x10(a0)
    sd      zero,0x18(a0)
    cache   Hit_Writeback_Inv_SD,0(a0)
    daddiu  a0,0x20
    bne     a0,a1,1b
	nop

	j		ra
	nop

    .set    reorder
	.end	memz

/*
 * uint64 dmfc0_berr_dpa
#define C0_ECC		26
#define C0_CACHEERR	27
 */

	.globl	dmfc0_berr_dpa
	.ent	dmfc0_berr_dpa
dmfc0_berr_dpa:
    dmfc0   v0,C0_ECC,1 
    j       ra
	.end	dmfc0_berr_dpa

	.globl	dmtc0_berr_dpa
	.ent	dmtc0_berr_dpa
dmtc0_berr_dpa:
    dmtc0   a0,C0_ECC,1 
    j       ra
	.end	dmtc0_berr_dpa

	.globl	dmfc0_cerr_i
	.ent	dmfc0_cerr_i
dmfc0_cerr_i:
    dmfc0   v0,C0_CACHEERR,0 
    j       ra
	.end	dmfc0_cerr_i

	.globl	dmtc0_cerr_i
	.ent	dmtc0_cerr_i
dmtc0_cerr_i:
    dmtc0   a0,C0_CACHEERR,0 
    j       ra
	.end	dmtc0_cerr_i

	.globl	dmfc0_cerr_d
	.ent	dmfc0_cerr_d
dmfc0_cerr_d:
    dmfc0   v0,C0_CACHEERR,1 
    j       ra
	.end	dmfc0_cerr_d

	.globl	dmtc0_cerr_d
	.ent	dmtc0_cerr_d
dmtc0_cerr_d:
    dmtc0   a0,C0_CACHEERR,1 
    j       ra
	.end	dmtc0_cerr_d

	.globl	dmfc0_cerr_dpa
	.ent	dmfc0_cerr_dpa
dmfc0_cerr_dpa:
    dmfc0   v0,C0_CACHEERR,3 
    j       ra
	.end	dmfc0_cerr_dpa

	.globl	dmtc0_cerr_dpa
	.ent	dmtc0_cerr_dpa
dmtc0_cerr_dpa:
    dmtc0   a0,C0_CACHEERR,3 
    j       ra
	.end	dmtc0_cerr_dpa



