#ifndef __SDM_RW_API_H_
#define __SDM_RW_API_H_

#include <nfx-types.h>

#define BLOCK_SIZE		512
#define COPY_BLK_CNT	16
#define MAX_TAGS		8
#define ERASE_BLK_CNT	16

#define RW_FLAG_READ_SUPER		0x00000001L
#define	RW_FLAG_PHY_OP			0x00000002L
#define RW_FLAG_KICK_WR_GATE	0x00000004L
#define RW_FLAG_IGN_WR_GATE		0x00000008L
#define RW_FLAG_OUTPUT_FILE		0x00000010L
#define RW_FLAG_INPUT_FILE		0x00000020L
#define RW_FLAG_USE_BUFFER		0x00000040L
#define RW_FLAG_ERASE_DATA		0x00000080L
#define RW_FLAG_WRITE_SAME		0x00000100L

extern char*	self;			// Our Name
extern char*	outputFile;
extern char*	inputFile;
extern char*	dataBuf;

extern uint32	sdm_ui_getSdmHandle(int64, int32);

extern int 		disk_read(uint32, uint32, uint32, uint32);
extern int 		disk_read_super(uint32 handle, uint32 lba);
extern int 		show_data(char *, int);
extern int		save_data(char *, int);
extern int		disk_write(uint32, uint32, uint32, uint32);
extern int		disk_write_from_sac(uint32, uint64, uint32);
extern int		disk_wrv(uint , uint , uint , uint);
extern int		disk_copy(uint32, uint32, uint32, uint32, uint32);
extern int		disk_erase(uint64, uint32, uint32, uint32, uint32, uint32);

#endif
