/*  
 *  ========================================================================
 *  File Name  :    sdm-conf.h
 *
 *  RCS        :    $Id: sdm-conf.h,v 1.5 2002/11/09 00:37:35 nitinb Exp $
 *
 *  Description:    
 *
 *  Created    :    10 January 2002
 *
 *  Author     :    Frank Salzmann
 *
 *  Copyright(c)  Agile Storage, Inc. 2001, 2002
 *  ========================================================================
 */
#ifndef __SDM_CONF_H_
#define	__SDM_CONF_H_

//------ How to use ---------------------------------------------------------
//
// Location: /usr/local/agile/etc/sdm.conf
//
// Keyword: mask  : Will prevent WWN/LUN from being used on a slot/port.
// Keyword: allow : Allows WWN/LUN to only be used on a certain slot/port.
//
// Syntax :  keyword <wwn> <lun> port=m, slot=n
//
// Comments: Comments are allowed and must start with the '#' character.
//
// Examples:
//
//
//--------------------------------------------------------------------------

#define SDM_MAX_CFG_ENTRIES		1024

#define SDM_CONF_ATTR_UNDEF		0 
#define SDM_CONF_ATTR_MASK		1
#define SDM_CONF_ATTR_ALLOW		2
#define SDM_CONF_ATTR_CLEAR		3

#define SDM_CONF_GET_PORT		1
#define SDM_CONF_GET_SLOT		2

typedef struct _sdm_conf_parse {
	char *keyword;
	int   action_key;
	struct _sdm_conf *(*parse_func)(int);
} sdm_conf_parse_t;

#define SDM_CONF_ATTR_MAX_PORT_BIT	0xFFFF
#define SDM_CONF_ATTR_MAX_SLOT_BIT	0xFFF
#define SDM_CONF_ATTR_MAX_PORT		4
#define SDM_CONF_ATTR_MAX_SLOT		3

/* 
 *-----------------------
 * External Declarations.
 *-----------------------
 */
int sdm_confRead( char *);
int sdm_confParse(FILE *);
int sdm_confClose(FILE *);
int sdm_confWrite( char *);
int sdm_confSaveRec( sdm_conf_t * );
int	sdm_confRemRec( sdm_conf_t *);
sdm_conf_t *sdm_confParseMask(int);
sdm_conf_t * sdm_confFindRec(uint64, uint32);
int	sdm_confGetMaskCount( void );
int	sdm_confGetMasks(sdm_conf_t *);
int sdm_confVerify( uint64 , uint32 , scsi_path_t , char *);
int sdm_confViewRecs( void );

#endif
