//------------------------------------------------------------------------------
//  FileName   : sdm-msg.h
//
//  Description: Prototypes for functions in sdm-msg.c
//
//	Created    : Nov 8, 2002
//
//  Author     : Nitin Nahadur
//
//  RCS        : $Id: sdm-msg.h,v 1.2 2002/11/19 20:38:56 nitinb Exp $
//
//  Copyright (c)  Agile Storage, Inc. 2002
//------------------------------------------------------------------------------

#ifndef __SDM_MSG_H_
#define __SDM_MSG_H_

// Function Prototypes

int		sdm_msgInit( void );
int		sdm_slotPortMsgInit( int, int );
int		sdm_sendMsg( char *, int, char *, uint32, uint32, struct timeval *,
				 	char *, uint32 );
int		sdm_allocTransaction( sdm_devDBRec_t *, sdm_msgDesc_t *);
int		sdm_deallocTransaction(int);
int		sdm_allocRelayTransaction( sdm_devDBRec_t *, sdm_msgDesc_t *,
						   int (*callBackFunc)(), int ); 
int		sdm_rcvMsg( void );
int		sdm_sendScsiOpenReq( scsi_path_t, sdm_devDBRec_t * );
int		sdm_sendSetPathMsg(scsi_id_t, uint32, scsi_path_t);
int		sdm_sendRemPathMsg( uint32 );
int		sdm_sendSdmaHandleReq( struct _sdm_dev_db_rec *, scsi_id_t, scsi_path_t, uint32 );
int		sdm_sendDevAddNotify(char *, sdm_devDBRec_t *);
int		sdm_sendDevAddNotifySpm( sdm_devDBRec_t * );
int		sdm_sendDevDelNotify( char *, sdm_devDBRec_t * );
int		sdm_sendSyncReq( uint32, uint32 );
int		sdm_sendScsiAddMsg( sdm_dir_t * );
int		sdm_sendDelDevReq (scsi_id_t, scsi_path_t);
int		sdm_procRediscReq(sdm_msgDesc_t * );
int		sdm_sendNullRsp( int, int, char * );


uint64		sdm_swap64( uint64 );
ushort16	sdm_getTransactionId( void );

#endif
