/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: ibutton-api.h,v 1.1 2002/12/10 20:30:43 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	12/10/02
 *
 *-----------------------------------------------------------------
 */

#ifndef IBUTTON_API_H
#define IBUTTON_API_H

#define IBUTTON_BACKPLANE	0x1
#define IBUTTON_PS0			0x2
#define IBUTTON_PS1			0x3

extern uint32 ibutton_detect(uint32 which_ibutton);
extern uchar8 ibutton_read(uint32 which_ibutton, uint32 offset);
extern void ibutton_write(uint32 which_ibutton, uint32 offset, uchar8 data);
extern void ibutton_read_rom(uint32 which_ibutton, uchar8 * rom);

#define IBUTTON_READ		0x1
#define IBUTTON_WRITE		0x2
#define IBUTTON_DETECT		0x3
#define IBUTTON_READ_ROM	0x4
#define IBUTTON_TEST		0x5

extern int32 ibutton(uint32 op,
					uint32 which_ibutton,
					uint32 offset,
					uint32 len,
					uchar8 * buf);

typedef struct ibut {
	uint32	command;
	uint32	buffer;
	uint32	res[2];
	uint32	intr;
	uint32	intr_enable;
	uint32	res2[2];
	uint32	clock_divisor;
	uint32	control;
} ibutton_t;

#define IBUTTON_BACKPLANE_OFFSET	0x340
#define IBUTTON_PS0_OFFSET			0x380
#define IBUTTON_PS1_OFFSET			0x3C0


#define IBUTTON_COMMAND_RESET		0x01
#define IBUTTON_COMMAND_FORCE_ONE	0x04
#define IBUTTON_COMMAND_INPUT		0x08

#define IBUTTON_INTR_PRESENCE_DETECT			0x01
#define IBUTTON_INTR_PRESENCE_DETECT_RESULT		0x02
#define IBUTTON_INTR_TRANSMIT_BUF_EMPTY			0x04
#define IBUTTON_INTR_TRANSMIT_SHIFT_REG_EMPTY	0x08
#define IBUTTON_INTR_RX_BUF_FULL				0x10
#define IBUTTON_INTR_RX_SHIFT_REG_FULL			0x20
#define IBUTTON_INTR_ONE_WIRE_SHORT				0x40
#define IBUTTON_INTR_ONE_WIRE_LOW				0x80

#define IBUTTON_INTR_ENABLE_PRESENCE_DETECT		0x01
#define IBUTTON_INTR_ENABLE_INTR_ACTIVE_STATE	0x02
#define IBUTTON_INTR_ENABLE_TB_EMPTY			0x04
#define IBUTTON_INTR_ENABLE_TSRE				0x08
#define IBUTTON_INTR_ENABLE_RB_FULL				0x10
#define IBUTTON_INTR_ENABLE_RSR_FULL			0x20
#define IBUTTON_INTR_ENABLE_ONE_WIRE_SHORT		0x40
#define IBUTTON_INTR_ENABLE_ONE_WIRE_LOW		0x80

#define IBUTTON_CLOCK_DIVISOR_PRE0				0x01
#define IBUTTON_CLOCK_DIVISOR_PRE1				0x02
#define IBUTTON_CLOCK_DIVISOR_DIV0				0x04
#define IBUTTON_CLOCK_DIVISOR_DIV1				0x08
#define IBUTTON_CLOCK_DIVISOR_DIV2				0x10
#define IBUTTON_CLOCK_DIVISOR_CLOCK_ENABLE		0x80

#define IBUTTON_CONTROL_LONG_LINE				0x01
#define IBUTTON_CONTROL_PRESENCE_PULSE_MASK		0x02
#define IBUTTON_CONTROL_ENABLE_FORCE_ONE		0x04
#define IBUTTON_CONTROL_STRONG_PULL_UP_ENABLE	0x08
#define IBUTTON_CONTROL_STRONG_PULL_UP_SUPPLY	0x10
#define IBUTTON_CONTROL_BIT_CONTROL				0x20
#define IBUTTON_CONTROL_OVERDRIVE				0x40 

#endif	/* IBUTTON_API_H */

