/*
 *-----------------------------------------------------------------
 *
 * Name:	serio-api.c
 *
 * RCS:  $Id: serio-api.c,v 1.1.1.1 2002/01/10 20:44:52 frank Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6t/18/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/serio-api.h>

int32	(*console_driver)(uint32 op, uint32 chan, int32 data);

int32	serio_inited = 0;

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
void
serio_init()
{
	extern int32 sb1250_uart(uint32 op, uint32 chan, int32 data);
	extern int32 gt64240_console(uint32 op, uint32 chan, int32 data);
	extern int32 st16552(uint32 op, uint32 chan, int32 data);

	if (serio_inited)
		return;

#ifdef EVAL_BOARD
#ifdef SIBYTE

	console_driver = sb1250_uart;
	sb1250_uart(OP_INIT, 0, 115200);
	sb1250_uart(OP_INIT, 1, 115200);

#else

	console_driver = gt64240_console;
	gt64240_console(OP_INIT, 0, 0);
	gt64240_console(OP_INIT, 1, 0);

/*
	console_driver = st16552;
*/

#endif	/* SIBYTE */
#endif	/* EVAL_BOARD */

	serio_inited = 1;

}	/* serio_init() */

#if defined(EVAL_BOARD) || defined(AGILE_HARDWARE)
/*-----------------------------------------------------------------
 * Name:	getchar()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
getchar()
{
	int32	chan;
#ifdef SIBYTE
	chan = 0;
#else
	chan = 1;
#endif
	while (!(*console_driver)(OP_RXRDY, chan, 0))
		eee_poll();

	return ((*console_driver)(OP_RX, chan, 0));

}	/* getchar() */

int32
tty1_getchar()
{
	int32	chan;
#ifdef SIBYTE
	chan = 1;
#else
	chan = 0;
#endif
	while (!(*console_driver)(OP_RXRDY, chan, 0))
		eee_poll();

	return ((*console_driver)(OP_RX, chan, 0));

}	/* getchar() */

/*-----------------------------------------------------------------
 * Name:	putchar()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
putchar(
	int32	c
)
{
	int32	chan;
	uint32	x;
#ifdef SIBYTE
	chan = 0;
#else
	chan = 1;
#endif
	while (!(*console_driver)(OP_TXRDY, chan, 0));

	(*console_driver)(OP_TX, chan, c);

	if (c == 0xa) {
		while (!(*console_driver)(OP_TXRDY, chan, 0));

		(*console_driver)(OP_TX, chan, 0xd);
	}

	return NFX_OK;

}	/* putchar() */

int32
tty1_putchar(
	int32	c
)
{
	int32	chan;
	uint32	x;
#ifdef SIBYTE
	chan = 1;
#else
	chan = 0;
#endif
	while (!(*console_driver)(OP_TXRDY, chan, 0));

	(*console_driver)(OP_TX, chan, c);

	if (c == 0xa) {
		while (!(*console_driver)(OP_TXRDY, chan, 0));

		(*console_driver)(OP_TX, chan, 0xd);
	}

	return NFX_OK;

}	/* putchar() */

/*-----------------------------------------------------------------
 * Name:	char_avail()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
char_avail()
{
	int32	chan;
#ifdef SIBYTE
	chan = 0;
#else
	chan = 1;
#endif
	return((*console_driver)(OP_RXRDY, chan, 0));

}	/* char_avail() */

int32
tty1_char_avail()
{
	int32	chan;
#ifdef SIBYTE
	chan = 1;
#else
	chan = 0;
#endif
	return((*console_driver)(OP_RXRDY, chan, 0));

}	/* char_avail() */

#endif	/* EVAL_BOARD || AGILE_HARDWARE */

