/*
 *-----------------------------------------------------------------
 *
 * Name:	tx3927-uart.c
 *
 * RCS:  $Id: tx3927-uart.c,v 1.3 2002/11/05 00:25:12 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	 Serial driver for Toshiba TX3927
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/28/01
 *
 *-----------------------------------------------------------------
 */

#if defined(AGILE_HARDWARE) && (defined(SSC_MGMT) || defined(PROM_TOSHIBA))

#include <nfx-incl.h>
#include <sys/tx3927.h>
#include <exports/serio-api.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
int32
tx3927_uart(
	uint32	op,
	uint32	chan,
	int32	data
)
{
	tx3927_sio_t	* dp;

	if (chan > 1)
		return SERIO_ERR_BAD_PARAM;

	if (chan == 0)
		dp = (tx3927_sio_t *)TX3927_SIO0_BASE;
	else
		dp = (tx3927_sio_t *)TX3927_SIO1_BASE;

	switch (op) {
		case OP_INIT:
		case OP_BAUD:
			dp->lcr = 0x00000024;	/* IMCLK | 8-N-1 */
			dp->dicr = 0;
			dp->disr = 0;
			dp->cisr = 0;
			dp->fcr = 0;
			dp->flcr = 0;
			dp->bgr = 14;			/* 57600 */
			break;

		case OP_TXRDY:
			return (dp->cisr & 0x00000004);

		case OP_RXRDY:
			return (!(dp->disr & 0x00004000));

		case OP_TX:
			dp->tfifo = data;
			break;

		case OP_RX:
			return (dp->rfifo);
	}		

	return NFX_OK;

}	/* st16552() */

#endif	/* EVAL_BOARD && !SIBYTE */

