/*------------------------------------------------------------------------------
 * RCS:  $Id: stats-dbg.c,v 1.1.1.1 2002/10/29 01:57:48 syen Exp $
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Name         : stats-dbg.c
 *
 * Description  : stats agent debug functions
 *
 * Created by   : Shyh-Pei Yen
 *
 * Date Created : 10/22/02
 *
 *------------------------------------------------------------------------------
 */

#include "stats.h"
#include "stats-dbg.h"

// Global variables.

// Local function prototypes.


/*------------------------------------------------------------------------------
 * Name         : stats_trace
 *
 * Description  : trace function for the stats agent module
 *
 * Created by   : Shyh-Pei Yen
 *
 * Date Created : 10/22/02
 *------------------------------------------------------------------------------
 */

void
stats_trace(int32 level, char *fmt, ...)
    
{
va_list ap;
char trace_buf[STATS_MAX_TRACESTR];

	if (level == LOG_ERR)
	{
		va_start(ap, fmt);
		vsprintf(trace_buf, fmt, ap);
		E_LOG(class_1, level, statsAppId, 0, 0, 0,
						("StatsAgent(ERR): %s", trace_buf));
		va_end(ap);
	}
	else if (level == LOG_INFO)
	{
		va_start(ap, fmt);
		vsprintf(trace_buf, fmt, ap);
		E_LOG(class_1, level, statsAppId, 0, 0, 0,
						("StatsAgent(INF): %s", trace_buf));
		va_end(ap);
	}
	else if (level == LOG_DEBUG)
	{
		va_start(ap, fmt);
		vsprintf(trace_buf, fmt, ap);
		E_LOG(class_1, level, statsAppId, 0, 0, 0,
						("StatsAgent(DBG): %s", trace_buf));
		va_end(ap);
	}
    return;
}

