/*
 *-----------------------------------------------------------------
 *
 * Name:	dvt-api.h
 *
 * RCS:  $Id: dvt-api.h,v 1.3 2002/05/03 23:34:47 lipikaathome Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:	exported API for the manufacturing dvt tests.
 *
 * Created by:	eric choi
 *
 * Date Created:	3/4/02
 *
 *-----------------------------------------------------------------
 */

#include <exports/eee-desc.h>
#if defined (NFP_TXRX) || defined (FCNIM)
#include "../sm-dp83820/dp83820-regs.h"
#endif

#define	SYS_DVT_TESTTYPE_MAX	5
#define SYS_DVT_SLOT_MAX	3
#define SYS_DVT_CPU_MAX		4
#define SYS_DVT_CMD_MAX		7

typedef struct {
	uchar8	slot;
	uchar8	cpu;
	uchar8	port;
	uchar8	misc;
} dvt_error_location_info;

typedef struct {
	uint32 command;
	uint32 slot;
	uint32 cpu;
	uint32 packets_sent[SYS_DVT_CPU_MAX][SYS_DVT_TESTTYPE_MAX];
	uint32 packets_received[SYS_DVT_CPU_MAX][SYS_DVT_TESTTYPE_MAX];
	uint32 packet_errors[SYS_DVT_CPU_MAX][SYS_DVT_TESTTYPE_MAX];
	uint32 packet_send_errors[SYS_DVT_CPU_MAX][SYS_DVT_TESTTYPE_MAX];
	uint32 seq_errors[SYS_DVT_CPU_MAX][SYS_DVT_TESTTYPE_MAX];
	uint32 crc_errors[SYS_DVT_CPU_MAX][SYS_DVT_TESTTYPE_MAX];
} dvt_local_stats_t;

typedef struct {
	uint32 command;
	uint32 slot;
	uint32 cpu;
	uint32 packets_sent[SYS_DVT_TESTTYPE_MAX];
	uint32 packets_received[SYS_DVT_TESTTYPE_MAX];
	uint32 packet_errors[SYS_DVT_TESTTYPE_MAX];
	uint32 packet_send_errors[SYS_DVT_TESTTYPE_MAX];
	uint32 seq_errors[SYS_DVT_TESTTYPE_MAX];
	uint32 crc_errors[SYS_DVT_TESTTYPE_MAX];
} dvt_test_stats;

typedef struct {
	ushort16 rsvd;
        uint32  command;
	uint32	test_type;
	uint32 	port;
	uint32 	numPkts;
	uint32	seq;
	uint32	buf_size;
	uint32	num_bytes;
	uint32	orig_slot;
	uint32	orig_cpu;
} __attribute__ ((packed)) sys_dvt_control;

#define  SYS_DVT_START   	1
#define  SYS_DVT_STOP    	2
#define  SYS_DVT_DATA    	3
#define	 SYS_DVT_STATS_REPORT	4
#define	 SYS_DVT_STATS		5
#define SYS_DVT_START_ALL	6
#define SYS_DVT_CLEAR_STATS	7

/* This is another test type for this module
 * like EEE_USER_DATA, EEE_MGMT, EEE_CTRL
 */ 
#define	 SYS_DVT_FRONT		4


#define  DVT_RUN	   	1
#define  DVT_HALT  		0
#define  DVT_TEST_NUM_PKT_SPEC  1 

#define DVT_NFP_PORT_TXRX_MAX 	2 /* for now. since no TX fn registered for ETH2*/

void dvt_stats_display(dvt_test_stats * );

