/*
 *------------------------------------------------------------------------------
 *
 * Name:	tape-cap.h
 *
 * RCS:		$Id: tape-cap.h,v 1.5 2002/10/26 01:12:01 raster Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	Tape driver device capabilities definitions.
 *
 * Created by:	Radek Aster
 *
 * Date Created: 10/16/01
 *
 *------------------------------------------------------------------------------
 */

#ifndef __TAPE_CAP_H__
#define __TAPE_CAP_H__

typedef struct {
	char	vendor_id[TAPE_VENDOR_NAME_LEN];
	char	product_id[TAPE_MODEL_NAME_LEN];
	uint32	flags;
	struct { 
		int	density_code;				/* density specifier */
		uint32	compression;				/* compression algorithm */
		uint64	total_capacity;				/* Total bytes (uncompressed) */
		char	dens_name[TAPE_DENSITY_NAME_LEN];	/* density/comp. description */
		char	alias_dens_name[TAPE_DENSITY_NAME_LEN];	/* density/comp. description */
	} densities[TAPE_DENSITY_COUNT];
} tape_cap_t;

tape_cap_t *tape_find_cap_entry(char *, char *);
int tape_density_code_match(tape_cap_t *, char *);
int tape_is_DLT(tape_cap_t *);

#define ONE_MEG			(1024LL * 1024LL)
#define ONE_GIG			(1024LL * ONE_MEG)
#define UNKNOWN_CAPACITY	(0LL)
#define DEFAULT_DENSITY		0x00

#endif /* __TAPE_CAP_H__ */


