/*
 *-----------------------------------------------------------------
 *
 * Name:	argvize.c
 *
 * RCS:  $Id: argvize.c,v 1.1.1.1 2001/07/04 00:44:57 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	place address of each word in s into the array av
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include "pmon-ui.h"

int32 
argvize (
	char8	* av[],
	char8	* s
)
{
	char8	**pav = av, c;
	int32	ac;

	for (ac = 0; ac < MAX_AC; ac++) {
		/* step over cntrls and spaces */
		while (*s && *s <= ' ')
			++s;

		/* if eos quit */
		if (!*s)
			break;

		c = *s;
		/* if it's a quote skip forward */
		if (c == '\'' || c == '"') {
			if (pav)
				*pav++ = ++s;
			while (*s && *s != c)
				++s;
			if (*s)
				*s++ = 0;
		} else {		/* find end of word */
			if (pav)
				*pav++ = s;
			while (' ' < *s)
				++s;
		}

		/* not eos inc ptr */
		if (*s)
			*s++ = 0;
	}

	return (ac);

}	/* argvize() */

