// vi:ts=4
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>

#include "exports/anpssc-api.h"
#include "exports/evm-api.h"
#include "exports/event-api.h"
#include "ccm-api.h"

extern int
main (int argc, char *argv[])
{
	nfx_eventMsg_t evt;
	char line[80];

	memset (&evt, 0, sizeof(evt));

	evt.msgType = NFX_EVENT_POST;
	gethostname (evt.nodeName, sizeof(evt.nodeName));
	evt.eventType = NFX_EVENT_ROUTE;

	printf ("Delete Y/N -> ");
	fgets (line, sizeof(line), stdin);
	evt.param.ipRteEvent.state = (line[0] == 'y') || (line[0] == 'Y') 
	                             ? EVENT_STATE_REMOVE 
	                             : EVENT_STATE_UP;

	printf ("To network -> ");
	fgets (line, sizeof(line), stdin);
	evt.param.ipRteEvent.destNet = strtol (line, NULL, 16);
	
	printf ("Netmask -> ");
	fgets (line, sizeof(line), stdin);
	evt.param.ipRteEvent.destMask = strtol (line, NULL, 16);
	
	printf ("Gateway -> ");
	fgets (line, sizeof(line), stdin);
	evt.param.ipRteEvent.gateWay = strtol (line, NULL, 16);
	
	sendAgileMsg (-1, &evt, sizeof(evt),
	              "eventd", NFX_SSC_UNIX, SSC_SLOT, MGMTPLANE, NULL,
	              NULL, 0);
	return 0;
}
