// vi:ts=4

#include <stdio.h>

#include "exports/ncm-api.h"
#include "exports/anpssc-api.h"
#include "exports/event-api.h"

static char *state[] = { "NADA", "Up", "Down", "Offline", "Accessible" };

extern int
main (int argc, char *argv[])
{
	int sock;
	long long buf[512];
	nfx_eventMsg_t *evt = (nfx_eventMsg_t *)buf;
	int num, cpu, slot, plane;
	char app[256];
	int msgType;

	sock = regAgileApp ("ncm");

	evt->msgType = NFX_EVENT_REGISTER;
	evt->appId = eee_getApplicationId ("ncm");
	strcpy (evt->appName, "ncm");
	evt->eventType = NFX_EVENT_NODE;

	sendAgileMsg (sock, evt, sizeof (nfx_eventMsg_t), "eventd", NFX_SSC_UNIX,
	              SSC_SLOT, MGMTPLANE, NULL, NULL, 0);

	evt->eventType = NFX_EVENT_PCC;

	sendAgileMsg (sock, evt, sizeof (nfx_eventMsg_t), "eventd", NFX_SSC_UNIX,
	              SSC_SLOT, MGMTPLANE, NULL, NULL, 0);

	evt->eventType = NFX_EVENT_SCC;

	sendAgileMsg (sock, evt, sizeof (nfx_eventMsg_t), "eventd", NFX_SSC_UNIX,
	              SSC_SLOT, MGMTPLANE, NULL, NULL, 0);


	while (1) {
		num = recvAgileMsg (sock, buf, sizeof(buf), NULL,
		                    app, &cpu, &slot, &plane);

		msgType = *(int *)buf;

		switch (msgType) {
			case NFX_EVENT_POST:
				printf ("appid %d:%s\n", evt->appId, evt->appName);
				switch (evt->eventType) {
					case NFX_EVENT_NODE:
						printf ("NODE event, node: %s, state %s\n",
						        evt->param.nodeEvent.nodeName, 
						        state[evt->param.nodeEvent.state]);
						printf ("IPs %08x %08x\n", ((int *)(evt->appMsg))[0],
						        ((int *)(evt->appMsg))[1]);
						break;
					case NFX_EVENT_PCC:
						printf ("PCC event, node: %s, state %s\n",
						        evt->param.nodeEvent.nodeName, 
						        state[evt->param.nodeEvent.state]);
						printf ("IPs %08x %08x\n", ((int *)(evt->appMsg))[0],
						        ((int *)(evt->appMsg))[1]);
						break;
					case NFX_EVENT_SCC:
						printf ("SCC event, node: %s, state %s\n",
						        evt->param.nodeEvent.nodeName, 
						        state[evt->param.nodeEvent.state]);
						printf ("IPs %08x %08x\n", ((int *)(evt->appMsg))[0],
						        ((int *)(evt->appMsg))[1]);
						break;
					default:
						printf ("unknown event %d\n", evt->eventType);
				}
				break;

			case NFX_EVENT_STATUS:
				printf ("event status: %d\n", evt->status);
				break;

			default:
				printf ("%s Unknown msg type: %d\n", argv[0], msgType);
		}
		printf("\n");
	}

	return 0;
}
