
#define DVT_REV2

#define	SYS_DVT_NUM_TESTS	4
#define SYS_DVT_SLOT_MAX	3
#define SYS_DVT_CPU_MAX		4
#ifdef DVT_REV2
#define	SYS_DVT_TESTTYPE_MAX	4
#else
#define	SYS_DVT_TESTTYPE_MAX	5
#endif

#define EEE_MGMT_TEST_CMD_STOP		0x00112234
#define EEE_MGMT_TEST_CMD_START		0xffeeddcb
#define EEE_MGMT_TEST_CMD_DATA		0xa5b6c7d8
#define EEE_MGMT_STATS_REQUEST		0x55
#define EEE_MGMT_STATS_REPORT		0x66
#define EEE_MGMT_STATS_CLEAR		0x77

#ifdef DVT_REV2
typedef struct mgmt_test_hdr {
	uint32	cmd;
	uint32	seq;
	uint32	size;
	uint32	orig_slot;
	uint32	orig_cpu;
	uint32	plane;
	uint32	spin;
	uint32	res[1];
} sys_dvt_control;

#else

typedef struct {
	unsigned short rsvd;
	int	command;
	int	test_type;
	int 	port;
	int 	numPkts;
	int	seq;
	int	buf_size;
	int	num_bytes;
	int	orig_slot;
	int	orig_cpu;
} __attribute__ ((packed)) sys_dvt_control;

#endif

typedef struct {
	uint32 command;
	uint32 slot;
	uint32 cpu;
	uint32 packets_sent[SYS_DVT_TESTTYPE_MAX];
	uint32 packets_received[SYS_DVT_TESTTYPE_MAX];
	unsigned long long bytes_sent[SYS_DVT_TESTTYPE_MAX];
	unsigned long long bytes_received[SYS_DVT_TESTTYPE_MAX];
	uint32 packet_errors[SYS_DVT_TESTTYPE_MAX];
	uint32 packet_send_errors[SYS_DVT_TESTTYPE_MAX];
	uint32 seq_errors[SYS_DVT_TESTTYPE_MAX];
	uint32 crc_errors[SYS_DVT_TESTTYPE_MAX];
	uint32 pktComp_errors[SYS_DVT_TESTTYPE_MAX];
	uint32 fatal_errors;
} dvt_test_stats;

/*
typedef struct {
	uint32 command;
	uint32 slot;
	uint32 cpu;
	uint32 packets_sent[SYS_DVT_NUM_TESTS][SYS_DVT_SLOT_MAX][SYS_DVT_CPU_MAX];
	uint32 packets_received[SYS_DVT_NUM_TESTS][SYS_DVT_SLOT_MAX][SYS_DVT_CPU_MAX];
	uint32 packet_errors[SYS_DVT_NUM_TESTS][SYS_DVT_SLOT_MAX][SYS_DVT_CPU_MAX];
	uint32 packet_send_errors[SYS_DVT_NUM_TESTS][SYS_DVT_SLOT_MAX][SYS_DVT_CPU_MAX];
	uint32 crc_errors[SYS_DVT_NUM_TESTS][SYS_DVT_SLOT_MAX][SYS_DVT_CPU_MAX];
} dvt_test_stats;
*/


#define EEE_USER_DATA	0
#define EEE_CONTROL	1
#define EEE_MGMT	2
/* This is another test type for this module
 * like EEE_USER_DATA, EEE_MGMT, EEE_CTRL
 */ 
#define SYS_DVT_FRONT	4

/* Test Commands */
#define SYS_DVT_START	1
#define SYS_DVT_STOP	2
#define SYS_DVT_DATA	3
#define SYS_DVT_STATS_REPORT	4
#define SYS_DVT_STATS	5
#define SYS_DVT_START_ALL	6
#define SYS_DVT_CLEAR_STATS	7

