#
#-----------------------------------------------------------------
#
# Name:	target.mk
#
# RCS:  $Id: target.mk,v 1.12 2002/05/02 01:43:48 rick Exp $
#
# Copyright (C) 2001, Agile Storage, Inc.
#
# Description:	which NFX target image is to be built
#
#			TARGET specifies which image to build.
#				TARGET must = one of:
#						NFP_TXRX, NFP_FP,
#						SSC, SSC_MGMT
#						FCNIM, PROM
#
#			HOST_PLATFORM specifies on what hardware the image will
#			be running.
#				HOST_PLATFORM must = one of:
#						LINUX_TEST
#						EVAL_BOARD
#						SSC
#						AGILE_HARDWARE
#
# Created by:	Rick Lund
#
# Date Created:	4/13/01
#
#-----------------------------------------------------------------
#

#
#-----------------------------------------------------------------
#
# Set up TARGET
#
#-----------------------------------------------------------------
#
ifeq (${TGT}, txrx)
	TARGET =			NFP_TXRX
endif

ifeq (${TGT}, fp)
	TARGET =			NFP_FP
endif

ifeq (${TGT}, fc)
	TARGET =			FCNIM
endif

ifeq (${TGT}, tmfc)
	TARGET =			FCNIM_TM
endif

ifeq (${TGT}, fc-eval)
	TARGET =			FCNIM
endif

ifeq (${TGT}, ssc)
	TARGET =			SSC
endif

ifeq (${TGT}, ssc-mgmt)
	TARGET =			SSC_MGMT
endif

ifeq (${TGT}, mgmt)
	TARGET =			SSC_MGMT
endif

ifeq (${TGT}, shmem)
	TARGET =			SHMEM
endif

ifeq (${TGT}, prom.r9000)
	TARGET =			PROM_R9000
endif

ifeq (${TGT}, prom.r7000)
	TARGET =			PROM_R7000
endif

ifeq (${TGT}, prom.r7k)
	TARGET =			PROM_R7000
endif

ifeq (${TGT}, prom.sibyte)
	TARGET =			PROM_SIBYTE
endif

ifeq (${TGT}, prom.sibyte_bc)
	TARGET =			PROM_SIBYTE_BC
endif

ifeq (${TGT}, prom.ssc_mgmt)
	TARGET =			PROM_SSC_MGMT
endif

ifeq (${TGT}, diag.r7000)
	TARGET =			DIAG_R7000
endif

ifeq (${TGT}, diag.sibyte)
	TARGET =			DIAG_SIBYTE
endif

#
#-----------------------------------------------------------------
#
# Set up HOST_PLATFORM
#
#-----------------------------------------------------------------
#
ifeq (${HOST}, $(findstring ${HOST}, "sim linux test"))
	HOST_PLATFORM =		LINUX_TEST
else
ifeq (${HOST}, SSC)
	HOST_PLATFORM =		SSC_mips
else
ifeq (${HOST}, SSC_x86)
	HOST_PLATFORM =     SSC_x86
else
ifeq (${HOST}, eval)
	HOST_PLATFORM =		EVAL_BOARD
else
	HOST_PLATFORM =		AGILE_HARDWARE
endif
endif
endif
endif

#
#-----------------------------------------------------------------
#
# For ease of debug development, the user can set the TARGET expicitly.
# This essentially makes the tree build only one TARGET at a time.
#
#-----------------------------------------------------------------
#
#override TARGET =			SSC
#override HOST_PLATFORM =	AGILE_HARDWARE

