/*
 *=============================================================================
 * File Name   :    bcm5632-socregs.h
 *
 *  RCS: $Id: bcm5632-socregs.h,v 1.1.1.1 2001/12/22 04:14:58 tonyw Exp $
 *
 *  Description:    Copied and modified from Broadcom
 *
 *  Created    :    09-04-2001
 *
 *  Author     :    Tony Wong
 *
 *  Copyright(c)  Agile Storage, Inc. 2001
 *=============================================================================
 */

#ifndef BCM5632_SOCREGS_H
#define BCM5632_SOCREGS_H

#define MAKE_UINT32(a, b)  ((((uint32)a & 0xFFFF) << 16) | ((uint32)b & 0xFFFF))
#define GET_HI_WORD(a)     (((uint32)a >> 16) & 0xFFFF)
#define GET_LO_WORD(a)     ((uint32)a & 0xFFFF)
#define SET_VLAN_STATE_ENTRY(entry,port,value)  \
    (entry.PortState = (entry.PortState & ~(0x3<<(port*2))) | (value<<(port*2)))
#define GET_VLAN_STATE_ENTRY(entry,port)  ((entry.PortState>>(port*2))&0x3)


/* This remaps the names of FE macros according to whether
 * we're in GSL mode or not.  In that mode, the macros have
 * _GTH_ inserted in their names.
 */
#define       FE_SET(_p, _t, _v, _val)        SET_ ## _t(_v, _val)
#define       FE_GET(_p, _t, _v)              GET_ ## _t(_v)
#define       FE_READ(_t, _u, _p, _v)         (READ_ ## _t(_u, _p, _v))
#define       FE_WRITE(_t, _u, _p, _v)        (WRITE_ ## _t(_u, _p, _v))

#define _u32 unsigned int
#define EXTERN	extern

#define	N_SOC_DEVICES		1

#define NUM_GPIC_5632		1
#define NUM_PIC_5632		NUM_GPIC_5632
#define NUM_COS_5632		4

#define MIN_FE_PORT_5632	0
#define MAX_FE_PORT_5632    	0
#define NUM_FE_PORT_5632    	0
#define MIN_GE_PORT_5632    	0
#define MAX_GE_PORT_5632    	11
#define NUM_GE_PORT_5632    	12
#define MIN_XGE_PORT_5632	12
#define MAX_XGE_PORT_5632	12
#define NUM_XGE_PORT_5632	1

#define MIN_E_PORT_5632		MIN_FE_PORT_5632
#define MAX_E_PORT_5632		MAX_XGE_PORT_5632
#define NUM_E_PORT_5632	   (NUM_FE_PORT_5632+NUM_GE_PORT_5632+NUM_XGE_PORT_5632)
#define CMIC_PORT_5632   	13

#define BYTES2WORDS(x)	(((x)+3)>>2)

#define MAX_MEM_BYTES	72
#define MAX_MEM_WORDS	BYTES2WORDS(MAX_MEM_BYTES)

/*****************************************************************************
 **	ACCESS MACROS
 **
 ** EXAMPLES:
 **
 **	// Global (generic non-PIC) Register
 **	uint32 fooval=0;		// Zero all register fields
 **	SET_FOOr_F1(fooval,42);		// Set field F1 of FOO register to 42
 **	SET_FOOr_F2(fooval,1);		// Set field F1 of FOO register to 1
 **	WRITE_FOOr(unit, fooval);	// Update SOC
 **
 **	READ_FOOr(unit, &fooval);		// Read FOO register from SOC
 **	SET_FOOr_F2(fooval,0);		// Set field F1 of FOO register to 0
 **	WRITE_FOOr(unit, fooval);	// Update SOC
 **
 **	// Monolithic Memory
 **	uint32 barval[BARm_WORDS];	// Buffer for BAR memory datum
 **	uint32 bar_f1val=0x20;		// Mem field F1 (less than 33 bits)
 **	uint32 bar_f2val[BARm_F4_WORDS]={0x00000001, 0x0b}; // 1 + 11*2^32
 **	assert(BAR_F1_WORDS==1);
 **	ZERO_BARm(barval);		// Zero all fields
 **	SET_BARm_F1(barval,&bar_f1val);	// Set field F1
 **	SET_BARm_F2(barval,&bar_f2val);	// Set field F2
 **	WRITE_BARm(unit,7,barval);	// Write to BAR memory location 7
 **
 *****************************************************************************/

/* Register SYS_CONF_1 */
#define SYS_CONF_1r_ADDR(pic)		reg_addr_5632(SYS_CONF_1r, pic)
#define READ_SYS_CONF_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, SYS_CONF_1r_ADDR(pic), rvp) 
#define WRITE_SYS_CONF_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, SYS_CONF_1r_ADDR(pic), rv) 
#define GET_SYS_CONF_1r_CPUprst(rv)                 ((rv)>>15&0x1)
#define SET_SYS_CONF_1r_CPUprst(rv,fv)              (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_SYS_CONF_1r_Flood_control(rv)           ((rv)>>14&0x1)
#define SET_SYS_CONF_1r_Flood_control(rv,fv)        (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_SYS_CONF_1r_Chip_security(rv)           ((rv)>>13&0x1)
#define SET_SYS_CONF_1r_Chip_security(rv,fv)        (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_SYS_CONF_1r_AgeEN(rv)                   ((rv)>>12&0x1)
#define SET_SYS_CONF_1r_AgeEN(rv,fv)                (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_SYS_CONF_1r_Per_VLAN_ST(rv)             ((rv)>>11&0x1)
#define SET_SYS_CONF_1r_Per_VLAN_ST(rv,fv)          (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_SYS_CONF_1r_STPEN(rv)                   ((rv)>>10&0x1)
#define SET_SYS_CONF_1r_STPEN(rv,fv)                (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_SYS_CONF_1r_PinMon(rv)                  ((rv)>>9&0x1)
#define SET_SYS_CONF_1r_PinMon(rv,fv)               (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_SYS_CONF_1r_PoutMon(rv)                 ((rv)>>8&0x1)
#define SET_SYS_CONF_1r_PoutMon(rv,fv)              (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_SYS_CONF_1r_CPUcfgrdy(rv)               ((rv)>>7&0x1)
#define SET_SYS_CONF_1r_CPUcfgrdy(rv,fv)            (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_SYS_CONF_1r_GMC(rv)                     ((rv)>>6&0x1)
#define SET_SYS_CONF_1r_GMC(rv,fv)                  (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_SYS_CONF_1r_VLAN_GMC(rv)                ((rv)>>5&0x1)
#define SET_SYS_CONF_1r_VLAN_GMC(rv,fv)             (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_SYS_CONF_1r_PQWRREn(rv)                 ((rv)>>4&0x1)
#define SET_SYS_CONF_1r_PQWRREn(rv,fv)              (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_SYS_CONF_1r_Cooperative(rv)             ((rv)>>3&0x1)
#define SET_SYS_CONF_1r_Cooperative(rv,fv)          (rv=(rv&~(0x1<<3))|((fv)&0x1)<<3)
#define GET_SYS_CONF_1r_FailOverEn(rv)              ((rv)>>2&0x1)
#define SET_SYS_CONF_1r_FailOverEn(rv,fv)           (rv=(rv&~(0x1<<2))|((fv)&0x1)<<2)
#define GET_SYS_CONF_1r_Multiplexer10Gport(rv)      ((rv)>>1&0x1)
#define SET_SYS_CONF_1r_Multiplexer10Gport(rv,fv)   (rv=(rv&~(0x1<<1))|((fv)&0x1)<<1)
#define GET_SYS_CONF_1r_ReservedConf1(rv)           ((rv)>>0&0x1)
#define SET_SYS_CONF_1r_ReservedConf1(rv,fv)        (rv=(rv&~(0x1<<0))|((fv)&0x1)<<0)

/* Register SYS_CONF_2 */
#define SYS_CONF_2r_ADDR(pic)		reg_addr_5632(SYS_CONF_2r, pic)
#define READ_SYS_CONF_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, SYS_CONF_2r_ADDR(pic), rvp) 
#define WRITE_SYS_CONF_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, SYS_CONF_2r_ADDR(pic), rv) 
#define GET_SYS_CONF_2r_MaxAge(rv)                  ((rv)>>9&0x7f)
#define SET_SYS_CONF_2r_MaxAge(rv,fv)               (rv=(rv&~(0x7f<<9))|((fv)&0x7f)<<9)
#define GET_SYS_CONF_2r_TimeoutEN(rv)               ((rv)>>8&0x1)
#define SET_SYS_CONF_2r_TimeoutEN(rv,fv)            (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_SYS_CONF_2r_CPU_Timeout_EN(rv)          ((rv)>>7&0x1)
#define SET_SYS_CONF_2r_CPU_Timeout_EN(rv,fv)       (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_SYS_CONF_2r_BConly_SC(rv)               ((rv)>>6&0x1)
#define SET_SYS_CONF_2r_BConly_SC(rv,fv)            (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_SYS_CONF_2r_MaxStorm(rv)                ((rv)>>4&0x3)
#define SET_SYS_CONF_2r_MaxStorm(rv,fv)             (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_SYS_CONF_2r_MaxStorm10g(rv)             ((rv)>>2&0x3)
#define SET_SYS_CONF_2r_MaxStorm10g(rv,fv)          (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_SYS_CONF_2r_ReservedConf2(rv)           ((rv)>>0&0x3)
#define SET_SYS_CONF_2r_ReservedConf2(rv,fv)        (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register SYS_CONF_3 */
#define SYS_CONF_3r_ADDR(pic)		reg_addr_5632(SYS_CONF_3r, pic)
#define READ_SYS_CONF_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, SYS_CONF_3r_ADDR(pic), rvp) 
#define WRITE_SYS_CONF_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, SYS_CONF_3r_ADDR(pic), rv) 
#define GET_SYS_CONF_3r_Qon(rv)                     ((rv)>>15&0x1)
#define SET_SYS_CONF_3r_Qon(rv,fv)                  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_SYS_CONF_3r_ReservedConf3(rv)           ((rv)>>14&0x1)
#define SET_SYS_CONF_3r_ReservedConf3(rv,fv)        (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_SYS_CONF_3r_DiffServ(rv)                ((rv)>>13&0x1)
#define SET_SYS_CONF_3r_DiffServ(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_SYS_CONF_3r_TypeParse(rv)               ((rv)>>12&0x1)
#define SET_SYS_CONF_3r_TypeParse(rv,fv)            (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_SYS_CONF_3r_IPMCtrap(rv)                ((rv)>>11&0x1)
#define SET_SYS_CONF_3r_IPMCtrap(rv,fv)             (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_SYS_CONF_3r_IGMPtrap(rv)                ((rv)>>10&0x1)
#define SET_SYS_CONF_3r_IGMPtrap(rv,fv)             (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_SYS_CONF_3r_GARPtrap(rv)                ((rv)>>9&0x1)
#define SET_SYS_CONF_3r_GARPtrap(rv,fv)             (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_SYS_CONF_3r_ARPtrap(rv)                 ((rv)>>8&0x1)
#define SET_SYS_CONF_3r_ARPtrap(rv,fv)              (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_SYS_CONF_3r_T802ADtrap(rv)              ((rv)>>7&0x1)
#define SET_SYS_CONF_3r_T802ADtrap(rv,fv)           (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_SYS_CONF_3r_ICMPtrap(rv)                ((rv)>>6&0x1)
#define SET_SYS_CONF_3r_ICMPtrap(rv,fv)             (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_SYS_CONF_3r_BPDU1trap(rv)               ((rv)>>5&0x1)
#define SET_SYS_CONF_3r_BPDU1trap(rv,fv)            (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_SYS_CONF_3r_BPDU2trap(rv)               ((rv)>>4&0x1)
#define SET_SYS_CONF_3r_BPDU2trap(rv,fv)            (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_SYS_CONF_3r_MarkerEN(rv)                ((rv)>>3&0x1)
#define SET_SYS_CONF_3r_MarkerEN(rv,fv)             (rv=(rv&~(0x1<<3))|((fv)&0x1)<<3)
#define GET_SYS_CONF_3r_BufDataEn(rv)               ((rv)>>2&0x1)
#define SET_SYS_CONF_3r_BufDataEn(rv,fv)            (rv=(rv&~(0x1<<2))|((fv)&0x1)<<2)
#define GET_SYS_CONF_3r_ReservedConf32(rv)          ((rv)>>0&0x3)
#define SET_SYS_CONF_3r_ReservedConf32(rv,fv)       (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register EP_SETUP_1 */
#define EP_SETUP_1r_ADDR(pic)		reg_addr_5632(EP_SETUP_1r, pic)
#define READ_EP_SETUP_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, EP_SETUP_1r_ADDR(pic), rvp) 
#define WRITE_EP_SETUP_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, EP_SETUP_1r_ADDR(pic), rv) 
#define GET_EP_SETUP_1r_Epprst(rv)                  ((rv)>>15&0x1)
#define SET_EP_SETUP_1r_Epprst(rv,fv)               (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_EP_SETUP_1r_Epconf(rv)                  ((rv)>>12&0x7)
#define SET_EP_SETUP_1r_Epconf(rv,fv)               (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_EP_SETUP_1r_ReservedEP(rv)              ((rv)>>6&0x3f)
#define SET_EP_SETUP_1r_ReservedEP(rv,fv)           (rv=(rv&~(0x3f<<6))|((fv)&0x3f)<<6)
#define GET_EP_SETUP_1r_EPL2size(rv)                ((rv)>>0&0x3f)
#define SET_EP_SETUP_1r_EPL2size(rv,fv)             (rv=(rv&~(0x3f<<0))|((fv)&0x3f)<<0)

/* Register EP_SETUP_2 */
#define EP_SETUP_2r_ADDR(pic)		reg_addr_5632(EP_SETUP_2r, pic)
#define READ_EP_SETUP_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, EP_SETUP_2r_ADDR(pic), rvp) 
#define WRITE_EP_SETUP_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, EP_SETUP_2r_ADDR(pic), rv) 
#define GET_EP_SETUP_2r_EEPROMID(rv)                ((rv)>>13&0x7)
#define SET_EP_SETUP_2r_EEPROMID(rv,fv)             (rv=(rv&~(0x7<<13))|((fv)&0x7)<<13)
#define GET_EP_SETUP_2r_ReservedEP2(rv)             ((rv)>>8&0x1f)
#define SET_EP_SETUP_2r_ReservedEP2(rv,fv)          (rv=(rv&~(0x1f<<8))|((fv)&0x1f)<<8)
#define GET_EP_SETUP_2r_EPVLANsize(rv)              ((rv)>>0&0xff)
#define SET_EP_SETUP_2r_EPVLANsize(rv,fv)           (rv=(rv&~(0xff<<0))|((fv)&0xff)<<0)

/* Register PRIO_QMAP */
#define PRIO_QMAPr_ADDR(pic)		reg_addr_5632(PRIO_QMAPr, pic)
#define READ_PRIO_QMAPr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, PRIO_QMAPr_ADDR(pic), rvp) 
#define WRITE_PRIO_QMAPr(unit, pic, rv) \
	cmic_write_reg_5632(unit, PRIO_QMAPr_ADDR(pic), rv) 
#define GET_PRIO_QMAPr_PL7QA(rv)                    ((rv)>>14&0x3)
#define SET_PRIO_QMAPr_PL7QA(rv,fv)                 (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_PRIO_QMAPr_PL6QA(rv)                    ((rv)>>12&0x3)
#define SET_PRIO_QMAPr_PL6QA(rv,fv)                 (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_PRIO_QMAPr_PL5QA(rv)                    ((rv)>>10&0x3)
#define SET_PRIO_QMAPr_PL5QA(rv,fv)                 (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_PRIO_QMAPr_PL4QA(rv)                    ((rv)>>8&0x3)
#define SET_PRIO_QMAPr_PL4QA(rv,fv)                 (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_PRIO_QMAPr_PL3QA(rv)                    ((rv)>>6&0x3)
#define SET_PRIO_QMAPr_PL3QA(rv,fv)                 (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_PRIO_QMAPr_PL2QA(rv)                    ((rv)>>4&0x3)
#define SET_PRIO_QMAPr_PL2QA(rv,fv)                 (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_PRIO_QMAPr_PL1QA(rv)                    ((rv)>>2&0x3)
#define SET_PRIO_QMAPr_PL1QA(rv,fv)                 (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_PRIO_QMAPr_PL0QA(rv)                    ((rv)>>0&0x3)
#define SET_PRIO_QMAPr_PL0QA(rv,fv)                 (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register DFSV_QMAP_0 */
#define DFSV_QMAP_0r_ADDR(pic)		reg_addr_5632(DFSV_QMAP_0r, pic)
#define READ_DFSV_QMAP_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFSV_QMAP_0r_ADDR(pic), rvp) 
#define WRITE_DFSV_QMAP_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFSV_QMAP_0r_ADDR(pic), rv) 
#define GET_DFSV_QMAP_0r_DS7QA(rv)                  ((rv)>>14&0x3)
#define SET_DFSV_QMAP_0r_DS7QA(rv,fv)               (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_DFSV_QMAP_0r_DS6QA(rv)                  ((rv)>>12&0x3)
#define SET_DFSV_QMAP_0r_DS6QA(rv,fv)               (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_DFSV_QMAP_0r_DS5QA(rv)                  ((rv)>>10&0x3)
#define SET_DFSV_QMAP_0r_DS5QA(rv,fv)               (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_DFSV_QMAP_0r_DS4QA(rv)                  ((rv)>>8&0x3)
#define SET_DFSV_QMAP_0r_DS4QA(rv,fv)               (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_DFSV_QMAP_0r_DS3QA(rv)                  ((rv)>>6&0x3)
#define SET_DFSV_QMAP_0r_DS3QA(rv,fv)               (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_DFSV_QMAP_0r_DS2QA(rv)                  ((rv)>>4&0x3)
#define SET_DFSV_QMAP_0r_DS2QA(rv,fv)               (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_DFSV_QMAP_0r_DS1QA(rv)                  ((rv)>>2&0x3)
#define SET_DFSV_QMAP_0r_DS1QA(rv,fv)               (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_DFSV_QMAP_0r_DS0QA(rv)                  ((rv)>>0&0x3)
#define SET_DFSV_QMAP_0r_DS0QA(rv,fv)               (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register DFSV_QMAP_1 */
#define DFSV_QMAP_1r_ADDR(pic)		reg_addr_5632(DFSV_QMAP_1r, pic)
#define READ_DFSV_QMAP_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFSV_QMAP_1r_ADDR(pic), rvp) 
#define WRITE_DFSV_QMAP_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFSV_QMAP_1r_ADDR(pic), rv) 
#define GET_DFSV_QMAP_1r_DS7QA(rv)                  ((rv)>>14&0x3)
#define SET_DFSV_QMAP_1r_DS7QA(rv,fv)               (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_DFSV_QMAP_1r_DS6QA(rv)                  ((rv)>>12&0x3)
#define SET_DFSV_QMAP_1r_DS6QA(rv,fv)               (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_DFSV_QMAP_1r_DS5QA(rv)                  ((rv)>>10&0x3)
#define SET_DFSV_QMAP_1r_DS5QA(rv,fv)               (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_DFSV_QMAP_1r_DS4QA(rv)                  ((rv)>>8&0x3)
#define SET_DFSV_QMAP_1r_DS4QA(rv,fv)               (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_DFSV_QMAP_1r_DS3QA(rv)                  ((rv)>>6&0x3)
#define SET_DFSV_QMAP_1r_DS3QA(rv,fv)               (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_DFSV_QMAP_1r_DS2QA(rv)                  ((rv)>>4&0x3)
#define SET_DFSV_QMAP_1r_DS2QA(rv,fv)               (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_DFSV_QMAP_1r_DS1QA(rv)                  ((rv)>>2&0x3)
#define SET_DFSV_QMAP_1r_DS1QA(rv,fv)               (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_DFSV_QMAP_1r_DS0QA(rv)                  ((rv)>>0&0x3)
#define SET_DFSV_QMAP_1r_DS0QA(rv,fv)               (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register DFSV_QMAP_2 */
#define DFSV_QMAP_2r_ADDR(pic)		reg_addr_5632(DFSV_QMAP_2r, pic)
#define READ_DFSV_QMAP_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFSV_QMAP_2r_ADDR(pic), rvp) 
#define WRITE_DFSV_QMAP_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFSV_QMAP_2r_ADDR(pic), rv) 
#define GET_DFSV_QMAP_2r_DS7QA(rv)                  ((rv)>>14&0x3)
#define SET_DFSV_QMAP_2r_DS7QA(rv,fv)               (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_DFSV_QMAP_2r_DS6QA(rv)                  ((rv)>>12&0x3)
#define SET_DFSV_QMAP_2r_DS6QA(rv,fv)               (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_DFSV_QMAP_2r_DS5QA(rv)                  ((rv)>>10&0x3)
#define SET_DFSV_QMAP_2r_DS5QA(rv,fv)               (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_DFSV_QMAP_2r_DS4QA(rv)                  ((rv)>>8&0x3)
#define SET_DFSV_QMAP_2r_DS4QA(rv,fv)               (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_DFSV_QMAP_2r_DS3QA(rv)                  ((rv)>>6&0x3)
#define SET_DFSV_QMAP_2r_DS3QA(rv,fv)               (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_DFSV_QMAP_2r_DS2QA(rv)                  ((rv)>>4&0x3)
#define SET_DFSV_QMAP_2r_DS2QA(rv,fv)               (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_DFSV_QMAP_2r_DS1QA(rv)                  ((rv)>>2&0x3)
#define SET_DFSV_QMAP_2r_DS1QA(rv,fv)               (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_DFSV_QMAP_2r_DS0QA(rv)                  ((rv)>>0&0x3)
#define SET_DFSV_QMAP_2r_DS0QA(rv,fv)               (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register DFSV_QMAP_3 */
#define DFSV_QMAP_3r_ADDR(pic)		reg_addr_5632(DFSV_QMAP_3r, pic)
#define READ_DFSV_QMAP_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFSV_QMAP_3r_ADDR(pic), rvp) 
#define WRITE_DFSV_QMAP_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFSV_QMAP_3r_ADDR(pic), rv) 
#define GET_DFSV_QMAP_3r_DS7QA(rv)                  ((rv)>>14&0x3)
#define SET_DFSV_QMAP_3r_DS7QA(rv,fv)               (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_DFSV_QMAP_3r_DS6QA(rv)                  ((rv)>>12&0x3)
#define SET_DFSV_QMAP_3r_DS6QA(rv,fv)               (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_DFSV_QMAP_3r_DS5QA(rv)                  ((rv)>>10&0x3)
#define SET_DFSV_QMAP_3r_DS5QA(rv,fv)               (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_DFSV_QMAP_3r_DS4QA(rv)                  ((rv)>>8&0x3)
#define SET_DFSV_QMAP_3r_DS4QA(rv,fv)               (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_DFSV_QMAP_3r_DS3QA(rv)                  ((rv)>>6&0x3)
#define SET_DFSV_QMAP_3r_DS3QA(rv,fv)               (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_DFSV_QMAP_3r_DS2QA(rv)                  ((rv)>>4&0x3)
#define SET_DFSV_QMAP_3r_DS2QA(rv,fv)               (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_DFSV_QMAP_3r_DS1QA(rv)                  ((rv)>>2&0x3)
#define SET_DFSV_QMAP_3r_DS1QA(rv,fv)               (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_DFSV_QMAP_3r_DS0QA(rv)                  ((rv)>>0&0x3)
#define SET_DFSV_QMAP_3r_DS0QA(rv,fv)               (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register DFSV_QMAP_4 */
#define DFSV_QMAP_4r_ADDR(pic)		reg_addr_5632(DFSV_QMAP_4r, pic)
#define READ_DFSV_QMAP_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFSV_QMAP_4r_ADDR(pic), rvp) 
#define WRITE_DFSV_QMAP_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFSV_QMAP_4r_ADDR(pic), rv) 
#define GET_DFSV_QMAP_4r_DS7QA(rv)                  ((rv)>>14&0x3)
#define SET_DFSV_QMAP_4r_DS7QA(rv,fv)               (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_DFSV_QMAP_4r_DS6QA(rv)                  ((rv)>>12&0x3)
#define SET_DFSV_QMAP_4r_DS6QA(rv,fv)               (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_DFSV_QMAP_4r_DS5QA(rv)                  ((rv)>>10&0x3)
#define SET_DFSV_QMAP_4r_DS5QA(rv,fv)               (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_DFSV_QMAP_4r_DS4QA(rv)                  ((rv)>>8&0x3)
#define SET_DFSV_QMAP_4r_DS4QA(rv,fv)               (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_DFSV_QMAP_4r_DS3QA(rv)                  ((rv)>>6&0x3)
#define SET_DFSV_QMAP_4r_DS3QA(rv,fv)               (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_DFSV_QMAP_4r_DS2QA(rv)                  ((rv)>>4&0x3)
#define SET_DFSV_QMAP_4r_DS2QA(rv,fv)               (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_DFSV_QMAP_4r_DS1QA(rv)                  ((rv)>>2&0x3)
#define SET_DFSV_QMAP_4r_DS1QA(rv,fv)               (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_DFSV_QMAP_4r_DS0QA(rv)                  ((rv)>>0&0x3)
#define SET_DFSV_QMAP_4r_DS0QA(rv,fv)               (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register DFSV_QMAP_5 */
#define DFSV_QMAP_5r_ADDR(pic)		reg_addr_5632(DFSV_QMAP_5r, pic)
#define READ_DFSV_QMAP_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFSV_QMAP_5r_ADDR(pic), rvp) 
#define WRITE_DFSV_QMAP_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFSV_QMAP_5r_ADDR(pic), rv) 
#define GET_DFSV_QMAP_5r_DS7QA(rv)                  ((rv)>>14&0x3)
#define SET_DFSV_QMAP_5r_DS7QA(rv,fv)               (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_DFSV_QMAP_5r_DS6QA(rv)                  ((rv)>>12&0x3)
#define SET_DFSV_QMAP_5r_DS6QA(rv,fv)               (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_DFSV_QMAP_5r_DS5QA(rv)                  ((rv)>>10&0x3)
#define SET_DFSV_QMAP_5r_DS5QA(rv,fv)               (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_DFSV_QMAP_5r_DS4QA(rv)                  ((rv)>>8&0x3)
#define SET_DFSV_QMAP_5r_DS4QA(rv,fv)               (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_DFSV_QMAP_5r_DS3QA(rv)                  ((rv)>>6&0x3)
#define SET_DFSV_QMAP_5r_DS3QA(rv,fv)               (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_DFSV_QMAP_5r_DS2QA(rv)                  ((rv)>>4&0x3)
#define SET_DFSV_QMAP_5r_DS2QA(rv,fv)               (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_DFSV_QMAP_5r_DS1QA(rv)                  ((rv)>>2&0x3)
#define SET_DFSV_QMAP_5r_DS1QA(rv,fv)               (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_DFSV_QMAP_5r_DS0QA(rv)                  ((rv)>>0&0x3)
#define SET_DFSV_QMAP_5r_DS0QA(rv,fv)               (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register DFSV_QMAP_6 */
#define DFSV_QMAP_6r_ADDR(pic)		reg_addr_5632(DFSV_QMAP_6r, pic)
#define READ_DFSV_QMAP_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFSV_QMAP_6r_ADDR(pic), rvp) 
#define WRITE_DFSV_QMAP_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFSV_QMAP_6r_ADDR(pic), rv) 
#define GET_DFSV_QMAP_6r_DS7QA(rv)                  ((rv)>>14&0x3)
#define SET_DFSV_QMAP_6r_DS7QA(rv,fv)               (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_DFSV_QMAP_6r_DS6QA(rv)                  ((rv)>>12&0x3)
#define SET_DFSV_QMAP_6r_DS6QA(rv,fv)               (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_DFSV_QMAP_6r_DS5QA(rv)                  ((rv)>>10&0x3)
#define SET_DFSV_QMAP_6r_DS5QA(rv,fv)               (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_DFSV_QMAP_6r_DS4QA(rv)                  ((rv)>>8&0x3)
#define SET_DFSV_QMAP_6r_DS4QA(rv,fv)               (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_DFSV_QMAP_6r_DS3QA(rv)                  ((rv)>>6&0x3)
#define SET_DFSV_QMAP_6r_DS3QA(rv,fv)               (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_DFSV_QMAP_6r_DS2QA(rv)                  ((rv)>>4&0x3)
#define SET_DFSV_QMAP_6r_DS2QA(rv,fv)               (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_DFSV_QMAP_6r_DS1QA(rv)                  ((rv)>>2&0x3)
#define SET_DFSV_QMAP_6r_DS1QA(rv,fv)               (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_DFSV_QMAP_6r_DS0QA(rv)                  ((rv)>>0&0x3)
#define SET_DFSV_QMAP_6r_DS0QA(rv,fv)               (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register DFSV_QMAP_7 */
#define DFSV_QMAP_7r_ADDR(pic)		reg_addr_5632(DFSV_QMAP_7r, pic)
#define READ_DFSV_QMAP_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFSV_QMAP_7r_ADDR(pic), rvp) 
#define WRITE_DFSV_QMAP_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFSV_QMAP_7r_ADDR(pic), rv) 
#define GET_DFSV_QMAP_7r_DS7QA(rv)                  ((rv)>>14&0x3)
#define SET_DFSV_QMAP_7r_DS7QA(rv,fv)               (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_DFSV_QMAP_7r_DS6QA(rv)                  ((rv)>>12&0x3)
#define SET_DFSV_QMAP_7r_DS6QA(rv,fv)               (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_DFSV_QMAP_7r_DS5QA(rv)                  ((rv)>>10&0x3)
#define SET_DFSV_QMAP_7r_DS5QA(rv,fv)               (rv=(rv&~(0x3<<10))|((fv)&0x3)<<10)
#define GET_DFSV_QMAP_7r_DS4QA(rv)                  ((rv)>>8&0x3)
#define SET_DFSV_QMAP_7r_DS4QA(rv,fv)               (rv=(rv&~(0x3<<8))|((fv)&0x3)<<8)
#define GET_DFSV_QMAP_7r_DS3QA(rv)                  ((rv)>>6&0x3)
#define SET_DFSV_QMAP_7r_DS3QA(rv,fv)               (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_DFSV_QMAP_7r_DS2QA(rv)                  ((rv)>>4&0x3)
#define SET_DFSV_QMAP_7r_DS2QA(rv,fv)               (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_DFSV_QMAP_7r_DS1QA(rv)                  ((rv)>>2&0x3)
#define SET_DFSV_QMAP_7r_DS1QA(rv,fv)               (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_DFSV_QMAP_7r_DS0QA(rv)                  ((rv)>>0&0x3)
#define SET_DFSV_QMAP_7r_DS0QA(rv,fv)               (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register QWEIGHT_1G */
#define QWEIGHT_1Gr_ADDR(pic)		reg_addr_5632(QWEIGHT_1Gr, pic)
#define READ_QWEIGHT_1Gr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QWEIGHT_1Gr_ADDR(pic), rvp) 
#define WRITE_QWEIGHT_1Gr(unit, pic, rv) \
	cmic_write_reg_5632(unit, QWEIGHT_1Gr_ADDR(pic), rv) 
#define GET_QWEIGHT_1Gr_Q3RRWeight(rv)              ((rv)>>12&0xf)
#define SET_QWEIGHT_1Gr_Q3RRWeight(rv,fv)           (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_QWEIGHT_1Gr_Q2RRWeight(rv)              ((rv)>>8&0xf)
#define SET_QWEIGHT_1Gr_Q2RRWeight(rv,fv)           (rv=(rv&~(0xf<<8))|((fv)&0xf)<<8)
#define GET_QWEIGHT_1Gr_Q1RRWeight(rv)              ((rv)>>4&0xf)
#define SET_QWEIGHT_1Gr_Q1RRWeight(rv,fv)           (rv=(rv&~(0xf<<4))|((fv)&0xf)<<4)
#define GET_QWEIGHT_1Gr_Q0RRWeight(rv)              ((rv)>>0&0xf)
#define SET_QWEIGHT_1Gr_Q0RRWeight(rv,fv)           (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register QWEIGHT_10G */
#define QWEIGHT_10Gr_ADDR(pic)		reg_addr_5632(QWEIGHT_10Gr, pic)
#define READ_QWEIGHT_10Gr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QWEIGHT_10Gr_ADDR(pic), rvp) 
#define WRITE_QWEIGHT_10Gr(unit, pic, rv) \
	cmic_write_reg_5632(unit, QWEIGHT_10Gr_ADDR(pic), rv) 
#define GET_QWEIGHT_10Gr_Q3RRWeight10G(rv)          ((rv)>>12&0xf)
#define SET_QWEIGHT_10Gr_Q3RRWeight10G(rv,fv)       (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_QWEIGHT_10Gr_Q2RRWeight10G(rv)          ((rv)>>8&0xf)
#define SET_QWEIGHT_10Gr_Q2RRWeight10G(rv,fv)       (rv=(rv&~(0xf<<8))|((fv)&0xf)<<8)
#define GET_QWEIGHT_10Gr_Q1RRWeight10G(rv)          ((rv)>>4&0xf)
#define SET_QWEIGHT_10Gr_Q1RRWeight10G(rv,fv)       (rv=(rv&~(0xf<<4))|((fv)&0xf)<<4)
#define GET_QWEIGHT_10Gr_Q0RRWeight10G(rv)          ((rv)>>0&0xf)
#define SET_QWEIGHT_10Gr_Q0RRWeight10G(rv,fv)       (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register QMAX_1G */
#define QMAX_1Gr_ADDR(pic)		reg_addr_5632(QMAX_1Gr, pic)
#define READ_QMAX_1Gr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QMAX_1Gr_ADDR(pic), rvp) 
#define WRITE_QMAX_1Gr(unit, pic, rv) \
	cmic_write_reg_5632(unit, QMAX_1Gr_ADDR(pic), rv) 
#define GET_QMAX_1Gr_Q3MaxLimit(rv)                 ((rv)>>12&0xf)
#define SET_QMAX_1Gr_Q3MaxLimit(rv,fv)              (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_QMAX_1Gr_Q2MaxLimit(rv)                 ((rv)>>8&0xf)
#define SET_QMAX_1Gr_Q2MaxLimit(rv,fv)              (rv=(rv&~(0xf<<8))|((fv)&0xf)<<8)
#define GET_QMAX_1Gr_Q1MaxLimit(rv)                 ((rv)>>4&0xf)
#define SET_QMAX_1Gr_Q1MaxLimit(rv,fv)              (rv=(rv&~(0xf<<4))|((fv)&0xf)<<4)
#define GET_QMAX_1Gr_Q0MaxLimit(rv)                 ((rv)>>0&0xf)
#define SET_QMAX_1Gr_Q0MaxLimit(rv,fv)              (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register QMAX_10G */
#define QMAX_10Gr_ADDR(pic)		reg_addr_5632(QMAX_10Gr, pic)
#define READ_QMAX_10Gr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QMAX_10Gr_ADDR(pic), rvp) 
#define WRITE_QMAX_10Gr(unit, pic, rv) \
	cmic_write_reg_5632(unit, QMAX_10Gr_ADDR(pic), rv) 
#define GET_QMAX_10Gr_Q3MaxLimit10G(rv)             ((rv)>>12&0xf)
#define SET_QMAX_10Gr_Q3MaxLimit10G(rv,fv)          (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_QMAX_10Gr_Q2MaxLimit10G(rv)             ((rv)>>8&0xf)
#define SET_QMAX_10Gr_Q2MaxLimit10G(rv,fv)          (rv=(rv&~(0xf<<8))|((fv)&0xf)<<8)
#define GET_QMAX_10Gr_Q1MaxLimit10G(rv)             ((rv)>>4&0xf)
#define SET_QMAX_10Gr_Q1MaxLimit10G(rv,fv)          (rv=(rv&~(0xf<<4))|((fv)&0xf)<<4)
#define GET_QMAX_10Gr_Q0MaxLimit10G(rv)             ((rv)>>0&0xf)
#define SET_QMAX_10Gr_Q0MaxLimit10G(rv,fv)          (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register QMGMT_1 */
#define QMGMT_1r_ADDR(pic)		reg_addr_5632(QMGMT_1r, pic)
#define READ_QMGMT_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QMGMT_1r_ADDR(pic), rvp) 
#define WRITE_QMGMT_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, QMGMT_1r_ADDR(pic), rv) 
#define GET_QMGMT_1r_ReservedQM(rv)                 ((rv)>>14&0x3)
#define SET_QMGMT_1r_ReservedQM(rv,fv)              (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_QMGMT_1r_CPUQ0En(rv)                    ((rv)>>13&0x1)
#define SET_QMGMT_1r_CPUQ0En(rv,fv)                 (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_QMGMT_1r_TGQ0En(rv)                     ((rv)>>12&0x1)
#define SET_QMGMT_1r_TGQ0En(rv,fv)                  (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_QMGMT_1r_GxQ0En(rv)                     ((rv)>>0&0xfff)
#define SET_QMGMT_1r_GxQ0En(rv,fv)                  (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register QMGMT_2 */
#define QMGMT_2r_ADDR(pic)		reg_addr_5632(QMGMT_2r, pic)
#define READ_QMGMT_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QMGMT_2r_ADDR(pic), rvp) 
#define WRITE_QMGMT_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, QMGMT_2r_ADDR(pic), rv) 
#define GET_QMGMT_2r_ReservedQM2(rv)                ((rv)>>13&0x7)
#define SET_QMGMT_2r_ReservedQM2(rv,fv)             (rv=(rv&~(0x7<<13))|((fv)&0x7)<<13)
#define GET_QMGMT_2r_TGQ1En(rv)                     ((rv)>>12&0x1)
#define SET_QMGMT_2r_TGQ1En(rv,fv)                  (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_QMGMT_2r_GxQ1En(rv)                     ((rv)>>0&0xfff)
#define SET_QMGMT_2r_GxQ1En(rv,fv)                  (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register QMGMT_3 */
#define QMGMT_3r_ADDR(pic)		reg_addr_5632(QMGMT_3r, pic)
#define READ_QMGMT_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QMGMT_3r_ADDR(pic), rvp) 
#define WRITE_QMGMT_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, QMGMT_3r_ADDR(pic), rv) 
#define GET_QMGMT_3r_ReservedQM3(rv)                ((rv)>>13&0x7)
#define SET_QMGMT_3r_ReservedQM3(rv,fv)             (rv=(rv&~(0x7<<13))|((fv)&0x7)<<13)
#define GET_QMGMT_3r_TGQ2En(rv)                     ((rv)>>12&0x1)
#define SET_QMGMT_3r_TGQ2En(rv,fv)                  (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_QMGMT_3r_GxQ2En(rv)                     ((rv)>>0&0xfff)
#define SET_QMGMT_3r_GxQ2En(rv,fv)                  (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register QMGMT_4 */
#define QMGMT_4r_ADDR(pic)		reg_addr_5632(QMGMT_4r, pic)
#define READ_QMGMT_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QMGMT_4r_ADDR(pic), rvp) 
#define WRITE_QMGMT_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, QMGMT_4r_ADDR(pic), rv) 
#define GET_QMGMT_4r_ReservedQM4(rv)                ((rv)>>13&0x7)
#define SET_QMGMT_4r_ReservedQM4(rv,fv)             (rv=(rv&~(0x7<<13))|((fv)&0x7)<<13)
#define GET_QMGMT_4r_TGQ3En(rv)                     ((rv)>>12&0x1)
#define SET_QMGMT_4r_TGQ3En(rv,fv)                  (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_QMGMT_4r_GxQ3En(rv)                     ((rv)>>0&0xfff)
#define SET_QMGMT_4r_GxQ3En(rv,fv)                  (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register QMGMT_5 */
#define QMGMT_5r_ADDR(pic)		reg_addr_5632(QMGMT_5r, pic)
#define READ_QMGMT_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, QMGMT_5r_ADDR(pic), rvp) 
#define WRITE_QMGMT_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, QMGMT_5r_ADDR(pic), rv) 
#define GET_QMGMT_5r_OqFullBp3(rv)                  ((rv)>>15&0x1)
#define SET_QMGMT_5r_OqFullBp3(rv,fv)               (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_QMGMT_5r_OqFullBp2(rv)                  ((rv)>>14&0x1)
#define SET_QMGMT_5r_OqFullBp2(rv,fv)               (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_QMGMT_5r_OqFullBp1(rv)                  ((rv)>>13&0x1)
#define SET_QMGMT_5r_OqFullBp1(rv,fv)               (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_QMGMT_5r_OqFullBp0(rv)                  ((rv)>>12&0x1)
#define SET_QMGMT_5r_OqFullBp0(rv,fv)               (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_QMGMT_5r_Q3LatencyEn(rv)                ((rv)>>11&0x1)
#define SET_QMGMT_5r_Q3LatencyEn(rv,fv)             (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_QMGMT_5r_Q2LatencyEn(rv)                ((rv)>>10&0x1)
#define SET_QMGMT_5r_Q2LatencyEn(rv,fv)             (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_QMGMT_5r_Q1LatencyEn(rv)                ((rv)>>9&0x1)
#define SET_QMGMT_5r_Q1LatencyEn(rv,fv)             (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_QMGMT_5r_Q0LatencyEn(rv)                ((rv)>>8&0x1)
#define SET_QMGMT_5r_Q0LatencyEn(rv,fv)             (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_QMGMT_5r_Q3LatencyLim(rv)               ((rv)>>6&0x3)
#define SET_QMGMT_5r_Q3LatencyLim(rv,fv)            (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_QMGMT_5r_Q2LatencyLim(rv)               ((rv)>>4&0x3)
#define SET_QMGMT_5r_Q2LatencyLim(rv,fv)            (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_QMGMT_5r_Q1LatencyLim(rv)               ((rv)>>2&0x3)
#define SET_QMGMT_5r_Q1LatencyLim(rv,fv)            (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_QMGMT_5r_Q0LatencyLim(rv)               ((rv)>>0&0x3)
#define SET_QMGMT_5r_Q0LatencyLim(rv,fv)            (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register BMGMT_1 */
#define BMGMT_1r_ADDR(pic)		reg_addr_5632(BMGMT_1r, pic)
#define READ_BMGMT_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, BMGMT_1r_ADDR(pic), rvp) 
#define WRITE_BMGMT_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, BMGMT_1r_ADDR(pic), rv) 
#define GET_BMGMT_1r_JumboEn(rv)                    ((rv)>>15&0x1)
#define SET_BMGMT_1r_JumboEn(rv,fv)                 (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_BMGMT_1r_JumboSize(rv)                  ((rv)>>13&0x3)
#define SET_BMGMT_1r_JumboSize(rv,fv)               (rv=(rv&~(0x3<<13))|((fv)&0x3)<<13)
#define GET_BMGMT_1r_B8G_mode(rv)                   ((rv)>>12&0x1)
#define SET_BMGMT_1r_B8G_mode(rv,fv)                (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_BMGMT_1r_CPUless_mode(rv)               ((rv)>>11&0x1)
#define SET_BMGMT_1r_CPUless_mode(rv,fv)            (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_BMGMT_1r_Fair_Share(rv)                 ((rv)>>10&0x1)
#define SET_BMGMT_1r_Fair_Share(rv,fv)              (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_BMGMT_1r_Non_Jumbo_MTU(rv)              ((rv)>>9&0x1)
#define SET_BMGMT_1r_Non_Jumbo_MTU(rv,fv)           (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_BMGMT_1r_ReservedBM(rv)                 ((rv)>>7&0x3)
#define SET_BMGMT_1r_ReservedBM(rv,fv)              (rv=(rv&~(0x3<<7))|((fv)&0x3)<<7)
#define GET_BMGMT_1r_WaterMark1(rv)                 ((rv)>>0&0x7f)
#define SET_BMGMT_1r_WaterMark1(rv,fv)              (rv=(rv&~(0x7f<<0))|((fv)&0x7f)<<0)

/* Register BMGMT_2 */
#define BMGMT_2r_ADDR(pic)		reg_addr_5632(BMGMT_2r, pic)
#define READ_BMGMT_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, BMGMT_2r_ADDR(pic), rvp) 
#define WRITE_BMGMT_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, BMGMT_2r_ADDR(pic), rv) 
#define GET_BMGMT_2r_ReservedBM2(rv)                ((rv)>>14&0x3)
#define SET_BMGMT_2r_ReservedBM2(rv,fv)             (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_BMGMT_2r_WaterMark2(rv)                 ((rv)>>7&0x7f)
#define SET_BMGMT_2r_WaterMark2(rv,fv)              (rv=(rv&~(0x7f<<7))|((fv)&0x7f)<<7)
#define GET_BMGMT_2r_WaterMark3(rv)                 ((rv)>>0&0x7f)
#define SET_BMGMT_2r_WaterMark3(rv,fv)              (rv=(rv&~(0x7f<<0))|((fv)&0x7f)<<0)

/* Register BMGMT_3 */
#define BMGMT_3r_ADDR(pic)		reg_addr_5632(BMGMT_3r, pic)
#define READ_BMGMT_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, BMGMT_3r_ADDR(pic), rvp) 
#define WRITE_BMGMT_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, BMGMT_3r_ADDR(pic), rv) 
#define GET_BMGMT_3r_WaterMark1CPU(rv)              ((rv)>>9&0x7f)
#define SET_BMGMT_3r_WaterMark1CPU(rv,fv)           (rv=(rv&~(0x7f<<9))|((fv)&0x7f)<<9)
#define GET_BMGMT_3r_WaterMark1_10G(rv)             ((rv)>>0&0x1ff)
#define SET_BMGMT_3r_WaterMark1_10G(rv,fv)          (rv=(rv&~(0x1ff<<0))|((fv)&0x1ff)<<0)

/* Register BMGMT_4 */
#define BMGMT_4r_ADDR(pic)		reg_addr_5632(BMGMT_4r, pic)
#define READ_BMGMT_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, BMGMT_4r_ADDR(pic), rvp) 
#define WRITE_BMGMT_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, BMGMT_4r_ADDR(pic), rv) 
#define GET_BMGMT_4r_WaterMark2CPU(rv)              ((rv)>>9&0x7f)
#define SET_BMGMT_4r_WaterMark2CPU(rv,fv)           (rv=(rv&~(0x7f<<9))|((fv)&0x7f)<<9)
#define GET_BMGMT_4r_WaterMark2_10G(rv)             ((rv)>>0&0x1ff)
#define SET_BMGMT_4r_WaterMark2_10G(rv,fv)          (rv=(rv&~(0x1ff<<0))|((fv)&0x1ff)<<0)

/* Register BMGMT_5 */
#define BMGMT_5r_ADDR(pic)		reg_addr_5632(BMGMT_5r, pic)
#define READ_BMGMT_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, BMGMT_5r_ADDR(pic), rvp) 
#define WRITE_BMGMT_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, BMGMT_5r_ADDR(pic), rv) 
#define GET_BMGMT_5r_WaterMark3CPU(rv)              ((rv)>>9&0x7f)
#define SET_BMGMT_5r_WaterMark3CPU(rv,fv)           (rv=(rv&~(0x7f<<9))|((fv)&0x7f)<<9)
#define GET_BMGMT_5r_WaterMark3_10G(rv)             ((rv)>>0&0x1ff)
#define SET_BMGMT_5r_WaterMark3_10G(rv,fv)          (rv=(rv&~(0x1ff<<0))|((fv)&0x1ff)<<0)

/* Register PHY_CONF */
#define PHY_CONFr_ADDR(pic)		reg_addr_5632(PHY_CONFr, pic)
#define READ_PHY_CONFr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, PHY_CONFr_ADDR(pic), rvp) 
#define WRITE_PHY_CONFr(unit, pic, rv) \
	cmic_write_reg_5632(unit, PHY_CONFr_ADDR(pic), rv) 
#define GET_PHY_CONFr_ReservedPHY(rv)               ((rv)>>14&0x3)
#define SET_PHY_CONFr_ReservedPHY(rv,fv)            (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_PHY_CONFr_MIISlowClk(rv)                ((rv)>>13&0x1)
#define SET_PHY_CONFr_MIISlowClk(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_PHY_CONFr_PHYOpReg(rv)                  ((rv)>>8&0x1f)
#define SET_PHY_CONFr_PHYOpReg(rv,fv)               (rv=(rv&~(0x1f<<8))|((fv)&0x1f)<<8)
#define GET_PHY_CONFr_PHYOpSp(rv)                   ((rv)>>4&0xf)
#define SET_PHY_CONFr_PHYOpSp(rv,fv)                (rv=(rv&~(0xf<<4))|((fv)&0xf)<<4)
#define GET_PHY_CONFr_PHYOpMd(rv)                   ((rv)>>0&0xf)
#define SET_PHY_CONFr_PHYOpMd(rv,fv)                (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register MAC_CONF_1G */
#define MAC_CONF_1Gr_ADDR(pic)		reg_addr_5632(MAC_CONF_1Gr, pic)
#define READ_MAC_CONF_1Gr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, MAC_CONF_1Gr_ADDR(pic), rvp) 
#define WRITE_MAC_CONF_1Gr(unit, pic, rv) \
	cmic_write_reg_5632(unit, MAC_CONF_1Gr_ADDR(pic), rv) 
#define GET_MAC_CONF_1Gr_SuperMac(rv)               ((rv)>>15&0x1)
#define SET_MAC_CONF_1Gr_SuperMac(rv,fv)            (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_MAC_CONF_1Gr_UltraMac(rv)               ((rv)>>14&0x1)
#define SET_MAC_CONF_1Gr_UltraMac(rv,fv)            (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_MAC_CONF_1Gr_Bp_col(rv)                 ((rv)>>13&0x1)
#define SET_MAC_CONF_1Gr_Bp_col(rv,fv)              (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_MAC_CONF_1Gr_IPG64(rv)                  ((rv)>>12&0x1)
#define SET_MAC_CONF_1Gr_IPG64(rv,fv)               (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_MAC_CONF_1Gr_BP_IPG64(rv)               ((rv)>>11&0x1)
#define SET_MAC_CONF_1Gr_BP_IPG64(rv,fv)            (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_MAC_CONF_1Gr_Bprate(rv)                 ((rv)>>9&0x3)
#define SET_MAC_CONF_1Gr_Bprate(rv,fv)              (rv=(rv&~(0x3<<9))|((fv)&0x3)<<9)
#define GET_MAC_CONF_1Gr_BebSel(rv)                 ((rv)>>8&0x1)
#define SET_MAC_CONF_1Gr_BebSel(rv,fv)              (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_MAC_CONF_1Gr_Extcycsel(rv)              ((rv)>>6&0x3)
#define SET_MAC_CONF_1Gr_Extcycsel(rv,fv)           (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_MAC_CONF_1Gr_Mactest(rv)                ((rv)>>5&0x1)
#define SET_MAC_CONF_1Gr_Mactest(rv,fv)             (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_MAC_CONF_1Gr_BPIpgSel(rv)               ((rv)>>3&0x3)
#define SET_MAC_CONF_1Gr_BPIpgSel(rv,fv)            (rv=(rv&~(0x3<<3))|((fv)&0x3)<<3)
#define GET_MAC_CONF_1Gr_ReservedMAC(rv)            ((rv)>>0&0x7)
#define SET_MAC_CONF_1Gr_ReservedMAC(rv,fv)         (rv=(rv&~(0x7<<0))|((fv)&0x7)<<0)

/* Register TRK_SETUP_0 */
#define TRK_SETUP_0r_ADDR(pic)		reg_addr_5632(TRK_SETUP_0r, pic)
#define READ_TRK_SETUP_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TRK_SETUP_0r_ADDR(pic), rvp) 
#define WRITE_TRK_SETUP_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TRK_SETUP_0r_ADDR(pic), rv) 
#define GET_TRK_SETUP_0r_Tsetup_remote(rv)          ((rv)>>12&0xf)
#define SET_TRK_SETUP_0r_Tsetup_remote(rv,fv)       (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_TRK_SETUP_0r_Tsetup_local(rv)           ((rv)>>0&0xfff)
#define SET_TRK_SETUP_0r_Tsetup_local(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register TRK_SETUP_1 */
#define TRK_SETUP_1r_ADDR(pic)		reg_addr_5632(TRK_SETUP_1r, pic)
#define READ_TRK_SETUP_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TRK_SETUP_1r_ADDR(pic), rvp) 
#define WRITE_TRK_SETUP_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TRK_SETUP_1r_ADDR(pic), rv) 
#define GET_TRK_SETUP_1r_Tsetup_remote(rv)          ((rv)>>12&0xf)
#define SET_TRK_SETUP_1r_Tsetup_remote(rv,fv)       (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_TRK_SETUP_1r_Tsetup_local(rv)           ((rv)>>0&0xfff)
#define SET_TRK_SETUP_1r_Tsetup_local(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register TRK_SETUP_2 */
#define TRK_SETUP_2r_ADDR(pic)		reg_addr_5632(TRK_SETUP_2r, pic)
#define READ_TRK_SETUP_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TRK_SETUP_2r_ADDR(pic), rvp) 
#define WRITE_TRK_SETUP_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TRK_SETUP_2r_ADDR(pic), rv) 
#define GET_TRK_SETUP_2r_Tsetup_remote(rv)          ((rv)>>12&0xf)
#define SET_TRK_SETUP_2r_Tsetup_remote(rv,fv)       (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_TRK_SETUP_2r_Tsetup_local(rv)           ((rv)>>0&0xfff)
#define SET_TRK_SETUP_2r_Tsetup_local(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register TRK_SETUP_3 */
#define TRK_SETUP_3r_ADDR(pic)		reg_addr_5632(TRK_SETUP_3r, pic)
#define READ_TRK_SETUP_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TRK_SETUP_3r_ADDR(pic), rvp) 
#define WRITE_TRK_SETUP_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TRK_SETUP_3r_ADDR(pic), rv) 
#define GET_TRK_SETUP_3r_Tsetup_remote(rv)          ((rv)>>12&0xf)
#define SET_TRK_SETUP_3r_Tsetup_remote(rv,fv)       (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_TRK_SETUP_3r_Tsetup_local(rv)           ((rv)>>0&0xfff)
#define SET_TRK_SETUP_3r_Tsetup_local(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register TRK_SETUP_4 */
#define TRK_SETUP_4r_ADDR(pic)		reg_addr_5632(TRK_SETUP_4r, pic)
#define READ_TRK_SETUP_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TRK_SETUP_4r_ADDR(pic), rvp) 
#define WRITE_TRK_SETUP_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TRK_SETUP_4r_ADDR(pic), rv) 
#define GET_TRK_SETUP_4r_Tsetup_remote(rv)          ((rv)>>12&0xf)
#define SET_TRK_SETUP_4r_Tsetup_remote(rv,fv)       (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_TRK_SETUP_4r_Tsetup_local(rv)           ((rv)>>0&0xfff)
#define SET_TRK_SETUP_4r_Tsetup_local(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register TRK_SETUP_5 */
#define TRK_SETUP_5r_ADDR(pic)		reg_addr_5632(TRK_SETUP_5r, pic)
#define READ_TRK_SETUP_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TRK_SETUP_5r_ADDR(pic), rvp) 
#define WRITE_TRK_SETUP_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TRK_SETUP_5r_ADDR(pic), rv) 
#define GET_TRK_SETUP_5r_Tsetup_remote(rv)          ((rv)>>12&0xf)
#define SET_TRK_SETUP_5r_Tsetup_remote(rv,fv)       (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_TRK_SETUP_5r_Tsetup_local(rv)           ((rv)>>0&0xfff)
#define SET_TRK_SETUP_5r_Tsetup_local(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register TRK_DIST_SEL */
#define TRK_DIST_SELr_ADDR(pic)		reg_addr_5632(TRK_DIST_SELr, pic)
#define READ_TRK_DIST_SELr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TRK_DIST_SELr_ADDR(pic), rvp) 
#define WRITE_TRK_DIST_SELr(unit, pic, rv) \
	cmic_write_reg_5632(unit, TRK_DIST_SELr_ADDR(pic), rv) 
#define GET_TRK_DIST_SELr_Failover_Timer(rv)        ((rv)>>14&0x3)
#define SET_TRK_DIST_SELr_Failover_Timer(rv,fv)     (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_TRK_DIST_SELr_Failback_Timer(rv)        ((rv)>>12&0x3)
#define SET_TRK_DIST_SELr_Failback_Timer(rv,fv)     (rv=(rv&~(0x3<<12))|((fv)&0x3)<<12)
#define GET_TRK_DIST_SELr_L2MacSA(rv)               ((rv)>>11&0x1)
#define SET_TRK_DIST_SELr_L2MacSA(rv,fv)            (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_TRK_DIST_SELr_L2MacDA(rv)               ((rv)>>10&0x1)
#define SET_TRK_DIST_SELr_L2MacDA(rv,fv)            (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_TRK_DIST_SELr_L2EthType(rv)             ((rv)>>9&0x1)
#define SET_TRK_DIST_SELr_L2EthType(rv,fv)          (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_TRK_DIST_SELr_L2VLANID(rv)              ((rv)>>8&0x1)
#define SET_TRK_DIST_SELr_L2VLANID(rv,fv)           (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_TRK_DIST_SELr_IPMacSA(rv)               ((rv)>>7&0x1)
#define SET_TRK_DIST_SELr_IPMacSA(rv,fv)            (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_TRK_DIST_SELr_IPMacDA(rv)               ((rv)>>6&0x1)
#define SET_TRK_DIST_SELr_IPMacDA(rv,fv)            (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_TRK_DIST_SELr_L3Protocol(rv)            ((rv)>>5&0x1)
#define SET_TRK_DIST_SELr_L3Protocol(rv,fv)         (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_TRK_DIST_SELr_L3VLANID(rv)              ((rv)>>4&0x1)
#define SET_TRK_DIST_SELr_L3VLANID(rv,fv)           (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_TRK_DIST_SELr_L3IPSA(rv)                ((rv)>>3&0x1)
#define SET_TRK_DIST_SELr_L3IPSA(rv,fv)             (rv=(rv&~(0x1<<3))|((fv)&0x1)<<3)
#define GET_TRK_DIST_SELr_L3IPDA(rv)                ((rv)>>2&0x1)
#define SET_TRK_DIST_SELr_L3IPDA(rv,fv)             (rv=(rv&~(0x1<<2))|((fv)&0x1)<<2)
#define GET_TRK_DIST_SELr_L3SS(rv)                  ((rv)>>1&0x1)
#define SET_TRK_DIST_SELr_L3SS(rv,fv)               (rv=(rv&~(0x1<<1))|((fv)&0x1)<<1)
#define GET_TRK_DIST_SELr_L3DS(rv)                  ((rv)>>0&0x1)
#define SET_TRK_DIST_SELr_L3DS(rv,fv)               (rv=(rv&~(0x1<<0))|((fv)&0x1)<<0)

/* Register PMON_CONF */
#define PMON_CONFr_ADDR(pic)		reg_addr_5632(PMON_CONFr, pic)
#define READ_PMON_CONFr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, PMON_CONFr_ADDR(pic), rvp) 
#define WRITE_PMON_CONFr(unit, pic, rv) \
	cmic_write_reg_5632(unit, PMON_CONFr_ADDR(pic), rv) 
#define GET_PMON_CONFr_ReservedPM(rv)               ((rv)>>12&0xf)
#define SET_PMON_CONFr_ReservedPM(rv,fv)            (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_PMON_CONFr_MdPID(rv)                    ((rv)>>8&0xf)
#define SET_PMON_CONFr_MdPID(rv,fv)                 (rv=(rv&~(0xf<<8))|((fv)&0xf)<<8)
#define GET_PMON_CONFr_MgIPID(rv)                   ((rv)>>4&0xf)
#define SET_PMON_CONFr_MgIPID(rv,fv)                (rv=(rv&~(0xf<<4))|((fv)&0xf)<<4)
#define GET_PMON_CONFr_MgOPID(rv)                   ((rv)>>0&0xf)
#define SET_PMON_CONFr_MgOPID(rv,fv)                (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register PENG_CONF_1 */
#define PENG_CONF_1r_ADDR(pic)		reg_addr_5632(PENG_CONF_1r, pic)
#define READ_PENG_CONF_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, PENG_CONF_1r_ADDR(pic), rvp) 
#define WRITE_PENG_CONF_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, PENG_CONF_1r_ADDR(pic), rv) 
#define GET_PENG_CONF_1r_ReservedR26(rv)            ((rv)>>0&0xffff)
#define SET_PENG_CONF_1r_ReservedR26(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register PENG_CONF_2 */
#define PENG_CONF_2r_ADDR(pic)		reg_addr_5632(PENG_CONF_2r, pic)
#define READ_PENG_CONF_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, PENG_CONF_2r_ADDR(pic), rvp) 
#define WRITE_PENG_CONF_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, PENG_CONF_2r_ADDR(pic), rv) 
#define GET_PENG_CONF_2r_ReservedR27(rv)            ((rv)>>0&0xffff)
#define SET_PENG_CONF_2r_ReservedR27(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register XGMI_CONF_1 */
#define XGMI_CONF_1r_ADDR(pic)		reg_addr_5632(XGMI_CONF_1r, pic)
#define READ_XGMI_CONF_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, XGMI_CONF_1r_ADDR(pic), rvp) 
#define WRITE_XGMI_CONF_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, XGMI_CONF_1r_ADDR(pic), rv) 
#define GET_XGMI_CONF_1r_XGMII_IDLE(rv)             ((rv)>>8&0xff)
#define SET_XGMI_CONF_1r_XGMII_IDLE(rv,fv)          (rv=(rv&~(0xff<<8))|((fv)&0xff)<<8)
#define GET_XGMI_CONF_1r_XGMII_SOP(rv)              ((rv)>>0&0xff)
#define SET_XGMI_CONF_1r_XGMII_SOP(rv,fv)           (rv=(rv&~(0xff<<0))|((fv)&0xff)<<0)

/* Register XGMI_CONF_2 */
#define XGMI_CONF_2r_ADDR(pic)		reg_addr_5632(XGMI_CONF_2r, pic)
#define READ_XGMI_CONF_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, XGMI_CONF_2r_ADDR(pic), rvp) 
#define WRITE_XGMI_CONF_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, XGMI_CONF_2r_ADDR(pic), rv) 
#define GET_XGMI_CONF_2r_XGMII_EOP(rv)              ((rv)>>8&0xff)
#define SET_XGMI_CONF_2r_XGMII_EOP(rv,fv)           (rv=(rv&~(0xff<<8))|((fv)&0xff)<<8)
#define GET_XGMI_CONF_2r_XGMII_ERROR(rv)            ((rv)>>0&0xff)
#define SET_XGMI_CONF_2r_XGMII_ERROR(rv,fv)         (rv=(rv&~(0xff<<0))|((fv)&0xff)<<0)

/* Register XGMI_CONF_3 */
#define XGMI_CONF_3r_ADDR(pic)		reg_addr_5632(XGMI_CONF_3r, pic)
#define READ_XGMI_CONF_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, XGMI_CONF_3r_ADDR(pic), rvp) 
#define WRITE_XGMI_CONF_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, XGMI_CONF_3r_ADDR(pic), rv) 
#define GET_XGMI_CONF_3r_XGMII_BIDLE(rv)            ((rv)>>8&0xff)
#define SET_XGMI_CONF_3r_XGMII_BIDLE(rv,fv)         (rv=(rv&~(0xff<<8))|((fv)&0xff)<<8)
#define GET_XGMI_CONF_3r_ReservedXGMI3(rv)          ((rv)>>0&0xff)
#define SET_XGMI_CONF_3r_ReservedXGMI3(rv,fv)       (rv=(rv&~(0xff<<0))|((fv)&0xff)<<0)

/* Register XGMI_CONF_4 */
#define XGMI_CONF_4r_ADDR(pic)		reg_addr_5632(XGMI_CONF_4r, pic)
#define READ_XGMI_CONF_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, XGMI_CONF_4r_ADDR(pic), rvp) 
#define WRITE_XGMI_CONF_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, XGMI_CONF_4r_ADDR(pic), rv) 
#define GET_XGMI_CONF_4r_SEL_XGMII_PA(rv)           ((rv)>>15&0x1)
#define SET_XGMI_CONF_4r_SEL_XGMII_PA(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_XGMI_CONF_4r_ReservedXGMI(rv)           ((rv)>>14&0x1)
#define SET_XGMI_CONF_4r_ReservedXGMI(rv,fv)        (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_XGMI_CONF_4r_EnOpenLoop(rv)             ((rv)>>13&0x1)
#define SET_XGMI_CONF_4r_EnOpenLoop(rv,fv)          (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_XGMI_CONF_4r_OpenLoop_IPGExtRatio(rv)   ((rv)>>0&0x1fff)
#define SET_XGMI_CONF_4r_OpenLoop_IPGExtRatio(rv,fv)(rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)
#define GET_XGMI_CONF_4r_Reserved22C(rv)            ((rv)>>0&0x0)
#define SET_XGMI_CONF_4r_Reserved22C(rv,fv)         (rv=(rv&~(0x0<<0))|((fv)&0x0)<<0)

/* Register XGMI_CONF_5 */
#define XGMI_CONF_5r_ADDR(pic)		reg_addr_5632(XGMI_CONF_5r, pic)
#define READ_XGMI_CONF_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, XGMI_CONF_5r_ADDR(pic), rvp) 
#define WRITE_XGMI_CONF_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, XGMI_CONF_5r_ADDR(pic), rv) 
#define GET_XGMI_CONF_5r_XGMII_BIDLE_ODD(rv)        ((rv)>>8&0xff)
#define SET_XGMI_CONF_5r_XGMII_BIDLE_ODD(rv,fv)     (rv=(rv&~(0xff<<8))|((fv)&0xff)<<8)
#define GET_XGMI_CONF_5r_XGMII_IDLE_ODD(rv)         ((rv)>>0&0xff)
#define SET_XGMI_CONF_5r_XGMII_IDLE_ODD(rv,fv)      (rv=(rv&~(0xff<<0))|((fv)&0xff)<<0)

/* Register AUTH_VLAN */
#define AUTH_VLANr_ADDR(pic)		reg_addr_5632(AUTH_VLANr, pic)
#define READ_AUTH_VLANr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, AUTH_VLANr_ADDR(pic), rvp) 
#define WRITE_AUTH_VLANr(unit, pic, rv) \
	cmic_write_reg_5632(unit, AUTH_VLANr_ADDR(pic), rv) 
#define GET_AUTH_VLANr_VLAN_Au_EN(rv)               ((rv)>>15&0x1)
#define SET_AUTH_VLANr_VLAN_Au_EN(rv,fv)            (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_AUTH_VLANr_VLAN_Au_P(rv)                ((rv)>>12&0x7)
#define SET_AUTH_VLANr_VLAN_Au_P(rv,fv)             (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_AUTH_VLANr_VLAN_Au_ID(rv)               ((rv)>>0&0xfff)
#define SET_AUTH_VLANr_VLAN_Au_ID(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CONF_1 */
#define P_CONF_1r_ADDR(pic)		reg_addr_5632(P_CONF_1r, pic)
#define READ_P_CONF_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CONF_1r_ADDR(pic), rvp) 
#define WRITE_P_CONF_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CONF_1r_ADDR(pic), rv) 
#define GET_P_CONF_1r_UpLinkID(rv)                  ((rv)>>12&0xf)
#define SET_P_CONF_1r_UpLinkID(rv,fv)               (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_P_CONF_1r_Drop_untag(rv)                ((rv)>>11&0x1)
#define SET_P_CONF_1r_Drop_untag(rv,fv)             (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_P_CONF_1r_Drop_tag(rv)                  ((rv)>>10&0x1)
#define SET_P_CONF_1r_Drop_tag(rv,fv)               (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_P_CONF_1r_Flood_loopback(rv)            ((rv)>>9&0x1)
#define SET_P_CONF_1r_Flood_loopback(rv,fv)         (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_P_CONF_1r_LinkLEDEn(rv)                 ((rv)>>8&0x1)
#define SET_P_CONF_1r_LinkLEDEn(rv,fv)              (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_P_CONF_1r_Storm_control(rv)             ((rv)>>7&0x1)
#define SET_P_CONF_1r_Storm_control(rv,fv)          (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_P_CONF_1r_Port_security(rv)             ((rv)>>6&0x1)
#define SET_P_CONF_1r_Port_security(rv,fv)          (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_P_CONF_1r_VLAN_ingress(rv)              ((rv)>>5&0x1)
#define SET_P_CONF_1r_VLAN_ingress(rv,fv)           (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_P_CONF_1r_LrnDis(rv)                    ((rv)>>4&0x1)
#define SET_P_CONF_1r_LrnDis(rv,fv)                 (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_P_CONF_1r_PortST(rv)                    ((rv)>>2&0x3)
#define SET_P_CONF_1r_PortST(rv,fv)                 (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_P_CONF_1r_B2benable(rv)                 ((rv)>>1&0x1)
#define SET_P_CONF_1r_B2benable(rv,fv)              (rv=(rv&~(0x1<<1))|((fv)&0x1)<<1)
#define GET_P_CONF_1r_Multiplexer1Gport(rv)         ((rv)>>0&0x1)
#define SET_P_CONF_1r_Multiplexer1Gport(rv,fv)      (rv=(rv&~(0x1<<0))|((fv)&0x1)<<0)

/* Register P_CONF_2 */
#define P_CONF_2r_ADDR(pic)		reg_addr_5632(P_CONF_2r, pic)
#define READ_P_CONF_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CONF_2r_ADDR(pic), rvp) 
#define WRITE_P_CONF_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CONF_2r_ADDR(pic), rv) 
#define GET_P_CONF_2r_RstAneg(rv)                   ((rv)>>15&0x1)
#define SET_P_CONF_2r_RstAneg(rv,fv)                (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CONF_2r_AnegEnb(rv)                   ((rv)>>14&0x1)
#define SET_P_CONF_2r_AnegEnb(rv,fv)                (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_P_CONF_2r_LinkUp(rv)                    ((rv)>>13&0x1)
#define SET_P_CONF_2r_LinkUp(rv,fv)                 (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_CONF_2r_PAUSE_CAP(rv)                 ((rv)>>12&0x1)
#define SET_P_CONF_2r_PAUSE_CAP(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_CONF_2r_ASM_DIR(rv)                   ((rv)>>11&0x1)
#define SET_P_CONF_2r_ASM_DIR(rv,fv)                (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_P_CONF_2r_TXPAUSE(rv)                   ((rv)>>10&0x1)
#define SET_P_CONF_2r_TXPAUSE(rv,fv)                (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_P_CONF_2r_RXPAUSE(rv)                   ((rv)>>9&0x1)
#define SET_P_CONF_2r_RXPAUSE(rv,fv)                (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_P_CONF_2r_Offline(rv)                   ((rv)>>8&0x1)
#define SET_P_CONF_2r_Offline(rv,fv)                (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_P_CONF_2r_back_jam_en(rv)               ((rv)>>7&0x1)
#define SET_P_CONF_2r_back_jam_en(rv,fv)            (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_P_CONF_2r_Preamblewd(rv)                ((rv)>>4&0x7)
#define SET_P_CONF_2r_Preamblewd(rv,fv)             (rv=(rv&~(0x7<<4))|((fv)&0x7)<<4)
#define GET_P_CONF_2r_IPGwd(rv)                     ((rv)>>0&0xf)
#define SET_P_CONF_2r_IPGwd(rv,fv)                  (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register P_CONF_3 */
#define P_CONF_3r_ADDR(pic)		reg_addr_5632(P_CONF_3r, pic)
#define READ_P_CONF_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CONF_3r_ADDR(pic), rvp) 
#define WRITE_P_CONF_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CONF_3r_ADDR(pic), rv) 
#define GET_P_CONF_3r_M_S_cfg(rv)                   ((rv)>>15&0x1)
#define SET_P_CONF_3r_M_S_cfg(rv,fv)                (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CONF_3r_M_S_val(rv)                   ((rv)>>14&0x1)
#define SET_P_CONF_3r_M_S_val(rv,fv)                (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_P_CONF_3r_EnGMII(rv)                    ((rv)>>13&0x1)
#define SET_P_CONF_3r_EnGMII(rv,fv)                 (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_CONF_3r_EnTxExPause(rv)               ((rv)>>12&0x1)
#define SET_P_CONF_3r_EnTxExPause(rv,fv)            (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_CONF_3r_Skip_expan(rv)                ((rv)>>11&0x1)
#define SET_P_CONF_3r_Skip_expan(rv,fv)             (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_P_CONF_3r_M_S_ptype(rv)                 ((rv)>>10&0x1)
#define SET_P_CONF_3r_M_S_ptype(rv,fv)              (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_P_CONF_3r_Dis_phy_reset(rv)             ((rv)>>9&0x1)
#define SET_P_CONF_3r_Dis_phy_reset(rv,fv)          (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_P_CONF_3r_Keep_default(rv)              ((rv)>>8&0x1)
#define SET_P_CONF_3r_Keep_default(rv,fv)           (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_P_CONF_3r_ReservedPC3(rv)               ((rv)>>7&0x1)
#define SET_P_CONF_3r_ReservedPC3(rv,fv)            (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_P_CONF_3r_Duplex_cfg(rv)                ((rv)>>6&0x1)
#define SET_P_CONF_3r_Duplex_cfg(rv,fv)             (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_P_CONF_3r_Speedselect_cfg(rv)           ((rv)>>4&0x3)
#define SET_P_CONF_3r_Speedselect_cfg(rv,fv)        (rv=(rv&~(0x3<<4))|((fv)&0x3)<<4)
#define GET_P_CONF_3r_Force_mode(rv)                ((rv)>>0&0xf)
#define SET_P_CONF_3r_Force_mode(rv,fv)             (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register P10G_CONF_1 */
#define P10G_CONF_1r_ADDR(pic)		reg_addr_5632(P10G_CONF_1r, pic)
#define READ_P10G_CONF_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P10G_CONF_1r_ADDR(pic), rvp) 
#define WRITE_P10G_CONF_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P10G_CONF_1r_ADDR(pic), rv) 
#define GET_P10G_CONF_1r_UpLinkID10G(rv)            ((rv)>>12&0xf)
#define SET_P10G_CONF_1r_UpLinkID10G(rv,fv)         (rv=(rv&~(0xf<<12))|((fv)&0xf)<<12)
#define GET_P10G_CONF_1r_Drop_untag10G(rv)          ((rv)>>11&0x1)
#define SET_P10G_CONF_1r_Drop_untag10G(rv,fv)       (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_P10G_CONF_1r_Drop_tag10G(rv)            ((rv)>>10&0x1)
#define SET_P10G_CONF_1r_Drop_tag10G(rv,fv)         (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_P10G_CONF_1r_ReservedPG(rv)             ((rv)>>9&0x1)
#define SET_P10G_CONF_1r_ReservedPG(rv,fv)          (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_P10G_CONF_1r_LinkLEDEn10G(rv)           ((rv)>>8&0x1)
#define SET_P10G_CONF_1r_LinkLEDEn10G(rv,fv)        (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_P10G_CONF_1r_Storm_control10G(rv)       ((rv)>>7&0x1)
#define SET_P10G_CONF_1r_Storm_control10G(rv,fv)    (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_P10G_CONF_1r_Port_security10G(rv)       ((rv)>>6&0x1)
#define SET_P10G_CONF_1r_Port_security10G(rv,fv)    (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_P10G_CONF_1r_VLAN_ingress10G(rv)        ((rv)>>5&0x1)
#define SET_P10G_CONF_1r_VLAN_ingress10G(rv,fv)     (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_P10G_CONF_1r_LrnDis10G(rv)              ((rv)>>4&0x1)
#define SET_P10G_CONF_1r_LrnDis10G(rv,fv)           (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_P10G_CONF_1r_PortST10G(rv)              ((rv)>>2&0x3)
#define SET_P10G_CONF_1r_PortST10G(rv,fv)           (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_P10G_CONF_1r_ReservedPG2(rv)            ((rv)>>0&0x3)
#define SET_P10G_CONF_1r_ReservedPG2(rv,fv)         (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register P10G_CONF_2 */
#define P10G_CONF_2r_ADDR(pic)		reg_addr_5632(P10G_CONF_2r, pic)
#define READ_P10G_CONF_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P10G_CONF_2r_ADDR(pic), rvp) 
#define WRITE_P10G_CONF_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P10G_CONF_2r_ADDR(pic), rv) 
#define GET_P10G_CONF_2r_ReservedPG10G(rv)          ((rv)>>14&0x3)
#define SET_P10G_CONF_2r_ReservedPG10G(rv,fv)       (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P10G_CONF_2r_LinkUp10G(rv)              ((rv)>>13&0x1)
#define SET_P10G_CONF_2r_LinkUp10G(rv,fv)           (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P10G_CONF_2r_PAUSE10G(rv)               ((rv)>>12&0x1)
#define SET_P10G_CONF_2r_PAUSE10G(rv,fv)            (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P10G_CONF_2r_ASM_DIR10G(rv)             ((rv)>>11&0x1)
#define SET_P10G_CONF_2r_ASM_DIR10G(rv,fv)          (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_P10G_CONF_2r_TXPAUSE10G(rv)             ((rv)>>10&0x1)
#define SET_P10G_CONF_2r_TXPAUSE10G(rv,fv)          (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_P10G_CONF_2r_RXPAUSE10G(rv)             ((rv)>>9&0x1)
#define SET_P10G_CONF_2r_RXPAUSE10G(rv,fv)          (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_P10G_CONF_2r_ReservedPG22(rv)           ((rv)>>5&0xf)
#define SET_P10G_CONF_2r_ReservedPG22(rv,fv)        (rv=(rv&~(0xf<<5))|((fv)&0xf)<<5)
#define GET_P10G_CONF_2r_IPGwordselect10G(rv)       ((rv)>>4&0x1)
#define SET_P10G_CONF_2r_IPGwordselect10G(rv,fv)    (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_P10G_CONF_2r_IPGword10G(rv)             ((rv)>>0&0xf)
#define SET_P10G_CONF_2r_IPGword10G(rv,fv)          (rv=(rv&~(0xf<<0))|((fv)&0xf)<<0)

/* Register P10G_CONF_3 */
#define P10G_CONF_3r_ADDR(pic)		reg_addr_5632(P10G_CONF_3r, pic)
#define READ_P10G_CONF_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P10G_CONF_3r_ADDR(pic), rvp) 
#define WRITE_P10G_CONF_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P10G_CONF_3r_ADDR(pic), rv) 
#define GET_P10G_CONF_3r_ReservedPG3(rv)            ((rv)>>0&0xffff)
#define SET_P10G_CONF_3r_ReservedPG3(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_VLAN_MAP_0 */
#define P_VLAN_MAP_0r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_0r, pic)
#define READ_P_VLAN_MAP_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_0r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_0r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_0r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_0r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_0r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_0r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_0r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_0r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_0r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_0r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_1 */
#define P_VLAN_MAP_1r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_1r, pic)
#define READ_P_VLAN_MAP_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_1r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_1r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_1r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_1r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_1r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_1r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_1r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_1r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_1r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_1r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_2 */
#define P_VLAN_MAP_2r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_2r, pic)
#define READ_P_VLAN_MAP_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_2r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_2r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_2r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_2r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_2r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_2r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_2r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_2r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_2r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_2r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_3 */
#define P_VLAN_MAP_3r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_3r, pic)
#define READ_P_VLAN_MAP_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_3r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_3r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_3r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_3r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_3r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_3r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_3r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_3r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_3r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_3r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_4 */
#define P_VLAN_MAP_4r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_4r, pic)
#define READ_P_VLAN_MAP_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_4r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_4r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_4r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_4r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_4r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_4r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_4r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_4r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_4r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_4r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_5 */
#define P_VLAN_MAP_5r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_5r, pic)
#define READ_P_VLAN_MAP_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_5r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_5r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_5r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_5r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_5r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_5r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_5r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_5r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_5r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_5r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_6 */
#define P_VLAN_MAP_6r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_6r, pic)
#define READ_P_VLAN_MAP_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_6r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_6r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_6r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_6r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_6r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_6r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_6r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_6r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_6r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_6r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_7 */
#define P_VLAN_MAP_7r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_7r, pic)
#define READ_P_VLAN_MAP_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_7r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_7r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_7r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_7r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_7r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_7r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_7r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_7r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_7r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_7r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_8 */
#define P_VLAN_MAP_8r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_8r, pic)
#define READ_P_VLAN_MAP_8r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_8r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_8r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_8r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_8r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_8r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_8r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_8r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_8r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_8r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_8r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_8r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_9 */
#define P_VLAN_MAP_9r_ADDR(pic)		reg_addr_5632(P_VLAN_MAP_9r, pic)
#define READ_P_VLAN_MAP_9r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_9r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_9r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_9r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_9r_ReservedPV(rv)            ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_9r_ReservedPV(rv,fv)         (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_9r_CpuMap(rv)                ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_9r_CpuMap(rv,fv)             (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_9r_TGMap(rv)                 ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_9r_TGMap(rv,fv)              (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_9r_GigaMap(rv)               ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_9r_GigaMap(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_10 */
#define P_VLAN_MAP_10r_ADDR(pic)	reg_addr_5632(P_VLAN_MAP_10r, pic)
#define READ_P_VLAN_MAP_10r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_10r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_10r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_10r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_10r_ReservedPV(rv)           ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_10r_ReservedPV(rv,fv)        (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_10r_CpuMap(rv)               ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_10r_CpuMap(rv,fv)            (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_10r_TGMap(rv)                ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_10r_TGMap(rv,fv)             (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_10r_GigaMap(rv)              ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_10r_GigaMap(rv,fv)           (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_11 */
#define P_VLAN_MAP_11r_ADDR(pic)	reg_addr_5632(P_VLAN_MAP_11r, pic)
#define READ_P_VLAN_MAP_11r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_11r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_11r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_11r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_11r_ReservedPV(rv)           ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_11r_ReservedPV(rv,fv)        (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_11r_CpuMap(rv)               ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_11r_CpuMap(rv,fv)            (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_11r_TGMap(rv)                ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_11r_TGMap(rv,fv)             (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_11r_GigaMap(rv)              ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_11r_GigaMap(rv,fv)           (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_VLAN_MAP_12 */
#define P_VLAN_MAP_12r_ADDR(pic)	reg_addr_5632(P_VLAN_MAP_12r, pic)
#define READ_P_VLAN_MAP_12r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_VLAN_MAP_12r_ADDR(pic), rvp) 
#define WRITE_P_VLAN_MAP_12r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_VLAN_MAP_12r_ADDR(pic), rv) 
#define GET_P_VLAN_MAP_12r_ReservedPV(rv)           ((rv)>>14&0x3)
#define SET_P_VLAN_MAP_12r_ReservedPV(rv,fv)        (rv=(rv&~(0x3<<14))|((fv)&0x3)<<14)
#define GET_P_VLAN_MAP_12r_CpuMap(rv)               ((rv)>>13&0x1)
#define SET_P_VLAN_MAP_12r_CpuMap(rv,fv)            (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_VLAN_MAP_12r_TGMap(rv)                ((rv)>>12&0x1)
#define SET_P_VLAN_MAP_12r_TGMap(rv,fv)             (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_VLAN_MAP_12r_GigaMap(rv)              ((rv)>>0&0xfff)
#define SET_P_VLAN_MAP_12r_GigaMap(rv,fv)           (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_0 */
#define DFT_PORT_PRIORITY_0r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_0r, pic)
#define READ_DFT_PORT_PRIORITY_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_0r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_0r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_0r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_0r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_0r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_0r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_0r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_0r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_1 */
#define DFT_PORT_PRIORITY_1r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_1r, pic)
#define READ_DFT_PORT_PRIORITY_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_1r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_1r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_1r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_1r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_1r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_1r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_1r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_1r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_2 */
#define DFT_PORT_PRIORITY_2r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_2r, pic)
#define READ_DFT_PORT_PRIORITY_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_2r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_2r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_2r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_2r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_2r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_2r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_2r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_2r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_3 */
#define DFT_PORT_PRIORITY_3r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_3r, pic)
#define READ_DFT_PORT_PRIORITY_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_3r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_3r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_3r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_3r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_3r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_3r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_3r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_3r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_4 */
#define DFT_PORT_PRIORITY_4r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_4r, pic)
#define READ_DFT_PORT_PRIORITY_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_4r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_4r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_4r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_4r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_4r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_4r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_4r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_4r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_5 */
#define DFT_PORT_PRIORITY_5r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_5r, pic)
#define READ_DFT_PORT_PRIORITY_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_5r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_5r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_5r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_5r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_5r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_5r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_5r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_5r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_6 */
#define DFT_PORT_PRIORITY_6r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_6r, pic)
#define READ_DFT_PORT_PRIORITY_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_6r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_6r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_6r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_6r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_6r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_6r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_6r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_6r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_7 */
#define DFT_PORT_PRIORITY_7r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_7r, pic)
#define READ_DFT_PORT_PRIORITY_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_7r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_7r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_7r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_7r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_7r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_7r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_7r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_7r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_8 */
#define DFT_PORT_PRIORITY_8r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_8r, pic)
#define READ_DFT_PORT_PRIORITY_8r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_8r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_8r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_8r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_8r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_8r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_8r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_8r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_8r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_8r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_9 */
#define DFT_PORT_PRIORITY_9r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_9r, pic)
#define READ_DFT_PORT_PRIORITY_9r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_9r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_9r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_9r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_9r_ReservedPP(rv)     ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_9r_ReservedPP(rv,fv)  (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_9r_Priority(rv)       ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_9r_Priority(rv,fv)    (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_9r_VLAN(rv)           ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_9r_VLAN(rv,fv)        (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_10 */
#define DFT_PORT_PRIORITY_10r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_10r, pic)
#define READ_DFT_PORT_PRIORITY_10r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_10r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_10r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_10r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_10r_ReservedPP(rv)    ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_10r_ReservedPP(rv,fv) (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_10r_Priority(rv)      ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_10r_Priority(rv,fv)   (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_10r_VLAN(rv)          ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_10r_VLAN(rv,fv)       (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_11 */
#define DFT_PORT_PRIORITY_11r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_11r, pic)
#define READ_DFT_PORT_PRIORITY_11r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_11r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_11r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_11r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_11r_ReservedPP(rv)    ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_11r_ReservedPP(rv,fv) (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_11r_Priority(rv)      ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_11r_Priority(rv,fv)   (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_11r_VLAN(rv)          ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_11r_VLAN(rv,fv)       (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register DFT_PORT_PRIORITY_12 */
#define DFT_PORT_PRIORITY_12r_ADDR(pic)	reg_addr_5632(DFT_PORT_PRIORITY_12r, pic)
#define READ_DFT_PORT_PRIORITY_12r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, DFT_PORT_PRIORITY_12r_ADDR(pic), rvp) 
#define WRITE_DFT_PORT_PRIORITY_12r(unit, pic, rv) \
	cmic_write_reg_5632(unit, DFT_PORT_PRIORITY_12r_ADDR(pic), rv) 
#define GET_DFT_PORT_PRIORITY_12r_ReservedPP(rv)    ((rv)>>15&0x1)
#define SET_DFT_PORT_PRIORITY_12r_ReservedPP(rv,fv) (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_DFT_PORT_PRIORITY_12r_Priority(rv)      ((rv)>>12&0x7)
#define SET_DFT_PORT_PRIORITY_12r_Priority(rv,fv)   (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_DFT_PORT_PRIORITY_12r_VLAN(rv)          ((rv)>>0&0xfff)
#define SET_DFT_PORT_PRIORITY_12r_VLAN(rv,fv)       (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_0 */
#define P_CTYP_0r_ADDR(pic)		reg_addr_5632(P_CTYP_0r, pic)
#define READ_P_CTYP_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_0r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_0r_ADDR(pic), rv) 
#define GET_P_CTYP_0r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_0r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_0 */
#define P_CDFT_0r_ADDR(pic)		reg_addr_5632(P_CDFT_0r, pic)
#define READ_P_CDFT_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_0r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_0r_ADDR(pic), rv) 
#define GET_P_CDFT_0r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_0r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_0r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_0r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_0r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_0r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_1 */
#define P_CTYP_1r_ADDR(pic)		reg_addr_5632(P_CTYP_1r, pic)
#define READ_P_CTYP_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_1r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_1r_ADDR(pic), rv) 
#define GET_P_CTYP_1r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_1r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_1 */
#define P_CDFT_1r_ADDR(pic)		reg_addr_5632(P_CDFT_1r, pic)
#define READ_P_CDFT_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_1r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_1r_ADDR(pic), rv) 
#define GET_P_CDFT_1r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_1r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_1r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_1r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_1r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_1r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_2 */
#define P_CTYP_2r_ADDR(pic)		reg_addr_5632(P_CTYP_2r, pic)
#define READ_P_CTYP_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_2r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_2r_ADDR(pic), rv) 
#define GET_P_CTYP_2r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_2r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_2 */
#define P_CDFT_2r_ADDR(pic)		reg_addr_5632(P_CDFT_2r, pic)
#define READ_P_CDFT_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_2r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_2r_ADDR(pic), rv) 
#define GET_P_CDFT_2r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_2r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_2r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_2r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_2r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_2r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_3 */
#define P_CTYP_3r_ADDR(pic)		reg_addr_5632(P_CTYP_3r, pic)
#define READ_P_CTYP_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_3r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_3r_ADDR(pic), rv) 
#define GET_P_CTYP_3r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_3r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_3 */
#define P_CDFT_3r_ADDR(pic)		reg_addr_5632(P_CDFT_3r, pic)
#define READ_P_CDFT_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_3r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_3r_ADDR(pic), rv) 
#define GET_P_CDFT_3r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_3r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_3r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_3r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_3r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_3r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_4 */
#define P_CTYP_4r_ADDR(pic)		reg_addr_5632(P_CTYP_4r, pic)
#define READ_P_CTYP_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_4r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_4r_ADDR(pic), rv) 
#define GET_P_CTYP_4r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_4r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_4 */
#define P_CDFT_4r_ADDR(pic)		reg_addr_5632(P_CDFT_4r, pic)
#define READ_P_CDFT_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_4r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_4r_ADDR(pic), rv) 
#define GET_P_CDFT_4r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_4r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_4r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_4r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_4r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_4r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_5 */
#define P_CTYP_5r_ADDR(pic)		reg_addr_5632(P_CTYP_5r, pic)
#define READ_P_CTYP_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_5r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_5r_ADDR(pic), rv) 
#define GET_P_CTYP_5r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_5r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_5 */
#define P_CDFT_5r_ADDR(pic)		reg_addr_5632(P_CDFT_5r, pic)
#define READ_P_CDFT_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_5r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_5r_ADDR(pic), rv) 
#define GET_P_CDFT_5r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_5r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_5r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_5r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_5r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_5r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_6 */
#define P_CTYP_6r_ADDR(pic)		reg_addr_5632(P_CTYP_6r, pic)
#define READ_P_CTYP_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_6r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_6r_ADDR(pic), rv) 
#define GET_P_CTYP_6r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_6r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_6 */
#define P_CDFT_6r_ADDR(pic)		reg_addr_5632(P_CDFT_6r, pic)
#define READ_P_CDFT_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_6r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_6r_ADDR(pic), rv) 
#define GET_P_CDFT_6r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_6r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_6r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_6r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_6r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_6r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_7 */
#define P_CTYP_7r_ADDR(pic)		reg_addr_5632(P_CTYP_7r, pic)
#define READ_P_CTYP_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_7r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_7r_ADDR(pic), rv) 
#define GET_P_CTYP_7r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_7r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_7 */
#define P_CDFT_7r_ADDR(pic)		reg_addr_5632(P_CDFT_7r, pic)
#define READ_P_CDFT_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_7r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_7r_ADDR(pic), rv) 
#define GET_P_CDFT_7r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_7r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_7r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_7r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_7r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_7r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_8 */
#define P_CTYP_8r_ADDR(pic)		reg_addr_5632(P_CTYP_8r, pic)
#define READ_P_CTYP_8r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_8r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_8r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_8r_ADDR(pic), rv) 
#define GET_P_CTYP_8r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_8r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_8 */
#define P_CDFT_8r_ADDR(pic)		reg_addr_5632(P_CDFT_8r, pic)
#define READ_P_CDFT_8r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_8r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_8r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_8r_ADDR(pic), rv) 
#define GET_P_CDFT_8r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_8r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_8r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_8r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_8r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_8r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_9 */
#define P_CTYP_9r_ADDR(pic)		reg_addr_5632(P_CTYP_9r, pic)
#define READ_P_CTYP_9r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_9r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_9r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_9r_ADDR(pic), rv) 
#define GET_P_CTYP_9r_VlClassEthType(rv)            ((rv)>>0&0xffff)
#define SET_P_CTYP_9r_VlClassEthType(rv,fv)         (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_9 */
#define P_CDFT_9r_ADDR(pic)		reg_addr_5632(P_CDFT_9r, pic)
#define READ_P_CDFT_9r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_9r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_9r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_9r_ADDR(pic), rv) 
#define GET_P_CDFT_9r_VlClassValEtnry(rv)           ((rv)>>15&0x1)
#define SET_P_CDFT_9r_VlClassValEtnry(rv,fv)        (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_9r_VlClassPriority(rv)           ((rv)>>12&0x7)
#define SET_P_CDFT_9r_VlClassPriority(rv,fv)        (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_9r_VlClassVID(rv)                ((rv)>>0&0xfff)
#define SET_P_CDFT_9r_VlClassVID(rv,fv)             (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_10 */
#define P_CTYP_10r_ADDR(pic)		reg_addr_5632(P_CTYP_10r, pic)
#define READ_P_CTYP_10r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_10r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_10r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_10r_ADDR(pic), rv) 
#define GET_P_CTYP_10r_VlClassEthType(rv)           ((rv)>>0&0xffff)
#define SET_P_CTYP_10r_VlClassEthType(rv,fv)        (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_10 */
#define P_CDFT_10r_ADDR(pic)		reg_addr_5632(P_CDFT_10r, pic)
#define READ_P_CDFT_10r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_10r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_10r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_10r_ADDR(pic), rv) 
#define GET_P_CDFT_10r_VlClassValEtnry(rv)          ((rv)>>15&0x1)
#define SET_P_CDFT_10r_VlClassValEtnry(rv,fv)       (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_10r_VlClassPriority(rv)          ((rv)>>12&0x7)
#define SET_P_CDFT_10r_VlClassPriority(rv,fv)       (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_10r_VlClassVID(rv)               ((rv)>>0&0xfff)
#define SET_P_CDFT_10r_VlClassVID(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_11 */
#define P_CTYP_11r_ADDR(pic)		reg_addr_5632(P_CTYP_11r, pic)
#define READ_P_CTYP_11r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_11r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_11r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_11r_ADDR(pic), rv) 
#define GET_P_CTYP_11r_VlClassEthType(rv)           ((rv)>>0&0xffff)
#define SET_P_CTYP_11r_VlClassEthType(rv,fv)        (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_11 */
#define P_CDFT_11r_ADDR(pic)		reg_addr_5632(P_CDFT_11r, pic)
#define READ_P_CDFT_11r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_11r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_11r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_11r_ADDR(pic), rv) 
#define GET_P_CDFT_11r_VlClassValEtnry(rv)          ((rv)>>15&0x1)
#define SET_P_CDFT_11r_VlClassValEtnry(rv,fv)       (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_11r_VlClassPriority(rv)          ((rv)>>12&0x7)
#define SET_P_CDFT_11r_VlClassPriority(rv,fv)       (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_11r_VlClassVID(rv)               ((rv)>>0&0xfff)
#define SET_P_CDFT_11r_VlClassVID(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_12 */
#define P_CTYP_12r_ADDR(pic)		reg_addr_5632(P_CTYP_12r, pic)
#define READ_P_CTYP_12r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_12r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_12r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_12r_ADDR(pic), rv) 
#define GET_P_CTYP_12r_VlClassEthType(rv)           ((rv)>>0&0xffff)
#define SET_P_CTYP_12r_VlClassEthType(rv,fv)        (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_12 */
#define P_CDFT_12r_ADDR(pic)		reg_addr_5632(P_CDFT_12r, pic)
#define READ_P_CDFT_12r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_12r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_12r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_12r_ADDR(pic), rv) 
#define GET_P_CDFT_12r_VlClassValEtnry(rv)          ((rv)>>15&0x1)
#define SET_P_CDFT_12r_VlClassValEtnry(rv,fv)       (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_12r_VlClassPriority(rv)          ((rv)>>12&0x7)
#define SET_P_CDFT_12r_VlClassPriority(rv,fv)       (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_12r_VlClassVID(rv)               ((rv)>>0&0xfff)
#define SET_P_CDFT_12r_VlClassVID(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_13 */
#define P_CTYP_13r_ADDR(pic)		reg_addr_5632(P_CTYP_13r, pic)
#define READ_P_CTYP_13r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_13r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_13r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_13r_ADDR(pic), rv) 
#define GET_P_CTYP_13r_VlClassEthType(rv)           ((rv)>>0&0xffff)
#define SET_P_CTYP_13r_VlClassEthType(rv,fv)        (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_13 */
#define P_CDFT_13r_ADDR(pic)		reg_addr_5632(P_CDFT_13r, pic)
#define READ_P_CDFT_13r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_13r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_13r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_13r_ADDR(pic), rv) 
#define GET_P_CDFT_13r_VlClassValEtnry(rv)          ((rv)>>15&0x1)
#define SET_P_CDFT_13r_VlClassValEtnry(rv,fv)       (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_13r_VlClassPriority(rv)          ((rv)>>12&0x7)
#define SET_P_CDFT_13r_VlClassPriority(rv,fv)       (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_13r_VlClassVID(rv)               ((rv)>>0&0xfff)
#define SET_P_CDFT_13r_VlClassVID(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_14 */
#define P_CTYP_14r_ADDR(pic)		reg_addr_5632(P_CTYP_14r, pic)
#define READ_P_CTYP_14r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_14r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_14r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_14r_ADDR(pic), rv) 
#define GET_P_CTYP_14r_VlClassEthType(rv)           ((rv)>>0&0xffff)
#define SET_P_CTYP_14r_VlClassEthType(rv,fv)        (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_14 */
#define P_CDFT_14r_ADDR(pic)		reg_addr_5632(P_CDFT_14r, pic)
#define READ_P_CDFT_14r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_14r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_14r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_14r_ADDR(pic), rv) 
#define GET_P_CDFT_14r_VlClassValEtnry(rv)          ((rv)>>15&0x1)
#define SET_P_CDFT_14r_VlClassValEtnry(rv,fv)       (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_14r_VlClassPriority(rv)          ((rv)>>12&0x7)
#define SET_P_CDFT_14r_VlClassPriority(rv,fv)       (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_14r_VlClassVID(rv)               ((rv)>>0&0xfff)
#define SET_P_CDFT_14r_VlClassVID(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register P_CTYP_15 */
#define P_CTYP_15r_ADDR(pic)		reg_addr_5632(P_CTYP_15r, pic)
#define READ_P_CTYP_15r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CTYP_15r_ADDR(pic), rvp) 
#define WRITE_P_CTYP_15r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CTYP_15r_ADDR(pic), rv) 
#define GET_P_CTYP_15r_VlClassEthType(rv)           ((rv)>>0&0xffff)
#define SET_P_CTYP_15r_VlClassEthType(rv,fv)        (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register P_CDFT_15 */
#define P_CDFT_15r_ADDR(pic)		reg_addr_5632(P_CDFT_15r, pic)
#define READ_P_CDFT_15r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_CDFT_15r_ADDR(pic), rvp) 
#define WRITE_P_CDFT_15r(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_CDFT_15r_ADDR(pic), rv) 
#define GET_P_CDFT_15r_VlClassValEtnry(rv)          ((rv)>>15&0x1)
#define SET_P_CDFT_15r_VlClassValEtnry(rv,fv)       (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_CDFT_15r_VlClassPriority(rv)          ((rv)>>12&0x7)
#define SET_P_CDFT_15r_VlClassPriority(rv,fv)       (rv=(rv&~(0x7<<12))|((fv)&0x7)<<12)
#define GET_P_CDFT_15r_VlClassVID(rv)               ((rv)>>0&0xfff)
#define SET_P_CDFT_15r_VlClassVID(rv,fv)            (rv=(rv&~(0xfff<<0))|((fv)&0xfff)<<0)

/* Register TEST_CTL_1 */
#define TEST_CTL_1r_ADDR(pic)		reg_addr_5632(TEST_CTL_1r, pic)
#define READ_TEST_CTL_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TEST_CTL_1r_ADDR(pic), rvp) 
#define WRITE_TEST_CTL_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TEST_CTL_1r_ADDR(pic), rv) 
#define GET_TEST_CTL_1r_CtrlFlags1(rv)              ((rv)>>0&0xffff)
#define SET_TEST_CTL_1r_CtrlFlags1(rv,fv)           (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register TEST_CTL_2 */
#define TEST_CTL_2r_ADDR(pic)		reg_addr_5632(TEST_CTL_2r, pic)
#define READ_TEST_CTL_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TEST_CTL_2r_ADDR(pic), rvp) 
#define WRITE_TEST_CTL_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TEST_CTL_2r_ADDR(pic), rv) 
#define GET_TEST_CTL_2r_CtrlFlags2(rv)              ((rv)>>0&0xffff)
#define SET_TEST_CTL_2r_CtrlFlags2(rv,fv)           (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register TEST_CTL_3 */
#define TEST_CTL_3r_ADDR(pic)		reg_addr_5632(TEST_CTL_3r, pic)
#define READ_TEST_CTL_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TEST_CTL_3r_ADDR(pic), rvp) 
#define WRITE_TEST_CTL_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TEST_CTL_3r_ADDR(pic), rv) 
#define GET_TEST_CTL_3r_CtrlFlags3(rv)              ((rv)>>0&0xffff)
#define SET_TEST_CTL_3r_CtrlFlags3(rv,fv)           (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register TEST_CTL_4 */
#define TEST_CTL_4r_ADDR(pic)		reg_addr_5632(TEST_CTL_4r, pic)
#define READ_TEST_CTL_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TEST_CTL_4r_ADDR(pic), rvp) 
#define WRITE_TEST_CTL_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TEST_CTL_4r_ADDR(pic), rv) 
#define GET_TEST_CTL_4r_CtrlFlags4(rv)              ((rv)>>0&0xffff)
#define SET_TEST_CTL_4r_CtrlFlags4(rv,fv)           (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register TEST_CTL_5 */
#define TEST_CTL_5r_ADDR(pic)		reg_addr_5632(TEST_CTL_5r, pic)
#define READ_TEST_CTL_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TEST_CTL_5r_ADDR(pic), rvp) 
#define WRITE_TEST_CTL_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TEST_CTL_5r_ADDR(pic), rv) 
#define GET_TEST_CTL_5r_CtrlFlags5(rv)              ((rv)>>0&0xffff)
#define SET_TEST_CTL_5r_CtrlFlags5(rv,fv)           (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register TEST_CTL_6 */
#define TEST_CTL_6r_ADDR(pic)		reg_addr_5632(TEST_CTL_6r, pic)
#define READ_TEST_CTL_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TEST_CTL_6r_ADDR(pic), rvp) 
#define WRITE_TEST_CTL_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TEST_CTL_6r_ADDR(pic), rv) 
#define GET_TEST_CTL_6r_CtrlFlags6(rv)              ((rv)>>0&0xffff)
#define SET_TEST_CTL_6r_CtrlFlags6(rv,fv)           (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register TEST_CTL_7 */
#define TEST_CTL_7r_ADDR(pic)		reg_addr_5632(TEST_CTL_7r, pic)
#define READ_TEST_CTL_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TEST_CTL_7r_ADDR(pic), rvp) 
#define WRITE_TEST_CTL_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TEST_CTL_7r_ADDR(pic), rv) 
#define GET_TEST_CTL_7r_CtrlFlags7(rv)              ((rv)>>0&0xffff)
#define SET_TEST_CTL_7r_CtrlFlags7(rv,fv)           (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register HMON_MAC_1 */
#define HMON_MAC_1r_ADDR(pic)		reg_addr_5632(HMON_MAC_1r, pic)
#define READ_HMON_MAC_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, HMON_MAC_1r_ADDR(pic), rvp) 
#define WRITE_HMON_MAC_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, HMON_MAC_1r_ADDR(pic), rv) 
#define GET_HMON_MAC_1r_H1MacLSB(rv)                ((rv)>>0&0x20202020)
#define SET_HMON_MAC_1r_H1MacLSB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register HMON_MAC_2 */
#define HMON_MAC_2r_ADDR(pic)		reg_addr_5632(HMON_MAC_2r, pic)
#define READ_HMON_MAC_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, HMON_MAC_2r_ADDR(pic), rvp) 
#define WRITE_HMON_MAC_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, HMON_MAC_2r_ADDR(pic), rv) 
#define GET_HMON_MAC_2r_H2MacMSB(rv)                ((rv)>>0&0x20202020)
#define SET_HMON_MAC_2r_H2MacMSB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register HMON_MAC_3 */
#define HMON_MAC_3r_ADDR(pic)		reg_addr_5632(HMON_MAC_3r, pic)
#define READ_HMON_MAC_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, HMON_MAC_3r_ADDR(pic), rvp) 
#define WRITE_HMON_MAC_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, HMON_MAC_3r_ADDR(pic), rv) 
#define GET_HMON_MAC_3r_H2MacMSB3(rv)               ((rv)>>16&0xffff)
#define SET_HMON_MAC_3r_H2MacMSB3(rv,fv)            (rv=(rv&~(0xffff<<16))|((fv)&0xffff)<<16)
#define GET_HMON_MAC_3r_H1MacMSB3(rv)               ((rv)>>0&0xffff)
#define SET_HMON_MAC_3r_H1MacMSB3(rv,fv)            (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Register VMON_0 */
#define VMON_0r_ADDR(pic)		reg_addr_5632(VMON_0r, pic)
#define READ_VMON_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_0r_ADDR(pic), rvp) 
#define WRITE_VMON_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_0r_ADDR(pic), rv) 
#define GET_VMON_0r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_0r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_0r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_0r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_1 */
#define VMON_1r_ADDR(pic)		reg_addr_5632(VMON_1r, pic)
#define READ_VMON_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_1r_ADDR(pic), rvp) 
#define WRITE_VMON_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_1r_ADDR(pic), rv) 
#define GET_VMON_1r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_1r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_1r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_1r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_2 */
#define VMON_2r_ADDR(pic)		reg_addr_5632(VMON_2r, pic)
#define READ_VMON_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_2r_ADDR(pic), rvp) 
#define WRITE_VMON_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_2r_ADDR(pic), rv) 
#define GET_VMON_2r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_2r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_2r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_2r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_3 */
#define VMON_3r_ADDR(pic)		reg_addr_5632(VMON_3r, pic)
#define READ_VMON_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_3r_ADDR(pic), rvp) 
#define WRITE_VMON_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_3r_ADDR(pic), rv) 
#define GET_VMON_3r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_3r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_3r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_3r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_4 */
#define VMON_4r_ADDR(pic)		reg_addr_5632(VMON_4r, pic)
#define READ_VMON_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_4r_ADDR(pic), rvp) 
#define WRITE_VMON_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_4r_ADDR(pic), rv) 
#define GET_VMON_4r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_4r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_4r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_4r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_5 */
#define VMON_5r_ADDR(pic)		reg_addr_5632(VMON_5r, pic)
#define READ_VMON_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_5r_ADDR(pic), rvp) 
#define WRITE_VMON_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_5r_ADDR(pic), rv) 
#define GET_VMON_5r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_5r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_5r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_5r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_6 */
#define VMON_6r_ADDR(pic)		reg_addr_5632(VMON_6r, pic)
#define READ_VMON_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_6r_ADDR(pic), rvp) 
#define WRITE_VMON_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_6r_ADDR(pic), rv) 
#define GET_VMON_6r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_6r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_6r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_6r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_7 */
#define VMON_7r_ADDR(pic)		reg_addr_5632(VMON_7r, pic)
#define READ_VMON_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_7r_ADDR(pic), rvp) 
#define WRITE_VMON_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_7r_ADDR(pic), rv) 
#define GET_VMON_7r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_7r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_7r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_7r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_8 */
#define VMON_8r_ADDR(pic)		reg_addr_5632(VMON_8r, pic)
#define READ_VMON_8r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_8r_ADDR(pic), rvp) 
#define WRITE_VMON_8r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_8r_ADDR(pic), rv) 
#define GET_VMON_8r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_8r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_8r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_8r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_9 */
#define VMON_9r_ADDR(pic)		reg_addr_5632(VMON_9r, pic)
#define READ_VMON_9r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_9r_ADDR(pic), rvp) 
#define WRITE_VMON_9r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_9r_ADDR(pic), rv) 
#define GET_VMON_9r_ReservedMVLAN(rv)               ((rv)>>13&0x7ffff)
#define SET_VMON_9r_ReservedMVLAN(rv,fv)            (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_9r_MVLANID(rv)                     ((rv)>>0&0x1fff)
#define SET_VMON_9r_MVLANID(rv,fv)                  (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_10 */
#define VMON_10r_ADDR(pic)		reg_addr_5632(VMON_10r, pic)
#define READ_VMON_10r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_10r_ADDR(pic), rvp) 
#define WRITE_VMON_10r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_10r_ADDR(pic), rv) 
#define GET_VMON_10r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_10r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_10r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_10r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_11 */
#define VMON_11r_ADDR(pic)		reg_addr_5632(VMON_11r, pic)
#define READ_VMON_11r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_11r_ADDR(pic), rvp) 
#define WRITE_VMON_11r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_11r_ADDR(pic), rv) 
#define GET_VMON_11r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_11r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_11r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_11r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_12 */
#define VMON_12r_ADDR(pic)		reg_addr_5632(VMON_12r, pic)
#define READ_VMON_12r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_12r_ADDR(pic), rvp) 
#define WRITE_VMON_12r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_12r_ADDR(pic), rv) 
#define GET_VMON_12r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_12r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_12r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_12r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_13 */
#define VMON_13r_ADDR(pic)		reg_addr_5632(VMON_13r, pic)
#define READ_VMON_13r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_13r_ADDR(pic), rvp) 
#define WRITE_VMON_13r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_13r_ADDR(pic), rv) 
#define GET_VMON_13r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_13r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_13r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_13r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_14 */
#define VMON_14r_ADDR(pic)		reg_addr_5632(VMON_14r, pic)
#define READ_VMON_14r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_14r_ADDR(pic), rvp) 
#define WRITE_VMON_14r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_14r_ADDR(pic), rv) 
#define GET_VMON_14r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_14r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_14r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_14r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_15 */
#define VMON_15r_ADDR(pic)		reg_addr_5632(VMON_15r, pic)
#define READ_VMON_15r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_15r_ADDR(pic), rvp) 
#define WRITE_VMON_15r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_15r_ADDR(pic), rv) 
#define GET_VMON_15r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_15r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_15r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_15r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_16 */
#define VMON_16r_ADDR(pic)		reg_addr_5632(VMON_16r, pic)
#define READ_VMON_16r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_16r_ADDR(pic), rvp) 
#define WRITE_VMON_16r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_16r_ADDR(pic), rv) 
#define GET_VMON_16r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_16r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_16r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_16r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_17 */
#define VMON_17r_ADDR(pic)		reg_addr_5632(VMON_17r, pic)
#define READ_VMON_17r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_17r_ADDR(pic), rvp) 
#define WRITE_VMON_17r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_17r_ADDR(pic), rv) 
#define GET_VMON_17r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_17r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_17r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_17r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_18 */
#define VMON_18r_ADDR(pic)		reg_addr_5632(VMON_18r, pic)
#define READ_VMON_18r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_18r_ADDR(pic), rvp) 
#define WRITE_VMON_18r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_18r_ADDR(pic), rv) 
#define GET_VMON_18r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_18r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_18r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_18r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_19 */
#define VMON_19r_ADDR(pic)		reg_addr_5632(VMON_19r, pic)
#define READ_VMON_19r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_19r_ADDR(pic), rvp) 
#define WRITE_VMON_19r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_19r_ADDR(pic), rv) 
#define GET_VMON_19r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_19r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_19r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_19r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_20 */
#define VMON_20r_ADDR(pic)		reg_addr_5632(VMON_20r, pic)
#define READ_VMON_20r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_20r_ADDR(pic), rvp) 
#define WRITE_VMON_20r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_20r_ADDR(pic), rv) 
#define GET_VMON_20r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_20r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_20r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_20r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_21 */
#define VMON_21r_ADDR(pic)		reg_addr_5632(VMON_21r, pic)
#define READ_VMON_21r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_21r_ADDR(pic), rvp) 
#define WRITE_VMON_21r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_21r_ADDR(pic), rv) 
#define GET_VMON_21r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_21r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_21r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_21r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_22 */
#define VMON_22r_ADDR(pic)		reg_addr_5632(VMON_22r, pic)
#define READ_VMON_22r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_22r_ADDR(pic), rvp) 
#define WRITE_VMON_22r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_22r_ADDR(pic), rv) 
#define GET_VMON_22r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_22r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_22r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_22r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_23 */
#define VMON_23r_ADDR(pic)		reg_addr_5632(VMON_23r, pic)
#define READ_VMON_23r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_23r_ADDR(pic), rvp) 
#define WRITE_VMON_23r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_23r_ADDR(pic), rv) 
#define GET_VMON_23r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_23r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_23r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_23r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_24 */
#define VMON_24r_ADDR(pic)		reg_addr_5632(VMON_24r, pic)
#define READ_VMON_24r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_24r_ADDR(pic), rvp) 
#define WRITE_VMON_24r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_24r_ADDR(pic), rv) 
#define GET_VMON_24r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_24r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_24r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_24r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_25 */
#define VMON_25r_ADDR(pic)		reg_addr_5632(VMON_25r, pic)
#define READ_VMON_25r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_25r_ADDR(pic), rvp) 
#define WRITE_VMON_25r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_25r_ADDR(pic), rv) 
#define GET_VMON_25r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_25r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_25r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_25r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_26 */
#define VMON_26r_ADDR(pic)		reg_addr_5632(VMON_26r, pic)
#define READ_VMON_26r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_26r_ADDR(pic), rvp) 
#define WRITE_VMON_26r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_26r_ADDR(pic), rv) 
#define GET_VMON_26r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_26r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_26r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_26r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_27 */
#define VMON_27r_ADDR(pic)		reg_addr_5632(VMON_27r, pic)
#define READ_VMON_27r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_27r_ADDR(pic), rvp) 
#define WRITE_VMON_27r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_27r_ADDR(pic), rv) 
#define GET_VMON_27r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_27r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_27r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_27r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_28 */
#define VMON_28r_ADDR(pic)		reg_addr_5632(VMON_28r, pic)
#define READ_VMON_28r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_28r_ADDR(pic), rvp) 
#define WRITE_VMON_28r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_28r_ADDR(pic), rv) 
#define GET_VMON_28r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_28r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_28r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_28r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_29 */
#define VMON_29r_ADDR(pic)		reg_addr_5632(VMON_29r, pic)
#define READ_VMON_29r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_29r_ADDR(pic), rvp) 
#define WRITE_VMON_29r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_29r_ADDR(pic), rv) 
#define GET_VMON_29r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_29r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_29r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_29r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_30 */
#define VMON_30r_ADDR(pic)		reg_addr_5632(VMON_30r, pic)
#define READ_VMON_30r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_30r_ADDR(pic), rvp) 
#define WRITE_VMON_30r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_30r_ADDR(pic), rv) 
#define GET_VMON_30r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_30r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_30r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_30r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register VMON_31 */
#define VMON_31r_ADDR(pic)		reg_addr_5632(VMON_31r, pic)
#define READ_VMON_31r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, VMON_31r_ADDR(pic), rvp) 
#define WRITE_VMON_31r(unit, pic, rv) \
	cmic_write_reg_5632(unit, VMON_31r_ADDR(pic), rv) 
#define GET_VMON_31r_ReservedMVLAN(rv)              ((rv)>>13&0x7ffff)
#define SET_VMON_31r_ReservedMVLAN(rv,fv)           (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_VMON_31r_MVLANID(rv)                    ((rv)>>0&0x1fff)
#define SET_VMON_31r_MVLANID(rv,fv)                 (rv=(rv&~(0x1fff<<0))|((fv)&0x1fff)<<0)

/* Register SECVIO_PORTMAP */
#define SECVIO_PORTMAPr_ADDR(pic)	reg_addr_5632(SECVIO_PORTMAPr, pic)
#define READ_SECVIO_PORTMAPr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, SECVIO_PORTMAPr_ADDR(pic), rvp) 
#define WRITE_SECVIO_PORTMAPr(unit, pic, rv) \
	cmic_write_reg_5632(unit, SECVIO_PORTMAPr_ADDR(pic), rv) 
#define GET_SECVIO_PORTMAPr_ReservedSV(rv)          ((rv)>>13&0x7ffff)
#define SET_SECVIO_PORTMAPr_ReservedSV(rv,fv)       (rv=(rv&~(0x7ffff<<13))|((fv)&0x7ffff)<<13)
#define GET_SECVIO_PORTMAPr_P12X(rv)                ((rv)>>12&0x1)
#define SET_SECVIO_PORTMAPr_P12X(rv,fv)             (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_SECVIO_PORTMAPr_P11X(rv)                ((rv)>>11&0x1)
#define SET_SECVIO_PORTMAPr_P11X(rv,fv)             (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_SECVIO_PORTMAPr_P10X(rv)                ((rv)>>10&0x1)
#define SET_SECVIO_PORTMAPr_P10X(rv,fv)             (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_SECVIO_PORTMAPr_P09X(rv)                ((rv)>>9&0x1)
#define SET_SECVIO_PORTMAPr_P09X(rv,fv)             (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_SECVIO_PORTMAPr_P08X(rv)                ((rv)>>8&0x1)
#define SET_SECVIO_PORTMAPr_P08X(rv,fv)             (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_SECVIO_PORTMAPr_P07X(rv)                ((rv)>>7&0x1)
#define SET_SECVIO_PORTMAPr_P07X(rv,fv)             (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_SECVIO_PORTMAPr_P06X(rv)                ((rv)>>6&0x1)
#define SET_SECVIO_PORTMAPr_P06X(rv,fv)             (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_SECVIO_PORTMAPr_P05X(rv)                ((rv)>>5&0x1)
#define SET_SECVIO_PORTMAPr_P05X(rv,fv)             (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_SECVIO_PORTMAPr_P04X(rv)                ((rv)>>4&0x1)
#define SET_SECVIO_PORTMAPr_P04X(rv,fv)             (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_SECVIO_PORTMAPr_P03X(rv)                ((rv)>>3&0x1)
#define SET_SECVIO_PORTMAPr_P03X(rv,fv)             (rv=(rv&~(0x1<<3))|((fv)&0x1)<<3)
#define GET_SECVIO_PORTMAPr_P02X(rv)                ((rv)>>2&0x1)
#define SET_SECVIO_PORTMAPr_P02X(rv,fv)             (rv=(rv&~(0x1<<2))|((fv)&0x1)<<2)
#define GET_SECVIO_PORTMAPr_P01X(rv)                ((rv)>>1&0x1)
#define SET_SECVIO_PORTMAPr_P01X(rv,fv)             (rv=(rv&~(0x1<<1))|((fv)&0x1)<<1)
#define GET_SECVIO_PORTMAPr_P00X(rv)                ((rv)>>0&0x1)
#define SET_SECVIO_PORTMAPr_P00X(rv,fv)             (rv=(rv&~(0x1<<0))|((fv)&0x1)<<0)

/* Register SYS_STATUS */
#define SYS_STATUSr_ADDR(pic)		reg_addr_5632(SYS_STATUSr, pic)
#define READ_SYS_STATUSr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, SYS_STATUSr_ADDR(pic), rvp) 
#define WRITE_SYS_STATUSr(unit, pic, rv) \
	cmic_write_reg_5632(unit, SYS_STATUSr_ADDR(pic), rv) 
#define GET_SYS_STATUSr_ReservedSS(rv)              ((rv)>>21&0x7ff)
#define SET_SYS_STATUSr_ReservedSS(rv,fv)           (rv=(rv&~(0x7ff<<21))|((fv)&0x7ff)<<21)
#define GET_SYS_STATUSr_LastOfMIBId(rv)             ((rv)>>9&0xfff)
#define SET_SYS_STATUSr_LastOfMIBId(rv,fv)          (rv=(rv&~(0xfff<<9))|((fv)&0xfff)<<9)
#define GET_SYS_STATUSr_LastTblCmdX(rv)             ((rv)>>8&0x1)
#define SET_SYS_STATUSr_LastTblCmdX(rv,fv)          (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_SYS_STATUSr_NowTblMgmt(rv)              ((rv)>>7&0x1)
#define SET_SYS_STATUSr_NowTblMgmt(rv,fv)           (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_SYS_STATUSr_NowEPInit(rv)               ((rv)>>6&0x1)
#define SET_SYS_STATUSr_NowEPInit(rv,fv)            (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_SYS_STATUSr_NowMIBInit(rv)              ((rv)>>5&0x1)
#define SET_SYS_STATUSr_NowMIBInit(rv,fv)           (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_SYS_STATUSr_NowL2Init(rv)               ((rv)>>4&0x1)
#define SET_SYS_STATUSr_NowL2Init(rv,fv)            (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_SYS_STATUSr_ReservedSS2(rv)             ((rv)>>3&0x1)
#define SET_SYS_STATUSr_ReservedSS2(rv,fv)          (rv=(rv&~(0x1<<3))|((fv)&0x1)<<3)
#define GET_SYS_STATUSr_NowSBInit(rv)               ((rv)>>2&0x1)
#define SET_SYS_STATUSr_NowSBInit(rv,fv)            (rv=(rv&~(0x1<<2))|((fv)&0x1)<<2)
#define GET_SYS_STATUSr_LastBISTX(rv)               ((rv)>>1&0x1)
#define SET_SYS_STATUSr_LastBISTX(rv,fv)            (rv=(rv&~(0x1<<1))|((fv)&0x1)<<1)
#define GET_SYS_STATUSr_NowBIST(rv)                 ((rv)>>0&0x1)
#define SET_SYS_STATUSr_NowBIST(rv,fv)              (rv=(rv&~(0x1<<0))|((fv)&0x1)<<0)

/* Register P_STATUS */
#define P_STATUSr_ADDR(pic)		reg_addr_5632(P_STATUSr, pic)
#define READ_P_STATUSr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P_STATUSr_ADDR(pic), rvp) 
#define WRITE_P_STATUSr(unit, pic, rv) \
	cmic_write_reg_5632(unit, P_STATUSr_ADDR(pic), rv) 
#define GET_P_STATUSr_Aneglpreg(rv)                 ((rv)>>16&0xffff)
#define SET_P_STATUSr_Aneglpreg(rv,fv)              (rv=(rv&~(0xffff<<16))|((fv)&0xffff)<<16)
#define GET_P_STATUSr_LinkFail(rv)                  ((rv)>>15&0x1)
#define SET_P_STATUSr_LinkFail(rv,fv)               (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P_STATUSr_AnegCompt(rv)                 ((rv)>>14&0x1)
#define SET_P_STATUSr_AnegCompt(rv,fv)              (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_P_STATUSr_SvlanViolation(rv)            ((rv)>>13&0x1)
#define SET_P_STATUSr_SvlanViolation(rv,fv)         (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P_STATUSr_DvlanViolation(rv)            ((rv)>>12&0x1)
#define SET_P_STATUSr_DvlanViolation(rv,fv)         (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P_STATUSr_AllQueueDrop(rv)              ((rv)>>11&0x1)
#define SET_P_STATUSr_AllQueueDrop(rv,fv)           (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_P_STATUSr_InBFull(rv)                   ((rv)>>10&0x1)
#define SET_P_STATUSr_InBFull(rv,fv)                (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_P_STATUSr_TblUNAVL(rv)                  ((rv)>>9&0x1)
#define SET_P_STATUSr_TblUNAVL(rv,fv)               (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_P_STATUSr_TimeOut(rv)                   ((rv)>>8&0x1)
#define SET_P_STATUSr_TimeOut(rv,fv)                (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_P_STATUSr_AnegFail(rv)                  ((rv)>>7&0x1)
#define SET_P_STATUSr_AnegFail(rv,fv)               (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_P_STATUSr_DisTxPause(rv)                ((rv)>>6&0x1)
#define SET_P_STATUSr_DisTxPause(rv,fv)             (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_P_STATUSr_DisRxPause(rv)                ((rv)>>5&0x1)
#define SET_P_STATUSr_DisRxPause(rv,fv)             (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_P_STATUSr_Anegpagervd(rv)               ((rv)>>4&0x1)
#define SET_P_STATUSr_Anegpagervd(rv,fv)            (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_P_STATUSr_PS1_PS0(rv)                   ((rv)>>2&0x3)
#define SET_P_STATUSr_PS1_PS0(rv,fv)                (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_P_STATUSr_RF2_RF1(rv)                   ((rv)>>0&0x3)
#define SET_P_STATUSr_RF2_RF1(rv,fv)                (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register P10G_STATUS */
#define P10G_STATUSr_ADDR(pic)		reg_addr_5632(P10G_STATUSr, pic)
#define READ_P10G_STATUSr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, P10G_STATUSr_ADDR(pic), rvp) 
#define WRITE_P10G_STATUSr(unit, pic, rv) \
	cmic_write_reg_5632(unit, P10G_STATUSr_ADDR(pic), rv) 
#define GET_P10G_STATUSr_Aneglpreg10G(rv)           ((rv)>>16&0xffff)
#define SET_P10G_STATUSr_Aneglpreg10G(rv,fv)        (rv=(rv&~(0xffff<<16))|((fv)&0xffff)<<16)
#define GET_P10G_STATUSr_LinkFail10G(rv)            ((rv)>>15&0x1)
#define SET_P10G_STATUSr_LinkFail10G(rv,fv)         (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_P10G_STATUSr_AnegCompt10G(rv)           ((rv)>>14&0x1)
#define SET_P10G_STATUSr_AnegCompt10G(rv,fv)        (rv=(rv&~(0x1<<14))|((fv)&0x1)<<14)
#define GET_P10G_STATUSr_SvlanViolation10G(rv)      ((rv)>>13&0x1)
#define SET_P10G_STATUSr_SvlanViolation10G(rv,fv)   (rv=(rv&~(0x1<<13))|((fv)&0x1)<<13)
#define GET_P10G_STATUSr_DvlanViolation10G(rv)      ((rv)>>12&0x1)
#define SET_P10G_STATUSr_DvlanViolation10G(rv,fv)   (rv=(rv&~(0x1<<12))|((fv)&0x1)<<12)
#define GET_P10G_STATUSr_AllQueueDrop10G(rv)        ((rv)>>11&0x1)
#define SET_P10G_STATUSr_AllQueueDrop10G(rv,fv)     (rv=(rv&~(0x1<<11))|((fv)&0x1)<<11)
#define GET_P10G_STATUSr_InBFull10G(rv)             ((rv)>>10&0x1)
#define SET_P10G_STATUSr_InBFull10G(rv,fv)          (rv=(rv&~(0x1<<10))|((fv)&0x1)<<10)
#define GET_P10G_STATUSr_TblUNAVL10G(rv)            ((rv)>>9&0x1)
#define SET_P10G_STATUSr_TblUNAVL10G(rv,fv)         (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_P10G_STATUSr_TimeOut10G(rv)             ((rv)>>8&0x1)
#define SET_P10G_STATUSr_TimeOut10G(rv,fv)          (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_P10G_STATUSr_AnegFail10G(rv)            ((rv)>>7&0x1)
#define SET_P10G_STATUSr_AnegFail10G(rv,fv)         (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_P10G_STATUSr_DisTxPause10G(rv)          ((rv)>>6&0x1)
#define SET_P10G_STATUSr_DisTxPause10G(rv,fv)       (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_P10G_STATUSr_DisRxPause10G(rv)          ((rv)>>5&0x1)
#define SET_P10G_STATUSr_DisRxPause10G(rv,fv)       (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_P10G_STATUSr_Anegpagervd10G(rv)         ((rv)>>4&0x1)
#define SET_P10G_STATUSr_Anegpagervd10G(rv,fv)      (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_P10G_STATUSr_PS1_PS010G(rv)             ((rv)>>2&0x3)
#define SET_P10G_STATUSr_PS1_PS010G(rv,fv)          (rv=(rv&~(0x3<<2))|((fv)&0x3)<<2)
#define GET_P10G_STATUSr_RF2_RF110G(rv)             ((rv)>>0&0x3)
#define SET_P10G_STATUSr_RF2_RF110G(rv,fv)          (rv=(rv&~(0x3<<0))|((fv)&0x3)<<0)

/* Register CPU_CMD */
#define CPU_CMDr_ADDR(pic)		reg_addr_5632(CPU_CMDr, pic)
#define READ_CPU_CMDr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, CPU_CMDr_ADDR(pic), rvp) 
#define WRITE_CPU_CMDr(unit, pic, rv) \
	cmic_write_reg_5632(unit, CPU_CMDr_ADDR(pic), rv) 
#define GET_CPU_CMDr_SxAddrMSB(rv)                  ((rv)>>16&0xffff)
#define SET_CPU_CMDr_SxAddrMSB(rv,fv)               (rv=(rv&~(0xffff<<16))|((fv)&0xffff)<<16)
#define GET_CPU_CMDr_ReservedCPU(rv)                ((rv)>>9&0x7f)
#define SET_CPU_CMDr_ReservedCPU(rv,fv)             (rv=(rv&~(0x7f<<9))|((fv)&0x7f)<<9)
#define GET_CPU_CMDr_SwReset(rv)                    ((rv)>>8&0x1)
#define SET_CPU_CMDr_SwReset(rv,fv)                 (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_CPU_CMDr_ReservedCPU2(rv)               ((rv)>>6&0x3)
#define SET_CPU_CMDr_ReservedCPU2(rv,fv)            (rv=(rv&~(0x3<<6))|((fv)&0x3)<<6)
#define GET_CPU_CMDr_TblSel(rv)                     ((rv)>>3&0x7)
#define SET_CPU_CMDr_TblSel(rv,fv)                  (rv=(rv&~(0x7<<3))|((fv)&0x7)<<3)
#define GET_CPU_CMDr_TblMgmtCmd(rv)                 ((rv)>>0&0x7)
#define SET_CPU_CMDr_TblMgmtCmd(rv,fv)              (rv=(rv&~(0x7<<0))|((fv)&0x7)<<0)

/* Register TBL_ENTID */
#define TBL_ENTIDr_ADDR(pic)		reg_addr_5632(TBL_ENTIDr, pic)
#define READ_TBL_ENTIDr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_ENTIDr_ADDR(pic), rvp) 
#define WRITE_TBL_ENTIDr(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_ENTIDr_ADDR(pic), rv) 
#define GET_TBL_ENTIDr_ReservedTA(rv)               ((rv)>>31&0x1)
#define SET_TBL_ENTIDr_ReservedTA(rv,fv)            (rv=(rv&~(0x1<<31))|((fv)&0x1)<<31)
#define GET_TBL_ENTIDr_TblEntryCnt(rv)              ((rv)>>16&0x7fff)
#define SET_TBL_ENTIDr_TblEntryCnt(rv,fv)           (rv=(rv&~(0x7fff<<16))|((fv)&0x7fff)<<16)
#define GET_TBL_ENTIDr_ReservedTA2(rv)              ((rv)>>15&0x1)
#define SET_TBL_ENTIDr_ReservedTA2(rv,fv)           (rv=(rv&~(0x1<<15))|((fv)&0x1)<<15)
#define GET_TBL_ENTIDr_TblEntryNo(rv)               ((rv)>>0&0x7fff)
#define SET_TBL_ENTIDr_TblEntryNo(rv,fv)            (rv=(rv&~(0x7fff<<0))|((fv)&0x7fff)<<0)

/* Register TBL_SXADDR */
#define TBL_SXADDRr_ADDR(pic)		reg_addr_5632(TBL_SXADDRr, pic)
#define READ_TBL_SXADDRr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_SXADDRr_ADDR(pic), rvp) 
#define WRITE_TBL_SXADDRr(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_SXADDRr_ADDR(pic), rv) 
#define GET_TBL_SXADDRr_SxAddrLSB(rv)               ((rv)>>0&0x20202020)
#define SET_TBL_SXADDRr_SxAddrLSB(rv,fv)            (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_0 */
#define TBL_DBUF_0r_ADDR(pic)		reg_addr_5632(TBL_DBUF_0r, pic)
#define READ_TBL_DBUF_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_0r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_0r_ADDR(pic), rv) 
#define GET_TBL_DBUF_0r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_0r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_1 */
#define TBL_DBUF_1r_ADDR(pic)		reg_addr_5632(TBL_DBUF_1r, pic)
#define READ_TBL_DBUF_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_1r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_1r_ADDR(pic), rv) 
#define GET_TBL_DBUF_1r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_1r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_2 */
#define TBL_DBUF_2r_ADDR(pic)		reg_addr_5632(TBL_DBUF_2r, pic)
#define READ_TBL_DBUF_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_2r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_2r_ADDR(pic), rv) 
#define GET_TBL_DBUF_2r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_2r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_3 */
#define TBL_DBUF_3r_ADDR(pic)		reg_addr_5632(TBL_DBUF_3r, pic)
#define READ_TBL_DBUF_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_3r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_3r_ADDR(pic), rv) 
#define GET_TBL_DBUF_3r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_3r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_4 */
#define TBL_DBUF_4r_ADDR(pic)		reg_addr_5632(TBL_DBUF_4r, pic)
#define READ_TBL_DBUF_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_4r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_4r_ADDR(pic), rv) 
#define GET_TBL_DBUF_4r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_4r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_5 */
#define TBL_DBUF_5r_ADDR(pic)		reg_addr_5632(TBL_DBUF_5r, pic)
#define READ_TBL_DBUF_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_5r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_5r_ADDR(pic), rv) 
#define GET_TBL_DBUF_5r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_5r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_6 */
#define TBL_DBUF_6r_ADDR(pic)		reg_addr_5632(TBL_DBUF_6r, pic)
#define READ_TBL_DBUF_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_6r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_6r_ADDR(pic), rv) 
#define GET_TBL_DBUF_6r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_6r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_7 */
#define TBL_DBUF_7r_ADDR(pic)		reg_addr_5632(TBL_DBUF_7r, pic)
#define READ_TBL_DBUF_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_7r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_7r_ADDR(pic), rv) 
#define GET_TBL_DBUF_7r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_7r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_8 */
#define TBL_DBUF_8r_ADDR(pic)		reg_addr_5632(TBL_DBUF_8r, pic)
#define READ_TBL_DBUF_8r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_8r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_8r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_8r_ADDR(pic), rv) 
#define GET_TBL_DBUF_8r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_8r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TBL_DBUF_9 */
#define TBL_DBUF_9r_ADDR(pic)		reg_addr_5632(TBL_DBUF_9r, pic)
#define READ_TBL_DBUF_9r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TBL_DBUF_9r_ADDR(pic), rvp) 
#define WRITE_TBL_DBUF_9r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TBL_DBUF_9r_ADDR(pic), rv) 
#define GET_TBL_DBUF_9r_TblDataB(rv)                ((rv)>>0&0x20202020)
#define SET_TBL_DBUF_9r_TblDataB(rv,fv)             (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register INV */
#define INVr_ADDR(pic)			reg_addr_5632(INVr, pic)
#define READ_INVr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, INVr_ADDR(pic), rvp) 
#define WRITE_INVr(unit, pic, rv) \
	cmic_write_reg_5632(unit, INVr_ADDR(pic), rv) 
#define GET_INVr_ReservedCPUI(rv)                   ((rv)>>10&0x3fffff)
#define SET_INVr_ReservedCPUI(rv,fv)                (rv=(rv&~(0x3fffff<<10))|((fv)&0x3fffff)<<10)
#define GET_INVr_CPUInitStart(rv)                   ((rv)>>9&0x1)
#define SET_INVr_CPUInitStart(rv,fv)                (rv=(rv&~(0x1<<9))|((fv)&0x1)<<9)
#define GET_INVr_PCIErr(rv)                         ((rv)>>8&0x1)
#define SET_INVr_PCIErr(rv,fv)                      (rv=(rv&~(0x1<<8))|((fv)&0x1)<<8)
#define GET_INVr_MemInitDone(rv)                    ((rv)>>7&0x1)
#define SET_INVr_MemInitDone(rv,fv)                 (rv=(rv&~(0x1<<7))|((fv)&0x1)<<7)
#define GET_INVr_BISTDone(rv)                       ((rv)>>6&0x1)
#define SET_INVr_BISTDone(rv,fv)                    (rv=(rv&~(0x1<<6))|((fv)&0x1)<<6)
#define GET_INVr_MIBCntOF(rv)                       ((rv)>>5&0x1)
#define SET_INVr_MIBCntOF(rv,fv)                    (rv=(rv&~(0x1<<5))|((fv)&0x1)<<5)
#define GET_INVr_TblCmdDone(rv)                     ((rv)>>4&0x1)
#define SET_INVr_TblCmdDone(rv,fv)                  (rv=(rv&~(0x1<<4))|((fv)&0x1)<<4)
#define GET_INVr_RxPktLast(rv)                      ((rv)>>3&0x1)
#define SET_INVr_RxPktLast(rv,fv)                   (rv=(rv&~(0x1<<3))|((fv)&0x1)<<3)
#define GET_INVr_RxPkt(rv)                          ((rv)>>2&0x1)
#define SET_INVr_RxPkt(rv,fv)                       (rv=(rv&~(0x1<<2))|((fv)&0x1)<<2)
#define GET_INVr_TxPktLast(rv)                      ((rv)>>1&0x1)
#define SET_INVr_TxPktLast(rv,fv)                   (rv=(rv&~(0x1<<1))|((fv)&0x1)<<1)
#define GET_INVr_TxPkt(rv)                          ((rv)>>0&0x1)
#define SET_INVr_TxPkt(rv,fv)                       (rv=(rv&~(0x1<<0))|((fv)&0x1)<<0)

/* Register INV_MSK */
#define INV_MSKr_ADDR(pic)		reg_addr_5632(INV_MSKr, pic)
#define READ_INV_MSKr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, INV_MSKr_ADDR(pic), rvp) 
#define WRITE_INV_MSKr(unit, pic, rv) \
	cmic_write_reg_5632(unit, INV_MSKr_ADDR(pic), rv) 
#define GET_INV_MSKr_IntVecMsk(rv)                  ((rv)>>0&0x20202020)
#define SET_INV_MSKr_IntVecMsk(rv,fv)               (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register PKT_CH_PTRS */
#define PKT_CH_PTRSr_ADDR(pic)		reg_addr_5632(PKT_CH_PTRSr, pic)
#define READ_PKT_CH_PTRSr(unit, pic, rvp) \
	cmic_read_reg_5632(unit, PKT_CH_PTRSr_ADDR(pic), rvp) 
#define WRITE_PKT_CH_PTRSr(unit, pic, rv) \
	cmic_write_reg_5632(unit, PKT_CH_PTRSr_ADDR(pic), rv) 
#define GET_PKT_CH_PTRSr_ReservedDMA(rv)            ((rv)>>29&0x7)
#define SET_PKT_CH_PTRSr_ReservedDMA(rv,fv)         (rv=(rv&~(0x7<<29))|((fv)&0x7)<<29)
#define GET_PKT_CH_PTRSr_NxtTxCh(rv)                ((rv)>>24&0x1f)
#define SET_PKT_CH_PTRSr_NxtTxCh(rv,fv)             (rv=(rv&~(0x1f<<24))|((fv)&0x1f)<<24)
#define GET_PKT_CH_PTRSr_ReservedDMA2(rv)           ((rv)>>21&0x7)
#define SET_PKT_CH_PTRSr_ReservedDMA2(rv,fv)        (rv=(rv&~(0x7<<21))|((fv)&0x7)<<21)
#define GET_PKT_CH_PTRSr_NxtAllocTxCh(rv)           ((rv)>>16&0x1f)
#define SET_PKT_CH_PTRSr_NxtAllocTxCh(rv,fv)        (rv=(rv&~(0x1f<<16))|((fv)&0x1f)<<16)
#define GET_PKT_CH_PTRSr_ReservedDMA3(rv)           ((rv)>>13&0x7)
#define SET_PKT_CH_PTRSr_ReservedDMA3(rv,fv)        (rv=(rv&~(0x7<<13))|((fv)&0x7)<<13)
#define GET_PKT_CH_PTRSr_NxtRxCh(rv)                ((rv)>>8&0x1f)
#define SET_PKT_CH_PTRSr_NxtRxCh(rv,fv)             (rv=(rv&~(0x1f<<8))|((fv)&0x1f)<<8)
#define GET_PKT_CH_PTRSr_ReservedDMA4(rv)           ((rv)>>5&0x7)
#define SET_PKT_CH_PTRSr_ReservedDMA4(rv,fv)        (rv=(rv&~(0x7<<5))|((fv)&0x7)<<5)
#define GET_PKT_CH_PTRSr_NxtAllocRxCh(rv)           ((rv)>>0&0x1f)
#define SET_PKT_CH_PTRSr_NxtAllocRxCh(rv,fv)        (rv=(rv&~(0x1f<<0))|((fv)&0x1f)<<0)

/* Register RX_CH_0 */
#define RX_CH_0r_ADDR(pic)		reg_addr_5632(RX_CH_0r, pic)
#define READ_RX_CH_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_0r_ADDR(pic), rvp) 
#define WRITE_RX_CH_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_0r_ADDR(pic), rv) 
#define GET_RX_CH_0r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_0r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_1 */
#define RX_CH_1r_ADDR(pic)		reg_addr_5632(RX_CH_1r, pic)
#define READ_RX_CH_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_1r_ADDR(pic), rvp) 
#define WRITE_RX_CH_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_1r_ADDR(pic), rv) 
#define GET_RX_CH_1r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_1r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_2 */
#define RX_CH_2r_ADDR(pic)		reg_addr_5632(RX_CH_2r, pic)
#define READ_RX_CH_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_2r_ADDR(pic), rvp) 
#define WRITE_RX_CH_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_2r_ADDR(pic), rv) 
#define GET_RX_CH_2r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_2r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_3 */
#define RX_CH_3r_ADDR(pic)		reg_addr_5632(RX_CH_3r, pic)
#define READ_RX_CH_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_3r_ADDR(pic), rvp) 
#define WRITE_RX_CH_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_3r_ADDR(pic), rv) 
#define GET_RX_CH_3r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_3r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_4 */
#define RX_CH_4r_ADDR(pic)		reg_addr_5632(RX_CH_4r, pic)
#define READ_RX_CH_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_4r_ADDR(pic), rvp) 
#define WRITE_RX_CH_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_4r_ADDR(pic), rv) 
#define GET_RX_CH_4r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_4r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_5 */
#define RX_CH_5r_ADDR(pic)		reg_addr_5632(RX_CH_5r, pic)
#define READ_RX_CH_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_5r_ADDR(pic), rvp) 
#define WRITE_RX_CH_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_5r_ADDR(pic), rv) 
#define GET_RX_CH_5r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_5r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_6 */
#define RX_CH_6r_ADDR(pic)		reg_addr_5632(RX_CH_6r, pic)
#define READ_RX_CH_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_6r_ADDR(pic), rvp) 
#define WRITE_RX_CH_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_6r_ADDR(pic), rv) 
#define GET_RX_CH_6r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_6r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_7 */
#define RX_CH_7r_ADDR(pic)		reg_addr_5632(RX_CH_7r, pic)
#define READ_RX_CH_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_7r_ADDR(pic), rvp) 
#define WRITE_RX_CH_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_7r_ADDR(pic), rv) 
#define GET_RX_CH_7r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_7r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_8 */
#define RX_CH_8r_ADDR(pic)		reg_addr_5632(RX_CH_8r, pic)
#define READ_RX_CH_8r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_8r_ADDR(pic), rvp) 
#define WRITE_RX_CH_8r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_8r_ADDR(pic), rv) 
#define GET_RX_CH_8r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_8r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_9 */
#define RX_CH_9r_ADDR(pic)		reg_addr_5632(RX_CH_9r, pic)
#define READ_RX_CH_9r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_9r_ADDR(pic), rvp) 
#define WRITE_RX_CH_9r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_9r_ADDR(pic), rv) 
#define GET_RX_CH_9r_PktsRxA(rv)                    ((rv)>>0&0x20202020)
#define SET_RX_CH_9r_PktsRxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_10 */
#define RX_CH_10r_ADDR(pic)		reg_addr_5632(RX_CH_10r, pic)
#define READ_RX_CH_10r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_10r_ADDR(pic), rvp) 
#define WRITE_RX_CH_10r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_10r_ADDR(pic), rv) 
#define GET_RX_CH_10r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_10r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_11 */
#define RX_CH_11r_ADDR(pic)		reg_addr_5632(RX_CH_11r, pic)
#define READ_RX_CH_11r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_11r_ADDR(pic), rvp) 
#define WRITE_RX_CH_11r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_11r_ADDR(pic), rv) 
#define GET_RX_CH_11r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_11r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_12 */
#define RX_CH_12r_ADDR(pic)		reg_addr_5632(RX_CH_12r, pic)
#define READ_RX_CH_12r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_12r_ADDR(pic), rvp) 
#define WRITE_RX_CH_12r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_12r_ADDR(pic), rv) 
#define GET_RX_CH_12r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_12r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_13 */
#define RX_CH_13r_ADDR(pic)		reg_addr_5632(RX_CH_13r, pic)
#define READ_RX_CH_13r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_13r_ADDR(pic), rvp) 
#define WRITE_RX_CH_13r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_13r_ADDR(pic), rv) 
#define GET_RX_CH_13r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_13r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_14 */
#define RX_CH_14r_ADDR(pic)		reg_addr_5632(RX_CH_14r, pic)
#define READ_RX_CH_14r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_14r_ADDR(pic), rvp) 
#define WRITE_RX_CH_14r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_14r_ADDR(pic), rv) 
#define GET_RX_CH_14r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_14r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_15 */
#define RX_CH_15r_ADDR(pic)		reg_addr_5632(RX_CH_15r, pic)
#define READ_RX_CH_15r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_15r_ADDR(pic), rvp) 
#define WRITE_RX_CH_15r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_15r_ADDR(pic), rv) 
#define GET_RX_CH_15r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_15r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_16 */
#define RX_CH_16r_ADDR(pic)		reg_addr_5632(RX_CH_16r, pic)
#define READ_RX_CH_16r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_16r_ADDR(pic), rvp) 
#define WRITE_RX_CH_16r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_16r_ADDR(pic), rv) 
#define GET_RX_CH_16r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_16r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_17 */
#define RX_CH_17r_ADDR(pic)		reg_addr_5632(RX_CH_17r, pic)
#define READ_RX_CH_17r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_17r_ADDR(pic), rvp) 
#define WRITE_RX_CH_17r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_17r_ADDR(pic), rv) 
#define GET_RX_CH_17r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_17r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_18 */
#define RX_CH_18r_ADDR(pic)		reg_addr_5632(RX_CH_18r, pic)
#define READ_RX_CH_18r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_18r_ADDR(pic), rvp) 
#define WRITE_RX_CH_18r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_18r_ADDR(pic), rv) 
#define GET_RX_CH_18r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_18r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_19 */
#define RX_CH_19r_ADDR(pic)		reg_addr_5632(RX_CH_19r, pic)
#define READ_RX_CH_19r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_19r_ADDR(pic), rvp) 
#define WRITE_RX_CH_19r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_19r_ADDR(pic), rv) 
#define GET_RX_CH_19r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_19r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_20 */
#define RX_CH_20r_ADDR(pic)		reg_addr_5632(RX_CH_20r, pic)
#define READ_RX_CH_20r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_20r_ADDR(pic), rvp) 
#define WRITE_RX_CH_20r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_20r_ADDR(pic), rv) 
#define GET_RX_CH_20r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_20r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_21 */
#define RX_CH_21r_ADDR(pic)		reg_addr_5632(RX_CH_21r, pic)
#define READ_RX_CH_21r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_21r_ADDR(pic), rvp) 
#define WRITE_RX_CH_21r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_21r_ADDR(pic), rv) 
#define GET_RX_CH_21r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_21r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_22 */
#define RX_CH_22r_ADDR(pic)		reg_addr_5632(RX_CH_22r, pic)
#define READ_RX_CH_22r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_22r_ADDR(pic), rvp) 
#define WRITE_RX_CH_22r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_22r_ADDR(pic), rv) 
#define GET_RX_CH_22r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_22r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_23 */
#define RX_CH_23r_ADDR(pic)		reg_addr_5632(RX_CH_23r, pic)
#define READ_RX_CH_23r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_23r_ADDR(pic), rvp) 
#define WRITE_RX_CH_23r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_23r_ADDR(pic), rv) 
#define GET_RX_CH_23r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_23r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_24 */
#define RX_CH_24r_ADDR(pic)		reg_addr_5632(RX_CH_24r, pic)
#define READ_RX_CH_24r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_24r_ADDR(pic), rvp) 
#define WRITE_RX_CH_24r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_24r_ADDR(pic), rv) 
#define GET_RX_CH_24r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_24r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_25 */
#define RX_CH_25r_ADDR(pic)		reg_addr_5632(RX_CH_25r, pic)
#define READ_RX_CH_25r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_25r_ADDR(pic), rvp) 
#define WRITE_RX_CH_25r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_25r_ADDR(pic), rv) 
#define GET_RX_CH_25r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_25r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_26 */
#define RX_CH_26r_ADDR(pic)		reg_addr_5632(RX_CH_26r, pic)
#define READ_RX_CH_26r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_26r_ADDR(pic), rvp) 
#define WRITE_RX_CH_26r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_26r_ADDR(pic), rv) 
#define GET_RX_CH_26r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_26r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_27 */
#define RX_CH_27r_ADDR(pic)		reg_addr_5632(RX_CH_27r, pic)
#define READ_RX_CH_27r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_27r_ADDR(pic), rvp) 
#define WRITE_RX_CH_27r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_27r_ADDR(pic), rv) 
#define GET_RX_CH_27r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_27r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_28 */
#define RX_CH_28r_ADDR(pic)		reg_addr_5632(RX_CH_28r, pic)
#define READ_RX_CH_28r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_28r_ADDR(pic), rvp) 
#define WRITE_RX_CH_28r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_28r_ADDR(pic), rv) 
#define GET_RX_CH_28r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_28r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_29 */
#define RX_CH_29r_ADDR(pic)		reg_addr_5632(RX_CH_29r, pic)
#define READ_RX_CH_29r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_29r_ADDR(pic), rvp) 
#define WRITE_RX_CH_29r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_29r_ADDR(pic), rv) 
#define GET_RX_CH_29r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_29r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_30 */
#define RX_CH_30r_ADDR(pic)		reg_addr_5632(RX_CH_30r, pic)
#define READ_RX_CH_30r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_30r_ADDR(pic), rvp) 
#define WRITE_RX_CH_30r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_30r_ADDR(pic), rv) 
#define GET_RX_CH_30r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_30r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register RX_CH_31 */
#define RX_CH_31r_ADDR(pic)		reg_addr_5632(RX_CH_31r, pic)
#define READ_RX_CH_31r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, RX_CH_31r_ADDR(pic), rvp) 
#define WRITE_RX_CH_31r(unit, pic, rv) \
	cmic_write_reg_5632(unit, RX_CH_31r_ADDR(pic), rv) 
#define GET_RX_CH_31r_PktsRxA(rv)                   ((rv)>>0&0x20202020)
#define SET_RX_CH_31r_PktsRxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_0 */
#define TX_CH_0r_ADDR(pic)		reg_addr_5632(TX_CH_0r, pic)
#define READ_TX_CH_0r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_0r_ADDR(pic), rvp) 
#define WRITE_TX_CH_0r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_0r_ADDR(pic), rv) 
#define GET_TX_CH_0r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_0r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_1 */
#define TX_CH_1r_ADDR(pic)		reg_addr_5632(TX_CH_1r, pic)
#define READ_TX_CH_1r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_1r_ADDR(pic), rvp) 
#define WRITE_TX_CH_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_1r_ADDR(pic), rv) 
#define GET_TX_CH_1r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_1r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_2 */
#define TX_CH_2r_ADDR(pic)		reg_addr_5632(TX_CH_2r, pic)
#define READ_TX_CH_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_2r_ADDR(pic), rvp) 
#define WRITE_TX_CH_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_2r_ADDR(pic), rv) 
#define GET_TX_CH_2r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_2r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_3 */
#define TX_CH_3r_ADDR(pic)		reg_addr_5632(TX_CH_3r, pic)
#define READ_TX_CH_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_3r_ADDR(pic), rvp) 
#define WRITE_TX_CH_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_3r_ADDR(pic), rv) 
#define GET_TX_CH_3r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_3r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_4 */
#define TX_CH_4r_ADDR(pic)		reg_addr_5632(TX_CH_4r, pic)
#define READ_TX_CH_4r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_4r_ADDR(pic), rvp) 
#define WRITE_TX_CH_4r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_4r_ADDR(pic), rv) 
#define GET_TX_CH_4r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_4r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_5 */
#define TX_CH_5r_ADDR(pic)		reg_addr_5632(TX_CH_5r, pic)
#define READ_TX_CH_5r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_5r_ADDR(pic), rvp) 
#define WRITE_TX_CH_5r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_5r_ADDR(pic), rv) 
#define GET_TX_CH_5r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_5r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_6 */
#define TX_CH_6r_ADDR(pic)		reg_addr_5632(TX_CH_6r, pic)
#define READ_TX_CH_6r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_6r_ADDR(pic), rvp) 
#define WRITE_TX_CH_6r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_6r_ADDR(pic), rv) 
#define GET_TX_CH_6r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_6r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_7 */
#define TX_CH_7r_ADDR(pic)		reg_addr_5632(TX_CH_7r, pic)
#define READ_TX_CH_7r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_7r_ADDR(pic), rvp) 
#define WRITE_TX_CH_7r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_7r_ADDR(pic), rv) 
#define GET_TX_CH_7r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_7r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_8 */
#define TX_CH_8r_ADDR(pic)		reg_addr_5632(TX_CH_8r, pic)
#define READ_TX_CH_8r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_8r_ADDR(pic), rvp) 
#define WRITE_TX_CH_8r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_8r_ADDR(pic), rv) 
#define GET_TX_CH_8r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_8r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_9 */
#define TX_CH_9r_ADDR(pic)		reg_addr_5632(TX_CH_9r, pic)
#define READ_TX_CH_9r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_9r_ADDR(pic), rvp) 
#define WRITE_TX_CH_9r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_9r_ADDR(pic), rv) 
#define GET_TX_CH_9r_PktsTxA(rv)                    ((rv)>>0&0x20202020)
#define SET_TX_CH_9r_PktsTxA(rv,fv)                 (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_10 */
#define TX_CH_10r_ADDR(pic)		reg_addr_5632(TX_CH_10r, pic)
#define READ_TX_CH_10r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_10r_ADDR(pic), rvp) 
#define WRITE_TX_CH_10r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_10r_ADDR(pic), rv) 
#define GET_TX_CH_10r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_10r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_11 */
#define TX_CH_11r_ADDR(pic)		reg_addr_5632(TX_CH_11r, pic)
#define READ_TX_CH_11r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_11r_ADDR(pic), rvp) 
#define WRITE_TX_CH_11r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_11r_ADDR(pic), rv) 
#define GET_TX_CH_11r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_11r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_12 */
#define TX_CH_12r_ADDR(pic)		reg_addr_5632(TX_CH_12r, pic)
#define READ_TX_CH_12r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_12r_ADDR(pic), rvp) 
#define WRITE_TX_CH_12r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_12r_ADDR(pic), rv) 
#define GET_TX_CH_12r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_12r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_13 */
#define TX_CH_13r_ADDR(pic)		reg_addr_5632(TX_CH_13r, pic)
#define READ_TX_CH_13r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_13r_ADDR(pic), rvp) 
#define WRITE_TX_CH_13r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_13r_ADDR(pic), rv) 
#define GET_TX_CH_13r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_13r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_14 */
#define TX_CH_14r_ADDR(pic)		reg_addr_5632(TX_CH_14r, pic)
#define READ_TX_CH_14r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_14r_ADDR(pic), rvp) 
#define WRITE_TX_CH_14r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_14r_ADDR(pic), rv) 
#define GET_TX_CH_14r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_14r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_15 */
#define TX_CH_15r_ADDR(pic)		reg_addr_5632(TX_CH_15r, pic)
#define READ_TX_CH_15r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_15r_ADDR(pic), rvp) 
#define WRITE_TX_CH_15r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_15r_ADDR(pic), rv) 
#define GET_TX_CH_15r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_15r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_16 */
#define TX_CH_16r_ADDR(pic)		reg_addr_5632(TX_CH_16r, pic)
#define READ_TX_CH_16r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_16r_ADDR(pic), rvp) 
#define WRITE_TX_CH_16r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_16r_ADDR(pic), rv) 
#define GET_TX_CH_16r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_16r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_17 */
#define TX_CH_17r_ADDR(pic)		reg_addr_5632(TX_CH_17r, pic)
#define READ_TX_CH_17r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_17r_ADDR(pic), rvp) 
#define WRITE_TX_CH_17r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_17r_ADDR(pic), rv) 
#define GET_TX_CH_17r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_17r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_18 */
#define TX_CH_18r_ADDR(pic)		reg_addr_5632(TX_CH_18r, pic)
#define READ_TX_CH_18r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_18r_ADDR(pic), rvp) 
#define WRITE_TX_CH_18r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_18r_ADDR(pic), rv) 
#define GET_TX_CH_18r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_18r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_19 */
#define TX_CH_19r_ADDR(pic)		reg_addr_5632(TX_CH_19r, pic)
#define READ_TX_CH_19r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_19r_ADDR(pic), rvp) 
#define WRITE_TX_CH_19r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_19r_ADDR(pic), rv) 
#define GET_TX_CH_19r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_19r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_20 */
#define TX_CH_20r_ADDR(pic)		reg_addr_5632(TX_CH_20r, pic)
#define READ_TX_CH_20r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_20r_ADDR(pic), rvp) 
#define WRITE_TX_CH_20r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_20r_ADDR(pic), rv) 
#define GET_TX_CH_20r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_20r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_21 */
#define TX_CH_21r_ADDR(pic)		reg_addr_5632(TX_CH_21r, pic)
#define READ_TX_CH_21r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_21r_ADDR(pic), rvp) 
#define WRITE_TX_CH_21r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_21r_ADDR(pic), rv) 
#define GET_TX_CH_21r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_21r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_22 */
#define TX_CH_22r_ADDR(pic)		reg_addr_5632(TX_CH_22r, pic)
#define READ_TX_CH_22r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_22r_ADDR(pic), rvp) 
#define WRITE_TX_CH_22r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_22r_ADDR(pic), rv) 
#define GET_TX_CH_22r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_22r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_23 */
#define TX_CH_23r_ADDR(pic)		reg_addr_5632(TX_CH_23r, pic)
#define READ_TX_CH_23r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_23r_ADDR(pic), rvp) 
#define WRITE_TX_CH_23r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_23r_ADDR(pic), rv) 
#define GET_TX_CH_23r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_23r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_24 */
#define TX_CH_24r_ADDR(pic)		reg_addr_5632(TX_CH_24r, pic)
#define READ_TX_CH_24r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_24r_ADDR(pic), rvp) 
#define WRITE_TX_CH_24r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_24r_ADDR(pic), rv) 
#define GET_TX_CH_24r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_24r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_25 */
#define TX_CH_25r_ADDR(pic)		reg_addr_5632(TX_CH_25r, pic)
#define READ_TX_CH_25r(unit, pic, rvp) \
	cmic_read_reg(unit, TX_CH_25r_ADDR(pic), rvp) 
#define WRITE_TX_CH_25r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_25r_ADDR(pic), rv) 
#define GET_TX_CH_25r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_25r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_26 */
#define TX_CH_26r_ADDR(pic)		reg_addr_5632(TX_CH_26r, pic)
#define READ_TX_CH_26r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_26r_ADDR(pic), rvp) 
#define WRITE_TX_CH_26r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_26r_ADDR(pic), rv) 
#define GET_TX_CH_26r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_26r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_27 */
#define TX_CH_27r_ADDR(pic)		reg_addr_5632(TX_CH_27r, pic)
#define READ_TX_CH_27r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_27r_ADDR(pic), rvp) 
#define WRITE_TX_CH_27r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_27r_ADDR(pic), rv) 
#define GET_TX_CH_27r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_27r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_28 */
#define TX_CH_28r_ADDR(pic)		reg_addr_5632(TX_CH_28r, pic)
#define READ_TX_CH_28r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_28r_ADDR(pic), rvp) 
#define WRITE_TX_CH_28r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_28r_ADDR(pic), rv) 
#define GET_TX_CH_28r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_28r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_29 */
#define TX_CH_29r_ADDR(pic)		reg_addr_5632(TX_CH_29r, pic)
#define READ_TX_CH_29r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_29r_ADDR(pic), rvp) 
#define WRITE_TX_CH_29r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_29r_ADDR(pic), rv) 
#define GET_TX_CH_29r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_29r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_30 */
#define TX_CH_30r_ADDR(pic)		reg_addr_5632(TX_CH_30r, pic)
#define READ_TX_CH_30r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_30r_ADDR(pic), rvp) 
#define WRITE_TX_CH_30r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_30r_ADDR(pic), rv) 
#define GET_TX_CH_30r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_30r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register TX_CH_31 */
#define TX_CH_31r_ADDR(pic)		reg_addr_5632(TX_CH_31r, pic)
#define READ_TX_CH_31r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, TX_CH_31r_ADDR(pic), rvp) 
#define WRITE_TX_CH_31r(unit, pic, rv) \
	cmic_write_reg_5632(unit, TX_CH_31r_ADDR(pic), rv) 
#define GET_TX_CH_31r_PktsTxA(rv)                   ((rv)>>0&0x20202020)
#define SET_TX_CH_31r_PktsTxA(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register BPDU_1 */
#define BPDU_1r_ADDR(pic)		reg_addr_5632(BPDU_1r, pic)
#define READ_BPDU_1r(unit, pic, rvp) \
	cmic_read_reg(unit, BPDU_1r_ADDR(pic), rvp) 
#define WRITE_BPDU_1r(unit, pic, rv) \
	cmic_write_reg_5632(unit, BPDU_1r_ADDR(pic), rv) 
#define GET_BPDU_1r_BPDU1_LSB(rv)                   ((rv)>>0&0x20202020)
#define SET_BPDU_1r_BPDU1_LSB(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register BPDU_2 */
#define BPDU_2r_ADDR(pic)		reg_addr_5632(BPDU_2r, pic)
#define READ_BPDU_2r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, BPDU_2r_ADDR(pic), rvp) 
#define WRITE_BPDU_2r(unit, pic, rv) \
	cmic_write_reg_5632(unit, BPDU_2r_ADDR(pic), rv) 
#define GET_BPDU_2r_BPDU2_LSB(rv)                   ((rv)>>0&0x20202020)
#define SET_BPDU_2r_BPDU2_LSB(rv,fv)                (rv=(rv&~(0x20202020<<0))|((fv)&0x20202020)<<0)

/* Register BPDU_3 */
#define BPDU_3r_ADDR(pic)		reg_addr_5632(BPDU_3r, pic)
#define READ_BPDU_3r(unit, pic, rvp) \
	cmic_read_reg_5632(unit, BPDU_3r_ADDR(pic), rvp) 
#define WRITE_BPDU_3r(unit, pic, rv) \
	cmic_write_reg_5632(unit, BPDU_3r_ADDR(pic), rv) 
#define GET_BPDU_3r_BPDU2_MSB(rv)                   ((rv)>>16&0xffff)
#define SET_BPDU_3r_BPDU2_MSB(rv,fv)                (rv=(rv&~(0xffff<<16))|((fv)&0xffff)<<16)
#define GET_BPDU_3r_BPDU1_MSB(rv)                   ((rv)>>0&0xffff)
#define SET_BPDU_3r_BPDU1_MSB(rv,fv)                (rv=(rv&~(0xffff<<0))|((fv)&0xffff)<<0)

/* Memory L2_L7_m */
#define L2_L7_m_BYTES                   40
#define L2_L7_m_WORDS                   BYTESTOWORDS(L2_L7_m_BYTES)
#define READ_L2_L7_m(unit, blkidx, index, data) \
	cmic_read_memory_5632(unit, L2_L7_m, blkidx, index, data) 
#define WRITE_L2_L7_m(unit, blkidx, index, data) \
	cmic_write_memory_5632(unit, L2_L7_m, blkidx, index, data) 
#define ZERO_L2_L7_m(buf) \
	zero_mem_value(L2_L7_m, buf) 
#define GET_L2_L7_m_IncCntr(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IncCntrf, fldbuf)
#define SET_L2_L7_m_IncCntr(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IncCntrf, fldbuf)
#define L2_L7_m_IncCntr_WORDS		1
#define GET_L2_L7_m_UncondFwd(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, UncondFwdf, fldbuf)
#define SET_L2_L7_m_UncondFwd(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, UncondFwdf, fldbuf)
#define L2_L7_m_UncondFwd_WORDS		1
#define GET_L2_L7_m_CondDrop(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, CondDropf, fldbuf)
#define SET_L2_L7_m_CondDrop(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, CondDropf, fldbuf)
#define L2_L7_m_CondDrop_WORDS		1
#define GET_L2_L7_m_CP_Portnum(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, CP_Portnumf, fldbuf)
#define SET_L2_L7_m_CP_Portnum(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, CP_Portnumf, fldbuf)
#define L2_L7_m_CP_Portnum_WORDS		1
#define GET_L2_L7_m_CpPkt(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, CpPktf, fldbuf)
#define SET_L2_L7_m_CpPkt(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, CpPktf, fldbuf)
#define L2_L7_m_CpPkt_WORDS		1
#define GET_L2_L7_m_QueueNum(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, QueueNumf, fldbuf)
#define SET_L2_L7_m_QueueNum(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, QueueNumf, fldbuf)
#define L2_L7_m_QueueNum_WORDS		1
#define GET_L2_L7_m_RplQue(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, RplQuef, fldbuf)
#define SET_L2_L7_m_RplQue(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, RplQuef, fldbuf)
#define L2_L7_m_RplQue_WORDS		1
#define GET_L2_L7_m_VlanPri(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, VlanPrif, fldbuf)
#define SET_L2_L7_m_VlanPri(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, VlanPrif, fldbuf)
#define L2_L7_m_VlanPri_WORDS		1
#define GET_L2_L7_m_RplVpri(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, RplVprif, fldbuf)
#define SET_L2_L7_m_RplVpri(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, RplVprif, fldbuf)
#define L2_L7_m_RplVpri_WORDS		1
#define GET_L2_L7_m_Vid(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, Vidf, fldbuf)
#define SET_L2_L7_m_Vid(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, Vidf, fldbuf)
#define L2_L7_m_Vid_WORDS		1
#define GET_L2_L7_m_RplVid(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, RplVidf, fldbuf)
#define SET_L2_L7_m_RplVid(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, RplVidf, fldbuf)
#define L2_L7_m_RplVid_WORDS		1
#define GET_L2_L7_m_Dscp(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, Dscpf, fldbuf)
#define SET_L2_L7_m_Dscp(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, Dscpf, fldbuf)
#define L2_L7_m_Dscp_WORDS		1
#define GET_L2_L7_m_RplDscp(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, RplDscpf, fldbuf)
#define SET_L2_L7_m_RplDscp(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, RplDscpf, fldbuf)
#define L2_L7_m_RplDscp_WORDS		1
#define GET_L2_L7_m_Portnum(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, Portnumf, fldbuf)
#define SET_L2_L7_m_Portnum(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, Portnumf, fldbuf)
#define L2_L7_m_Portnum_WORDS		1
#define GET_L2_L7_m_RplPortnum(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, RplPortnumf, fldbuf)
#define SET_L2_L7_m_RplPortnum(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, RplPortnumf, fldbuf)
#define L2_L7_m_RplPortnum_WORDS		1
#define GET_L2_L7_m_PortEnable(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, PortEnablef, fldbuf)
#define SET_L2_L7_m_PortEnable(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, PortEnablef, fldbuf)
#define L2_L7_m_PortEnable_WORDS		1
#define GET_L2_L7_m_FLDDEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDDEqf, fldbuf)
#define SET_L2_L7_m_FLDDEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDDEqf, fldbuf)
#define L2_L7_m_FLDDEq_WORDS		1
#define GET_L2_L7_m_FLDDMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDDMaskf, fldbuf)
#define SET_L2_L7_m_FLDDMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDDMaskf, fldbuf)
#define L2_L7_m_FLDDMask_WORDS		1
#define GET_L2_L7_m_FLDD(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDDf, fldbuf)
#define SET_L2_L7_m_FLDD(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDDf, fldbuf)
#define L2_L7_m_FLDD_WORDS		1
#define GET_L2_L7_m_FLDCEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDCEqf, fldbuf)
#define SET_L2_L7_m_FLDCEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDCEqf, fldbuf)
#define L2_L7_m_FLDCEq_WORDS		1
#define GET_L2_L7_m_FLDCMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDCMaskf, fldbuf)
#define SET_L2_L7_m_FLDCMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDCMaskf, fldbuf)
#define L2_L7_m_FLDCMask_WORDS		1
#define GET_L2_L7_m_FLDC(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDCf, fldbuf)
#define SET_L2_L7_m_FLDC(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDCf, fldbuf)
#define L2_L7_m_FLDC_WORDS		1
#define GET_L2_L7_m_FLDBEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDBEqf, fldbuf)
#define SET_L2_L7_m_FLDBEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDBEqf, fldbuf)
#define L2_L7_m_FLDBEq_WORDS		1
#define GET_L2_L7_m_FLDBMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDBMaskf, fldbuf)
#define SET_L2_L7_m_FLDBMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDBMaskf, fldbuf)
#define L2_L7_m_FLDBMask_WORDS		1
#define GET_L2_L7_m_FLDB(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDBf, fldbuf)
#define SET_L2_L7_m_FLDB(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDBf, fldbuf)
#define L2_L7_m_FLDB_WORDS		1
#define GET_L2_L7_m_FLDAEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDAEqf, fldbuf)
#define SET_L2_L7_m_FLDAEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDAEqf, fldbuf)
#define L2_L7_m_FLDAEq_WORDS		1
#define GET_L2_L7_m_FLDAMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDAMaskf, fldbuf)
#define SET_L2_L7_m_FLDAMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDAMaskf, fldbuf)
#define L2_L7_m_FLDAMask_WORDS		1
#define GET_L2_L7_m_FLDA(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, FLDAf, fldbuf)
#define SET_L2_L7_m_FLDA(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, FLDAf, fldbuf)
#define L2_L7_m_FLDA_WORDS		1
#define GET_L2_L7_m_TOSEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TOSEqf, fldbuf)
#define SET_L2_L7_m_TOSEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TOSEqf, fldbuf)
#define L2_L7_m_TOSEq_WORDS		1
#define GET_L2_L7_m_TOSMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TOSMaskf, fldbuf)
#define SET_L2_L7_m_TOSMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TOSMaskf, fldbuf)
#define L2_L7_m_TOSMask_WORDS		1
#define GET_L2_L7_m_TOS(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TOSf, fldbuf)
#define SET_L2_L7_m_TOS(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TOSf, fldbuf)
#define L2_L7_m_TOS_WORDS		1
#define GET_L2_L7_m_PROTEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, PROTEqf, fldbuf)
#define SET_L2_L7_m_PROTEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, PROTEqf, fldbuf)
#define L2_L7_m_PROTEq_WORDS		1
#define GET_L2_L7_m_PROTMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, PROTMaskf, fldbuf)
#define SET_L2_L7_m_PROTMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, PROTMaskf, fldbuf)
#define L2_L7_m_PROTMask_WORDS		1
#define GET_L2_L7_m_PROT(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, PROTf, fldbuf)
#define SET_L2_L7_m_PROT(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, PROTf, fldbuf)
#define L2_L7_m_PROT_WORDS		1
#define GET_L2_L7_m_TSSEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TSSEqf, fldbuf)
#define SET_L2_L7_m_TSSEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TSSEqf, fldbuf)
#define L2_L7_m_TSSEq_WORDS		1
#define GET_L2_L7_m_TSSMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TSSMaskf, fldbuf)
#define SET_L2_L7_m_TSSMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TSSMaskf, fldbuf)
#define L2_L7_m_TSSMask_WORDS		1
#define GET_L2_L7_m_TSS(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TSSf, fldbuf)
#define SET_L2_L7_m_TSS(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TSSf, fldbuf)
#define L2_L7_m_TSS_WORDS		1
#define GET_L2_L7_m_TDSEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TDSEqf, fldbuf)
#define SET_L2_L7_m_TDSEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TDSEqf, fldbuf)
#define L2_L7_m_TDSEq_WORDS		1
#define GET_L2_L7_m_TDSMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TDSMaskf, fldbuf)
#define SET_L2_L7_m_TDSMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TDSMaskf, fldbuf)
#define L2_L7_m_TDSMask_WORDS		1
#define GET_L2_L7_m_TDS(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, TDSf, fldbuf)
#define SET_L2_L7_m_TDS(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, TDSf, fldbuf)
#define L2_L7_m_TDS_WORDS		1
#define GET_L2_L7_m_IPSAMaskAll(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IPSAMaskAllf, fldbuf)
#define SET_L2_L7_m_IPSAMaskAll(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IPSAMaskAllf, fldbuf)
#define L2_L7_m_IPSAMaskAll_WORDS		1
#define GET_L2_L7_m_IPSAEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IPSAEqf, fldbuf)
#define SET_L2_L7_m_IPSAEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IPSAEqf, fldbuf)
#define L2_L7_m_IPSAEq_WORDS		1
#define GET_L2_L7_m_IPSAMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IPSAMaskf, fldbuf)
#define SET_L2_L7_m_IPSAMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IPSAMaskf, fldbuf)
#define L2_L7_m_IPSAMask_WORDS		1
#define GET_L2_L7_m_IPSA(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IPSAf, fldbuf)
#define SET_L2_L7_m_IPSA(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IPSAf, fldbuf)
#define L2_L7_m_IPSA_WORDS		2
#define GET_L2_L7_m_IPDAMaskAll(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IPDAMaskAllf, fldbuf)
#define SET_L2_L7_m_IPDAMaskAll(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IPDAMaskAllf, fldbuf)
#define L2_L7_m_IPDAMaskAll_WORDS		1
#define GET_L2_L7_m_IPDAEq(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IPDAEqf, fldbuf)
#define SET_L2_L7_m_IPDAEq(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IPDAEqf, fldbuf)
#define L2_L7_m_IPDAEq_WORDS		1
#define GET_L2_L7_m_IPDAMask(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IPDAMaskf, fldbuf)
#define SET_L2_L7_m_IPDAMask(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IPDAMaskf, fldbuf)
#define L2_L7_m_IPDAMask_WORDS		1
#define GET_L2_L7_m_IPDA(entbuf, fldbuf) \
	get_mem_field(L2_L7_m, entbuf, IPDAf, fldbuf)
#define SET_L2_L7_m_IPDA(entbuf, fldbuf) \
	set_mem_field(L2_L7_m, entbuf, IPDAf, fldbuf)
#define L2_L7_m_IPDA_WORDS		2

/* Memory VLAN_m */
#define VLAN_m_BYTES                    7
#define VLAN_m_WORDS                    BYTESTOWORDS(VLAN_m_BYTES)
#define READ_VLAN_m(unit, blkidx, index, data) \
	cmic_read_memory_5632(unit, VLAN_m, blkidx, index, data) 
#define WRITE_VLAN_m(unit, blkidx, index, data) \
	cmic_write_memory_5632(unit, VLAN_m, blkidx, index, data) 
#define ZERO_VLAN_m(buf) \
	zero_mem_value(VLAN_m, buf) 
#define GET_VLAN_m_PortMap(entbuf, fldbuf) \
	get_mem_field(VLAN_m, entbuf, PortMapf, fldbuf)
#define SET_VLAN_m_PortMap(entbuf, fldbuf) \
	set_mem_field(VLAN_m, entbuf, PortMapf, fldbuf)
#define VLAN_m_PortMap_WORDS		1
#define GET_VLAN_m_OutputTagUntag(entbuf, fldbuf) \
	get_mem_field(VLAN_m, entbuf, OutputTagUntagf, fldbuf)
#define SET_VLAN_m_OutputTagUntag(entbuf, fldbuf) \
	set_mem_field(VLAN_m, entbuf, OutputTagUntagf, fldbuf)
#define VLAN_m_OutputTagUntag_WORDS		1
#define GET_VLAN_m_PortState(entbuf, fldbuf) \
	get_mem_field(VLAN_m, entbuf, PortStatef, fldbuf)
#define SET_VLAN_m_PortState(entbuf, fldbuf) \
	set_mem_field(VLAN_m, entbuf, PortStatef, fldbuf)
#define VLAN_m_PortState_WORDS		2

/* Memory ARL_5632_m */
#define ARL_5632_m_BYTES                10
#define ARL_5632_m_WORDS                BYTESTOWORDS(ARL_5632_m_BYTES)
#define READ_ARL_5632_m(unit, blkidx, index, data) \
	cmic_read_memory_5632(unit, ARL_5632_m, blkidx, index, data) 
#define WRITE_ARL_5632_m(unit, blkidx, index, data) \
	cmic_write_memory_5632(unit, ARL_5632_m, blkidx, index, data) 
#define ZERO_ARL_5632_m(buf) \
	zero_mem_value(ARL_5632_m, buf) 
#define GET_ARL_5632_m_MacAddr0(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, MacAddr0f, fldbuf)
#define SET_ARL_5632_m_MacAddr0(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, MacAddr0f, fldbuf)
#define ARL_5632_m_MacAddr0_WORDS		1
#define GET_ARL_5632_m_MacAddr1(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, MacAddr1f, fldbuf)
#define SET_ARL_5632_m_MacAddr1(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, MacAddr1f, fldbuf)
#define ARL_5632_m_MacAddr1_WORDS		1
#define GET_ARL_5632_m_MacAddr2(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, MacAddr2f, fldbuf)
#define SET_ARL_5632_m_MacAddr2(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, MacAddr2f, fldbuf)
#define ARL_5632_m_MacAddr2_WORDS		1
#define GET_ARL_5632_m_MacAddr3(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, MacAddr3f, fldbuf)
#define SET_ARL_5632_m_MacAddr3(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, MacAddr3f, fldbuf)
#define ARL_5632_m_MacAddr3_WORDS		1
#define GET_ARL_5632_m_MacAddr4(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, MacAddr4f, fldbuf)
#define SET_ARL_5632_m_MacAddr4(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, MacAddr4f, fldbuf)
#define ARL_5632_m_MacAddr4_WORDS		1
#define GET_ARL_5632_m_MacAddr5(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, MacAddr5f, fldbuf)
#define SET_ARL_5632_m_MacAddr5(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, MacAddr5f, fldbuf)
#define ARL_5632_m_MacAddr5_WORDS		1
#define GET_ARL_5632_m_VLANId(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, VLANIdf, fldbuf)
#define SET_ARL_5632_m_VLANId(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, VLANIdf, fldbuf)
#define ARL_5632_m_VLANId_WORDS		1
#define GET_ARL_5632_m_DestinationPort(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, DestinationPortf, fldbuf)
#define SET_ARL_5632_m_DestinationPort(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, DestinationPortf, fldbuf)
#define ARL_5632_m_DestinationPort_WORDS		1
#define GET_ARL_5632_m_TimeStamp(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, TimeStampf, fldbuf)
#define SET_ARL_5632_m_TimeStamp(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, TimeStampf, fldbuf)
#define ARL_5632_m_TimeStamp_WORDS		1
#define GET_ARL_5632_m_valid(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, validf, fldbuf)
#define SET_ARL_5632_m_valid(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, validf, fldbuf)
#define ARL_5632_m_valid_WORDS		1
#define GET_ARL_5632_m_Static(entbuf, fldbuf) \
	get_mem_field(ARL_5632_m, entbuf, Staticf, fldbuf)
#define SET_ARL_5632_m_Static(entbuf, fldbuf) \
	set_mem_field(ARL_5632_m, entbuf, Staticf, fldbuf)
#define ARL_5632_m_Static_WORDS		1

/* Memory EEPROM_m */
#define EEPROM_m_BYTES                  2
#define EEPROM_m_WORDS                  BYTESTOWORDS(EEPROM_m_BYTES)
#define READ_EEPROM_m(unit, blkidx, index, data) \
	cmic_read_memory_5632(unit, EEPROM_m, blkidx, index, data) 
#define WRITE_EEPROM_m(unit, blkidx, index, data) \
	cmic_write_memory_5632(unit, EEPROM_m, blkidx, index, data) 
#define ZERO_EEPROM_m(buf) \
	zero_mem_value(EEPROM_m, buf) 
#define GET_EEPROM_m_ValueEEPROM(entbuf, fldbuf) \
	get_mem_field(EEPROM_m, entbuf, ValueEEPROMf, fldbuf)
#define SET_EEPROM_m_ValueEEPROM(entbuf, fldbuf) \
	set_mem_field(EEPROM_m, entbuf, ValueEEPROMf, fldbuf)
#define EEPROM_m_ValueEEPROM_WORDS	1

/* Memory table entry L2_L7_m */
typedef struct L2_L7_m_entry_s {
	 _u32 IncCntr:16;
	 _u32 UncondFwd:1;
	 _u32 CondDrop:1;
	 _u32 CP_Portnum:4;
	 _u32 CpPkt:1;
	 _u32 QueueNum:2;
	 _u32 RplQue:1;
	 _u32 VlanPri:3;
	 _u32 RplVpri:1;
	 _u32 Vid:12;
	 _u32 RplVid:1;
	 _u32 Dscp:8;
	 _u32 RplDscp:1;
	 _u32 Portnum:4;
	 _u32 RplPortnum:1;
	 _u32 PortEnable:13;
	 _u32 FLDDEq:1;
	 _u32 FLDDMask:8;
	 _u32 FLDD:8;
	 _u32 FLDCEq:1;
	 _u32 FLDCMask:8;
	 _u32 FLDC:8;
	 _u32 FLDBEq:1;
	 _u32 FLDBMask:8;
	 _u32 FLDB:8;
	 _u32 FLDAEq:1;
	 _u32 FLDAMask:8;
	 _u32 FLDA:8;
	 _u32 TOSEq:1;
	 _u32 TOSMask:8;
	 _u32 TOS:8;
	 _u32 PROTEq:1;
	 _u32 PROTMask:8;
	 _u32 PROT:8;
	 _u32 TSSEq:1;
	 _u32 TSSMask:16;
	 _u32 TSS:16;
	 _u32 TDSEq:1;
	 _u32 TDSMask:16;
	 _u32 TDS:16;
	 _u32 IPSAMaskAll:1;
	 _u32 IPSAEq:1;
	 _u32 IPSAMask:5;
	 _u32 IPSA:32;
	 _u32 IPDAMaskAll:1;
	 _u32 IPDAEq:1;
	 _u32 IPDAMask:5;
	 _u32 IPDA:32;
} L2_L7_m_entry_t;


/* Memory table entry VLAN_m */
typedef struct VLAN_m_entry_s {
	 _u32 PortMap:14;
	 _u32 OutputTagUntag:14;
	 _u32 PortState:26;
} VLAN_m_entry_t;


/* Memory table entry ARL_5632_m */
typedef struct ARL_5632_m_entry_s {
	 _u32 MacAddr0:8;
	 _u32 MacAddr1:8;
	 _u32 MacAddr2:8;
	 _u32 MacAddr3:8;
	 _u32 MacAddr4:8;
	 _u32 MacAddr5:8;
	 _u32 VLANId:12;
	 _u32 DestinationPort:6;
	 _u32 TimeStamp:7;
	 _u32 valid:1;
	 _u32 Static:1;
} ARL_5632_m_entry_t;


/* Memory table entry EEPROM_m */
typedef struct EEPROM_m_entry_s {
	 _u32 ValueEEPROM:16;
} EEPROM_m_entry_t;

/* VLAN list entry */
typedef struct VLAN_list_s {
	VLAN_m_entry_t entry;
	int vid;
} VLAN_list_t;

/* This table doesn't exist in BCM5632, but just use structure fields */
typedef struct ptable_entry_s {
#if defined(BCM5632_LE_HOST)
    _u32 vlan_tag:12;           /* VLAN Tag */
    _u32 sp_st:2;               /* Spanning Tree State */
    _u32 prt_dis:6;             /* Port Discard */
    _u32 jumbo:1;               /* Jumbo */
    _u32 rtag:3;                /* Trunk Selection */
    _u32 tgid:3;                /* Trunk Group ID */
    _u32 trunk:1;               /* Trunk Bit */
    _u32 cpu:1;                 /* CPU Bit */
    _u32 ptype:2;               /* Port type */
    _u32 bpdu:1;                /* BPDU Bit */
    _u32 port_bitmap:28;        /* Port Bitmap */
    _u32 mi:1;                  /* Mirror on Ingress */
    _u32 cml:2;                 /* CPU Managed Learning */
    _u32 _pad0:1;               /* Reserved */
    _u32 ut_port_bitmap:28;     /* Untag Bitmap */
    _u32 _pad1:4;               /* Reserved */
#else /* BCM5632_BE_HOST */
    _u32 bpdu:1;                /* BPDU Bit */
    _u32 ptype:2;               /* Port type */
    _u32 cpu:1;                 /* CPU Bit */
    _u32 trunk:1;               /* Trunk Bit */
    _u32 tgid:3;                /* Trunk Group ID */
    _u32 rtag:3;                /* Trunk Selection */
    _u32 jumbo:1;               /* Jumbo */
    _u32 prt_dis:6;             /* Port Discard */
    _u32 sp_st:2;               /* Spanning Tree State */
    _u32 vlan_tag:12;           /* VLAN Tag */
    _u32 _pad0:1;               /* Reserved */
    _u32 cml:2;                 /* CPU Managed Learning */
    _u32 mi:1;                  /* Mirror on Ingress */
    _u32 port_bitmap:28;        /* Port Bitmap */
    _u32 _pad1:4;               /* Reserved */
    _u32 ut_port_bitmap:28;     /* Untag Bitmap */
#endif /* BCM5632_BE_HOST */
} ptable_entry_t;

/*****************************************************************************

 **	ACCESS FUNCTIONS
 ** These are "swiss-army-knife" style functions. If possible, you should
 ** use the macros above instead.
 *****************************************************************************/

#ifdef NO_REGFILE_NAMES
# define NO_MEM_NAMES
# define NO_REG_NAMES
#endif

#define MIN_GPIC_5632	0x3
#define MAX_GPIC_5632	(MIN_GPIC_5632+NUM_GPIC_5632-1)
#define MIN_PIC_5632	0x0
#define MAX_PIC_5632	MAX_GPIC_5632

#define MIN_PORT_5632	0x00
#define MAX_PORT_5632	0x0c
#define NUM_PORT_5632	(MAX_PORT_5632 - MIN_PORT_5632 + 1)

typedef enum soc_reg_t {
	INVALIDr = -1,
	SYS_CONF_1r = 0,
	SYS_CONF_2r,
	SYS_CONF_3r,
	EP_SETUP_1r,
	EP_SETUP_2r,
	PRIO_QMAPr,
	DFSV_QMAP_0r,
	DFSV_QMAP_1r,
	DFSV_QMAP_2r,
	DFSV_QMAP_3r,
	DFSV_QMAP_4r,
	DFSV_QMAP_5r,
	DFSV_QMAP_6r,
	DFSV_QMAP_7r,
	QWEIGHT_1Gr,
	QWEIGHT_10Gr,
	QMAX_1Gr,
	QMAX_10Gr,
	QMGMT_1r,
	QMGMT_2r,
	QMGMT_3r,
	QMGMT_4r,
	QMGMT_5r,
	BMGMT_1r,
	BMGMT_2r,
	BMGMT_3r,
	BMGMT_4r,
	BMGMT_5r,
	PHY_CONFr,
	MAC_CONF_1Gr,
	TRK_SETUP_0r,
	TRK_SETUP_1r,
	TRK_SETUP_2r,
	TRK_SETUP_3r,
	TRK_SETUP_4r,
	TRK_SETUP_5r,
	TRK_DIST_SELr,
	PMON_CONFr,
	PENG_CONF_1r,
	PENG_CONF_2r,
	XGMI_CONF_1r,
	XGMI_CONF_2r,
	XGMI_CONF_3r,
	XGMI_CONF_4r,
	XGMI_CONF_5r,
	AUTH_VLANr,
	P_CONF_1r,
	P_CONF_2r,
	P_CONF_3r,
	P10G_CONF_1r = 0x52,
	P10G_CONF_2r,
	P10G_CONF_3r,
	P_VLAN_MAP_0r,
	P_VLAN_MAP_1r,
	P_VLAN_MAP_2r,
	P_VLAN_MAP_3r,
	P_VLAN_MAP_4r,
	P_VLAN_MAP_5r,
	P_VLAN_MAP_6r,
	P_VLAN_MAP_7r,
	P_VLAN_MAP_8r,
	P_VLAN_MAP_9r,
	P_VLAN_MAP_10r,
	P_VLAN_MAP_11r,
	P_VLAN_MAP_12r,
	DFT_PORT_PRIORITY_0r,
	DFT_PORT_PRIORITY_1r,
	DFT_PORT_PRIORITY_2r,
	DFT_PORT_PRIORITY_3r,
	DFT_PORT_PRIORITY_4r,
	DFT_PORT_PRIORITY_5r,
	DFT_PORT_PRIORITY_6r,
	DFT_PORT_PRIORITY_7r,
	DFT_PORT_PRIORITY_8r,
	DFT_PORT_PRIORITY_9r,
	DFT_PORT_PRIORITY_10r,
	DFT_PORT_PRIORITY_11r,
	DFT_PORT_PRIORITY_12r,
	P_CTYP_0r,
	P_CDFT_0r,
	P_CTYP_1r,
	P_CDFT_1r,
	P_CTYP_2r,
	P_CDFT_2r,
	P_CTYP_3r,
	P_CDFT_3r,
	P_CTYP_4r,
	P_CDFT_4r,
	P_CTYP_5r,
	P_CDFT_5r,
	P_CTYP_6r,
	P_CDFT_6r,
	P_CTYP_7r,
	P_CDFT_7r,
	P_CTYP_8r,
	P_CDFT_8r,
	P_CTYP_9r,
	P_CDFT_9r,
	P_CTYP_10r,
	P_CDFT_10r,
	P_CTYP_11r,
	P_CDFT_11r,
	P_CTYP_12r,
	P_CDFT_12r,
	P_CTYP_13r,
	P_CDFT_13r,
	P_CTYP_14r,
	P_CDFT_14r,
	P_CTYP_15r,
	P_CDFT_15r,
	TEST_CTL_1r = 0x20f,
	TEST_CTL_2r,
	TEST_CTL_3r,
	TEST_CTL_4r,
	TEST_CTL_5r,
	TEST_CTL_6r,
	TEST_CTL_7r,
	HMON_MAC_1r = 0x400,
	HMON_MAC_2r,
	HMON_MAC_3r,
	VMON_0r,
	VMON_1r,
	VMON_2r,
	VMON_3r,
	VMON_4r,
	VMON_5r,
	VMON_6r,
	VMON_7r,
	VMON_8r,
	VMON_9r,
	VMON_10r,
	VMON_11r,
	VMON_12r,
	VMON_13r,
	VMON_14r,
	VMON_15r,
	VMON_16r,
	VMON_17r,
	VMON_18r,
	VMON_19r,
	VMON_20r,
	VMON_21r,
	VMON_22r,
	VMON_23r,
	VMON_24r,
	VMON_25r,
	VMON_26r,
	VMON_27r,
	VMON_28r,
	VMON_29r,
	VMON_30r,
	VMON_31r,
	SECVIO_PORTMAPr,
	SYS_STATUSr,
	P_STATUSr,
	P10G_STATUSr = 0x431,
	CPU_CMDr,
	TBL_ENTIDr,
	TBL_SXADDRr,
	TBL_DBUF_0r,
	TBL_DBUF_1r,
	TBL_DBUF_2r,
	TBL_DBUF_3r,
	TBL_DBUF_4r,
	TBL_DBUF_5r,
	TBL_DBUF_6r,
	TBL_DBUF_7r,
	TBL_DBUF_8r,
	TBL_DBUF_9r,
	INVr,
	INV_MSKr,
	PKT_CH_PTRSr,
	RX_CH_0r,
	RX_CH_1r,
	RX_CH_2r,
	RX_CH_3r,
	RX_CH_4r,
	RX_CH_5r,
	RX_CH_6r,
	RX_CH_7r,
	RX_CH_8r,
	RX_CH_9r,
	RX_CH_10r,
	RX_CH_11r,
	RX_CH_12r,
	RX_CH_13r,
	RX_CH_14r,
	RX_CH_15r,
	RX_CH_16r,
	RX_CH_17r,
	RX_CH_18r,
	RX_CH_19r,
	RX_CH_20r,
	RX_CH_21r,
	RX_CH_22r,
	RX_CH_23r,
	RX_CH_24r,
	RX_CH_25r,
	RX_CH_26r,
	RX_CH_27r,
	RX_CH_28r,
	RX_CH_29r,
	RX_CH_30r,
	RX_CH_31r,
	TX_CH_0r,
	TX_CH_1r,
	TX_CH_2r,
	TX_CH_3r,
	TX_CH_4r,
	TX_CH_5r,
	TX_CH_6r,
	TX_CH_7r,
	TX_CH_8r,
	TX_CH_9r,
	TX_CH_10r,
	TX_CH_11r,
	TX_CH_12r,
	TX_CH_13r,
	TX_CH_14r,
	TX_CH_15r,
	TX_CH_16r,
	TX_CH_17r,
	TX_CH_18r,
	TX_CH_19r,
	TX_CH_20r,
	TX_CH_21r,
	TX_CH_22r,
	TX_CH_23r,
	TX_CH_24r,
	TX_CH_25r,
	TX_CH_26r,
	TX_CH_27r,
	TX_CH_28r,
	TX_CH_29r,
	TX_CH_30r,
	TX_CH_31r,
	BPDU_1r,
	BPDU_2r,
	BPDU_3r,
	NUM_SOC_REG
} soc_reg_t;

typedef enum soc_field_t {
	INVALIDf = -1,
	CPUprstf = 0,
	Flood_controlf,
	Chip_securityf,
	AgeENf,
	Per_VLAN_STf,
	STPENf,
	PinMonf,
	PoutMonf,
	CPUcfgrdyf,
	GMCf,
	VLAN_GMCf,
	PQWRREnf,
	Cooperativef,
	FailOverEnf,
	Multiplexer10Gportf,
	ReservedConf1f,
	MaxAgef,
	TimeoutENf,
	CPU_Timeout_ENf,
	BConly_SCf,
	MaxStormf,
	MaxStorm10gf,
	ReservedConf2f,
	Qonf,
	ReservedConf3f,
	DiffServf,
	TypeParsef,
	IPMCtrapf,
	IGMPtrapf,
	GARPtrapf,
	ARPtrapf,
	T802ADtrapf,
	ICMPtrapf,
	BPDU1trapf,
	BPDU2trapf,
	MarkerENf,
	BufDataEnf,
	ReservedConf32f,
	Epprstf,
	Epconff,
	ReservedEPf,
	EPL2sizef,
	EEPROMIDf,
	ReservedEP2f,
	EPVLANsizef,
	PL7QAf,
	PL6QAf,
	PL5QAf,
	PL4QAf,
	PL3QAf,
	PL2QAf,
	PL1QAf,
	PL0QAf,
	DS7QAf,
	DS6QAf,
	DS5QAf,
	DS4QAf,
	DS3QAf,
	DS2QAf,
	DS1QAf,
	DS0QAf,
	Q3RRWeightf,
	Q2RRWeightf,
	Q1RRWeightf,
	Q0RRWeightf,
	Q3RRWeight10Gf,
	Q2RRWeight10Gf,
	Q1RRWeight10Gf,
	Q0RRWeight10Gf,
	Q3MaxLimitf,
	Q2MaxLimitf,
	Q1MaxLimitf,
	Q0MaxLimitf,
	Q3MaxLimit10Gf,
	Q2MaxLimit10Gf,
	Q1MaxLimit10Gf,
	Q0MaxLimit10Gf,
	ReservedQMf,
	CPUQ0Enf,
	TGQ0Enf,
	GxQ0Enf,
	ReservedQM2f,
	TGQ1Enf,
	GxQ1Enf,
	ReservedQM3f,
	TGQ2Enf,
	GxQ2Enf,
	ReservedQM4f,
	TGQ3Enf,
	GxQ3Enf,
	OqFullBp3f,
	OqFullBp2f,
	OqFullBp1f,
	OqFullBp0f,
	Q3LatencyEnf,
	Q2LatencyEnf,
	Q1LatencyEnf,
	Q0LatencyEnf,
	Q3LatencyLimf,
	Q2LatencyLimf,
	Q1LatencyLimf,
	Q0LatencyLimf,
	JumboEnf,
	JumboSizef,
	B8G_modef,
	CPUless_modef,
	Fair_Sharef,
	Non_Jumbo_MTUf,
	ReservedBMf,
	WaterMark1f,
	ReservedBM2f,
	WaterMark2f,
	WaterMark3f,
	WaterMark1CPUf,
	WaterMark1_10Gf,
	WaterMark2CPUf,
	WaterMark2_10Gf,
	WaterMark3CPUf,
	WaterMark3_10Gf,
	ReservedPHYf,
	MIISlowClkf,
	PHYOpRegf,
	PHYOpSpf,
	PHYOpMdf,
	SuperMacf,
	UltraMacf,
	Bp_colf,
	IPG64f,
	BP_IPG64f,
	Bpratef,
	BebSelf,
	Extcycself,
	Mactestf,
	BPIpgSelf,
	ReservedMACf,
	Tsetup_remotef,
	Tsetup_localf,
	Failover_Timerf,
	Failback_Timerf,
	L2MacSAf,
	L2MacDAf,
	L2EthTypef,
	L2VLANIDf,
	IPMacSAf,
	IPMacDAf,
	L3Protocolf,
	L3VLANIDf,
	L3IPSAf,
	L3IPDAf,
	L3SSf,
	L3DSf,
	ReservedPMf,
	MdPIDf,
	MgIPIDf,
	MgOPIDf,
	ReservedR26f,
	ReservedR27f,
	XGMII_IDLEf,
	XGMII_SOPf,
	XGMII_EOPf,
	XGMII_ERRORf,
	XGMII_BIDLEf,
	ReservedXGMI3f,
	SEL_XGMII_PAf,
	ReservedXGMIf,
	EnOpenLoopf,
	OpenLoop_IPGExtRatiof,
	Reserved22Cf,
	XGMII_BIDLE_ODDf,
	XGMII_IDLE_ODDf,
	VLAN_Au_ENf,
	VLAN_Au_Pf,
	VLAN_Au_IDf,
	UpLinkIDf,
	Drop_untagf,
	Drop_tagf,
	Flood_loopbackf,
	LinkLEDEnf,
	Storm_controlf,
	Port_securityf,
	VLAN_ingressf,
	LrnDisf,
	PortSTf,
	B2benablef,
	Multiplexer1Gportf,
	RstAnegf,
	AnegEnbf,
	LinkUpf,
	PAUSE_CAPf,
	ASM_DIRf,
	TXPAUSEf,
	RXPAUSEf,
	Offlinef,
	back_jam_enf,
	Preamblewdf,
	IPGwdf,
	M_S_cfgf,
	M_S_valf,
	EnGMIIf,
	EnTxExPausef,
	Skip_expanf,
	M_S_ptypef,
	Dis_phy_resetf,
	Keep_defaultf,
	ReservedPC3f,
	Duplex_cfgf,
	Speedselect_cfgf,
	Force_modef,
	UpLinkID10Gf,
	Drop_untag10Gf,
	Drop_tag10Gf,
	ReservedPGf,
	LinkLEDEn10Gf,
	Storm_control10Gf,
	Port_security10Gf,
	VLAN_ingress10Gf,
	LrnDis10Gf,
	PortST10Gf,
	ReservedPG2f,
	ReservedPG10Gf,
	LinkUp10Gf,
	PAUSE10Gf,
	ASM_DIR10Gf,
	TXPAUSE10Gf,
	RXPAUSE10Gf,
	ReservedPG22f,
	IPGwordselect10Gf,
	IPGword10Gf,
	ReservedPG3f,
	ReservedPVf,
	CpuMapf,
	TGMapf,
	GigaMapf,
	ReservedPPf,
	Priorityf,
	VLANf,
	VlClassEthTypef,
	VlClassValEtnryf,
	VlClassPriorityf,
	VlClassVIDf,
	CtrlFlags1f,
	CtrlFlags2f,
	CtrlFlags3f,
	CtrlFlags4f,
	CtrlFlags5f,
	CtrlFlags6f,
	CtrlFlags7f,
	H1MacLSBf,
	H2MacMSBf,
	H2MacMSB3f,
	H1MacMSB3f,
	ReservedMVLANf,
	MVLANIDf,
	ReservedSVf,
	P12Xf,
	P11Xf,
	P10Xf,
	P09Xf,
	P08Xf,
	P07Xf,
	P06Xf,
	P05Xf,
	P04Xf,
	P03Xf,
	P02Xf,
	P01Xf,
	P00Xf,
	ReservedSSf,
	LastOfMIBIdf,
	LastTblCmdXf,
	NowTblMgmtf,
	NowEPInitf,
	NowMIBInitf,
	NowL2Initf,
	ReservedSS2f,
	NowSBInitf,
	LastBISTXf,
	NowBISTf,
	Aneglpregf,
	LinkFailf,
	AnegComptf,
	SvlanViolationf,
	DvlanViolationf,
	AllQueueDropf,
	InBFullf,
	TblUNAVLf,
	TimeOutf,
	AnegFailf,
	DisTxPausef,
	DisRxPausef,
	Anegpagervdf,
	PS1_PS0f,
	RF2_RF1f,
	Aneglpreg10Gf,
	LinkFail10Gf,
	AnegCompt10Gf,
	SvlanViolation10Gf,
	DvlanViolation10Gf,
	AllQueueDrop10Gf,
	InBFull10Gf,
	TblUNAVL10Gf,
	TimeOut10Gf,
	AnegFail10Gf,
	DisTxPause10Gf,
	DisRxPause10Gf,
	Anegpagervd10Gf,
	PS1_PS010Gf,
	RF2_RF110Gf,
	SxAddrMSBf,
	ReservedCPUf,
	SwResetf,
	ReservedCPU2f,
	TblSelf,
	TblMgmtCmdf,
	ReservedTAf,
	TblEntryCntf,
	ReservedTA2f,
	TblEntryNof,
	SxAddrLSBf,
	TblDataBf,
	ReservedCPUIf,
	CPUInitStartf,
	PCIErrf,
	MemInitDonef,
	BISTDonef,
	MIBCntOFf,
	TblCmdDonef,
	RxPktLastf,
	RxPktf,
	TxPktLastf,
	TxPktf,
	IntVecMskf,
	ReservedDMAf,
	NxtTxChf,
	ReservedDMA2f,
	NxtAllocTxChf,
	ReservedDMA3f,
	NxtRxChf,
	ReservedDMA4f,
	NxtAllocRxChf,
	PktsRxAf,
	PktsTxAf,
	BPDU1_LSBf,
	BPDU2_LSBf,
	BPDU2_MSBf,
	BPDU1_MSBf,
	IncCntrf,
	UncondFwdf,
	CondDropf,
	CP_Portnumf,
	CpPktf,
	QueueNumf,
	RplQuef,
	VlanPrif,
	RplVprif,
	Vidf,
	RplVidf,
	Dscpf,
	RplDscpf,
	Portnumf,
	RplPortnumf,
	PortEnablef,
	FLDDEqf,
	FLDDMaskf,
	FLDDf,
	FLDCEqf,
	FLDCMaskf,
	FLDCf,
	FLDBEqf,
	FLDBMaskf,
	FLDBf,
	FLDAEqf,
	FLDAMaskf,
	FLDAf,
	TOSEqf,
	TOSMaskf,
	TOSf,
	PROTEqf,
	PROTMaskf,
	PROTf,
	TSSEqf,
	TSSMaskf,
	TSSf,
	TDSEqf,
	TDSMaskf,
	TDSf,
	IPSAMaskAllf,
	IPSAEqf,
	IPSAMaskf,
	IPSAf,
	IPDAMaskAllf,
	IPDAEqf,
	IPDAMaskf,
	IPDAf,
	PortMapf,
	OutputTagUntagf,
	PortStatef,
	MacAddr0f,
	MacAddr1f,
	MacAddr2f,
	MacAddr3f,
	MacAddr4f,
	MacAddr5f,
	VLANIdf,
	DestinationPortf,
	TimeStampf,
	validf,
	Staticf,
	ValueEEPROMf,
	NUM_SOC_FIELD
} soc_field_t;

typedef enum soc_mem_t {
	/* BCM5632 memory name enum */
	INVALIDm = -1,
	L2_L7_m = 0,
	VLAN_m,
	ARL_5632_m,
	EEPROM_m,
	NUM_SOC_MEM
} soc_mem_t;

typedef uint32 soc_addr_t;

typedef enum soc_block_t {
	INVALIDb = -1,
        ANY_GPIC = 0,
        ANY_PIC,
	ANY_XGPIC
} soc_block_t;

typedef int soc_cos_t;
typedef int soc_port_t;

#define SOCF_LE		0x01	/* Flag: little endian */
#define SOCF_RO		0x02	/* Flag: read only */
#define SOCF_WO		0x04	/* Flag: write only */
#define SOCF_SC		0x08
#define SOCF_RES        0x10    /* Flag: reserved (do not test, etc.) */

typedef struct soc_fieldinfo_t {
	soc_field_t	field;
	uint16		len;	/* Bits in field */
	uint16		bp;	/* Least bit position of the field */
	unsigned char	flags;	/* Logical OR of SOC_FIELD_XXX */
} soc_fieldinfo_t;

typedef enum soc_regtype_t {
	soc_genreg, soc_portreg, soc_cosreg
} soc_regtype_t;

EXTERN char *soc_regtypenames[];

typedef struct soc_reginfo_t {
#ifndef NDEBUG
	soc_reg_t		reg;		/* Redundant */
#endif /* !NDEBUG */
#ifndef	NO_REG_NAMES
	char			*name;
#endif /* !NO_REG_NAMES */
	soc_block_t		block;
	soc_regtype_t		regtype;
	uint32			offset;		/* Includes 2-bit form field */
	unsigned		nFields;
	soc_fieldinfo_t		*fields;
#ifndef	NO_RESET_INFO
	uint32			resetVal;
	uint32			resetMask; 	/* 1 where resetVal is valid */
#endif /* !NO_RESET_INFO */
	char			*desc;
} soc_reginfo_t;

typedef struct soc_meminfo_t {
#ifndef NDEBUG
	soc_mem_t		mem;		/* Redundant */
#endif /* !NDEBUG */
#ifndef	NO_MEM_NAMES
	char			*name;
#endif /* !NO_MEM_NAMES */
	uint16			be;		/* nonzero for BE word order */
	uint16			nBlocks;	/* 0 if monolithic */
	soc_block_t		*blocks;
	uint32			offset;		/* Includes region */
	uint16			bytes;
	uint16			nFields;
	soc_fieldinfo_t		*fields;
} soc_meminfo_t;

typedef struct soc_portinfo_t {
#ifndef NDEBUG
	soc_port_t		portnum;	/* Redundant */
#endif /* !NDEBUG */
	soc_block_t		block;
	int			index;
} soc_portinfo_t;

typedef struct soc_regaddrinfo_t {
	uint32			addr;
	int			valid;
	soc_reg_t		reg;		/* INVALIDr if not used */
	soc_block_t		block;		/* INVALIDb if not used */
	soc_port_t		port;		/* -1 if not used */
	soc_cos_t		cos;		/* -1 if not used */
	soc_field_t		field;		/* INVALIDf for entire reg. */
} soc_regaddrinfo_t;

#define __NCREG			(NUM_PIC_5632 * NUM_COS_5632)
#define __NPREG			(NUM_PORT_5632)

#define REGADDRLIST_MAX		(__NCREG > __NPREG ? __NCREG : __NPREG)

typedef struct soc_regaddrlist_t {
	int			count;
	soc_regaddrinfo_t	ainfo[REGADDRLIST_MAX];
} soc_regaddrlist_t;

typedef struct soc_regaddrfields_t {
	soc_regtype_t	type;
	uint32		offset;
	soc_cos_t	minCOS;
	soc_cos_t	maxCOS;
	int		nBPs;
	struct {
		soc_block_t	block;
		soc_port_t	port;
	} bps[MAX_PORT_5632+1];
} soc_regaddrfields_t;

extern soc_reginfo_t soc_registers_5632[];
extern soc_meminfo_t soc_memories_5632[];
extern char *soc_blocknames_5632[];
extern char *soc_regtypenames_5632[];

/* Call socreg_init() before any of the other functions.
 */
#ifdef NDEBUG
#	define socreg_init_5632() ((void)0)
#else /* !NDEBUG */
	EXTERN void socreg_init_5632();
#endif /* !NDEBUG */

/* Get 'field' of datum 'current'.
 */
EXTERN uint32 get_reg_field_5632(
 soc_reg_t reg, uint32 current, soc_field_t field
);
EXTERN uint32 *get_mem_field_5632(
 soc_mem_t mem, uint32 *entbuf, soc_field_t field, uint32 *fldbuf
);
EXTERN unsigned get_mem_field_numwords_5632(soc_mem_t mem, soc_field_t field);
EXTERN unsigned get_mem_numbytes_5632(soc_mem_t mem);

/* Set 'field' of datum 'current' to 'value'.
 */
EXTERN uint32 set_reg_field_5632(
 soc_reg_t reg, uint32 current, soc_field_t field, uint32 value
);
EXTERN uint32 *set_mem_field_5632(
 soc_mem_t mem, uint32 *entbuf, soc_field_t field, uint32 *fldbuf
);
EXTERN uint32 *zero_mem_value_5632(soc_mem_t mem, uint32 *buf);

/* Set all fields to -1.
 */
EXTERN uint32 get_reg_datamask_5632(soc_reg_t reg, int flags);
EXTERN uint32 *get_mem_datamask_5632(soc_mem_t mem, uint32 *buf);

/* Print fields
 */
EXTERN void sprint_reg_data_5632(char *bp, char *infix,
			    soc_reg_t reg, uint32 value);

/* Assemble & Disassemble address
 */
EXTERN void get_regaddrinfo_5632(soc_regaddrinfo_t *ainfo, uint32 addr);
EXTERN void str2regaddrinfo_5632(soc_regaddrinfo_t *ainfo, char *str);

/* Find the valid address fields for a given register
 */
EXTERN soc_regaddrfields_t get_regaddrfields_5632(soc_reg_t reg);

/* Returns the name of the workset in which socregs.[ch] were generated */
EXTERN char *socreg_info(soc_reg_t);

/* Miscellaneous
 */
EXTERN soc_fieldinfo_t *find_field_5632(
 soc_field_t field, unsigned n, soc_fieldinfo_t *fields
);
EXTERN soc_port_t minport_5632(soc_block_t block);
EXTERN soc_port_t maxport_5632(soc_block_t block);

extern uint32 reg_addr_port_5632(soc_reg_t reg, soc_port_t port);

#endif /*!__SOCREGS_H*/
